<'
'>
File: 	vrst_snfp.e
Description:
	give the user the ability to use floating point type in e
Notes:
Created By: meir Thu Jan 11 00:07:17 IST 2001
			exp			mantisa
single		 8				23
double		11				52
extended	15				63
<'
import vrst_snfp_h.e ;
'>
o floating point e model
	snfp is a shortcut for the e structure representing a floating point, i.e.,
		a snfp consists of:
			sign	
			exp
			mantisa
		depending on the presicion these fields may be of different length.
	efp	is the snfp number as it is laidout in memory, i.e., it consists of:
		low		: uint
		high	: uint
		extended: uint
	  were,
	  %{low} may represent the layout of a singel precision number (c float, 32 bits wide)
	  %{high, low}	may represent a double precision number	(c double, 64 bits)
	  %{ext, high, low}		may represent an extended precision fp number (c long double, 80 bits wide)
<'
extend snfp_floating_point_s {
	sign	: snfp_sign_t;			// the sign
	exp		: uint;				// the exponent
	mantisa0: uint;				// the least significant uint
	mantisa1: uint;				// the least significant + 1 uint
	!low	: uint;
	!high	: uint;
	!ext	: uint;
	!str_fmt:	string;			// format to be used when converting to str
	!fpfn : snfp_floating_point_function_s ;
		// ifc spec
	to_str(): string is empty;	// convert the snfp representation to a string and returns its value
	snfp_to_efp_rep() is empty;		// convert a snfp consisting of sign, exp, mantisa to an efp 
	str_rep_to_snfp() is {		// convert a string rep of a fp to the corresponding snfp rep
		c_str_to_efp();			// first convert the str to an efp (double)
		kind = DOUBLE;
		efp_to_snfp_rep();		// then convert the efp to a snfp
	};
	set(sr : string) is also {
		str_rep = sr; 
		str_rep_to_snfp();
	};
	efp_to_snfp_rep() is empty;
	c_str_to_efp() is C routine c_str_to_efp;	// convert a str to an efp rep in double precision
			//
			// end ifc 
			//
		keep number_type == ZERO => (exp == 0) and (mantisa0 == 0);
		keep number_type == NORMAL => exp >= 1; 
		keep number_type == DENORMAL => exp == 0; 
		keep number_type in [INFINITY, SNaN, QNaN] => (exp == 0xFFFF_FFFF) ;
		keep number_type == INFINITY => mantisa0 == 0;
		//
	lt(op2 : snfp_floating_point_s) : bool is also {
		if( fpfn == NULL ) { fpfn = new; };
		fpfn.op1 = me;
		fpfn.op2 = op2;
		result = fpfn.lt();
	};
	eq(op2 : snfp_floating_point_s) : bool is also {
		if( fpfn == NULL ) { fpfn = new; };
		fpfn.op1 = me;
		fpfn.op2 = op2;
		result = fpfn.eq();
	};
	when SINGLE snfp_floating_point_s {
		keep mantisa1 == 0;
		keep mantisa0 <= SFP_MAN_MAX;
		keep number_type == NORMAL => exp < SFP_EXP_MAX;
		keep number_type == DENORMAL => mantisa0 != 0;
		keep number_type == SNaN     => mantisa0[22:22] == 0;
		keep number_type == QNaN     => mantisa0[22:22] == 1;
		--to_efp_rep() is also {
		snfp_to_efp_rep() is also {
			low = (sign.as_a(uint) << 31) | ((exp & SFP_EXP_MAX) << 23) | (mantisa0 & SFP_MAN_MAX);
		};
		efp_to_snfp_rep() is also {
			sign = low[31:31].as_a(snfp_sign_t);		// get the sign
			exp  = low[30:23];					// get exponent
			mantisa0 = low[22:0];				// and mantisa
			if (exp < SFP_EXP_MAX) and (exp >= 1) { number_type = NORMAL;};
			if (exp == 0) and (mantisa0 != 0) { number_type = DENORMAL; };
		};
		to_str() : string is C routine esfp_to_str;
		as_bin() : list of bit is also {
			result = %{low};
		};
		post_generate() is also { if fmt_to_use == E_FMT { str_fmt = "%.12e"; }; }; 
		init() is also { str_fmt = "%.12f"; };
	};
	when DOUBLE snfp_floating_point_s {
		keep mantisa1 <= 0xFFFF_F;
		keep number_type == NORMAL => exp < DFP_EXP_MAX;
		keep number_type == DENORMAL => (mantisa0 != 0) or (mantisa1 != 0);
		keep number_type == INFINITY => mantisa1 == 0;
		keep number_type == SNaN     => mantisa1[19:19] == 0;
		keep number_type == QNaN     => mantisa1[19:19] == 1;
		snfp_to_efp_rep() is also {
			low = mantisa0;
			high = (sign.as_a(uint) << 31) | ((exp & DFP_EXP_MAX) << 20) | (mantisa1 & DFP_MAN_MAX);
		};
		efp_to_snfp_rep() is also {
			sign = high[31:31].as_a(snfp_sign_t);		// get the sign
			mantisa0 = low;
			mantisa1 = high  & DFP_MAN_MAX;
			exp  = high[31:21];
			if (exp < DFP_EXP_MAX) and (exp >= 1) { number_type = NORMAL;};
			if (exp == 0) and ((mantisa0 != 0) or (mantisa1 != 0)) { number_type = DENORMAL; };
		};
		to_str() : string is C routine edfp_to_str;
		as_bin() : list of bit is also {
			result = %{high, low};
		};
		post_generate() is also { if fmt_to_use == E_FMT { str_fmt = "%.12le"; }; }; 
		init() is also { str_fmt = "%.12lf"; };
	};
#ifdef USE_EXTENDED_PRECISION {
	when EXTENDED snfp_floating_point_s {
		set(sr : string) is only {// convert a str to an efp rep
			str_rep = sr; 
			c_str_to_ext_efp();	
			efp_to_snfp_rep();		// then convert the efp to a snfp
		};
		c_str_to_ext_efp() is C routine c_str_to_ext_efp;// convert a str to an efp rep in extended precision
		efp_to_snfp_rep() is also {     					// convert an efp to a snfp rep
			sign = ext[14:14].as_a(snfp_sign_t);		// get the sign
			mantisa0 = low;
			mantisa1 = 0x8000_0000 | (high  & EXFP_MAN_MAX);	//msb always one
			exp  = ext & EXFP_EXP_MAX ;
			if (exp < EXFP_EXP_MAX) and (exp >= 1) { number_type = NORMAL;};
			if (exp == 0) and ((mantisa0 != 0) or (mantisa1 != 0)) { number_type = DENORMAL; };
		};
		to_str() : string is C routine eexfp_to_str;
		as_bin() : list of bit is also {
			var t : uint(bits:15) = ext;
			result = %{t,high,low};
		};
		post_generate() is also { if fmt_to_use == E_FMT { str_fmt = "%.16Le"; }; }; 
		init() is also { str_fmt = "%.16Lf"; };
	};
};
	post_generate() is also {
		if( str_rep == "" ) {
			snfp_to_efp_rep();
			str_rep = to_str();
		} else {
			str_rep_to_snfp();
		};
	};
};

extend snfp_floating_point_function_s {
	snfp_fn()  is C routine snfp_fn;
	do_fp() is only {
		dbg_out(debug.snfp, "op1=", op1.str_rep, ", exec ", its_type);
		if( its_type in [FADD, FSUB, FMUL, FDIV, CMP] ) {
			dbg_out(debug.snfp, "op2=", op2.str_rep);
		};
		snfp_fn();
		res.kind = DOUBLE;
		res.str_rep = res.to_str();
		dbg_out(debug.snfp, "result=", res.str_rep);
	};
	lt() : bool is also {
		var tt := its_type;
		its_type = CMP;
		do_fp();
		res.efp_to_snfp_rep();
		result = res.sign == NEG;
		its_type = tt;
	};
	eq() : bool is also {
		var tt := its_type;
		its_type = CMP;
		do_fp();
		result = res.str_rep == "0.";
		its_type = tt;
	};
	alloc() is {
		op1 = new snfp_floating_point_s;
		op2 = new snfp_floating_point_s;
		res = new snfp_floating_point_s;
	};
	init() is also {
		alloc();
	};
};

'>

<'
extend snfp_rnd_fp_s  {
	to_str_rep() : string is only {
		var frac : string = chop_zero_tail( fraction.as_a(string) );
		if no_zeros and (frac == "") {
			gen fraction keeping { for each (b) in it { index == 0 => b != 48; }; };
			frac = chop_zero_tail( fraction.as_a(string) );
		};
		var sl : list of string = {
			sign == 1 ? "-" : "";
			integer.as_a(string); 
			".";
			frac != "" ? frac : "0";
		};
		result = str_join(sl, "");
	};
};
routine chop_zero_tail(s:string) : string;	//removes zero ('0') characters from the end of a string
											//and returns it
extend debug {
	!snfp	: bool; 
};
'>
------------------------
-----  CODE END   ------
------------------------

