<'
--import vrst_snfp/e/vrst_snfp_h ;

define M_PI       3.14159265358979323846;
define M_PI_2     1.57079632679489661923;
define M_PI_4     0.78539816339744830962;
define M_1_PI     0.31830988618379067154;

struct sin_result {
	arg		: string;
	its_sin	: string; 
};

extend sys {
	!step : string;
	two_pi : snfp_floating_point_s;
	sin_fn  : SIN  snfp_floating_point_function_s;
	fp_fn  : FMUL snfp_floating_point_function_s ;
	add_fn  : FADD snfp_floating_point_function_s;
	post_generate() is also {
		sin_l = calc_sin(step);
		print sin_l;
	};
		// calculate the sin(arg) for 0<= arg <= 2 * pi using different step length
	calc_sin(step : string) : list of sin_result is {
		var op1 : snfp_floating_point_s = new;
		var op2 : snfp_floating_point_s = new;
		var idx : uint = 0;
		var sinres : sin_result;
		
		calc_2pi();
		SNFP op1 = 0.0;
		op2.set(step);
		add_fn.op2 = op2;
		fp_fn.op1 = op1; 
		fp_fn.op2 = two_pi; 
		while( op1.lt( two_pi ) ) {
			idx += 1;
			sin_fn.op1 = op1;
			sin_fn.do_fp();
			sinres = new sin_result with {
				.arg = op1.str_rep;
				.its_sin = sin_fn.res.str_rep;
			};
			result.add( sinres );
			add_fn.op1 = op1;
			add_fn.do_fp();
			op1 = add_fn.res;
			if idx > 100 { break;};
		};
	};
	calc_2pi() is {
		var pi : DOUBLE snfp_floating_point_s = new;
		var two : DOUBLE snfp_floating_point_s = new;
		SNFP pi = M_PI;
		SNFP two = 2.0;
		fp_fn.op1 = pi;
		fp_fn.op2 = two;
		fp_fn.its_type = FMUL;
		fp_fn.do_fp();
		two_pi = fp_fn.res.copy();
	};
	!sin_l : list of sin_result;
	init() is also {
		step = "0.2";
		--debug.snfp = TRUE;
	};
};

'>
------------------------
-----  CODE END   ------
------------------------
