/* vrst_snfp_.h - Translated from vrst_snfp_h.e by: */
/*   Specman Elite (4.0.1)  -  Linked on Sun Mar 10 12:35:00 2002 */

/* vrst_snfp_.h - Translated from vrst_snfp.e by: */
/*   Specman Elite (4.0.1)  -  Linked on Sun Mar 10 12:35:00 2002 */

    /***********************************************************************
     * COPYRIGHT (c) 1996, 1997 by Verisity Ltd., all rights reserved. *
     * This software is furnished under a license and may be used and       *
     * copied only in accordance of the terms of such license and with the  *
     * inclusion of the above copyright notice.                             *
     ***********************************************************************/

#ifndef ROOT_ALL_H
#define ROOT_ALL_H

/* #include version.h */
#ifndef SN_version_included
#define SN_version_included


#define SN_VERSION "4.0.1"

#endif

/* #include snoopy.h */
/* snoopy.h - the Snoopy include file ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

#ifndef snoopy_included
#define snoopy_included

#include <stdio.h>

/* #include cpp.h */
#ifndef _CPP_H_
#define _CPP_H_


#ifdef __cplusplus
#define SN_EXTERNC extern "C"
#else
#define SN_EXTERNC extern
#endif /* __cplusplus */

#ifdef __GNUC__
#ifndef GCC
#define GCC
#endif /* GCC */
#endif /* __GNUC__ */

/* 
 * Don't look at GCC or __GNUC__ , since even gcc's cpp can be old style
 * when gcc invoked with -traditional-cpp.
 * The real indication is the __STDC__ preprocessor define.
 */
#if defined(__STDC__) || defined(__cplusplus)
#ifndef __TOKEN_MERGER__
#define __TOKEN_MERGER__
#endif /* __TOKEN_MERGER__ */
#endif /* __STDC__ */


#define _SN_VERBATIM_(x) x
#if defined(__STDC__) || defined(__cplusplus)
# define _SN_STRINGIFY_(x) #x
# define _SN_JOIN_(a,b) a##b
#else
# define _SN_STRINGIFY_(x) "x"
# define _SN_JOIN_(a,b) _SN_VERBATIM_(a)_SN_VERBATIM_(b)
#endif


#undef _SN_ANSI_ARGS_

#if defined(__STDC__) || defined(__cplusplus)
#   define _SN_ANSI_ARGS_(x)	x
#else
#   define _SN_ANSI_ARGS_(x)	()
#endif


#endif /* _CPP_H_ */



/* #include regexp.h */
/*
 * Definitions etc. for regexp(3) routines.
 *
 * Caveat:  this is V8 regexp(3) [actually, a reimplementation thereof],
 * not the System V one.
 */
#ifndef regexp_included
#define regexp_included

#define NSUBEXP  36
typedef struct sn_regexp {
	char *startp[NSUBEXP];
	char *endp[NSUBEXP];
	char regstart;		/* Internal use only. */
	char reganch;		/* Internal use only. */
	char *regmust;		/* Internal use only. */
	int regmlen;		/* Internal use only. */
	char program[1];	/* Unwarranted chumminess with compiler. */
} sn_regexp;

typedef struct sn_regexp *sn_pattern;

#endif

extern int sn_regexp_dont_reset_flag;



#define MAX_STRING 256  /* Max no of chars in regular string for display etc.*/
#define MAX_BIG_STRING 4000  /* Max size for a big string (e.g. script) */
		/* Max no of strings that a single split can split into */
		/* Also max no. of lines that go in mem, max no of files */
#define MAX_CHARS_IN_LIST 100000  /* Max no of chars in an flist */

/* ---- Basic types */

#ifndef TRUE
#define FALSE	0x00
#define TRUE	0x01
#endif

#ifndef	__cplusplus
typedef unsigned int bool;
#define SN_UNSPEC_PARAMS_LIST () 
#else
#define SN_UNSPEC_PARAMS_LIST (...)
#endif
typedef int (*sn_routine_pointer_type) SN_UNSPEC_PARAMS_LIST;
typedef unsigned int sn_bool;

typedef char *SN_STRING;

#define SN_S0(_x) sub("\\0", _x)
#define SN_S1(_x) sub("\\1", _x)
#define SN_S2(_x) sub("\\2", _x)
#define SN_S3(_x) sub("\\3", _x)
#define SN_S4(_x) sub("\\4", _x)
#define SN_S5(_x) sub("\\5", _x)
#define SN_S6(_x) sub("\\6", _x)
#define SN_S7(_x) sub("\\7", _x)
#define SN_S8(_x) sub("\\8", _x)
#define SN_S9(_x) sub("\\9", _x)

#define SN_CHOP(_x) {(_x)[strlen(_x)-1] = '\0';}

#endif

/* extern.h - procedures and macros for snoopy ~~~~~~~~~~~~~~~~~~~~~~~~~~~ */

/* ----- Macros */

SN_EXTERNC int * sn_init_hash();	 /* */
SN_EXTERNC void sn_put_hash(); 	/* table, string, number */
SN_EXTERNC int sn_get_hash();		 /*table, string*/


/* String routines */

SN_EXTERNC sn_bool sn_str_empty();	 /*string*/
SN_EXTERNC sn_bool str_eq();		 /*s1, s2*/
SN_EXTERNC sn_bool sn_match();		 /*string, pattern, compiled*/
SN_EXTERNC sn_bool insensitive_match(); /*string, pattern, compiled*/
SN_EXTERNC sn_bool match_next();	/*string, pattern, compiled, before, delim*/
SN_EXTERNC void init_match();	 /*compiled*/
SN_EXTERNC SN_STRING make_case_insensitive();  /* string */
SN_EXTERNC SN_STRING sub();		 /*string, compiled*/
SN_EXTERNC int split();		 /*pattern, string, &list*/
SN_EXTERNC SN_STRING join();		 /*string, list, length*/
SN_EXTERNC SN_STRING replace(); 	 /*string, pattern, compiled, replacement */

SN_EXTERNC SN_STRING ts1();		 /*string*/

SN_EXTERNC int str_num();		 /*string*/
SN_EXTERNC SN_STRING substr();		 /*string, from, length ->  string */

/* ALLOC */

SN_EXTERNC void init_snoopy();

SN_EXTERNC int sn_min();		/*   num1, num2 -> min */
SN_EXTERNC int sn_max();		/*   num1, num2 -> max */
/* System routines */

#ifndef FAKE_E
#ifdef __STDC__
SN_EXTERNC SN_STRING sf(SN_STRING format, ...);
SN_EXTERNC void sn_out(SN_STRING, ...);		/* format, a, b, c, d, e, f - to stdout */
SN_EXTERNC void sn_error(SN_STRING, ...);		/* format, a, b, c, d, e, f - and exits */
SN_EXTERNC void sn_fatal(SN_STRING, ...);		/* format, a, b, c, d, e, f - and exits */
#else /* __STDC__ */
SN_EXTERNC SN_STRING sf();
SN_EXTERNC void sn_out();		/* format, a, b, c, d, e, f - to stdout */
SN_EXTERNC void sn_error();		/* format, a, b, c, d, e, f - and exits */
SN_EXTERNC void sn_fatal();		/* format, a, b, c, d, e, f - and exits */
#endif /* __STDC__ */
#endif /* FAKE_E */
/* #include list.h */
    /***********************************************************************
    * COPYRIGHT (c) 1996,1997 Verisity Ltd., all rights                    *
    * reserved. This software is furnished under a license and may be used *
    * and copied only in accordance of the terms of such license and with  *
    * the inclusion of the above copyright notice.                         *
    ***********************************************************************/

#ifndef LIST_H
#define LIST_H

/* -- List macros (see proto.doc) */
/* the list holds 3 fields:
    d__: as for every struct, the type index.
    gen__: as for every struct, the generation field, a reserved element for marking.
    data: the actual data which is scalars (integers) or pointer to structures.
    and another 4 hidden fields: 
    reserved:  a reserved element for marking (e.g data[-4])
    size: the number of elements in the current list. (e.g data[-3])
    allocated: the number of allocated elements for the list (not including 
    the first & last).  (e.g data[-2])
    hash: a pointer to a hash table.  (e.g data[-1]) 
	List and list with key are two diffrent types now.*/

/* Basic list structure */
typedef struct s__list {
    int d__;
    int gen__;
    int *data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *t__list;


#define INIT_LIST_SIZE 12
#define ELEM2SIZE(_num) ((_num) * sizeof(int *))
#define FORWARD(_num) (_num)
#define BACKWARD(_num) (_num)

#define LIST(_lvar) ((t__list)(_lvar)) /* Casting */
#define LIST_ITEM(_lvar,index) ((_lvar)->data[index])
#define LIST_ITEM_WITH_CHECK(_lvar,index) (LIST_ITEM_EXISTS(_lvar, index)? LIST_ITEM(_lvar,index):(sn_error("list %s - cannot access item %d",(LIST_IS_EMPTY(_lvar) ? "is empty" :sf("has only %d items", LIST_SIZE(_lvar))), index),LIST_ITEM(_lvar,index))) 
#define LIST_HASH(_lvar)  ((LIST(_lvar)->hash))/* Pointer to the hash table */
#define LIST_ALLOCATED(_lvar) (LIST(_lvar)->allocated)
#define LIST_RESERVED(_lvar)  (LIST(_lvar)->reserved)
	/* Where item 0 starts in list */
#define SIZE_CELL(_lvar) ((LIST(_lvar)->size))
#define LIST_SIZE(_lvar) SIZE_CELL(_lvar)
#define SN_LIST_SIZE(li) (sn_list_size(li))

#define NKEY -1 /* For non key */
#define SKEY 0  /* For string keys */
#define IKEY 1  /* For int keys */
#define TKEY 2  /* For struct keys */
#define LKEY 3  /* For long keys */
#define FKEY 4  /* For float keys */
#define DKEY 5  /* For double keys */



#ifndef FAKE_E
#define LIST_ITEM_CAST_LIST(_lvar,_index) LIST_ITEM((_lvar),(_index))
#else
#define LIST_ITEM_CAST_LIST(_lvar,_index) LIST_ITEM(LIST(_lvar),(_index))
#endif /* FAKE_E */

/* NOTE: the ordering between adding an element and incrementing the
   list size is *important*!  don't let the urge for microoptimization
   get you. */

#define LIST_ADD(_lvar, _svar) \
    do { if (LIST_SIZE(_lvar) >= LIST_ALLOCATED(_lvar)) \
         list_add_helper(LIST(_lvar), TRUE); \
	(_lvar)->data[SIZE_CELL(_lvar)] = (_svar); ++SIZE_CELL(_lvar); } while (0)

#define LIST_ADD_MALLOC(_lvar, _svar) \
    do { if (LIST_SIZE(_lvar) == LIST_ALLOCATED(_lvar)) \
         list_add_helper(LIST(_lvar), FALSE); \
      (_lvar)->data[SIZE_CELL(_lvar)] = (_svar); ++SIZE_CELL(_lvar); } while (0)

/* init the list's struct */
#define MAKE_NEW_LIST_MALLOC(_lvar, _d__)  do { \
    t__list tmp_v = (t__list)calloc(1,sizeof(struct s__list)); \
 	(_lvar) = (void *)tmp_v; \
	LIST(_lvar)->d__ = (_d__); \
} while (0)
#define MAKE_NEW_LIST(_lvar, _d__) do {  \
    t__list tmp_v = (t__list)sn_get_block (SN_BYTES2WORDS (sizeof (struct s__list)), sn_block_TYPED, TRUE); \
	(_lvar) = (void *) tmp_v; \
	LIST(_lvar)->d__ = (_d__);\
} while (0)

#define LIST_ADD_LIST(_lvar, _svar) \
	list_add_list_helper(LIST(_lvar), LIST(_svar))

#define LIST_INIT(_lvar, _size, _full, _value, _keep_old) \
	list_init_helper(_lvar, _size, _full, _value, _keep_old)

#define LIST_IS_EMPTY(_lvar)   (LIST_SIZE(_lvar) == 0)

#define LIST_CLEAR(_lvar)  do { SIZE_CELL(_lvar) = 0; } while (0)

#define LIST_CLEAR_AND_FREE_ELTS(l) do { \
    int i__; void *p__; LIST_FOR_EACH (l, p__, i__) { if (p__) free (p__); } \
    LIST_CLEAR (l); } while (0)

#define SN_REM_DATA(_list) do { SIZE_CELL(_list) = 0; LIST_ALLOCATED(_list) = 0; (_list)->data = NULL;} while (0)

#define LIST_ALLOC_SIZE(_lvar) LIST_ALLOCATED(_lvar)
	/* Size allocated for that list, in items */

#define LIST_ITEM_EXISTS(_lvar, _index)  ((_index) >= 0 && (_index) < LIST_SIZE(_lvar))

     /* Delete the item number _index from the list _lvar and 
        put there the last item in the list */
#define LIST_DELETE(_lvar, _index, _stype) \
    do { LIST_ITEM(_lvar,_index) = LIST_ITEM(_lvar,--SIZE_CELL(_lvar)); } while (0) 
#define LIST_KEY_FAST_DELETE(_lvar, _kval, _kcode, _index) \
    list_key_fast_delete_helper((t__list)(_lvar), _kval, _kcode, _index)

#define LIST_POP(_lvar, _stype) \
    ((_stype) LIST_ITEM_CAST_LIST((_lvar),--SIZE_CELL(_lvar)))

#define LIST_TOP(_lvar, _stype) \
    (LIST_ITEM_CAST_LIST(_lvar,LIST_SIZE(_lvar) - 1))


#define LIST_INSTANCE_ADD_CHECK(_lvar,_list_string) \
     ((LIST_RESERVED(_lvar) == 1)?\
      (sn_error("Can not modify '%s', it is reference to instance.",_list_string),0):0) 

#define INIT_UNIT_LIST_DATA(_lvar, _is_inst) \
     do { LIST_RESERVED(_lvar) = (_is_inst) ; } while (0)

#define LIST_FOR_EACH(_lvar1, _svar, _index) \
	   for(_index = 0; \
               ((_index) < LIST_SIZE(_lvar1)) &&  \
	       (_svar = LIST_ITEM_CAST_LIST((_lvar1), _index),1); \
			++(_index))

     /**  The following list_for_each eval the list size only once at the beggining **/
#define LIST_FOR_EACH_LIMITED(_lvar1, _svar, _index, _limit) \
           for(_index = 0; \
               ((_index) < (_limit))  &&  \
	       (_svar = LIST_ITEM_CAST_LIST((_lvar1), _index),1); \
			      ++(_index))

#define LIST_FOR_EACH_REVERSE(_lvar1, _svar, _index) \
	     for(_index = LIST_SIZE(_lvar1) - 1; \
		 ((_index) >= 0)  && ((_svar) = LIST_ITEM_CAST_LIST((_lvar1),(_index)),1); \
		  --(_index))

#define LIST_APPEND(_lto, _lfrom, _ltype) \
    do { _ltype _elem; int _tmp; \
        LIST_FOR_EACH(_lfrom,_elem,_tmp) { \
	    LIST_ADD(_lto,_elem); \
	} \
    } while (0)

#define FREE_MALLOCED_LIST(_list) { if((_list)->data) { free(BACKWARD((_list)->data)); } free(_list); }

#define LIST_KEY_ADD(_lvar, _str, _kt) \
	list_key_add_helper((t__list)(_lvar), (SN_STRING)(_str), _kt, LIST_SIZE(_lvar)-1)

#define LIST_KEY_POP(_lvar, _str, _kt) \
	list_key_pop_helper((t__list)(_lvar), (SN_STRING)(_str), _kt)

#define LIST_KEY_IN(_lvar, _str, _kt)  \
	list_key_in_helper((t__list)(_lvar), (SN_STRING)(_str), _kt)

#define LIST_KEY_GET(_lvar, _str, _kt, _stype) \
    ((_stype) list_key_get_helper((t__list)(_lvar), (SN_STRING)(_str), _kt))

#define LIST_KEY_INDEX(_lvar, _str, _kt)  \
	list_key_index_helper((t__list)(_lvar), (SN_STRING)(_str), _kt)

#define LIST_KEY_CLEAR(_lvar, _keycode)  list_key_clear_helper((t__list)(_lvar), _keycode)


#define LIST_KEY_ADD_CHECK(_lvar2, _svar2, _str2, _kt2, _error) \
   do {if (LIST_KEY_IN(_lvar2,_str2,_kt2)) sn_error(_error); \
    LIST_ADD(_lvar2,_svar2); LIST_KEY_ADD(_lvar2,_str2,_kt2);} while (0)

#define HAS_A_KEY(_type) (IS_A_LIST(_type) && AS(t__list_descriptor, _type)->kind != key_kind__none)
#define FIELD_HAS_A_KEY(_field) (HAS_A_KEY((_field)->base_type))

#define KEY_NUM(_type) (AS(t__list_descriptor, _type)->key_field_no)
#define FIELD_KEY_NUM(_field) (KEY_NUM((_field)->base_type))

#define KEY_KIND(_type) (AS(t__list_descriptor, _type)->kind)
#define FIELD_KEY_KIND(_field) (KEY_KIND((_field)->base_type))

#define FIELD_OF_INDEX(_instance,_index) (((int *)(_instance))[(_index) + 2])
#define FIELD_OF_KEY(_instance,_list_type) FIELD_OF_INDEX(_instance,KEY_NUM(_list_type))

/* TCMS */
#define IS_TCM_METHOD(_m) (index_is_a_child_of((_m)->d__, d__tcm))
#define IS_TCM(_ar) ((_ar)->method == NULL ? FALSE : IS_TCM_METHOD((_ar)->method))
#define AS_TCM(_ar) ((t__script_instance)(_ar))
#define AS_TCM_IF(_ar) (IS_TCM(_ar) ? AS_TCM(_ar) : NULL)
#define GLOB_CAR_ME(_m) ((t__any_struct)(IS_TCM(GLOB_CAR) ? AS_TCM(GLOB_CAR)->owner : ((SN_TYPE(any_struct))(CAR_VALUE(LIST_ITEM((_m)->scope->locals,0))))))
#define EVAL_CAR_ME(_m) ((t__any_struct)(IS_TCM(GLOB_CAR) ? AS_TCM(GLOB_CAR)->owner : ((SN_TYPE(any_struct))(LIST_ITEM(GLOB_CAR->values, 0)))))
#define SET_LAST_SI_CAR(_ar) {GLOB->session->last_si = _ar; GLOB_CAR = _ar;}

/* pack */
#define BIT_EXTRACT_WORK(_low_exp,_high_exp,_size_shift) (GLOB_ST->use_bits_taken = TRUE, sn_switch_bits_taken(_low_exp,_high_exp,_size_shift))

#define DEBUG_CODE_GEN(_d_index,_exp_code) ((((t__debug)(GLOB->debug))->packing) ? sn_out(sf("> Packing %s: = any_to_string(%s,%s)",_exp_code,_d_index)) : (void) 0)

#define CALL_DISPATCH_PACK(_options,_lob,_exp,_d_index) (DISPATCH(pack_item,GLOB->packing,packing,(GLOB->packing,_options,_lob,_exp,LIST_ITEM(GLOB->all_types, _d_index),TRUE)), GLOB_ST->use_bits_taken = FALSE)

/* error messages */
#define ERROR_STRING(_exp) ((SN_STRING)DISPATCH(error_string,_exp,ntv,(_exp)))
#define SET_SOURCE_ON_ERR(_source) DISPATCH(add_source,GLOB->session->src_on_runtime,src_on_runtime,(GLOB->session->src_on_runtime,_source))

#define RESET_SOURCE_ON_ERR  DISPATCH(get_source,GLOB->session->src_on_runtime,src_on_runtime,(GLOB->session->src_on_runtime))

#define STORE_PACK(_str)  do { old_packed =  GLOB_ST->currently_packed_string;\
                                                          GLOB_ST->currently_packed_string = _str; } while (0)
#define RELEASE_PACK do { GLOB_ST->currently_packed_string = old_packed; } while (0)


#define SN_LIST_GET(li,index,type) (((SN_TYPE(type))sn_list_get((SN_TYPE(list))(li),(index))))
#define SN_LIST_SET(li,index,item) (sn_list_set((SN_TYPE(list))(li),(index),(void*)(item)))
#define SN_LIST_ADD(li,item) (sn_list_add((SN_TYPE(list))(li),(void*)(item)))
#define SN_LIST_CHANGE(li,size) (sn_list_change((SN_TYPE(list))(li),(size)))

SN_EXTERNC int sn_list_size SN_UNSPEC_PARAMS_LIST;
SN_EXTERNC void *sn_list_get SN_UNSPEC_PARAMS_LIST;
SN_EXTERNC void sn_list_set SN_UNSPEC_PARAMS_LIST;
SN_EXTERNC void sn_list_add SN_UNSPEC_PARAMS_LIST;
SN_EXTERNC void sn_list_change SN_UNSPEC_PARAMS_LIST;

/* #include list_ix.h */

#ifndef _LIST_IX_H_
#define _LIST_IX_H_

/* #include cpp.h */
#ifndef _CPP_H_
#define _CPP_H_


#ifdef __cplusplus
#define SN_EXTERNC extern "C"
#else
#define SN_EXTERNC extern
#endif /* __cplusplus */

#ifdef __GNUC__
#ifndef GCC
#define GCC
#endif /* GCC */
#endif /* __GNUC__ */

/* 
 * Don't look at GCC or __GNUC__ , since even gcc's cpp can be old style
 * when gcc invoked with -traditional-cpp.
 * The real indication is the __STDC__ preprocessor define.
 */
#if defined(__STDC__) || defined(__cplusplus)
#ifndef __TOKEN_MERGER__
#define __TOKEN_MERGER__
#endif /* __TOKEN_MERGER__ */
#endif /* __STDC__ */


#define _SN_VERBATIM_(x) x
#if defined(__STDC__) || defined(__cplusplus)
# define _SN_STRINGIFY_(x) #x
# define _SN_JOIN_(a,b) a##b
#else
# define _SN_STRINGIFY_(x) "x"
# define _SN_JOIN_(a,b) _SN_VERBATIM_(a)_SN_VERBATIM_(b)
#endif


#undef _SN_ANSI_ARGS_

#if defined(__STDC__) || defined(__cplusplus)
#   define _SN_ANSI_ARGS_(x)	x
#else
#   define _SN_ANSI_ARGS_(x)	()
#endif


#endif /* _CPP_H_ */



#ifdef _LIST_IX_C_

#endif /* _LIST_IX_C_ */
SN_EXTERNC t__list make_new_list(int);
SN_EXTERNC t__list make_new_list_init_data(int);
SN_EXTERNC void list_add_helper(t__list, bool);
SN_EXTERNC void list_add_list_helper(t__list, t__list);
SN_EXTERNC t__list list_copy_helper(t__list);
SN_EXTERNC t__list list_get_slice_helper(t__list, int, int, int);
SN_EXTERNC t__list list_get_index_list_helper(t__list, t__list);

#ifndef FAKE_E
/* gaaaaaaag */
struct s__l__untyped;

SN_EXTERNC bool sn_list_equal_helper(struct s__l__untyped *, struct s__l__untyped *);
#endif

SN_EXTERNC void sn_byte_closest_power_fill(void);
SN_EXTERNC unsigned int sn_closest_power(unsigned int);
SN_EXTERNC void list_init_helper(t__list, int, bool, int, bool);
SN_EXTERNC void list_init_malloc_helper(t__list, int);
SN_EXTERNC int *make_new_malloc_helper(int, int);
SN_EXTERNC SN_STRING ms1(SN_STRING);
SN_EXTERNC SN_STRING sn_str_hex(int);
SN_EXTERNC SN_STRING sn_str_bin(int);
SN_EXTERNC t__list list_reverse_helper(t__list);
SN_EXTERNC void list_insert_helper(t__list, int, int);
SN_EXTERNC void list_insert_list_helper(t__list, int, t__list);
SN_EXTERNC void list_delete_helper(t__list, int);
SN_EXTERNC bool item_is_in_list(int, t__list, bool);
SN_EXTERNC void list_assign_slice(t__list, int, t__list, int, bool);
SN_EXTERNC void list_assign_slice_to_slice(t__list, int, int, t__list, int, int);
#endif /* _LIST_IX_H_ */
/* #include list_key_ix.h */

#ifndef _LIST_KEY_IX_H_
#define _LIST_KEY_IX_H_

#ifndef FAKE_E

/* #include cpp.h */
#ifndef _CPP_H_
#define _CPP_H_


#ifdef __cplusplus
#define SN_EXTERNC extern "C"
#else
#define SN_EXTERNC extern
#endif /* __cplusplus */

#ifdef __GNUC__
#ifndef GCC
#define GCC
#endif /* GCC */
#endif /* __GNUC__ */

/* 
 * Don't look at GCC or __GNUC__ , since even gcc's cpp can be old style
 * when gcc invoked with -traditional-cpp.
 * The real indication is the __STDC__ preprocessor define.
 */
#if defined(__STDC__) || defined(__cplusplus)
#ifndef __TOKEN_MERGER__
#define __TOKEN_MERGER__
#endif /* __TOKEN_MERGER__ */
#endif /* __STDC__ */


#define _SN_VERBATIM_(x) x
#if defined(__STDC__) || defined(__cplusplus)
# define _SN_STRINGIFY_(x) #x
# define _SN_JOIN_(a,b) a##b
#else
# define _SN_STRINGIFY_(x) "x"
# define _SN_JOIN_(a,b) _SN_VERBATIM_(a)_SN_VERBATIM_(b)
#endif


#undef _SN_ANSI_ARGS_

#if defined(__STDC__) || defined(__cplusplus)
#   define _SN_ANSI_ARGS_(x)	x
#else
#   define _SN_ANSI_ARGS_(x)	()
#endif


#endif /* _CPP_H_ */



#ifdef _LIST_KEY_IX_C_

#endif /* _LIST_KEY_IX_C_ */

SN_EXTERNC void list_key_add_list_helper(t__list, t__list, SN_STRING, int);
SN_EXTERNC void list_key_add_helper(t__list, SN_STRING, int, int);
SN_EXTERNC void sn_remove_from_hash(t__list, SN_STRING, int);
SN_EXTERNC void list_key_pop_helper(t__list, SN_STRING, int);
SN_EXTERNC void list_key_clear_helper(t__list, int);
SN_EXTERNC bool list_key_in_helper(t__list, SN_STRING, int);
SN_EXTERNC int list_key_index_helper(t__list, SN_STRING, int);
SN_EXTERNC int list_key_get_helper(t__list, SN_STRING, int);

#endif /* FAKE_E */

#endif /* _LIST_KEY_IX_H_ */

#endif /* LIST_H */

/* #include type.h */
    /***********************************************************************
     * COPYRIGHT (c) 1996, 1997 by Verisity Ltd., all rights reserved. *
     * This software is furnished under a license and may be used and       *
     * copied only in accordance of the terms of such license and with the  *
     * inclusion of the above copyright notice.                             *
     ***********************************************************************/

#ifndef TYPE_H
#define TYPE_H


#ifdef __TOKEN_MERGER__

#define DISPATCH(_m, _v, _t, _params) \
    (sn_last_method_index = m__##_t##__##_m, \
	sn_dispatch_tables[_v->d__][m__##_t##__##_m]_params)
        /* E.g. DISPATCH(print_it, my_house, house, (my_house, 3)) */

#define DISPATCH_ON_DESCRIPTOR(_m, _d, _t, _params) \
    (sn_last_method_index = m__##_t##__##_m, \
     sn_last_descriptor_d_index = _d->d_index,   \
	 sn_dispatch_tables[_d->d_index][m__##_t##__##_m]_params)
/* E.g. DISPATCH_ON_DESCRIPTOR(print_it, descriptor, house, (descriptor, 3)) */

#define SN_DISPATCH_DYNAMIC(_m, _v, _t, _params) \
    DISPATCH(call,_v->##_m,sn_dynamic_call__##_t##__##_m,_params)
/* e.g.. DISPATCH_DYNAMIC(set_sig, master_adapter, sn_simulator_adapter, (master_adapter->set_sig,...) */

#else /* __TOKEN_MERGER__ */

#define DISPATCH(_m, _v, _t, _params) \
        (sn_last_method_index = m__/**/_t/**/__/**/_m, \
         sn_dispatch_tables[_v->d__][m__/**/_t/**/__/**/_m]_params)
        /* E.g. DISPATCH(print_it, my_house, house, (my_house, 3)) */

#define DISPATCH_ON_DESCRIPTOR(_m, _d, _t, _params) \
          (sn_last_method_index = m__/**/_t/**/__/**/_m, \
           sn_last_descriptor_d_index = _d->d_index, \
	   sn_dispatch_tables[_d->d_index][m__/**/_t/**/__/**/_m]_params)
          /* E.g. DISPATCH_ON_DESCRIPTOR(print_it, descriptor, house, (descriptor, 3)) */

#define SN_DISPATCH_DYNAMIC(_m, _v, _t, _params) \
    DISPATCH(call,_v->/**/_m,sn_dynamic_call__/**/_t/**/__/**/_m,_params)
/* e.g.. DISPATCH_DYNAMIC(set_sig, master_adapter, sn_simulator_adapter, (master_adapter->set_sig,...) */

#endif /* __TOKEN_MERGER__ */

#define SN_SYS (SYS)

#define SN_DISPATCH(_m, _v, _t, _params) DISPATCH(_m,_v,_t,_params)

#ifdef __TOKEN_MERGER__
#define SN_TYPE_ID(type) d__##type
#define SN_LIST_TYPE_ID(type) d__l__##type
#define SN_TYPE(type) t__##type
#define SN_LIST(type) l__##type
#define SN_ENUM(type,val) type##__##val
#define SN_DEFINE(name) SNDEF__##name
#else /* __TOKEN_MERGER__ */
#define SN_TYPE_ID(type) d__/* */type
#define SN_LIST_TYPE_ID(type) d__l__/* */type
#define SN_TYPE(type) t__/* */type
#define SN_LIST(type) l__/* */type
#define SN_ENUM(type,val) type/* */__/* */val
#define SN_DEFINE(name) SNDEF__/* */name
#endif /* __TOKEN_MERGER__ */

#define DISPATCH1(_m1, _v1, _t1) DISPATCH(_m1,_v1,_t1,(_v1))
        /* E.g. DISPATCH1(print_it, my_house, house) */

#define TYPE(_v) LIST_ITEM(GLOB->all_types,(_v)->d__)
        /* The type descriptor of that var */

#define DTYPE(_d) LIST_ITEM(GLOB->all_types,_d)
        /* The type descriptor of the d_index */

#define STRUCT_TYPE(_v1) AS(t__struct_descriptor, TYPE(_v1))
        /* The struct descriptor of that var (no checking that it is a struct */
#define LIST_TYPE(_v1) AS(t__list_descriptor, TYPE(_v1))
        /* The list descriptor of that var (no checking that it is a struct */

#define T_NAME(_td) ((SN_STRING)DISPATCH(c_name,_td,type_descriptor,(_td)))

#define FIELD_NO(_d_index, _field_no) LIST_ITEM(AS(t__struct_descriptor,LIST_ITEM(GLOB->all_types,_d_index))->fields,_field_no)
        /* A way to access a field at runtime */

#define METHOD_NO(_d_index, _method_no) LIST_ITEM(AS(t__struct_descriptor,LIST_ITEM(GLOB->all_types,_d_index))->methods,_method_no)
        /* A way to access a method at runtime */

#define GET_SHORT_NAME(_td) ((SN_STRING)DISPATCH1(get_short_name,_td,type_descriptor))
#define IS_STRING(_td)  ((_td) && ((_td)->short_type == short_type__STRING_TYPE))
#define IS_ENUM(_td)   ((_td) && (_td)->short_type == short_type__ENUM_TYPE)
#define IS_INT(_td)    ((_td) && (_td)->short_type == short_type__INT_TYPE)
#define IS_UINT(_td)    ((_td) && (_td)->short_type == short_type__UINT_TYPE)
#define IS_BOOL(_td)    ((_td) && (_td)->short_type == short_type__BOOL_TYPE)
#define IS_LIST(_td)    ((_td) && (_td)->d__ == d__list_descriptor)
#define IS_COMPOUND(_td)((_td) && (_td)->short_type == short_type__STRUCT_TYPE)
#define IS_STRUCT(_td)  (IS_COMPOUND(_td) && !IS_LIST(_td))
#define IS_SUBTYPE(_td) ((_td) && (_td)->d__ == d__subtype_descriptor)
#define IS_FOREIGN(_td) ((_td) && (_td)->short_type == short_type__OTHER_TYPE)
#define IS_SCALAR(_td)  (IS_INT(_td) ||		\
			   IS_UINT(_td) ||		\
			   IS_ENUM(_td) ||		\
			   IS_BOOL(_td))
#define IS_REAL_STRUCT(_td) ((_td) && IS_STRUCT(_td) && !IS_LONG(_td))

/* to be replaced shortly */
#define IS_A_STRING(_td) IS_STRING(_td)
#define IS_A_SUBTYPE(_td) IS_SUBTYPE(_td)
#define IS_A_LIST(_td) IS_LIST(_td)
#define IS_A_SCALAR(_td) IS_SCALAR(_td)
#define IS_A_STRUCT(_td) IS_STRUCT(_td)
#define IS_AN_ENUM(_td) IS_ENUM(_td)
#define IS_UNTYPED(_td) ((_td) && ((_td)->d_index == d__untyped))

#define ELEM_TYPE(_list) (AS(t__list_descriptor, _list)->base_type)

#define LIST_ELEM_TYPE(_list) ((t__type_descriptor)ELEM_TYPE(TYPE(_list)))

#define IS_UNSIGNED(_td) ((_td)->short_type == short_type__UINT_TYPE || (_td)->short_type == short_type__ENUM_TYPE || (_td)->short_type == short_type__BOOL_TYPE)
        /* All others are considered signed */


#define GET_FIELD(_pointer, _field) (((int *)(_pointer))[(_field)->field_no+2])
   /* _pointer is a pointer to a struct ,
        +2 for the hidden fields: gen__ and d__ */

#define GET_FIELD_BY_NUM(_pointer, _field_num) (((int *)(_pointer))[(_field_num)+2])
   /* _pointer is a pointer to a struct , use to getting the field number on
      compile time and use that number at run time */

#define SAFE_GET_FIELD(_pointer, _field) safe_get_field_helper(_pointer, _field)

#define SAFE_PUT(_new, _old, _des, _string) \
   {if (!safe_put_helper((int **)&(_new), (int **)&(_old), _des)) sn_error(_string);}

#define TYPE_PUT(_var, _name, _module, _desc, _string) \
    {sn_type_put_helper(&(_var), _name, _desc, _string);}


#define MAKE_NEW_ACTION(act, sr_src) \
    MAKE_NEW(act, d__n__action); \
    (act)->source_ref = (sr_src)->source_ref;


#ifdef __TOKEN_MERGER__
/* -- Some definitions for writing macro methods */
#define DISPATCH_ME(_m, _v, _t, _params)  \
    (sn_last_method_index = m__n__##_t##__##_m, \
    sn_dispatch_tables[me->n__##_v->d__][m__n__##_t##__##_m]_params)
        /* Like DISPATCH(), but on me->n__xxx */
        /* E.g. DISPATCH_ME(do_update, second__exp, exp, (second__exp, so)) */

#define DISPATCH_EACH(_m1, _var, _field, _params1) \
    { \
        t__n__##_field _var; int _temp;\
        LIST_FOR_EACH(me->n__##_field##s,_var,_temp) { \
            DOING(_var); \
            DISPATCH(_m1,_var,n__##_field,_params1); \
            DOING(me); \
        } \
    }
        /* Dispatch each _field (call it _var) using _method with _params */
        /* E.g. DISPATCH_EACH(do_update, sm, struct_memeber, (sm, me->sd)) */

#define DISPATCH_ME1(_m1, _v1, _t1)  \
        DISPATCH_ME(_m1,_v1,_t1,(me->n__##_v1))
        /* Like DISPATCH1(), but on me->n__xxx */
        /* E.g. DISPATCH_ME1(do_update, second__exp, exp) */

#else /* __TOKEN_MERGER__ */

/* -- Some definitions for writing macro methods */
#define DISPATCH_ME(_m, _v, _t, _params)  \
    (sn_last_method_index = m__n__/**/_t/**/__/**/_m, \
    sn_dispatch_tables[me->n__/**/_v->d__][m__n__/**/_t/**/__/**/_m]_params)
        /* Like DISPATCH(), but on me->n__xxx */
        /* E.g. DISPATCH_ME(do_update, second__exp, exp, (second__exp, so)) */

#define DISPATCH_EACH(_m1, _var, _field, _params1) \
    { \
        t__n__/**/_field _var; int _temp;\
        LIST_FOR_EACH(me->n__/**/_field/**/s,_var,_temp) { \
            DOING(_var); \
            DISPATCH(_m1,_var,n__/**/_field,_params1); \
            DOING(me); \
        } \
    }
        /* Dispatch each _field (call it _var) using _method with _params */
        /* E.g. DISPATCH_EACH(do_update, sm, struct_memeber, (sm, me->sd)) */

#define DISPATCH_ME1(_m1, _v1, _t1)  \
        DISPATCH_ME(_m1,_v1,_t1,(me->n__/**/_v1))
        /* Like DISPATCH1(), but on me->n__xxx */
        /* E.g. DISPATCH_ME1(do_update, second__exp, exp) */
#endif /* __TOKEN_MERGER__ */

#define UPDATE_TYPE_FIELD(_struct,_field,_value)        {                       \
        SN_TYPE(struct_descriptor) ccc_sd;                                      \
        SN_TYPE(struct_descriptor) ccc_child;                                   \
        int i;                                                                  \
        for(ccc_sd = _struct;IS_SUBTYPE(ccc_sd);				\
	    ccc_sd = (SN_TYPE(struct_descriptor))ccc_sd->parent) { 		\
		; /* do nothing */						\
	}   									\
        ccc_sd->_field = _value;                                                \
        LIST_FOR_EACH(ccc_sd->children,ccc_child,i) {                           \
                if(IS_SUBTYPE(ccc_child) &&                                     \
                   (SN_TYPE(struct_descriptor))DISPATCH(subtype_parent,ccc_child,struct_descriptor,(ccc_child)) == ccc_sd) {               \
                        ccc_child->_field = _value;                             \
                }                                                               \
        }                                                                       \
}

extern sn_routine_pointer_type **sn_dispatch_tables;
SN_EXTERNC bool safe_put_helper(int **, int **, int);

#endif /* TYPE_H */


/* #include mm.h */
#ifndef MM_H_
#define MM_H_

/* #include filtered_block_c_defines.h */
#ifndef _FILTERED_BLOCK_C_DEFINES_H_
#define _FILTERED_BLOCK_C_DEFINES_H_

/* 
   The filtered blocks groups.
   The words "ZERO" , "ONE", etc. should be replaced by meaningful 
   names. 
   
   For example:
   
   #define SN_FILTER_GROUP_packing 0 
   #define SN_FILTER_GROUP_loading 1
   #define SN_FILTER_GROUP_assignment 2
   ...
*/
#define SN_FILTER_GROUP_ZERO 0 
#define SN_FILTER_GROUP_ONE 1
#define SN_FILTER_GROUP_TWO 2
#define SN_FILTER_GROUP_THREE 3
#define SN_FILTER_GROUP_FOUR 4
#define SN_FILTER_GROUP_FIVE 5
#define SN_FILTER_GROUP_SIX 6
#define SN_FILTER_GROUP_SEVEN 7
#define SN_FILTER_GROUP_EIGHT 8
#define SN_FILTER_GROUP_NINE 9
#define SN_FILTER_GROUP_TEN 10
#define SN_NUM_OF_FILTERED_BLOCK_GROUPS 11

/* three levels of filtered blocks */
#define SN_FILTERED_BLOCK_transparent 0
#define SN_FILTERED_BLOCK_light 1
#define SN_FILTERED_BLOCK_heavy 2

/* the default is transparent */
#ifndef SN_COMPILATION_FILTERED_BLOCK_LEVEL
#define SN_COMPILATION_FILTERED_BLOCK_LEVEL SN_FILTERED_BLOCK_transparent
#endif

/*the filtered blocks manager*/
#define FILTERED_BLOCKS_MANAGER (GLOB->parse->filtered_blocks_manager)

/* compile and runtime filter checks. 
   Return a boolean value: TRUE iff the parateter(s) pass the filter */
#ifdef __TOKEN_MERGER__
#define SN_FILTER_COMPILE_COND(level) (SN_FILTERED_BLOCK_##level <= SN_COMPILATION_FILTERED_BLOCK_LEVEL)
#define SN_FILTER_RUNTIME_COND(level,group)\
(SN_FILTERED_BLOCK_##level <= LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_##group))
#else /* __TOKEN_MERGER__ */
#define SN_FILTER_COMPILE_COND(level) (SN_FILTERED_BLOCK_/**/level <= SN_COMPILATION_FILTERED_BLOCK_LEVEL)
#define SN_FILTER_RUNTIME_COND(level,group)\
(SN_FILTERED_BLOCK_/**/level <= LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_/**/group))
#endif /* __TOKEN_MERGER__ */
     
     /* heavy compilation filter */
#if SN_FILTER_COMPILE_COND(heavy)
#define SN_ASSERT_heavy(group, exp, msg) do { \
     if (SN_FILTER_RUNTIME_COND(heavy,group) && (! (exp) )) \
         { SN_ERR(ERR_FILTERED_ASSERT,( #group ,__LINE__,__FILE__, #exp ,msg)); } } while (0)
#define SN_FILTER_heavy(group, block) do { \
     if (SN_FILTER_RUNTIME_COND(heavy,group)) { block; } } while (0)
#else
#define SN_ASSERT_heavy(group, exp, msg) 
#define SN_FILTER_heavy(group,block)
#endif /*SN_FILTER_COMPILE_COND(heavy)*/
	 
	 /* light or heavy compilation filter */
#if SN_FILTER_COMPILE_COND(light)
#define SN_ASSERT_light(group, exp, msg) do { \
     if ( SN_FILTER_RUNTIME_COND(light,group) && (! (exp) )) \
         { SN_ERR(ERR_FILTERED_ASSERT,( #group ,__LINE__,__FILE__, #exp ,msg)); } } while (0)
#define SN_FILTER_light(group,block) do { \
     if (SN_FILTER_RUNTIME_COND(light,group)) { block; } } while (0)
#else
#define SN_ASSERT_light(group, exp, msg)
#define SN_FILTER_light(group,block) 
#endif /*SN_FILTER_COMPILE_COND(light)*/

	 /* set filter macros*/
#ifdef __TOKEN_MERGER__
#define SN_SET_FILTER_AID(level,group) do { \
     LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_##group) \
	 = SN_FILTERED_BLOCK_##level ; } while (0)
#else /* __TOKEN_MERGER__ */
#define SN_SET_FILTER_AID(level,group) do { \
     LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_/**/group) \
         = SN_FILTERED_BLOCK_/**/level ; } while (0)
#endif /* __TOKEN_MERGER__ */

#define SN_SET_FILTER_all(group) SN_SET_FILTER_AID(heavy, group)
#define SN_SET_FILTER_light(group) SN_SET_FILTER_AID(light, group)
#define SN_SET_FILTER_off(group) SN_SET_FILTER_AID(transparent, group)

	 /*The public macros:*/	 
#ifdef __TOKEN_MERGER__
#define SN_ASSERT(level,group, exp, msg) SN_ASSERT_##level(group,exp,msg)
#define SN_FILTER(level, group, block) SN_FILTER_##level(group,block)
#define SN_SET_FILTER(flag,group) SN_SET_FILTER_##flag(group)
#else /* __TOKEN_MERGER__ */
#define SN_ASSERT(level,group, exp, msg) SN_ASSERT_/**/level(group,exp,msg)
#define SN_FILTER(level, group, block) SN_FILTER_/**/level(group,block)
#define SN_SET_FILTER(flag,group) SN_SET_FILTER_/**/flag(group)
#endif /* __TOKEN_MERGER__ */


#endif /* _FILTERED_BLOCK_C_DEFINES_H_ */

typedef enum {
    sn_block_PTRFREE = 0,
    sn_block_TYPED = 1,
    sn_block_STRING = 2,
    sn_block_BP = 3
} sn_block_type_t;

#define SN_N_BLOCK_TYPES 4

/* get a block (possibly from freelist) */
void *sn_get_block (int size, sn_block_type_t type, unsigned int clear);

/* direct from memory (not guarranteed to be cleared!) */
void *sn_get_fresh_block (int *size, sn_block_type_t type);

/* like sn_get_block, but will correct the size in case it's actually
   bigger */
void *sn_get_block_ext (int *size, sn_block_type_t type, unsigned int clear);

void *sn_realloc_block (void *block, int old_size, int *new_size, sn_block_type_t new_type);

void sn_free_block (void *block, int size, sn_block_type_t type);

/* somewhat higher-level: */
void *sn_alloc_typed (int d__, unsigned int clear);

/* queries */
int sn_is_a_legal_address (void *ptr, unsigned int is_start_of_block);

struct sn_allocator_t *sn_get_current_allocator (void);
struct sn_allocator_t *sn_set_allocator (struct sn_allocator_t *);
struct sn_allocator_t *sn_make_allocator (unsigned int threshold, unsigned int increment, unsigned int max);
void sn_destroy_allocator (struct sn_allocator_t *);

unsigned int sn_should_gc (void);
void sn_do_copy_and_compact (void);

void sn_do_mark_and_sweep (void);
void sn_do_mark_and_sweep_if_possible (void);

void sn_update_type_infos (void);
void sn_patch_type_infos (void);

void sn_update_ms_threshold (void);

unsigned int sn_gc_total_size (void);
unsigned int sn_gc_live_size (void);

void sn_alloc_list_data (struct s__list *, int);
void sn_realloc_list_data (struct s__list *, int);
void sn_realloc_list_data_to (struct s__list *, int);
void sn_free_list_data (struct s__list *);

#define SN_BYTES2WORDS(x) (((x) / sizeof (int)) + (((x) & (sizeof (int) - 1)) + sizeof (int) - 1) / sizeof (int))

/* options */
unsigned int sn_free_small_blocks_in_current_segment (unsigned int arg);
int sn_big_block_search_iterations (int arg);

/* danger! this should be done *before* any allocation! */
unsigned int sn_pre_clear_memory (unsigned int arg);

unsigned int sn_explicit_freeing (unsigned int arg);

void sn_init_mm ();

void sn_mm_reset_stats (void);

void sn_gc_register_root_range (void *from, int len);

#define SN_GC_REGISTER_ROOT(x) sn_gc_register_root_range (&(x), 1)

/* pretend you don't see these */
extern void *sn_stack_base;

extern unsigned int sn_gc_block_ms;

extern unsigned int sn_gc_all_fields_matter;

unsigned int sn_gc_get_block_ms (void);
void sn_gc_set_block_ms (unsigned int);
int sn_gc_random_value_up_to (int);

typedef unsigned int sn_word_t;
#define SN_WORD_SIZE sizeof (sn_word_t)
#define SN_WORD_BIT_SIZE (sizeof (sn_word_t) * 8)
#define SN_WORD_ADDR_MASK (~(SN_WORD_SIZE - 1))

/* food */

extern unsigned int sn_gc_sandwich;

#define SN_GC_SANDWICH_ASSERT(cond) do { if (!(cond)) abort (); } while (0)

extern unsigned int sn_gc_block_ms_save;

void sn_sim_enter_specman (void *base_addr);
void sn_sim_exit_specman (void);

#define SN_GC_BITE(addr) \
    do { if (sn_gc_sandwich++) { \
            if (sn_gc_sandwich == 2) sn_gc_block_ms_save = sn_gc_block_ms; \
            sn_gc_block_ms = 1; } \
         else { \
            sn_stack_base = addr; \
            SN_GC_MAYBE_MS; } \
         SN_GC_SANDWICH_ASSERT (sn_gc_sandwich > 0); } while (0)

#define SN_GC_SPIT_OUT \
    do { if (--sn_gc_sandwich) { \
            if (sn_gc_sandwich == 1) { \
               sn_gc_block_ms = sn_gc_block_ms_save; \
               SN_GC_MAYBE_MS; } } \
         SN_GC_SANDWICH_ASSERT (sn_gc_sandwich >= 0); } while (0)

extern int sn_currently_in_simulator__;

#define SN_SIM_ENTER_SPECMAN(addr) \
    do { if (sn_currently_in_simulator__) { \
            sn_currently_in_simulator__ = 0; \
            SN_GC_BITE(addr); } } while (0)

#define SN_SIM_EXIT_SPECMAN \
    do { if (!sn_currently_in_simulator__) { \
            SN_GC_SPIT_OUT; \
            sn_currently_in_simulator__ = 1; } } while (0)

#if SN_FILTER_COMPILE_COND(heavy)
#define SN_GC_MAYBE_MS do { \
    if (sn_can_use_filters) \
       SN_FILTER_heavy (FOUR, { sn_do_mark_and_sweep_if_possible (); }); } while (0)
#else
#define SN_GC_MAYBE_MS
#endif

/* profiling */

extern unsigned int sn_gc_mem_prof;
void sn_set_mem_prof_bound (unsigned int bound);

/* stuff */

extern int sn_gc_disable_count;
extern unsigned int sn_gc_was_disabled;

#define SN_GC_DISABLE_ON_THE_FLY \
    do { if (!(sn_gc_disable_count++)) { \
            sn_gc_was_disabled = sn_gc_block_ms; \
            sn_gc_block_ms = 1; } } while (0)

#define SN_GC_ENABLE_ON_THE_FLY \
    do { if (!sn_gc_disable_count) sn_fatal ("too many calls to SN_GC_ENABLE_ON_THE_FLY");\
         if (!(--sn_gc_disable_count)) sn_gc_block_ms = sn_gc_was_disabled; } while (0)

#ifndef FAKE_E
int sn_gc_translate_struct_address (int addr);
unsigned int sn_gc_struct_is_live (int addr);
#endif

/* filtering */

#define SN_GC_FILTER_GENERAL  ZERO
#define SN_GC_FILTER_ROOTS    ONE
#define SN_GC_FILTER_REPORTING TWO
#define SN_GC_FILTER_SANDWICH THREE

/* death */
void sn_gc_prepare_to_die (void);

#ifndef FAKE_E

/* #include filtered_block_c_defines.h */
#ifndef _FILTERED_BLOCK_C_DEFINES_H_
#define _FILTERED_BLOCK_C_DEFINES_H_

/* 
   The filtered blocks groups.
   The words "ZERO" , "ONE", etc. should be replaced by meaningful 
   names. 
   
   For example:
   
   #define SN_FILTER_GROUP_packing 0 
   #define SN_FILTER_GROUP_loading 1
   #define SN_FILTER_GROUP_assignment 2
   ...
*/
#define SN_FILTER_GROUP_ZERO 0 
#define SN_FILTER_GROUP_ONE 1
#define SN_FILTER_GROUP_TWO 2
#define SN_FILTER_GROUP_THREE 3
#define SN_FILTER_GROUP_FOUR 4
#define SN_FILTER_GROUP_FIVE 5
#define SN_FILTER_GROUP_SIX 6
#define SN_FILTER_GROUP_SEVEN 7
#define SN_FILTER_GROUP_EIGHT 8
#define SN_FILTER_GROUP_NINE 9
#define SN_FILTER_GROUP_TEN 10
#define SN_NUM_OF_FILTERED_BLOCK_GROUPS 11

/* three levels of filtered blocks */
#define SN_FILTERED_BLOCK_transparent 0
#define SN_FILTERED_BLOCK_light 1
#define SN_FILTERED_BLOCK_heavy 2

/* the default is transparent */
#ifndef SN_COMPILATION_FILTERED_BLOCK_LEVEL
#define SN_COMPILATION_FILTERED_BLOCK_LEVEL SN_FILTERED_BLOCK_transparent
#endif

/*the filtered blocks manager*/
#define FILTERED_BLOCKS_MANAGER (GLOB->parse->filtered_blocks_manager)

/* compile and runtime filter checks. 
   Return a boolean value: TRUE iff the parateter(s) pass the filter */
#ifdef __TOKEN_MERGER__
#define SN_FILTER_COMPILE_COND(level) (SN_FILTERED_BLOCK_##level <= SN_COMPILATION_FILTERED_BLOCK_LEVEL)
#define SN_FILTER_RUNTIME_COND(level,group)\
(SN_FILTERED_BLOCK_##level <= LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_##group))
#else /* __TOKEN_MERGER__ */
#define SN_FILTER_COMPILE_COND(level) (SN_FILTERED_BLOCK_/**/level <= SN_COMPILATION_FILTERED_BLOCK_LEVEL)
#define SN_FILTER_RUNTIME_COND(level,group)\
(SN_FILTERED_BLOCK_/**/level <= LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_/**/group))
#endif /* __TOKEN_MERGER__ */
     
     /* heavy compilation filter */
#if SN_FILTER_COMPILE_COND(heavy)
#define SN_ASSERT_heavy(group, exp, msg) do { \
     if (SN_FILTER_RUNTIME_COND(heavy,group) && (! (exp) )) \
         { SN_ERR(ERR_FILTERED_ASSERT,( #group ,__LINE__,__FILE__, #exp ,msg)); } } while (0)
#define SN_FILTER_heavy(group, block) do { \
     if (SN_FILTER_RUNTIME_COND(heavy,group)) { block; } } while (0)
#else
#define SN_ASSERT_heavy(group, exp, msg) 
#define SN_FILTER_heavy(group,block)
#endif /*SN_FILTER_COMPILE_COND(heavy)*/
	 
	 /* light or heavy compilation filter */
#if SN_FILTER_COMPILE_COND(light)
#define SN_ASSERT_light(group, exp, msg) do { \
     if ( SN_FILTER_RUNTIME_COND(light,group) && (! (exp) )) \
         { SN_ERR(ERR_FILTERED_ASSERT,( #group ,__LINE__,__FILE__, #exp ,msg)); } } while (0)
#define SN_FILTER_light(group,block) do { \
     if (SN_FILTER_RUNTIME_COND(light,group)) { block; } } while (0)
#else
#define SN_ASSERT_light(group, exp, msg)
#define SN_FILTER_light(group,block) 
#endif /*SN_FILTER_COMPILE_COND(light)*/

	 /* set filter macros*/
#ifdef __TOKEN_MERGER__
#define SN_SET_FILTER_AID(level,group) do { \
     LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_##group) \
	 = SN_FILTERED_BLOCK_##level ; } while (0)
#else /* __TOKEN_MERGER__ */
#define SN_SET_FILTER_AID(level,group) do { \
     LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_/**/group) \
         = SN_FILTERED_BLOCK_/**/level ; } while (0)
#endif /* __TOKEN_MERGER__ */

#define SN_SET_FILTER_all(group) SN_SET_FILTER_AID(heavy, group)
#define SN_SET_FILTER_light(group) SN_SET_FILTER_AID(light, group)
#define SN_SET_FILTER_off(group) SN_SET_FILTER_AID(transparent, group)

	 /*The public macros:*/	 
#ifdef __TOKEN_MERGER__
#define SN_ASSERT(level,group, exp, msg) SN_ASSERT_##level(group,exp,msg)
#define SN_FILTER(level, group, block) SN_FILTER_##level(group,block)
#define SN_SET_FILTER(flag,group) SN_SET_FILTER_##flag(group)
#else /* __TOKEN_MERGER__ */
#define SN_ASSERT(level,group, exp, msg) SN_ASSERT_/**/level(group,exp,msg)
#define SN_FILTER(level, group, block) SN_FILTER_/**/level(group,block)
#define SN_SET_FILTER(flag,group) SN_SET_FILTER_/**/flag(group)
#endif /* __TOKEN_MERGER__ */


#endif /* _FILTERED_BLOCK_C_DEFINES_H_ */

#if SN_FILTER_COMPILE_COND(heavy)
void sn_gc_set_filters (void);
#else
#define sn_gc_set_filters()
#endif

#endif

#endif /* MM_H_ */

#ifndef FAKE_E

/* #include long.h */

    /***********************************************************************
    * COPYRIGHT (c) 1996,1997 Verisity Ltd., all rights                    *
    * reserved. This software is furnished under a license and may be used *
    * and copied only in accordance of the terms of such license and with  *
    * the inclusion of the above copyright notice.                         *
    ***********************************************************************/



#ifndef LONG_H
#define LONG_H

typedef  unsigned char uchar;

#define IS_NUMERIC_LONG(_td) (index_is_a_child_of((_td)->d_index,d__sn_vec))
/**
#define IS_LONG(_td) ((_td)->d_index != d__sn_vec && (_td)->d_index != d__sn_long  && (_td)->d_index != d__sn_ulong && IS_NUMERIC_LONG(_td))
#define IS_UNBOUNDED(_td) (IS_LONG(_td) && ((_td)->size_in_bits == MAX_INT))
**/
#define IS_LONG(_td) ((_td)->d_index != d__sn_vec && IS_NUMERIC_LONG(_td))

#define IS_SIGNED_LONG(_td) (IS_LONG(_td) && (_td)->d_index != d__sn_long  && (_td)->d_index != d__sn_ulong )
/* #define IS_INFINITE(_td) (IS_LONG(_td) && (_td->size_in_bits == MAX_INT)) */
/* #define IS_INFINITE(_td) ((_td)->d_index == d__sn_long) */

#define IS_UNBOUNDED(_td) (IS_NUMERIC_LONG(_td) && \
			  (((_td)->d_index == d__sn_long) || ((_td)->d_index == d__sn_ulong) \
			  ||  ((_td)->d_index == d__sn_vec) ||  ((_td)->d_index == d__sn_long) \
			   || ((_td)->size_in_bits == MAX_INT))) 
/* MAX_INT for int(bits:*) sharon */

#define IS_UNSIGNED_LONG(_td) (index_is_a_child_of((_td)->d_index,d__sn_ulong))
#define IS_EXTENDED_SCALAR(_td) (IS_SCALAR(_td) || IS_NUMERIC_LONG(_td))
#define ZERO_EX(_int,_shift) (((_int) << (_shift)) >> (_shift))
/** ===============WATCH OUT the macro will be redefined ==========*/
#define GLOB_MASK1(_e) LIST_ITEM(GLOB_ST->mask_bit_table, _e)
/** ===============================================================*/
#define IS_SHORT_SIGNED (GLOB_ST->is_short_signed)
/** ask for Ronen ??? **/
#define IS_BIT_LIST(sd) (((sd)->d_index  ==  d__l__bit) ||  (IS_LIST(sd) && ((t__list_descriptor)(sd))->base_type->size_in_bits == 1))
#define IS_BYTE_LIST(sd) (((sd)->d_index  ==  d__l__byte) || (IS_LIST(sd) && ((t__list_descriptor)(sd))->base_type->size_in_bits == 8))

#define SET_SIGNED(ba)    ((ba)->attributes |= 0x02)
#define SET_UNSIGNED(ba)  ((ba)->attributes &= 0xFFFFFFFD)

#define SET_UNFIXED(ba)   ((ba)->attributes &= 0xFFFFFFFE)
#define SET_FIXED(ba)     ((ba)->attributes |= 0x01)



  /** new implementation of infinite int (list of bit) **/
#define INF_SET_SIGNED(v)    ((v)->attributes |= 0x02)
#define INF_SET_UNSIGNED(v)  ((v)->attributes &= 0xFFFFFFFD)

#define INF_SET_UNFIXED(v)   ((v)->attributes &= 0xFFFFFFFE)
#define INF_SET_FIXED(v)     ((v)->attributes |= 0x01)

#define INF_SET_TEMP(v)    ((v)->attributes |= 0x04)
#define INF_SET_NONTEMP(v)  ((v)->attributes &= 0xFFFFFFFFB)

#define INF_IS_SIGNED(v) ((v)->attributes & 2)
#define INF_IS_FIXED(v) ((v)->attributes & 1)
#define INF_IS_TEMP(v) ((v)->attributes & 4)


#define INF_LIST_BIT_SIZE(l)          (LIST_SIZE((l)))
#define INF_LIST_BYTE_SIZE(l)         ((LIST_SIZE((l)) + 7) >> 3)
#define INF_LIST_INT_SIZE(l)          ((LIST_SIZE((l)) + 31) >> 5)

#define INF_LIST_GET_DATA(l)          ((uchar *) ((l)->data))

  /** for put/ get byte **/
#define INF_LIST_ITEM_BYTE(l, index)            (((uchar *) ((l)->data))[(index)])

#define INF_LIST_ITEM_INT(l, index)              ((l)->data[index])

#define INF_LIST_COPY_DATA(l,offset,str,size)  \
                     (memcpy(&((uchar *)((l)->data))[(offset)], (str), (size))); 

/** infinite int interface **/
#define INF_VEC_BIT_SIZE(v)          (LIST_SIZE((v)->bytes))
#define INF_VEC_BYTE_SIZE(v)         ((LIST_SIZE((v)->bytes) + 7) >> 3)

#define INF_VEC_ITEM_BYTE(v, index)            (((uchar *) (((v)->bytes)->data))[(index)])


#define SN_GLOBAL_TEMP_STACK (GLOB_ST->stack_of_temp_long)
#define SN_STACK_SP(_stack) ((_stack)->sp)
#define SN_STACK_ROLLBACK(_stack, _sp) ((_stack)->sp = _sp)
#define SN_STACK_NEW(_stack) (SN_STACK_SP(_stack) >= LIST_SIZE(_stack->l) ? sn_stack_new(_stack) : (SN_TYPE(sn_vec))LIST(_stack->l)->data[SN_STACK_SP(_stack)++])


#define SN_STACK_PROLOG \
SN_TYPE(sn_stack_of_temp_long) st = SN_GLOBAL_TEMP_STACK; \
int st_sp = SN_STACK_SP(st)

#define SN_STACK_PRE_RETURN SN_STACK_ROLLBACK(st, st_sp)


#ifdef __TOKEN_MERGER__
#define SN_TOKENIZE(str) #str
#else /* __TOKEN_MERGER__ */
#define SN_TOKENIZE(str) "str"
#endif /* __TOKEN_MERGER__ */
#endif
/* #include filtered_block_c_defines.h */
#ifndef _FILTERED_BLOCK_C_DEFINES_H_
#define _FILTERED_BLOCK_C_DEFINES_H_

/* 
   The filtered blocks groups.
   The words "ZERO" , "ONE", etc. should be replaced by meaningful 
   names. 
   
   For example:
   
   #define SN_FILTER_GROUP_packing 0 
   #define SN_FILTER_GROUP_loading 1
   #define SN_FILTER_GROUP_assignment 2
   ...
*/
#define SN_FILTER_GROUP_ZERO 0 
#define SN_FILTER_GROUP_ONE 1
#define SN_FILTER_GROUP_TWO 2
#define SN_FILTER_GROUP_THREE 3
#define SN_FILTER_GROUP_FOUR 4
#define SN_FILTER_GROUP_FIVE 5
#define SN_FILTER_GROUP_SIX 6
#define SN_FILTER_GROUP_SEVEN 7
#define SN_FILTER_GROUP_EIGHT 8
#define SN_FILTER_GROUP_NINE 9
#define SN_FILTER_GROUP_TEN 10
#define SN_NUM_OF_FILTERED_BLOCK_GROUPS 11

/* three levels of filtered blocks */
#define SN_FILTERED_BLOCK_transparent 0
#define SN_FILTERED_BLOCK_light 1
#define SN_FILTERED_BLOCK_heavy 2

/* the default is transparent */
#ifndef SN_COMPILATION_FILTERED_BLOCK_LEVEL
#define SN_COMPILATION_FILTERED_BLOCK_LEVEL SN_FILTERED_BLOCK_transparent
#endif

/*the filtered blocks manager*/
#define FILTERED_BLOCKS_MANAGER (GLOB->parse->filtered_blocks_manager)

/* compile and runtime filter checks. 
   Return a boolean value: TRUE iff the parateter(s) pass the filter */
#ifdef __TOKEN_MERGER__
#define SN_FILTER_COMPILE_COND(level) (SN_FILTERED_BLOCK_##level <= SN_COMPILATION_FILTERED_BLOCK_LEVEL)
#define SN_FILTER_RUNTIME_COND(level,group)\
(SN_FILTERED_BLOCK_##level <= LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_##group))
#else /* __TOKEN_MERGER__ */
#define SN_FILTER_COMPILE_COND(level) (SN_FILTERED_BLOCK_/**/level <= SN_COMPILATION_FILTERED_BLOCK_LEVEL)
#define SN_FILTER_RUNTIME_COND(level,group)\
(SN_FILTERED_BLOCK_/**/level <= LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_/**/group))
#endif /* __TOKEN_MERGER__ */
     
     /* heavy compilation filter */
#if SN_FILTER_COMPILE_COND(heavy)
#define SN_ASSERT_heavy(group, exp, msg) do { \
     if (SN_FILTER_RUNTIME_COND(heavy,group) && (! (exp) )) \
         { SN_ERR(ERR_FILTERED_ASSERT,( #group ,__LINE__,__FILE__, #exp ,msg)); } } while (0)
#define SN_FILTER_heavy(group, block) do { \
     if (SN_FILTER_RUNTIME_COND(heavy,group)) { block; } } while (0)
#else
#define SN_ASSERT_heavy(group, exp, msg) 
#define SN_FILTER_heavy(group,block)
#endif /*SN_FILTER_COMPILE_COND(heavy)*/
	 
	 /* light or heavy compilation filter */
#if SN_FILTER_COMPILE_COND(light)
#define SN_ASSERT_light(group, exp, msg) do { \
     if ( SN_FILTER_RUNTIME_COND(light,group) && (! (exp) )) \
         { SN_ERR(ERR_FILTERED_ASSERT,( #group ,__LINE__,__FILE__, #exp ,msg)); } } while (0)
#define SN_FILTER_light(group,block) do { \
     if (SN_FILTER_RUNTIME_COND(light,group)) { block; } } while (0)
#else
#define SN_ASSERT_light(group, exp, msg)
#define SN_FILTER_light(group,block) 
#endif /*SN_FILTER_COMPILE_COND(light)*/

	 /* set filter macros*/
#ifdef __TOKEN_MERGER__
#define SN_SET_FILTER_AID(level,group) do { \
     LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_##group) \
	 = SN_FILTERED_BLOCK_##level ; } while (0)
#else /* __TOKEN_MERGER__ */
#define SN_SET_FILTER_AID(level,group) do { \
     LIST_ITEM(FILTERED_BLOCKS_MANAGER->C_run_time_flags,SN_FILTER_GROUP_/**/group) \
         = SN_FILTERED_BLOCK_/**/level ; } while (0)
#endif /* __TOKEN_MERGER__ */

#define SN_SET_FILTER_all(group) SN_SET_FILTER_AID(heavy, group)
#define SN_SET_FILTER_light(group) SN_SET_FILTER_AID(light, group)
#define SN_SET_FILTER_off(group) SN_SET_FILTER_AID(transparent, group)

	 /*The public macros:*/	 
#ifdef __TOKEN_MERGER__
#define SN_ASSERT(level,group, exp, msg) SN_ASSERT_##level(group,exp,msg)
#define SN_FILTER(level, group, block) SN_FILTER_##level(group,block)
#define SN_SET_FILTER(flag,group) SN_SET_FILTER_##flag(group)
#else /* __TOKEN_MERGER__ */
#define SN_ASSERT(level,group, exp, msg) SN_ASSERT_/**/level(group,exp,msg)
#define SN_FILTER(level, group, block) SN_FILTER_/**/level(group,block)
#define SN_SET_FILTER(flag,group) SN_SET_FILTER_/**/flag(group)
#endif /* __TOKEN_MERGER__ */


#endif /* _FILTERED_BLOCK_C_DEFINES_H_ */
#endif /* FAKE_E */

/* #include misc.h */
    /***********************************************************************
     * COPYRIGHT (c) 1996, 1997 by Verisity Ltd., all rights reserved. *
     * This software is furnished under a license and may be used and       *
     * copied only in accordance of the terms of such license and with the  *
     * inclusion of the above copyright notice.                             *
     ***********************************************************************/

#ifndef SN_MISC_H
#define SN_MISC_H


#ifdef SN_EXTERNAL_IS_HERE
#define SN_EXTERNAL
#else
#define SN_EXTERNAL SN_EXTERNC
#endif

#define UNDEF (-1)
        /* Value returned when no index is legal */
#define MAX_INT (0x7fffffff)
#define MIN_INT (-MAX_INT-1)

#define ELEMENT_SIZE 32

#define MAX_NAME_SIZE 31  /* Max size for an external name in this OS */
#define MAX_NTV_DEPTH 200  /* Max nesting for parsing */

#define AS(_type, _var) ((_type) (_var))  /* Unsafe */


/* -- Some function definitions */

FILE *fopen_check();
SN_STRING c_name();
int *tcalloc();


#ifndef FAKE_E

#define SN_SOURCE_MODULE_NUM(_s) (((_s)->source_ref >> 20) & 0xfff)

#ifdef __TOKEN_MERGER__
#define NAME(_name,_d)   (SN_STRING)DISPATCH(name,GLOB_ST->namer,namer,(GLOB_ST->namer,name_role__##_d,_name))
#else /* __TOKEN_MERGER__ */
#define NAME(_name,_d)   (SN_STRING)DISPATCH(name,GLOB_ST->namer,namer,(GLOB_ST->namer,name_role__/**/_d,_name))
#endif /* __TOKEN_MERGER__ */


/* -- The following are used only by init */

#define SN_INIT_ROUTINE(_name, _rout, _type) \
    {init_routine(_name, _rout);}
    /* Needs that scope to make the name known */

#define SN_INIT_ROUTINE_POINTER(_rout, _type) \
    {init_routine_pointer(_rout);}
    /* Needs that scope to make the name known */

/* -- Some selected globals from root.e */
SN_EXTERNAL struct s__module *CM;  /* Same as GLOB_ST->current_module */
SN_EXTERNAL SN_STRING specman_version;  /* The version of Specman, not in GLOB */
SN_EXTERNAL SN_STRING sn_translator_version;  /*The version of the translator of Specman*/
SN_EXTERNAL struct s__base_struct *sn_partial_init_struct;

SN_EXTERNAL struct s__active_exception *sn_current_exception;

#define GLOB (the_global_struct)
        /* Note that the the_global_struct itself is only defined in root_.h */

#define GLOB_ST (the_global_struct->symtab)
        /* The symbol table */

#define GLOB_SESS ((t__session)the_global_struct->session)
        /* The session */

#define GLOB_NS ((the_global_struct->no_save))
        /* The no_save struct of global */

#define GLOB_DISP ((t__display)the_global_struct->display)
        /* The display struct of global */

#define GLOB_ON ((t__on)(GLOB->on))

#define PARSE (the_global_struct->parse)

#define DISPLAY_STATUS(_str) DISPATCH(set_status_msg,GLOB_DISP,display,(GLOB_DISP,_str))

#define DOING(_ntv) {GLOB_NS->ntv_done_now = _ntv;}
        /* Sets this var for error messages */

/* -- Globals not in root.e */
SN_EXTERNAL sn_bool translation_in_progress;  /* See translate_command() */
#ifdef SN_EXTERNAL_IS_HERE
int translation_first_module_num = 0;
sn_bool sn_can_use_filters = FALSE;
#else
SN_EXTERNAL int translation_first_module_num;  /* See translate_command() */
SN_EXTERNAL sn_bool sn_can_use_filters;
#endif
SN_EXTERNAL sn_bool load_in_progress;    /* See load_command() */
SN_EXTERNAL sn_bool starting_in_progress;   /* True until before first user command */
SN_EXTERNAL int restore_in_progress;   /* True during restore */
SN_EXTERNAL sn_bool sn_gc_in_progress;   /* True during GC */
SN_EXTERNAL sn_bool sn_gc_init_methods_in_progress;
SN_EXTERNAL sn_bool minus_command_in_progress;  /* True if executing -command */
SN_EXTERNAL sn_bool disable_code;   /* Dont create code for action inside constraints */
SN_EXTERNAL int sn_last_method_index;  /* Set by every DISPATCH() for interp() */
SN_EXTERNAL int sn_last_descriptor_d_index;
                /* Set by every DISPATCH_ON_DESCRIPTOR() for interp() */
SN_EXTERNAL sn_bool debugging_in_progress; /* do we have breakpoints */
SN_EXTERNAL sn_bool communication_in_progress; /* True during communication session on socket */
SN_EXTERNAL sn_bool dbg_use_dispatch_table; /* should we use 'call_from_dispatch_table' */
SN_EXTERNAL sn_bool post_load_in_progress;  /* See post load stmt*/

SN_EXTERNC bool sn_preparing_ispecman_exe;  /* True when we are creaing ispecman 
						       executable or files ontop of ispecman */
SN_EXTERNC bool sn_running_ispecman_exe; /* True when running ispecman executable */
SN_EXTERNC bool sn_running_iisn_exe; /* True when running iisn - any executable on top of ispecman */
/* The following debugger flags are used to decide whether
we want to check for break points from the corresponding 
type. They are TRUE iff there is at least one b.p. of these
type. */
SN_EXTERNAL sn_bool break_on_method_call;
SN_EXTERNAL sn_bool break_on_method_return;
SN_EXTERNAL sn_bool break_on_tcm_start;
SN_EXTERNAL sn_bool break_on_tcm_end;
SN_EXTERNAL sn_bool break_on_tcm_call;
SN_EXTERNAL sn_bool break_on_tcm_return;

SN_EXTERNAL sn_bool boot_only_flag;
        /* True only during the boot_only run, used to avoid some ops */

SN_EXTERNAL int sn_after_simulator_prompt;
   /* indicates specman that simulator prompt had already shown, for the 
      activation of the SPECMAN_POST_RESTORE commands */

#define DEBUG_ON(_flag1) (((t__debug)GLOB->debug)->_flag1)
#define GLOB_DBG ((t__debug)GLOB->debug)
#define DBG(_flag, _string) {if (DEBUG_ON(_flag)) sn_dout(_string);}

#ifdef __TOKEN_MERGER__

#define NT(_first, _second) t__n__##_first##__##_second
#define SN_DNT(_first, _second) d__n__##_first##__##_second

#define MY(_field) (me->n__##_field)
        /* One of the NTVs */

#define STR(_field) (me->n__##_field->x->string)
        /* The string of that field */

#define STR_EMPTY(_field) sn_str_empty(me->n__##_field->x->string)
        /* Is this field's string empty ? */

#else /* __TOKEN_MERGER__ */

#define NT(_first, _second) t__n__/**/_first/**/__/**/_second
#define SN_DNT(_first, _second) d__n__/**/_first/**/__/**/_second

#define MY(_field) (me->n__/**/_field)
        /* One of the NTVs */

#define STR(_field) (me->n__/**/_field->x->string)
        /* The string of that field */

#define STR_EMPTY(_field) sn_str_empty(me->n__/**/_field->x->string)
        /* Is this field's string empty ? */

#endif /* __TOKEN_MERGER__ */


#define SUB(_i) LIST_ITEM(me->x->sub_matches,_i)
        /* Return the corresponding item of sub_matches */

#ifdef __TOKEN_MERGER__
#define SUBN(_macro,_nt,_name) LIST_ITEM(me->x->sub_matches,SUB__n__##_macro##__##_nt##__##_name)
#else
#define SUBN(_macro,_nt,_name) LIST_ITEM(me->x->sub_matches,SUB__n__/**/_macro/**/__/**/_nt/**/__/**/_name)
#endif /* __TOKEN_MERGER__ */

#define GET_VALUE(_ntv) DISPATCH_ME1(get_value,_ntv,num)

/* -- Function definitions - just the non-int non-void */
struct s__form *sn_get_inner_form();

#endif /* FAKE_E */

/* CHECK_NULL check if the string is "sn_str_..." its sn_error "str_..." */
#define CHECK_NULL(x,h) {                              \
    if((x) == NULL) {                                   \
        sn_error("Illegal NULL parameter in %s()",(((h)[0] == 's' && (h)[1]== 'n' && (h)[2] == '_') ? (h)+3 : (h)));   \
    }                                                   \
}

/** sometime empty lists are actualy NULLs this macro prevernt error messages from string routines **/
#define UPDATE_NULL(x) if((x) == NULL) { x = ""; }


#define CHECK_EMPTY(x,h) {                              \
    if((x) == NULL || (x)[0] == '\0') {                 \
        sn_error("Illegal empty parameter in %s()",h);  \
    }                                                   \
}

#define SN_MAX_EXTRA_FIELDS 20

#ifdef SUN_C
#define volatile  /* Older Sun C does not recognize the "volatile" keword */
#endif


#define POUT out_stream

/* print to specman's output, register for GC the struct pointers found in the string   */
/* example: SN_PRINT((POUT,"%2d%s", s-r->program, regprop(s))                           */
/* POUT - is the default output stream of specman                                       */
/* "%2d%s" - a format string, just like for printf                                      */
/* the other are parameters to the format string                                        */
/* NOTE: the macro invocation should be encapsulated with double parantices, because    */
/*       the pre-processor does not have macros with undefined parameter number         */

#define SN_PRINT(_params) {\
        extern FILE *POUT;\
        sn_fprintf_specman _params;\
        }

/* the same as the above macro, only does not check for pointers to objects inside the	*/
/* result string									*/
/* example: SN_PRINT_NO_POINTERS((POUT,"%s",xxx))                                       */
/* POUT - is the default output stream of specman                                       */
/* "%s" - a format string, just like for printf                                         */
/* xxx - a parameter to the foramted string                                             */
/* NOTE: this macro does not mark the strings inside the output string for GC           */
/*       use with extream care !!!                                                      */

#define SN_PRINT_NO_POINTERS(_params) {\
        extern FILE *POUT;\
        sn_fprintf_specman_no_pointers _params;\
        }

#define SN_CPP_ERR(_si, _error_name, _params) (sn_set_ntv_now(_si),SN_ERR(_error_name, _params),0)

#ifdef __TOKEN_MERGER__
#define SN_ERR(_error_name, _params) (GLOB_ST->exceptions->global_error_name = #_error_name,\
    exception_for_c_code##_params,0)
#else
#define SN_ERR(_error_name, _params) (GLOB_ST->exceptions->global_error_name = "_error_name",\
    exception_for_c_code/**/_params,0)
#endif
/* SN_EXTERNC void exception_for_c_code(); */



#define SN_ENCRYPTED_LINE_MESSAGE "Encrypted file, no source available"

#define GLOB_SIM ((t__simulator)(GLOB->simulator))
#define GLOB_SIM_AM ((t__sn_adapter_manager)(GLOB->simulator->adapter_manager))

#endif /* SN_MISC_H */
/* #include code.h */
#define H_CODE GLOB->no_save->h_code
#define LATE_H_CODE GLOB->no_save->late_h_code
#define LIST_H_CODE GLOB->no_save->list_h_code
#define ROUTINE_H_CODE GLOB->no_save->routine_h_code
#define TOP_CODE GLOB->no_save->top_code
#define INIT0_CODE GLOB->no_save->init0_code
#define INIT_CODE GLOB->no_save->init_code
#define ROUTINE_CODE GLOB->no_save->routine_code
#define C_CODE GLOB->no_save->c_code
#define LATE_C_CODE GLOB->no_save->late_c_code

/* #include new.h */

    /***********************************************************************
     * COPYRIGHT (c) 1996, 1997 by Verisity Ltd., all rights reserved. *
     * This software is furnished under a license and may be used and       *
     * copied only in accordance of the terms of such license and with the  *
     * inclusion of the above copyright notice.                             *
     ***********************************************************************/

#ifndef NEW_H
#define NEW_H


SN_EXTERNAL int *_make_new_temp;  /* For make_new_helper() */

#ifdef FAKE_E
#define make_new_sized_helper(_size, _index) \
    (_make_new_temp = calloc (_size, 1), *_make_new_temp = _index, _make_new_temp)
#else
#define make_new_sized_helper(_size, _index) \
    (_make_new_temp = sn_get_block (SN_BYTES2WORDS (_size), sn_block_TYPED, TRUE), *_make_new_temp = _index, _make_new_temp)
#endif

#define MAKE_NEW_SIZED(_svar1, _stype1, _desc1) \
    {_svar1 = (_stype1) make_new_sized_helper(sizeof(*(_svar1)), _desc1);}

#define MAKE_NEW_SIZED_MALLOC(_svar1, _stype1, _desc1) \
    {_svar1 = (_stype1) make_new_malloc_helper(sizeof(*(_svar1)), _desc1);}

#define FREE_MALLOC(_item) {if ((_item) != NULL) { \
   free(_item); (_item) = NULL;}}

#ifndef FAKE_E

#define MAKE_NEW(_svar1, _desc1)  \
  {_svar1 = (void *) make_new_helper(_desc1);}

#define MAKE_NEW1(_svar1, _desc1)  \
  {_svar1 = (int *) make_new_helper1(_desc1);}

#define MAKE_NEW2(_svar1)  \
  {make_new_helper2(_svar1);}

#define MAKE_NEW_MALLOC(_svar1, _desc1)  \
    {_svar1 = (int *) make_new_malloc_helper( \
     LIST_ITEM(GLOB->all_types,_desc1)->size_in_bytes, _desc1);}

#define MAKE_COPY(_to, _from) \
    {MAKE_NEW(_to,(_from)->d__); \
     memcpy(_to, _from, TYPE(_from)->size_in_bytes);}

#define MAKE_EXTEND(_to, _d_index, _from) \
    {MAKE_NEW(_to,_d_index); \
     memcpy(_to, _from, TYPE(_from)->size_in_bytes); \
     (_to)->d__ = _d_index;}

#ifdef __TOKEN_MERGER__

#define GET_MAKE_NEW(_name) ((t__##_name)make_new_helper(d__##_name))

#else /* __TOKEN_MERGER__ */

#define GET_MAKE_NEW(_name) ((t__/**/_name)make_new_helper(d__/**/_name))

#endif /* __TOKEN_MERGER__ */

#endif /* FAKE_E */

#define SN_STRUCT_NEW(type) ((SN_TYPE(type))make_new_helper(SN_TYPE_ID(type)))
#define SN_LIST_NEW(type) ((SN_LIST(type))make_new_list_helper(SN_LIST_TYPE_ID(type)))

SN_EXTERNC int *make_new_helper(int);
SN_EXTERNC t__list make_new_list_helper(int);
#endif /* NEW_H */

#ifndef FAKE_E
/* #include exception.h */
#ifndef SN_EXCEPTION
#define SN_EXCEPTION

/* -- The TRY_* stuff (for exceptions) */
#include <setjmp.h>
#include <stdlib.h>

typedef enum {
	TRY_UNUSED,
	TRY_OK, 
	TRY_ERROR,
	TRY_ERROR_BACKTRACK,
	LOW_LEVEL_ERROR_BACKTRACK
} try_status_st;

typedef struct {
    int size;
    int allocated;
    jmp_buf **data;
} try_stack_st;

extern try_status_st try_status;
extern try_stack_st try_stack;
extern sn_bool ignore_break_on_error;

SN_STRING sn_get_saved_try_string (void);
void sn_set_saved_try_string (SN_STRING);
#define SN_GET_SAVED_TRY_STRING sn_get_saved_try_string ()
#define SN_SET_SAVED_TRY_STRING(val) sn_set_saved_try_string (val)

SN_EXTERNC void sn_init_exception();
SN_EXTERNC void resize_try_stack();
SN_EXTERNC void sn_exception_failed();

#define BASIC_TRY_BEGIN 						\
	try_status = TRY_OK;						\
	if(try_stack.size >= try_stack.allocated) {			\
	    resize_try_stack();						\
	}								\
	/*printf("try%d\n",try_stack.size);*/				\
	if (!setjmp(*try_stack.data[try_stack.size++])) { 	

#define TRY_BEGIN 							\
    {									\
	t__activation_record try_local_car = GLOB->CAR;			\
        sn_bool saved_ignore_break_on_error = ignore_break_on_error;       \
        BASIC_TRY_BEGIN

#define TRY_BEGIN_IE /* ignore break on error */			\
    {									\
	t__activation_record try_local_car = GLOB->CAR;			\
        sn_bool saved_ignore_break_on_error = ignore_break_on_error;       \
        ignore_break_on_error = TRUE;                                   \
        BASIC_TRY_BEGIN

#define TRY_QUIT                                                    \
          ignore_break_on_error = saved_ignore_break_on_error;   	\
          --try_stack.size;						                    \


#define TRY_FAILED	                                                \
            ignore_break_on_error = saved_ignore_break_on_error;   	\
            --try_stack.size;						\
	    /*printf("end%d\n",try_stack.size);*/                       \
        } 								\
	else {								\
            ignore_break_on_error = saved_ignore_break_on_error;   	\
	    sn_exception_failed();					\
	    --try_stack.size;						\
	    /*printf("ret fail%d\n",try_stack.size);*/                  \
	    GLOB->CAR = try_local_car;					\
	    if (try_status == TRY_OK) {					\
		sn_fatal("Internal: try failed with status == ok");	\
	    }								\
	    {                                                           

#define TRY_END 							\
            ignore_break_on_error = saved_ignore_break_on_error;   	\
	    }								\
	}								\
    }                                                                   

#endif
/* #include packed_list.h */
#ifndef PACKED_LIST_H
#define PACKED_LIST_H 
 
extern char closest_power[];
extern char closest_shift[];
extern char bit_place[];
extern char shift_table[]; 
extern char items_in_byte[]; 
#define PACKED_LIST_MAX_SIZE  16


/*the two new macro's are for the short int sake. the EX_PACKED_LIST_ITEM is
making sign extension no questions aked. the COND_EX_PACKED_LIST_ITEM check the
list type to find if the extension is needed. the last my be alot slower thus the first is recommended*/
#define PACKED_LIST_ITEM(l,i) ( packed_list_item(l,i) )
#define EX_PACKED_LIST_ITEM(l,i) ( ZERO_EX((int)packed_list_item(l,i), 32 - LIST_RESERVED(l)))
#define COND_EX_PACKED_LIST_ITEM(l,i) ((IS_INT(ELEM_TYPE(TYPE(l)))) ? ( ZERO_EX((int)packed_list_item(l,i), 32 - LIST_RESERVED(l))): PACKED_LIST_ITEM(l,i))

#define PACKED_LIST_LITEM(l,i,x) ( packed_list_litem_function(l,i,x), 1)

#define GET_DATA(l) ((l)->data)
#define PACKED_LIST_DATA_AS_BYTE(l) ((unsigned char *)(l)->data)
#define PACKED_LIST_DATA_AS_SHORT(l) ((unsigned short *)(l)->data)


		     /* _d is the d__ of the list , _l is the list 	*/
#define UPDATE_RESERVED( _l ) \
        LIST_RESERVED(_l) = AS(t__list_descriptor,LIST_ITEM(GLOB->all_types,_l->d__))->base_type->size_in_bits;

#define UPDATE_RESERVED_EXPLICIT(_l, _size) LIST_RESERVED(_l) = _size
	
#define IS_A_PACKED_LIST(_elem) \
   ((AS(t__list_descriptor,_elem)->base_type->size_in_bits <= PACKED_LIST_MAX_SIZE) && (AS(t__list_descriptor,_elem)->base_type->size_in_bits > 0))
#define IS_A_PACKED_LIST_ITEM(_elem) \
   (((_elem)->size_in_bits <= PACKED_LIST_MAX_SIZE) && ((_elem)->size_in_bits > 0))
#define PACKED_LIST_SIZE_IN_BITS(_d) (AS(t__list_descriptor,LIST_ITEM(GLOB->all_types,_d))->base_type->size_in_bits)

#define PACKED_LIST_ADD(_lvar, _svar) \
    { if (LIST_SIZE(_lvar) >= LIST_ALLOCATED(_lvar)) \
         packed_list_add_helper(_lvar); \
		 packed_list_litem_function(_lvar,LIST_SIZE(_lvar),(_svar));SIZE_CELL(_lvar)+=1; }

#define PACKED_LIST_ADD_LIST(_lvar, _svar) \
	{packed_list_add_list_helper(_lvar, _svar);}

#define PACKED_LIST_INIT(_lvar, _size, _full, _value, _keep_old) \
        {sn_packed_list_init_helper(_lvar, _size, _full, _value, _keep_old);}

/**
o  watch the two new defines:
- EX_PACKED_LIST_FOR_EACH - always do sign extension, ussualy when the signed attribute is constant or after condition expression.
- COND_EX_PACKED_LIST_ITEM - on each iteration we ask whether the sign should be
  extended, very expensive use only where needed.
**/
#define PACKED_LIST_FOR_EACH(_lvar1, _svar, _index) \
	  for (_index = 0; \
	       (((_index) < LIST_SIZE(_lvar1))  &&  \
		((_svar = PACKED_LIST_ITEM(LIST(_lvar1), _index)),1)); \
	       ++(_index))

#define EX_PACKED_LIST_FOR_EACH(_lvar1, _svar, _index) \
	  for (_index = 0; \
	       (((_index) < LIST_SIZE(_lvar1))  &&  \
		((_svar = EX_PACKED_LIST_ITEM(LIST(_lvar1), _index)),1)); \
	       ++(_index))

#define COND_PACKED_LIST_FOR_EACH(_lvar1, _svar, _index) \
	  for (_index = 0; \
	       (((_index) < LIST_SIZE(_lvar1))  &&  \
		((_svar = COND_EX_PACKED_LIST_ITEM(LIST(_lvar1), _index)),1)); \
	       ++(_index))
    
#define PACKED_LIST_FOR_EACH_LIMITED(_lvar1, _svar, _index, _limit) \
	   for (_index = 0; \
	       (((_index) < (_limit))  &&  \
		((_svar = PACKED_LIST_ITEM(LIST(_lvar1), _index)),1)); \
	       ++(_index))

#define PACKED_LIST_FOR_EACH_REVERSE(_lvar1, _svar, _index) \
	  for (_index = LIST_SIZE(_lvar1) - 1; \
	       ((_index) >= 0)  && (((_svar) = PACKED_LIST_ITEM(LIST(_lvar1),(_index))),1); \
	       --(_index))

#define EX_PACKED_LIST_FOR_EACH_REVERSE(_lvar1, _svar, _index) \
	  for (_index = LIST_SIZE(_lvar1) - 1; \
	       ((_index) >= 0)  && (((_svar) = EX_PACKED_LIST_ITEM(LIST(_lvar1),(_index))),1); \
	       --(_index))

#define PACKED_LIST_DELETE(_lvar, _index, _stype) \
   {packed_list_litem_function(_lvar,_index, (PACKED_LIST_ITEM(_lvar,LIST_SIZE(_lvar)-1))); \
    packed_list_litem_function(_lvar,(LIST_SIZE(_lvar) - 1), 0); \
    SIZE_CELL(_lvar)-=1;}

#define PACKED_LIST_POP(_lvar, _stype) \
    ((_stype) packed_list_pop(_lvar))

#define PACKED_LIST_TOP(_lvar, _stype) \
    ((_stype) PACKED_LIST_ITEM(LIST(_lvar),(LIST_SIZE(_lvar) - 1)))

#define PACKED_LIST_APPEND(_lto, _lfrom, _ltype) \
    { _ltype _elem; int _tmp; \
        LIST_FOR_EACH(_lfrom,_elem,_tmp) { \
	    LIST_ADD(_lto,_elem); \
	} \
    }

#define PACKED_LIST_GET_BYTE(_l, _bn) (((unsigned char*)((_l)->data))[_bn])
#define PACKED_LIST_PUT_BYTE(_l, _bn, _data) ((unsigned char*)((_l)->data))[_bn] =(_data)
#define PACKED_LIST_GET_SHORT(_l, _bn) (((unsigned short*)((_l)->data))[_bn])
#define PACKED_LIST_PUT_SHORT(_l, _bn, _data) ((unsigned short*)((_l)->data))[_bn] =(_data)
/* work only for list smaller than 9 bits item size */
#define PACKED_LIST_SIZE_IN_BYTES(_list, _item_size) ((((LIST_SIZE(_list) << closest_shift[_item_size]) + 7)) >> 3) 
#define PACKED_LIST_ADD_BYTE( _l, _data) \
    {if ((!(LIST(_l)->data)) || \
        (LIST_SIZE(_l)+(8>>closest_shift[LIST_RESERVED(_l)]) > LIST_ALLOCATED(_l))) \
	packed_list_add_helper(_l); \
        PACKED_LIST_PUT_BYTE( _l, ((LIST_SIZE(_l)<<closest_shift[LIST_RESERVED(_l)])>>3), _data); \
        SIZE_CELL(_l)+=(8>>closest_shift[LIST_RESERVED(_l)]);}

#define PACKED_LIST_GET_BYTE_SIZE(_l)  \
   ((((LIST_SIZE(_l))<<closest_shift[LIST_RESERVED(_l)]) + 7)>>3 )

/* accelerator function for adding bytes to list of byte.
   to be used for STATIC list of bytes only, since it uses malloc and not
   specman GC. This macro was designed for the cases where we use list of bytes
   as string buffers */
#define SN_LOBYTE_ADD_MALLOC(_list,_byte) {			\
	if(LIST_SIZE(_list) == LIST_ALLOCATED(_list)) {    	\
		if((_list)->data == NULL) {			\
			sn_listOfByteCreateMalloc(_list);	\
		}						\
		else {						\
			sn_listOfByteResizeMalloc(_list);	\
		}						\
	}							\
	((char *)((_list)->data))[SIZE_CELL(_list)] = _byte;	\
	SIZE_CELL(_list)++;					\
}	

#define SN_LOBYTE_ADD(_list,_byte) {                            \
	if(LIST_SIZE(_list) == LIST_ALLOCATED(_list)) {    	\
        	if((_list)->data == NULL) {                       \
                	sn_listOfByteCreate(_list);             \
        	}                                               \
        	else {    					\
                	sn_listOfByteResize(_list);             \
        	}                                               \
	}							\
        ((char *)((_list)->data))[SIZE_CELL(_list)] = _byte;      \
        SIZE_CELL(_list)++;                                     \
}       

#define SN_LOBYTE_CHOP(_list) {                                         \
        if(SIZE_CELL(_list)) {                           		\
                SIZE_CELL(_list) -= 1;                                  \
                ((char *)((_list)->data))[SIZE_CELL(_list)] = '\0';       \
        }                                                               \
}

#define SN_LOBYTE_TOP(_list) (SIZE_CELL(_list) ? ((char *)((_list)->data))[SIZE_CELL(_list) - 1] : '\0')

#endif /* PACKED_LIST_H */

#endif /* FAKE_E */


#endif /* ROOT_ALL_H */
/* line 34 "../src/root_basic.e"  From 'type: string' */
typedef SN_STRING t__string;
#define d__string 3
/* line 33 "../src/root_basic.e"  From 'type: bool' */
typedef unsigned int t__bool;
#define d__bool 2
/* line 31 "../src/root_basic.e"  From 'type: int' */
typedef int t__int;
#define d__int 0
/* line 6 "/proj/specman/src/hdl_struct.e"  From 'Enum type 'sn_agent_kind'' */
typedef enum {
    sn_agent_kind__unset=0,
    sn_agent_kind__main=1,
    sn_agent_kind__slave=2
} t__sn_agent_kind;

/* line 32 "../src/root_basic.e"  From 'type: uint' */
typedef unsigned int t__uint;
#define d__uint 1
/* line 29 "/proj/specman/src/shlibs.e"  From 'Enum type 'sn_lib_resolve_mode'' */
typedef enum {
    sn_lib_resolve_mode__dont_care=0,
    sn_lib_resolve_mode__lazy=1,
    sn_lib_resolve_mode__now=2
} t__sn_lib_resolve_mode;

/* line 28 "/proj/specman/src/shlibs.e"  From 'Enum type 'sn_lib_scope_mode'' */
typedef enum {
    sn_lib_scope_mode__dont_care=0,
    sn_lib_scope_mode__global=1,
    sn_lib_scope_mode__local=2
} t__sn_lib_scope_mode;

/* line 38 "../src/root_basic.e"  From 'type: external_pointer' */
typedef void * t__external_pointer;
#define d__external_pointer 7
/* line 302 "../src/root_basic.e"  From 'Enum type 'config_os'' */
typedef enum {
    config_os__unknown=0,
    config_os__vms=1,
    config_os__unix=2
} t__config_os;

/* line 308 "../src/root_basic.e"  From 'Enum type 'config_machine'' */
typedef enum {
    config_machine__unknown=0,
    config_machine__vax=1,
    config_machine__mips=2,
    config_machine__alpha=3,
    config_machine__sparc=4,
    config_machine__hp=5
} t__config_machine;

/* line 35 "../src/root_basic.e"  From 'type: untyped' */
typedef int * t__untyped;
#define d__untyped 4
/* line 22 "/proj/specman/src/script_type.e"  From 'type: index' */
#define t__index t__int
/* line 40 "../src/root_basic.e"  From 'type: source_ref' */
typedef int t__source_ref;
#define d__source_ref 8
/* line 182 "../src/root_types.e"  From 'Enum type 'short_type'' */
typedef enum {
    short_type__INT_TYPE=0,
    short_type__UINT_TYPE=1,
    short_type__BOOL_TYPE=2,
    short_type__ENUM_TYPE=3,
    short_type__FLOAT_TYPE=4,
    short_type__DOUBLE_TYPE=5,
    short_type__OTHER_TYPE=6,
    short_type__STRING_TYPE=7,
    short_type__STRUCT_TYPE=8
} t__short_type;

/* line 308 "../src/root.e"  From 'Enum type 'range_list_base_type'' */
typedef enum {
    range_list_base_type__rl_int=0,
    range_list_base_type__rl_uint=1,
    range_list_base_type__rl_long=2
} t__range_list_base_type;

/* line 140 "../src/root_ntv.e"  From 'Enum type 'form_kind'' */
typedef enum {
    form_kind__PARAN_FORM=0,
    form_kind__SQUARE_FORM=1,
    form_kind__DOUBLE_QUOTE_FORM=2,
    form_kind__CURLY_FORM=3,
    form_kind__COLON_FORM=4,
    form_kind__HASH_COLON_FORM=5,
    form_kind__TOP_FORM=6,
    form_kind__SEMI_FORM=7,
    form_kind__REPARSE_FORM=8
} t__form_kind;

/* line 36 "../src/root_basic.e"  From 'type: pat' */
typedef sn_pattern t__pat;
#define d__pat 5
/* line 508 "../src/root_types.e"  From 'Enum type 'access_qualifier'' */
typedef enum {
    access_qualifier__public=0,
    access_qualifier__protected=1,
    access_qualifier__private=2
} t__access_qualifier;

/* line 1196 "../src/root_types.e"  From 'Enum type 'gen_status'' */
typedef enum {
    gen_status__generate=0,
    gen_status__do_not_generate=1,
    gen_status__use_as_is=2,
    gen_status__continue_generation=3,
    gen_status__pgen=4
} t__gen_status;

/* line 664 "../src/root_types.e"  From 'Enum type 'method_kind'' */
typedef enum {
    method_kind__C=0,
    method_kind__empty=1,
    method_kind__undefined=2,
    method_kind__also=3,
    method_kind__first=4,
    method_kind__only=5,
    method_kind__is=6,
    method_kind__none=7
} t__method_kind;

/* line 709 "../src/root_types.e"  From 'Enum type 'final_state'' */
typedef enum {
    final_state__none=0,
    final_state__final=1,
    final_state__inline=2
} t__final_state;

/* line 900 "../src/root_types.e"  From 'Enum type 'local_attribute'' */
typedef enum {
    local_attribute__normal=0,
    local_attribute__assigned=1,
    local_attribute__temp=2,
    local_attribute__temp_assigned=3,
    local_attribute__temp_stack_ptr=4
} t__local_attribute;

/* line 180 "../src/root_types.e"  From 'type: routine_pointer' */
typedef sn_routine_pointer_type t__routine_pointer;
#define d__routine_pointer 107
/* line 152 "/proj/specman/src/gen_static_reachable.e"  From 'Enum type 'visited_status'' */
typedef enum {
    visited_status__not_visited=0,
    visited_status__visited=1,
    visited_status__visited_on_path=2,
    visited_status__visited_one_field=3,
    visited_status__visited_all=4
} t__visited_status;

/* line 31 "/proj/specman/src/gen_constraint_header.e"  From 'Enum type 'gc_status'' */
typedef enum {
    gc_status__active=0,
    gc_status__reduce=1,
    gc_status__replaced=2,
    gc_status__replaced_by_or_simple=3,
    gc_status__reduced_false=4,
    gc_status__has_one_alt=5,
    gc_status__another_alt_is_true=6,
    gc_status__another_alt_is_false=7,
    gc_status__another_subtype=8,
    gc_status__another_gotf=9,
    gc_status__ignored=10,
    gc_status__all_fixed=11,
    gc_status__all_fixed_in_role=12,
    gc_status__has_fixed_output=13,
    gc_status__has_fixed_in_role_output=14,
    gc_status__ignore_in_role=15,
    gc_status__not_active_in_parent=16
} t__gc_status;

/* line 18 "/proj/specman/src/script_type.e"  From 'type: count' */
#define t__count t__int
/* line 544 "/proj/specman/src/basic_action.e"  From 'Enum type 'exp_kind'' */
typedef enum {
    exp_kind__normal=0,
    exp_kind__constant=1,
    exp_kind__call=2,
    exp_kind__constant_call=3
} t__exp_kind;

/* line 467 "/proj/specman/src/script.e"  From 'Enum type 'entry'code_status'' */
typedef enum {
    entry__code_status__none=0,
    entry__code_status__has_code=1,
    entry__code_status__has_code_leaf=2
} t__imp_enum_entry__code_status;

/* line 404 "/proj/specman/src/gen_parse.e"  From 'Enum type 'constraint_path_start_kind'' */
typedef enum {
    constraint_path_start_kind__me=0,
    constraint_path_start_kind__global=1,
    constraint_path_start_kind__range_path=2,
    constraint_path_start_kind__temp=3,
    constraint_path_start_kind__local=4,
    constraint_path_start_kind__me_local=5
} t__constraint_path_start_kind;

/* line 82 "/proj/specman/src/operators.e"  From 'Enum type 'constraint_role_type'' */
typedef enum {
    constraint_role_type__none=0,
    constraint_role_type__in_all=1,
    constraint_role_type__in_one=2,
    constraint_role_type__imply_exp=3,
    constraint_role_type__list_exp=4,
    constraint_role_type__field_exp=5,
    constraint_role_type__it_exp=6,
    constraint_role_type__index_exp=7,
    constraint_role_type__prev_exp=8,
    constraint_role_type__and_exp=9,
    constraint_role_type__size_attr=10,
    constraint_role_type__is_empty_a=11,
    constraint_role_type__is_a_exp=12,
    constraint_role_type__as_a_exp=13,
    constraint_role_type__all_iterations=14,
    constraint_role_type__elem_iteration=15,
    constraint_role_type__is_permutation=16,
    constraint_role_type__elem_it_permutation=17,
    constraint_role_type__elem_in_permutation=18,
    constraint_role_type__lazy_and=19,
    constraint_role_type__lazy_or=20,
    constraint_role_type__and_op=21,
    constraint_role_type__or_op=22,
    constraint_role_type__is_not_a_exp=23
} t__constraint_role_type;

/* line 465 "/proj/specman/src/gen_constraint_header.e"  From 'Enum type 'om_edge_reason'' */
typedef enum {
    om_edge_reason__UNDEFINED=0,
    om_edge_reason__explicit=1,
    om_edge_reason__uni_const=2,
    om_edge_reason__bi_const=3,
    om_edge_reason__when_determinant=4,
    om_edge_reason__list_item_constraint=5,
    om_edge_reason__temps_closure=6,
    om_edge_reason__uni_soft_bits=7,
    om_edge_reason__uni_bits_indices=8,
    om_edge_reason__uni_instance_to_unit=9,
    om_edge_reason__dof_uni_fixed_input=10,
    om_edge_reason__dof_uni_from_outside=11,
    om_edge_reason__dof_bi_with_fixed=12
} t__om_edge_reason;

/* line 187 "/proj/specman/src/gen_static_gcroles.e"  From 'Enum type 'a_role'gc_proc_status'' */
typedef enum {
    a_role__gc_proc_status__none=0,
    a_role__gc_proc_status__alloced=1,
    a_role__gc_proc_status__inited=2,
    a_role__gc_proc_status__eq_to_mgr=3
} t__imp_enum_a_role__gc_proc_status;

/* line 25 "/proj/specman/src/gen_static_header.e"  From 'Enum type 'role_range_status'' */
typedef enum {
    role_range_status__unknown=0,
    role_range_status__none=1,
    role_range_status__has_range=2,
    role_range_status__has_gcs=3
} t__role_range_status;

/* line 38 "/proj/specman/src/gen_static_header.e"  From 'Enum type 'status_in_role'' */
typedef enum {
    status_in_role__gotf=0,
    status_in_role__not_gotf=1,
    status_in_role__another_subtype=2,
    status_in_role__dont_gen=3,
    status_in_role__gen=4,
    status_in_role__on_gotf_path=5,
    status_in_role__never_gen=6,
    status_in_role__tmp_gotf=7,
    status_in_role__tmp_reallocated=8,
    status_in_role__tmp_in_keeping_only=9,
    status_in_role__tmp_another_keeping=10,
    status_in_role__tmp_another_local=11,
    status_in_role__tmp_another_subtype=12,
    status_in_role__tmp_global=13,
    status_in_role__tmp_dont_gen=14,
    status_in_role__tmp_gen=15,
    status_in_role__tmp_no_constraints=16
} t__status_in_role;

/* line 506 "/proj/specman/src/hdl_struct.e"  From 'Enum type 'vhdl_set'' */
typedef enum {
    vhdl_set__INERTIAL=0,
    vhdl_set__TRANSPORT=1
} t__vhdl_set;

/* line 403 "/proj/specman/src/scriptsim.e"  From 'Enum type 'simulator_kind'' */
typedef enum {
    simulator_kind__unknown=0,
    simulator_kind__external_run=1,
    simulator_kind__verilog=2,
    simulator_kind__vhdl=3,
    simulator_kind__ccli=4,
    simulator_kind__snsim=5
} t__simulator_kind;

/* line 323 "/proj/specman/src/te_structs.e"  From 'Enum type 'sn_event_kind'' */
typedef enum {
    sn_event_kind__empty=0,
    sn_event_kind__hdl=1,
    sn_event_kind__te=2,
    sn_event_kind__consumed=3
} t__sn_event_kind;

/* line 785 "/proj/specman/src/te_structs.e"  From 'Enum type 'on_method_status'' */
typedef enum {
    on_method_status__on_unknown=0,
    on_method_status__on_empty=1,
    on_method_status__on_extended=2
} t__on_method_status;

/* line 552 "/proj/specman/src/hdl_struct.e"  From 'Enum type 'callback_status'' */
typedef enum {
    callback_status__unset=0,
    callback_status__set=1,
    callback_status__done=2
} t__callback_status;

/* line 4 "/proj/specman/src/hdl_struct.e"  From 'Enum type 'hdl_data_type'' */
typedef enum {
    hdl_data_type__uint_type=0,
    hdl_data_type__long_type=1,
    hdl_data_type__bit_list_type=2,
    hdl_data_type__list_type=3
} t__hdl_data_type;

/* line 2 "/proj/specman/src/hdl_struct.e"  From 'Enum type 'sensitivity_kind'' */
typedef enum {
    sensitivity_kind__void=0,
    sensitivity_kind__change=1,
    sensitivity_kind__fall=2,
    sensitivity_kind__rise=3
} t__sensitivity_kind;

/* line 155 "/proj/specman/src/cover_misc.e"  From 'type: c_float' */
#define t__c_float t__int
/* line 1696 "../src/root_basic.e"  From 'Enum type 'po_radix'' */
typedef enum {
    po_radix__DEC=0,
    po_radix__HEX=1,
    po_radix__BIN=2
} t__po_radix;

/* line 156 "/proj/specman/src/cover_basic.e"  From 'Enum type 'sn_cvr_radix'' */
typedef enum {
    sn_cvr_radix__DEC=0,
    sn_cvr_radix__HEX=1,
    sn_cvr_radix__BIN=2,
    sn_cvr_radix__DEF=3
} t__sn_cvr_radix;

/* line 142 "/proj/specman/src/cover_basic.e"  From 'Enum type 'sn_cvr_external_option'' */
typedef enum {
    sn_cvr_external_option__none=0,
    sn_cvr_external_option__external=1,
    sn_cvr_external_option__normal=2
} t__sn_cvr_external_option;

/* line 119 "/proj/specman/src/cover_basic.e"  From 'Enum type 'sn_cvr_item_kind'' */
typedef enum {
    sn_cvr_item_kind__simple=0,
    sn_cvr_item_kind__cross=1,
    sn_cvr_item_kind__transition=2,
    sn_cvr_item_kind__extend=3
} t__sn_cvr_item_kind;

/* line 130 "/proj/specman/src/cover_basic.e"  From 'Enum type 'sn_cvr_show_status'' */
typedef enum {
    sn_cvr_show_status__full_bucket=0,
    sn_cvr_show_status__hole_bucket=1,
    sn_cvr_show_status__illegal_bucket=2,
    sn_cvr_show_status__ignore_bucket=3
} t__sn_cvr_show_status;

/* line 43 "../src/root_basic.e"  From 'type: bit' */
typedef unsigned int t__bit;
#define d__bit 10
/* line 189 "/proj/specman/src/cover_com.e"  From 'type: bool (bits: 8)' */
#define t__bool__8 t__bool
/* line 7 "/proj/specman/src/wave_init.e"  From 'Enum type 'wave_event_data'' */
typedef enum {
    wave_event_data__occurrence_only=0,
    wave_event_data__details=1,
    wave_event_data__all_data=2
} t__wave_event_data;

/* line 14 "/proj/specman/src/wave_services.e"  From 'Enum type 'wave_entry_type'' */
typedef enum {
    wave_entry_type__wave_bool=0,
    wave_entry_type__wave_str=1,
    wave_entry_type__wave_int=2,
    wave_entry_type__wave_uint=3,
    wave_entry_type__wave_event=4,
    wave_entry_type__wave_output=5,
    wave_entry_type__wave_error=6,
    wave_entry_type__wave_event_details=7
} t__wave_entry_type;

/* line 2 "/proj/specman/src/gen_static_comms.e"  From 'Enum type 'fg_stat'' */
typedef enum {
    fg_stat__not_relevant=0,
    fg_stat__from_type=1,
    fg_stat__from_range=2,
    fg_stat__from_gcs=3
} t__fg_stat;

/* line 321 "/proj/specman/src/rl_interface.e"  From 'Enum type 'abstract_gen_type'' */
typedef enum {
    abstract_gen_type__int_type=0,
    abstract_gen_type__uint_type=1,
    abstract_gen_type__long_type=2,
    abstract_gen_type__struct_type=3,
    abstract_gen_type__string_type=4,
    abstract_gen_type__list_of_int_type=5,
    abstract_gen_type__list_of_uint_type=6,
    abstract_gen_type__list_of_long_type=7,
    abstract_gen_type__list_of_struct_type=8,
    abstract_gen_type__list_of_string_type=9,
    abstract_gen_type__other_type=10
} t__abstract_gen_type;

/* line 1690 "../src/root_basic.e"  From 'Enum type 'radix'' */
typedef enum {
    radix__DEC=0,
    radix__HEX=1,
    radix__BIN=2,
    radix__OCT=3
} t__radix;

/* line 143 "../src/root_excep.e"  From 'Enum type 'do_reload_t'' */
typedef enum {
    do_reload_t__dont_reload=0,
    do_reload_t__reload_after_load=1,
    do_reload_t__reload_after_translate=2
} t__do_reload_t;

/* line 39 "../src/root_excep.e"  From 'Enum type 'severity'' */
typedef enum {
    severity__error=0,
    severity__warning=1,
    severity__fatal=2,
    severity__dut=3
} t__severity;

/* line 139 "../src/root_basic.e"  From 'Enum type 'vertice_color'' */
typedef enum {
    vertice_color__white=0,
    vertice_color__gray=1,
    vertice_color__black=2
} t__vertice_color;

/* line 973 "/proj/specman/src/basic_action.e"  From 'Enum type 'cast'' */
typedef enum {
    cast__int2uint=0,
    cast__int2long=1,
    cast__int2ulong=2,
    cast__int2float=3,
    cast__int2double=4,
    cast__uint2int=5,
    cast__uint2long=6,
    cast__uint2ulong=7,
    cast__uint2float=8,
    cast__uint2double=9,
    cast__long2int=10,
    cast__long2uint=11,
    cast__long2ulong=12,
    cast__long2float=13,
    cast__long2double=14,
    cast__ulong2int=15,
    cast__ulong2uint=16,
    cast__ulong2long=17,
    cast__ulong2float=18,
    cast__ulong2double=19,
    cast__float2int=20,
    cast__float2uint=21,
    cast__float2long=22,
    cast__float2ulong=23,
    cast__float2double=24,
    cast__double2int=25,
    cast__double2uint=26,
    cast__double2long=27,
    cast__double2ulong=28,
    cast__double2float=29,
    cast__none=30,
    cast__int=31,
    cast__uint=32,
    cast__long=33,
    cast__ulong=34,
    cast__float=35,
    cast__double=36,
    cast__error=37,
    cast__check=38
} t__cast;

/* line 418 "/proj/specman/src/script.e"  From 'Enum type 'script_lm_calculation'' */
typedef enum {
    script_lm_calculation__not_done=0,
    script_lm_calculation__in_progress=1,
    script_lm_calculation__done=2
} t__script_lm_calculation;

/* line 31 "/proj/specman/src/dut_error.e"  From 'Enum type 'check_effect'' */
typedef enum {
    check_effect__ERROR=0,
    check_effect__ERROR_BREAK_RUN=1,
    check_effect__ERROR_AUTOMATIC=2,
    check_effect__ERROR_CONTINUE=3,
    check_effect__WARNING=4,
    check_effect__IGNORE=5
} t__check_effect;

/* line 33 "/proj/specman/src/gen_static_header.e"  From 'Enum type 'reduce_result'' */
typedef enum {
    reduce_result__normal=0,
    reduce_result__contradiction=1,
    reduce_result__always=2,
    reduce_result__always_by_eval=3
} t__reduce_result;

/* line 294 "/proj/specman/src/gen_reduce.e"  From 'Enum type 'graph_type'' */
typedef enum {
    graph_type__static=0,
    graph_type__dynamic=1,
    graph_type__choose=2
} t__graph_type;

/* line 146 "/proj/specman/src/gen_debug_header.e"  From 'Enum type 'gendb_item'phase'' */
typedef enum {
    gendb_item__phase__static=0,
    gendb_item__phase__dynamic=1
} t__imp_enum_gendb_item__phase;

/* line 24 "/proj/specman/src/gen_static_header.e"  From 'Enum type 'which_rl'' */
typedef enum {
    which_rl__regular=0,
    which_rl__the_size=1,
    which_rl__the_item=2
} t__which_rl;

/* line 12 "/proj/specman/src/gen_run_structs.e"  From 'Enum type 'pn_status'' */
typedef enum {
    pn_status__active=0,
    pn_status__selected=1,
    pn_status__eval_by_gen=2,
    pn_status__eval_by_method=3,
    pn_status__skipped=4,
    pn_status__delayed=5
} t__pn_status;

/* line 21 "/proj/specman/src/gen_run_structs.e"  From 'subtype: TRUE'has_constraints field_node' */
#define d__TRUE__has_constraints__field_node 1438
/* line 360 "/proj/specman/src/gen_run_structs.e"  From 'Enum type 'sn_ci_kind'' */
typedef enum {
    sn_ci_kind__simple_ci=0,
    sn_ci_kind__or_ci=1,
    sn_ci_kind__and_ci=2
} t__sn_ci_kind;

/* line 362 "/proj/specman/src/gen_run_structs.e"  From 'Enum type 'sn_gen_status_type'' */
typedef enum {
    sn_gen_status_type__active=0,
    sn_gen_status_type__is_true=1,
    sn_gen_status_type__is_false=2,
    sn_gen_status_type__ignore=3,
    sn_gen_status_type__no_active=4
} t__sn_gen_status_type;

/* line 359 "/proj/specman/src/gen_cpi.e"  From 'Enum type 'sn_or_status_type'' */
typedef enum {
    sn_or_status_type__none=0,
    sn_or_status_type__no_active=1,
    sn_or_status_type__active=2,
    sn_or_status_type__ready=3
} t__sn_or_status_type;

/* line 411 "/proj/specman/src/gen_run_structs.e"  From 'Enum type 'sn_gen_access_status'' */
typedef enum {
    sn_gen_access_status__inaccessible=0,
    sn_gen_access_status__accessible=1,
    sn_gen_access_status__do_not_generate=2
} t__sn_gen_access_status;

/* line 21 "/proj/specman/src/gen_run_structs.e"  From 'subtype: TRUE'is_list field_node' */
#define d__TRUE__is_list__field_node 1441
/* line 21 "/proj/specman/src/gen_run_structs.e"  From 'subtype: FALSE'is_list TRUE'has_constraints the_item'the_wr field_node' */
#define d__the_item__the_wr__TRUE__has_constraints__FALSE__is_list__field_node 1442
/* line 74 "/proj/specman/src/gen_run_structs.e"  From 'Enum type 'list_ci'ci_type'' */
typedef enum {
    list_ci__ci_type__index_ci=0,
    list_ci__ci_type__item_in_list_ci=1,
    list_ci__ci_type__item_not_in_list_ci=2,
    list_ci__ci_type__list_in_list_ci=3,
    list_ci__ci_type__list_eq_ci=4,
    list_ci__ci_type__list_ne_ci=5,
    list_ci__ci_type__general_ci=6
} t__imp_enum_list_ci__ci_type;

/* line 21 "/proj/specman/src/gen_run_structs.e"  From 'subtype: struct_type'agt field_node' */
#define d__struct_type__agt__field_node 1431
/* line 2346 "/proj/specman/src/gen_gendb_header.e"  From 'Enum type 'sn_status_result_kinds'' */
typedef enum {
    sn_status_result_kinds__ci_TRUE=0,
    sn_status_result_kinds__ci_FALSE=1,
    sn_status_result_kinds__ci_IGNORED=2,
    sn_status_result_kinds__ci_BECAME_SIMPLE=3,
    sn_status_result_kinds__ci_NONE=4
} t__sn_status_result_kinds;

/* line 1397 "/proj/specman/src/gen_gendb_header.e"  From 'Enum type 'sn_gendb_status'' */
typedef enum {
    sn_gendb_status__SATISFIED=0,
    sn_gendb_status__CONTRADICTS=1,
    sn_gendb_status__IGNORED_INACCESSIBLE_DONGEN_PATH=2,
    sn_gendb_status__IGNORED_AND_BECAME_FALSE=3,
    sn_gendb_status__IGNORED_OR_BECAME_TRUE=4,
    sn_gendb_status__IGNORED_AND_BECAME_IGNORED=5,
    sn_gendb_status__BECAME_SIMPLE_AND_BECAME_SIMPLE=6,
    sn_gendb_status__BECAME_SIMPLE_OR_BECAME_ONE_ALT=7,
    sn_gendb_status__AND_ALT_BECAME_FALSE=8,
    sn_gendb_status__AND_ALT_BECAME_TRUE=9,
    sn_gendb_status__AND_LAST_ALT_BECAME_TRUE=10,
    sn_gendb_status__AND_IGNORED_OR_BECAME_TRUE=11,
    sn_gendb_status__AND_IGNORED_OR_BECAME_ONE_ALT=12,
    sn_gendb_status__OR_ALT_BECAME_TRUE=13,
    sn_gendb_status__OR_ALT_BECAME_FALSE=14,
    sn_gendb_status__OR_LEFT_WITH_ONE_ALT=15
} t__sn_gendb_status;

/* line 1042 "/proj/specman/src/gen_gendb_header.e"  From 'Enum type 'gen_process_status'' */
typedef enum {
    gen_process_status__in_progress=0,
    gen_process_status__complete=1,
    gen_process_status__error=2
} t__gen_process_status;

/* line 1573 "/proj/specman/src/gen_gendb_header.e"  From 'Enum type 'sn_create_edge_event'kind'' */
typedef enum {
    sn_create_edge_event__kind__Uni=0,
    sn_create_edge_event__kind__Bi=1,
    sn_create_edge_event__kind__Dof=2
} t__imp_enum_sn_create_edge_event__kind;

/* line 395 "/proj/specman/src/gen_reduce_or.e"  From 'Enum type 'status_in_and'' */
typedef enum {
    status_in_and__none=0,
    status_in_and__in_one_path=1,
    status_in_and__in_simple=2
} t__status_in_and;

/* line 393 "/proj/specman/src/gen_reduce_or.e"  From 'Enum type 'status_in_or'' */
typedef enum {
    status_in_or__none=0,
    status_in_or__in_one_path=1,
    status_in_or__in_simple=2,
    status_in_or__one_in_and=3,
    status_in_or__multi_in_and=4,
    status_in_or__removed=5
} t__status_in_or;

/* line 296 "../src/root_basic.e"  From 'Enum type 'next_prev_op'' */
typedef enum {
    next_prev_op__none=0,
    next_prev_op__print_list=1,
    next_prev_op__source=2
} t__next_prev_op;

/* line 300 "/proj/specman/src/basic_action.e"  From 'Enum type 'test_phase'' */
typedef enum {
    test_phase__before_setup=0,
    test_phase__before_generate=1,
    test_phase__before_start=2,
    test_phase__before_run=3,
    test_phase__before_check=4,
    test_phase__after_check=5
} t__test_phase;

/* line 94 "/proj/specman/src/interp.e"  From 'Enum type 'on_event_type'' */
typedef enum {
    on_event_type__none=0,
    on_event_type__event=1,
    on_event_type__tcm_start=2,
    on_event_type__tcm_end=3,
    on_event_type__tcm_call=4,
    on_event_type__tcm_return=5,
    on_event_type__tcm_wait=6,
    on_event_type__tcm_state=7,
    on_event_type__gen=8,
    on_event_type__call=9,
    on_event_type__return=10,
    on_event_type__cvl_call=11,
    on_event_type__cvl_return=12,
    on_event_type__sim_write=13,
    on_event_type__sim_read=14,
    on_event_type__output=15,
    on_event_type__line=16,
    on_event_type__check=17
} t__on_event_type;

/* line 239 "/proj/specman/src/scriptsim.e"  From 'Enum type 'run_status'' */
typedef enum {
    run_status__idle=0,
    run_status__ready=1,
    run_status__running=2,
    run_status__stopped=3
} t__run_status;

/* line 75 "/proj/specman/src/script.e"  From 'Enum type 'match_status'' */
typedef enum {
    match_status__NONE=0,
    match_status__BEFORE=1,
    match_status__FAILED=2,
    match_status__SUCCEEDED=3,
    match_status__ALREADY_SUCCEEDED=4,
    match_status__WAITING=5,
    match_status__WAITING_FOR_CHILD=6,
    match_status__TERMINATED=7,
    match_status__BREAK=8,
    match_status__CONTINUE=9,
    match_status__RETURN=10
} t__match_status;

/* line 518 "/proj/specman/src/config_main.e"  From 'Enum type 'config_categories'' */
typedef enum {
    config_categories__print=0,
    config_categories__cover=1,
    config_categories__gen=2,
    config_categories__run=3,
    config_categories__memory=4,
    config_categories__misc=5,
    config_categories__debug=6,
    config_categories__gui=7,
    config_categories__wave=8,
    config_categories__databrowser=9,
    config_categories__back32=10,
    config_categories__back33=11
} t__config_categories;

/* line 607 "/proj/specman/src/config_main.e"  From 'Enum type 'sn_cvr_grading_formula'' */
typedef enum {
    sn_cvr_grading_formula__linear=0,
    sn_cvr_grading_formula__root_mean_square=1
} t__sn_cvr_grading_formula;

/* line 600 "/proj/specman/src/config_main.e"  From 'Enum type 'sn_cfg_cover_mode'' */
typedef enum {
    sn_cfg_cover_mode__default=0,
    sn_cfg_cover_mode__off=1,
    sn_cfg_cover_mode__on=2,
    sn_cfg_cover_mode__on_interactive=3,
    sn_cfg_cover_mode__count_only=4,
    sn_cfg_cover_mode__normal=5
} t__sn_cfg_cover_mode;

/* line 596 "/proj/specman/src/config_main.e"  From 'Enum type 'show_mode'' */
typedef enum {
    show_mode__both=0,
    show_mode__holes_only=1,
    show_mode__full=2
} t__show_mode;

/* line 611 "/proj/specman/src/config_main.e"  From 'Enum type 'sn_cvr_cost_type'' */
typedef enum {
    sn_cvr_cost_type__constant_cost=0,
    sn_cvr_cost_type__cpu_time=1,
    sn_cvr_cost_type__user_cpu_time=2,
    sn_cvr_cost_type__system_cpu_time=3,
    sn_cvr_cost_type__test_time=4
} t__sn_cvr_cost_type;

/* line 619 "/proj/specman/src/config_main.e"  From 'Enum type 'sn_cover_gui_sync_mode'' */
typedef enum {
    sn_cover_gui_sync_mode__immediate=0,
    sn_cover_gui_sync_mode__deferred=1
} t__sn_cover_gui_sync_mode;

/* line 675 "/proj/specman/src/config_main.e"  From 'Enum type 'sn_show_on_trace'' */
typedef enum {
    sn_show_on_trace__structs=0,
    sn_show_on_trace__all=1,
    sn_show_on_trace__none=2
} t__sn_show_on_trace;

/* line 19 "/proj/specman/src/config_options_def.e"  From 'Enum type 't_exit_on'' */
typedef enum {
    t_exit_on__command=0,
    t_exit_on__normal_stop=1,
    t_exit_on__error=2,
    t_exit_on__all=3
} t__t_exit_on;

/* line 8 "/proj/specman/src/wave_init.e"  From 'Enum type 'wave_working_mode'' */
typedef enum {
    wave_working_mode__off_line=0,
    wave_working_mode__manual=1,
    wave_working_mode__interactive=2
} t__wave_working_mode;

/* line 522 "/proj/specman/src/config_main.e"  From 'subtype: print'category config_options' */
#define d__print__category__config_options 923
/* line 522 "/proj/specman/src/config_main.e"  From 'subtype: cover'category config_options' */
#define d__cover__category__config_options 918
/* line 522 "/proj/specman/src/config_main.e"  From 'subtype: gen'category config_options' */
#define d__gen__category__config_options 920
/* line 522 "/proj/specman/src/config_main.e"  From 'subtype: run'category config_options' */
#define d__run__category__config_options 924
/* line 522 "/proj/specman/src/config_main.e"  From 'subtype: memory'category config_options' */
#define d__memory__category__config_options 921
/* line 522 "/proj/specman/src/config_main.e"  From 'subtype: misc'category config_options' */
#define d__misc__category__config_options 925
/* line 522 "/proj/specman/src/config_main.e"  From 'subtype: debug'category config_options' */
#define d__debug__category__config_options 1021
/* line 522 "/proj/specman/src/config_main.e"  From 'subtype: gui'category config_options' */
#define d__gui__category__config_options 1023
/* line 522 "/proj/specman/src/config_main.e"  From 'subtype: wave'category config_options' */
#define d__wave__category__config_options 1025
/* line 522 "/proj/specman/src/config_main.e"  From 'subtype: databrowser'category config_options' */
#define d__databrowser__category__config_options 1027
/* line 522 "/proj/specman/src/config_main.e"  From 'subtype: back32'category config_options' */
#define d__back32__category__config_options 1029
/* line 522 "/proj/specman/src/config_main.e"  From 'subtype: back33'category config_options' */
#define d__back33__category__config_options 1031
/* line 513 "/proj/specman/src/config_main.e"  From 'Enum type 'ui_type'' */
typedef enum {
    ui_type__default=0,
    ui_type__check_box=1,
    ui_type__radio_button=2,
    ui_type__drop_down=3,
    ui_type__entry=4,
    ui_type__scale=5
} t__ui_type;

/* line 1788 "/proj/specman/src/config_main.e"  From 'Enum type 'config_option_status'' */
typedef enum {
    config_option_status__normal=0,
    config_option_status__deprecated=1,
    config_option_status__private=2,
    config_option_status__canceled=3
} t__config_option_status;

/* line 365 "/proj/specman/src/te_structs.e"  From 'Enum type 'waiting_thread_kind'' */
typedef enum {
    waiting_thread_kind__tcm_wait=0,
    waiting_thread_kind__tcm_sync=1,
    waiting_thread_kind__eval_event=2,
    waiting_thread_kind__eval_expect=3
} t__waiting_thread_kind;

/* line 256 "/proj/specman/src/te_root.e"  From 'type: bool (bits: 32)' */
#define t__bool__32 t__bool
/* line 258 "../src/root_basic.e"  From 'Enum type 'on_status'' */
typedef enum {
    on_status__normal=0,
    on_status__stopped=1,
    on_status__abort=2,
    on_status__continue=3
} t__on_status;

/* line 29 "/proj/specman/src/interp.e"  From 'Enum type 'on_kind'' */
typedef enum {
    on_kind__any=0,
    on_kind__call=1,
    on_kind__return=2,
    on_kind__step=3
} t__on_kind;

/* line 36 "/proj/specman/src/interp.e"  From 'Enum type 'on_stop_kind'' */
typedef enum {
    on_stop_kind__none=0,
    on_stop_kind__stop=1,
    on_stop_kind__trace=2,
    on_stop_kind__enter_debug=3,
    on_stop_kind__show_calls=4,
    on_stop_kind__skip=5
} t__on_stop_kind;

/* line 45 "/proj/specman/src/interp.e"  From 'Enum type 'request_type'' */
typedef enum {
    request_type__normal=0,
    request_type__event=1,
    request_type__on_error=2,
    request_type__on_interrupt=3,
    request_type__on_alloc=4,
    request_type__on_simulator=5,
    request_type__on_packing=6,
    request_type__on_reparse=7,
    request_type__on_deep=8,
    request_type__gen=9,
    request_type__each_line_for_interrupt=10,
    request_type__on_change=11,
    request_type__sim_read=12,
    request_type__sim_write=13,
    request_type__tcm_wait=14,
    request_type__tcm_state=15,
    request_type__output=16,
    request_type__check=17
} t__request_type;

/* line 66 "/proj/specman/src/interp.e"  From 'Enum type 'on_step_mode'' */
typedef enum {
    on_step_mode__none=0,
    on_step_mode__step=1,
    on_step_mode__next=2,
    on_step_mode__return=3
} t__on_step_mode;

/* line 14 "/proj/specman/src/dbg_thread_elem.e"  From 'Enum type 'thread_elem_kind'' */
typedef enum {
    thread_elem_kind__tcm=0,
    thread_elem_kind__fork_entry=1,
    thread_elem_kind__method=2
} t__thread_elem_kind;

/* line 37 "../src/root_basic.e"  From 'type: C_file' */
typedef FILE * t__C_file;
#define d__C_file 6
/* line 2 "/proj/specman/src/rl_rnd.e"  From 'Enum type 'rnd_policy'' */
typedef enum {
    rnd_policy__random=0,
    rnd_policy__median=1,
    rnd_policy__min=2,
    rnd_policy__max=3
} t__rnd_policy;

/* line 364 "/proj/specman/src/gen_static_header.e"  From 'Enum type 'pgen3'gen_static_phase'' */
typedef enum {
    pgen3__gen_static_phase__none=0,
    pgen3__gen_static_phase__reachability_analysis=1,
    pgen3__gen_static_phase__temps_relocation=2,
    pgen3__gen_static_phase__constraints_to_role_extraction=3,
    pgen3__gen_static_phase__create_extra_roles=4,
    pgen3__gen_static_phase__update_ranges=5,
    pgen3__gen_static_phase__static_reduction=6,
    pgen3__gen_static_phase__edge_creation=7,
    pgen3__gen_static_phase__finalize=8
} t__imp_enum_pgen3__gen_static_phase;

/* line 46 "/proj/specman/src/gen_basic.e"  From 'Enum type 'gen_phase'' */
typedef enum {
    gen_phase__none=0,
    gen_phase__static=1,
    gen_phase__after_static=2,
    gen_phase__pre_simulation=3,
    gen_phase__on_the_fly=4
} t__gen_phase;

/* line 223 "/proj/specman/src/gen_basic.e"  From 'Enum type 'pgen3'gen_status'' */
typedef enum {
    pgen3__gen_status__started=0,
    pgen3__gen_status__completed=1,
    pgen3__gen_status__failed=2
} t__imp_enum_pgen3__gen_status;

/* line 2749 "/proj/specman/src/gen_gendb_header.e"  From 'Enum type 'pgen3'visual_deb_level'' */
typedef enum {
    pgen3__visual_deb_level__none=0,
    pgen3__visual_deb_level__skeleton=1,
    pgen3__visual_deb_level__full=2
} t__imp_enum_pgen3__visual_deb_level;

/* line 438 "/proj/specman/src/gen_static_header.e"  From 'Enum type 'edge_relation'' */
typedef enum {
    edge_relation__before=0,
    edge_relation__after=1,
    edge_relation__exact=2,
    edge_relation__parallel=3,
    edge_relation__split=4,
    edge_relation__split_like=5
} t__edge_relation;

/* line 1739 "/proj/specman/src/gen_roles.e"  From 'Enum type 'the_edge_place'' */
typedef enum {
    the_edge_place__FIND_RE=0,
    the_edge_place__MATCH_END_POINT=1,
    the_edge_place__FIND_OR_CREATE=2,
    the_edge_place__FIND_EDGE_STAT=3,
    the_edge_place__MATCH_ROLE=4
} t__the_edge_place;

/* line 69 "/proj/specman/src/gen_parse.e"  From 'Enum type 'pgen3_debug'phase'' */
typedef enum {
    pgen3_debug__phase__static=0,
    pgen3_debug__phase__dynamic=1
} t__imp_enum_pgen3_debug__phase;

/* line 70 "/proj/specman/src/gen_parse.e"  From 'Enum type 'pgen3_debug'level'' */
typedef enum {
    pgen3_debug__level__terse=0,
    pgen3_debug__level__detailed=1,
    pgen3_debug__level__internal=2
} t__imp_enum_pgen3_debug__level;

/* line 14 "/proj/specman/src/gen_debug_order_graph.e"  From 'Enum type 'gdo_node_kind'' */
typedef enum {
    gdo_node_kind__scalar=0,
    gdo_node_kind__struct=1,
    gdo_node_kind__list=2
} t__gdo_node_kind;

/* line 1053 "/proj/specman/src/gen_debug.e"  From 'Enum type 'sn_gen_boring_status'' */
typedef enum {
    sn_gen_boring_status__unknown=0,
    sn_gen_boring_status__interesting=1,
    sn_gen_boring_status__boring=2
} t__sn_gen_boring_status;

/* line 314 "/proj/specman/src/gen_debug.e"  From 'Enum type 'sn_msg_show_request_kind'' */
typedef enum {
    sn_msg_show_request_kind__by_exp=0,
    sn_msg_show_request_kind__by_type=1,
    sn_msg_show_request_kind__by_type_only=2
} t__sn_msg_show_request_kind;

/* line 220 "/proj/specman/src/gen_om_item.e"  From 'Enum type 'om_item_node'color'' */
typedef enum {
    om_item_node__color__white=0,
    om_item_node__color__black=1
} t__imp_enum_om_item_node__color;

/* line 260 "/proj/specman/src/rl_interface.e"  From 'Enum type 'sn_gen_list_kind'' */
typedef enum {
    sn_gen_list_kind__is_int=0,
    sn_gen_list_kind__is_long=1,
    sn_gen_list_kind__is_packed=2,
    sn_gen_list_kind__is_struct=3
} t__sn_gen_list_kind;

/* line 192 "/proj/specman/src/disp_defs.e"  From 'Enum type 'display_kind'' */
typedef enum {
    display_kind__none=0,
    display_kind__tk=1
} t__display_kind;

/* line 204 "/proj/specman/src/disp_defs.e"  From 'Enum type 'presentation_type'' */
typedef enum {
    presentation_type__text=0,
    presentation_type__image=1,
    presentation_type__compound=2
} t__presentation_type;

/* line 92 "/proj/specman/src/disp_defs.e"  From 'Enum type 'display_window'state'' */
typedef enum {
    display_window__state__unmapped=0,
    display_window__state__unreachable=1,
    display_window__state__invisible=2,
    display_window__state__visible=3,
    display_window__state__visible_locked=4
} t__imp_enum_display_window__state;

/* line 86 "/proj/specman/src/disp_defs.e"  From 'Enum type 'main_window_kind'' */
typedef enum {
    main_window_kind__main=0,
    main_window_kind__list=1,
    main_window_kind__struct=2,
    main_window_kind__file=3,
    main_window_kind__help=4,
    main_window_kind__config=5,
    main_window_kind__graphic=6,
    main_window_kind__cover=7,
    main_window_kind__breakpoint=8,
    main_window_kind__src_browser=9,
    main_window_kind__thread_list=10,
    main_window_kind__single_thread=11,
    main_window_kind__debug=12,
    main_window_kind__event_chart=13,
    main_window_kind__quick_load=14,
    main_window_kind__scalar=15,
    main_window_kind__watch=16,
    main_window_kind__gen_debug=17,
    main_window_kind__struct_expand=18
} t__main_window_kind;

/* line 35 "/proj/specman/src/disp_defs.e"  From 'Enum type 'widget_kind'' */
typedef enum {
    widget_kind__menu=0,
    widget_kind__toolbar=1,
    widget_kind__popup=2
} t__widget_kind;

/* line 428 "../src/root_basic.e"  From 'Enum type 'sn_filter_level'' */
typedef enum {
    sn_filter_level__transparent=0,
    sn_filter_level__light=1,
    sn_filter_level__heavy=2
} t__sn_filter_level;

/* line 6 "/proj/specman/src/encrypt_table.e"  From 'Enum type 'encrypt_attribute'' */
typedef enum {
    encrypt_attribute__normal=0,
    encrypt_attribute__monitor_ip=1,
    encrypt_attribute__active_ip=2,
    encrypt_attribute__enhanced_ip=3
} t__encrypt_attribute;

/* line 45 "../src/root_basic.e"  From 'type: byte' */
typedef unsigned int t__byte;
#define d__byte 12
/* line 412 "/proj/specman/src/scriptsim.e"  From 'Enum type 'simulator_product'' */
typedef enum {
    simulator_product__unknown=0,
    simulator_product__xl=1,
    simulator_product__vcs=2,
    simulator_product__spd=3,
    simulator_product__qhsim=4,
    simulator_product__leapfrog=5,
    simulator_product__vss=6,
    simulator_product__mti=7,
    simulator_product__nc=8,
    simulator_product__ncvhdl=9,
    simulator_product__qvh=10,
    simulator_product__snsim=11
} t__simulator_product;

/* line 427 "/proj/specman/src/scriptsim.e"  From 'Enum type 'simulator_gui_mode'' */
typedef enum {
    simulator_gui_mode__unknown=0,
    simulator_gui_mode__text=1,
    simulator_gui_mode__gui=2
} t__simulator_gui_mode;

/* line 9 "/proj/specman/src/hdl_struct.e"  From 'Enum type 'sn_back33_stub'' */
typedef enum {
    sn_back33_stub__dont_care=0,
    sn_back33_stub__normal=1,
    sn_back33_stub__back33=2,
    sn_back33_stub__back_and_normal=3
} t__sn_back33_stub;

/* line 97 "/proj/specman/src/script.e"  From 'type: thread_handle' */
#define t__thread_handle t__index
/* line 840 "/proj/specman/src/te_structs.e"  From 'Enum type 'sn_sched_phase'' */
typedef enum {
    sn_sched_phase__none=0,
    sn_sched_phase__eval_te=1,
    sn_sched_phase__eval_tcm=2,
    sn_sched_phase__end_of_tick=3
} t__sn_sched_phase;

/* line 9 "/proj/specman/src/comm_request.e"  From 'Enum type 'comm_request_opcode'' */
typedef enum {
    comm_request_opcode__error=0,
    comm_request_opcode__undef=1,
    comm_request_opcode__get_application_desc=2,
    comm_request_opcode__general_in_request=100,
    comm_request_opcode__general_out_request=101,
    comm_request_opcode__general_in_notification=102,
    comm_request_opcode__general_out_notification=103,
    comm_request_opcode__initialize=3,
    comm_request_opcode__read_cover=4,
    comm_request_opcode__clear_cover=5,
    comm_request_opcode__get_cover_tests=6,
    comm_request_opcode__get_contributed_tests=7,
    comm_request_opcode__include_exclude=8,
    comm_request_opcode__get_initial_file_system_info=9,
    comm_request_opcode__get_dir_contents=10,
    comm_request_opcode__get_cover_element_data=11,
    comm_request_opcode__get_item_type=12,
    comm_request_opcode__report=13,
    comm_request_opcode__set_cover_config=14,
    comm_request_opcode__get_cover_config=15,
    comm_request_opcode__get_postrun_data=16,
    comm_request_opcode__opc_cancel_wakeup_in_notification=200
} t__comm_request_opcode;

/* line 16 "/proj/specman/src/comm_request.e"  From 'Enum type 'comm_status'' */
typedef enum {
    comm_status__OK=0,
    comm_status__ERROR=1,
    comm_status__READ_COVER_FORCE_REFRESH=3
} t__comm_status;

/* line 28 "/proj/specman/src/cvl_defs.e"  From 'Enum type 'sn_con_state'' */
typedef enum {
    sn_con_state__BOUND=0,
    sn_con_state__LISTEN=1,
    sn_con_state__CONNECTED=2,
    sn_con_state__CLOSED=3,
    sn_con_state__ERROR=4
} t__sn_con_state;

/* line 330 "/proj/specman/src/memory.e"  From 'Enum type 'pack_originate_from'' */
typedef enum {
    pack_originate_from__exp=0,
    pack_originate_from__field=1,
    pack_originate_from__list=2,
    pack_originate_from__packed_list=3
} t__pack_originate_from;

/* line 120 "/proj/specman/src/script_rnd.e"  From 'Enum type 'random_policy'' */
typedef enum {
    random_policy__flat=0,
    random_policy__lowest=1,
    random_policy__highest=2,
    random_policy__jumping=3
} t__random_policy;

/* line 321 "/proj/specman/src/scriptsim.e"  From 'Enum type 'capture_mode'' */
typedef enum {
    capture_mode__inactive=0,
    capture_mode__replaying=1,
    capture_mode__recording=2
} t__capture_mode;

/* line 17 "/proj/specman/src/cap_structs.e"  From 'Enum type 'data_format'' */
typedef enum {
    data_format__short_format=0,
    data_format__long_format=1
} t__data_format;

/* line 13 "/proj/specman/src/wave_test.e"  From 'Enum type 'wave_execution_mode'' */
typedef enum {
    wave_execution_mode__normal=0,
    wave_execution_mode__testing=1
} t__wave_execution_mode;

/* line 5 "/proj/specman/src/wave_init.e"  From 'Enum type 'waveform_kind'' */
typedef enum {
    waveform_kind__none=0,
    waveform_kind__unknown=1,
    waveform_kind__signalscan=2,
    waveform_kind__novas=3,
    waveform_kind__virsim=4,
    waveform_kind__mti=5,
    waveform_kind__undertow=6
} t__waveform_kind;

/* line 17 "/proj/specman/src/help_html.e"  From 'Enum type 'line_kind'' */
typedef enum {
    line_kind__startl=0,
    line_kind__endl=1,
    line_kind__matched=2,
    line_kind__none=3,
    line_kind__marked=4,
    line_kind__expecting=5,
    line_kind__endmarked=6,
    line_kind__startmarked=7,
    line_kind__discard=8
} t__line_kind;

/* line 113 "/proj/specman/src/cover_basic.e"  From 'Enum type 'sn_cvr_mode'' */
typedef enum {
    sn_cvr_mode__default=0,
    sn_cvr_mode__off=1,
    sn_cvr_mode__on=2,
    sn_cvr_mode__on_interactive=3
} t__sn_cvr_mode;

/* line 125 "/proj/specman/src/cover_basic.e"  From 'Enum type 'sn_cvr_xyz'' */
typedef enum {
    sn_cvr_xyz__x=0,
    sn_cvr_xyz__y=1,
    sn_cvr_xyz__z=2
} t__sn_cvr_xyz;

/* line 149 "/proj/specman/src/cover_basic.e"  From 'Enum type 'sn_cvr_external_type'' */
typedef enum {
    sn_cvr_external_type__none=0,
    sn_cvr_external_type__surecov=1
} t__sn_cvr_external_type;

/* line 186 "/proj/specman/src/cover_rank.e"  From 'type: sn_ranker'grade_threshold' */
#define t__sn_ranker__grade_threshold t__int
/* line 17 "/proj/specman/src/times.e"  From 'type: clock_t' */
#define t__clock_t t__uint
/* line 18 "/proj/specman/src/times.e"  From 'type: long' */
#define t__long t__uint
/* line 54 "/proj/specman/src/cover_jcvr.e"  From 'Enum type 'jcvr_pack_mode'' */
typedef enum {
    jcvr_pack_mode__property=0,
    jcvr_pack_mode__shallow=1,
    jcvr_pack_mode__deep=2,
    jcvr_pack_mode__item_type=3
} t__jcvr_pack_mode;

/* line 119 "/proj/specman/src/fl_struct.e"  From 'Enum type 'sn_fl_v_top_node'is_sticky_true_cash'' */
typedef enum {
    sn_fl_v_top_node__is_sticky_true_cash__UNSET=0,
    sn_fl_v_top_node__is_sticky_true_cash__YES=1,
    sn_fl_v_top_node__is_sticky_true_cash__NO=2
} t__imp_enum_sn_fl_v_top_node__is_sticky_true_cash;

/* line 121 "/proj/specman/src/fl_struct.e"  From 'Enum type 'sn_fl_v_top_node'is_neg_over_sense_cash'' */
typedef enum {
    sn_fl_v_top_node__is_neg_over_sense_cash__UNSET=0,
    sn_fl_v_top_node__is_neg_over_sense_cash__YES=1,
    sn_fl_v_top_node__is_neg_over_sense_cash__NO=2
} t__imp_enum_sn_fl_v_top_node__is_neg_over_sense_cash;

/* line 371 "/proj/specman/src/fl_sm.e"  From 'Enum type 'sn_fl_state_status'' */
typedef enum {
    sn_fl_state_status__UNVISIT=0,
    sn_fl_state_status__UNKNOWN=1,
    sn_fl_state_status__st_YES=2,
    sn_fl_state_status__st_NO=3
} t__sn_fl_state_status;

/* line 20 "/proj/specman/src/fl_struct.e"  From 'Enum type 'sn_fl_true_occ_kind'' */
typedef enum {
    sn_fl_true_occ_kind__UNDEFINED=0,
    sn_fl_true_occ_kind__UNIQUE=1,
    sn_fl_true_occ_kind__ONE_STATE=2,
    sn_fl_true_occ_kind__MANY_STATES=3
} t__sn_fl_true_occ_kind;

/* line 17 "/proj/specman/src/fl_debug.e"  From 'Enum type 'tdb_print_level'' */
typedef enum {
    tdb_print_level__none=0,
    tdb_print_level__short=1,
    tdb_print_level__medium=2,
    tdb_print_level__long=3
} t__tdb_print_level;

/* line 108 "/proj/specman/src/fl_debug.e"  From 'Enum type 'sn_hp_fsm_eval'location'' */
typedef enum {
    sn_hp_fsm_eval__location__starting=0,
    sn_hp_fsm_eval__location__finished=1
} t__imp_enum_sn_hp_fsm_eval__location;

/* line 30 "/proj/specman/src/cvl_defs.e"  From 'Enum type 'sn_connection_type'' */
typedef enum {
    sn_connection_type__server=0,
    sn_connection_type__client=1
} t__sn_connection_type;

/* line 32 "/proj/specman/src/cvl_defs.e"  From 'Enum type 'sn_callmode_type'' */
typedef enum {
    sn_callmode_type__sn_sync=0,
    sn_callmode_type__sn_async=1
} t__sn_callmode_type;

/* line 26 "/proj/specman/src/cvl_defs.e"  From 'Enum type 'sn_cvl_method_type'' */
typedef enum {
    sn_cvl_method_type__cvl_method=0,
    sn_cvl_method_type__cvl_callback=1,
    sn_cvl_method_type__stub_cvl_call=2,
    sn_cvl_method_type__stub_cvl_method=3
} t__sn_cvl_method_type;

/* line 151 "/proj/specman/src/cover_basic.e"  From 'Enum type 'sn_cover_report_kind'' */
typedef enum {
    sn_cover_report_kind__full=0,
    sn_cover_report_kind__summary=1,
    sn_cover_report_kind__spreadsheet=2
} t__sn_cover_report_kind;

/* line 647 "/proj/specman/src/snorb/edl/edl_generate.e"  From 'Enum type 'typeKind'' */
typedef enum {
    typeKind__edl_unknown=0,
    typeKind__edl_byte=1,
    typeKind__edl_bool=2,
    typeKind__edl_int=3,
    typeKind__edl_uint=4,
    typeKind__edl_string=5,
    typeKind__edl_interface=6,
    typeKind__edl_data=7,
    typeKind__edl_enum=8
} t__typeKind;

/* line 224 "/proj/specman/src/snorb/edl/edl_generate.e"  From 'Enum type 'EDLLanguage'' */
typedef enum {
    EDLLanguage__none=0,
    EDLLanguage__E=1,
    EDLLanguage__JAVA=2
} t__EDLLanguage;

/* line 10 "/proj/specman/src/japp/databrowser/db_cache_building_blocks.e"  From 'Enum type 'node_refresh_status'' */
typedef enum {
    node_refresh_status__none=0,
    node_refresh_status__visited=1,
    node_refresh_status__refreshed=2
} t__node_refresh_status;

/* line 47 "/proj/specman/src/japp/vt/vt_utils.e"  From 'Enum type 'sn_vt'trace'' */
typedef enum {
    sn_vt__trace__off=0,
    sn_vt__trace__on=1
} t__imp_enum_sn_vt__trace;

/* line 6 "/proj/specman/src/denali_unit.e"  From 'Enum type 'sn_denali_access_type'' */
typedef enum {
    sn_denali_access_type__sn_denali_read=0,
    sn_denali_access_type__sn_denali_read_unk=1,
    sn_denali_access_type__sn_denali_write=2,
    sn_denali_access_type__sn_denali_write_unk=3,
    sn_denali_access_type__sn_denali_write_mask=4,
    sn_denali_access_type__sn_denali_write_masked_unk=5,
    sn_denali_access_type__sn_denali_load=6,
    sn_denali_access_type__sn_denali_load_done=7,
    sn_denali_access_type__sn_denali_reset=8,
    sn_denali_access_type__sn_denali_ei=9,
    sn_denali_access_type__sn_denali_ei_unk=10,
    sn_denali_access_type__sn_denali_ei_mask=11,
    sn_denali_access_type__sn_denali_ei_masked_unk=12
} t__sn_denali_access_type;

/* line 14 "e/vrst_snfp_h.e"  From 'Enum type 'enum__44915'' */
typedef enum {
    enum__44915__POS=0,
    enum__44915__NEG=1
} t__enum__44915;

/* line 14 "e/vrst_snfp_h.e"  From 'Enum type 'snfp_sign_t'' */
typedef enum {
    snfp_sign_t__POS=0,
    snfp_sign_t__NEG=1
} t__snfp_sign_t;

/* line 15 "e/vrst_snfp_h.e"  From 'Enum type 'snfp_floating_point_t'' */
typedef enum {
    snfp_floating_point_t__SINGLE=0,
    snfp_floating_point_t__DOUBLE=1,
    snfp_floating_point_t__EXTENDED=2
} t__snfp_floating_point_t;

/* line 16 "e/vrst_snfp_h.e"  From 'Enum type 'snfp_floating_point_number_t'' */
typedef enum {
    snfp_floating_point_number_t__NORMAL=0,
    snfp_floating_point_number_t__DENORMAL=1,
    snfp_floating_point_number_t__ZERO=2,
    snfp_floating_point_number_t__INFINITY=3,
    snfp_floating_point_number_t__SNaN=4,
    snfp_floating_point_number_t__QNaN=5
} t__snfp_floating_point_number_t;

/* line 17 "e/vrst_snfp_h.e"  From 'Enum type 'snfp_fmt_t'' */
typedef enum {
    snfp_fmt_t__F_FMT=0,
    snfp_fmt_t__E_FMT=1
} t__snfp_fmt_t;

/* line 18 "e/vrst_snfp_h.e"  From 'Enum type 'snfp_efp_function_t'' */
typedef enum {
    snfp_efp_function_t__FADD=0,
    snfp_efp_function_t__FSUB=1,
    snfp_efp_function_t__FMUL=2,
    snfp_efp_function_t__FDIV=3,
    snfp_efp_function_t__ACOS=4,
    snfp_efp_function_t__ASIN=5,
    snfp_efp_function_t__ATAN=6,
    snfp_efp_function_t__COS=7,
    snfp_efp_function_t__SIN=8,
    snfp_efp_function_t__TAN=9,
    snfp_efp_function_t__COSH=10,
    snfp_efp_function_t__SINH=11,
    snfp_efp_function_t__TANH=12,
    snfp_efp_function_t__ACOSH=13,
    snfp_efp_function_t__ASINH=14,
    snfp_efp_function_t__ATANH=15,
    snfp_efp_function_t__EXP=16,
    snfp_efp_function_t__LOG=17,
    snfp_efp_function_t__LOG10=18,
    snfp_efp_function_t__CMP=19
} t__snfp_efp_function_t;

/* line 82 "e/vrst_snfp_h.e"  From 'Enum type 'snfp_random_fp_kind'' */
typedef enum {
    snfp_random_fp_kind__ZERO_TO_ONE=0,
    snfp_random_fp_kind__NON_TYPED=1,
    snfp_random_fp_kind__BIT_TOGGLE=2
} t__snfp_random_fp_kind;

/* line 117 "e/vrst_snfp_h.e"  From 'subtype: ZERO_TO_ONE'kind snfp_rnd_fp_s' */
#define d__ZERO_TO_ONE__kind__snfp_rnd_fp_s 4273
/* line 117 "e/vrst_snfp_h.e"  From 'subtype: BIT_TOGGLE'kind snfp_rnd_fp_s' */
#define d__BIT_TOGGLE__kind__snfp_rnd_fp_s 4274
/* line 48 "e/vrst_snfp_h.e"  From 'subtype: SINGLE'kind snfp_floating_point_s' */
#define d__SINGLE__kind__snfp_floating_point_s 4275
/* line 48 "e/vrst_snfp_h.e"  From 'subtype: DOUBLE'kind snfp_floating_point_s' */
#define d__DOUBLE__kind__snfp_floating_point_s 4276
/* line 24 "e/vrst_snfp_h.e"  From 'define SFP_EXP_MAX' */
#ifndef SNDEF__SFP_EXP_MAX
#define SNDEF__SFP_EXP_MAX (255)
#endif
/* line 25 "e/vrst_snfp_h.e"  From 'define SFP_MAN_MAX' */
#ifndef SNDEF__SFP_MAN_MAX
#define SNDEF__SFP_MAN_MAX (16777207)
#endif
/* line 26 "e/vrst_snfp_h.e"  From 'define DFP_EXP_MAX' */
#ifndef SNDEF__DFP_EXP_MAX
#define SNDEF__DFP_EXP_MAX (4087)
#endif
/* line 27 "e/vrst_snfp_h.e"  From 'define DFP_MAN_MAX' */
#ifndef SNDEF__DFP_MAN_MAX
#define SNDEF__DFP_MAN_MAX (1048575)
#endif
/* line 28 "e/vrst_snfp_h.e"  From 'define EXFP_EXP_MAX' */
#ifndef SNDEF__EXFP_EXP_MAX
#define SNDEF__EXFP_EXP_MAX (65527)
#endif
/* line 29 "e/vrst_snfp_h.e"  From 'define EXFP_MAN_MAX' */
#ifndef SNDEF__EXFP_MAN_MAX
#define SNDEF__EXFP_MAN_MAX (-9)
#endif
/* line 1101 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__global {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__specman_config *specman_config;
        struct s__symtab *symtab;
        struct s__units *units;
        struct s__k__type_descriptor__name *all_types;
        struct s__session *session;
        struct s__debug *debug;
        struct s__configuration *configuration;
        struct s__on *on;
        struct s__no_save *no_save;
        struct s__sn_memory_options *sn_memory_options;
        struct s__print_options *print_options;
        struct s__compatibility_options *compatibility_options;
        struct s__files *files;
        struct s__interactive_scope *interactive_scope;
        struct s__activation_record *CAR;
        struct s__pgen *pgen;
        struct s__pgen3 *pgen3;
        struct s__display *display;
        struct s__parse *parse;
        struct s__simulator *simulator;
        struct s__scheduler *scheduler;
        t__string final_path;
        t__string last_line;
        struct s__dual_line_buff *dl_buff;
        t__bool invisible_out;
        struct s__sn_communication *sn_communication;
        struct s__l__pat *files___all_pats;
        struct s__sys *sys;
        struct s__packing *packing;
        t__bool specman_version_macro_done;
        struct s__source_item *script_type___source_item;
        struct s__params *params;
        struct s__sn_capture *sn_capture;
        struct s__sn_wave *sn_wave;
        struct s__dut_error_struct *dut_error___dut_err;
        struct s__k__fake_signal__name *script___fake_signals;
        struct s__memory_globals *memory_globals;
        struct s__random_info *random_info;
        struct s__rf_manager *rf_manager;
        struct s__l__untyped_list_to_scala6585 *untyped_list_to_scalar_convertors;
        struct s__l__uint *masks;
        struct s__major_path *major_path;
        struct s__sn_shlibs *shlibs;
        struct s__sn_util *util;
        struct s__sn_patches *sn_patches;
        struct s__help_index *help_index;
        struct s__interact *interact;
        struct s__covers *covers;
        struct s__sn_guitest *p_guitest;
        struct s__sn_formal_link *fl;
        struct s__sn_bdd_manager *gmbdd;
        struct s__k__sn_define2_descripto16521 *all_def2_descriptors;
        struct s__seamless *seamless;
        struct s__cvl *cvl;
        struct s__sn_comm_api *sn_comm_api;
        struct s__sn_edl_parser *sn_edl_parser;
        struct s__sn_edl_code_generator *sn_edl_code_generator;
        struct s__EDLGlobal *p_edl_global;
        struct s__snorb *snorb;
        struct s__event_viewer *eve;
        t__bool prof_was_in_pre_quit;
        struct s__sn_pub_services *pub_services;
        struct s__sn_japp *japp;
        struct s__sn_jspecview_deli *jspecview_deli;
        struct s__sn_source_viewer *p_source_viewer;
        struct s__sn_jconfig *p_jconfig;
        struct s__sn_gt *sn_gt;
        struct s__sn_databrowser *p_databrowser;
        struct s__sn_evaluator *evaluator;
        t__int last_module_num;
        struct s__sn_vt *vt;
        struct s__sn_denali *sn_denali;
        t__bool denali_unit___sn_denali_init_flag;
        t__bool disable_capture;
        struct s__capture_helper *capture_helper;
        t__bool pre_specman___pre_quit_already_called;
} *t__global;
#define d__global 81

/* line 98 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__any_unit {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__int root___instance_id;
        t__string root___e_path;
        t__string root___full_hdl_path;
        t__string root___converted_full_hdl_path;
        t__string root___normal_hdl_path;
        t__int root___relative_id;
        t__string atomic_exp___hdl_path;
        struct s__sn_adapter_struct *atomic_exp___adapter_struct;
        t__string atomic_exp___agent_name;
        struct s__any_unit *atomic_exp___parent_unit;
        struct s__l__any_unit *atomic_exp___enclosing_list;
} *t__any_unit;
#define d__any_unit 17

/* line 111 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__sn_adapter_struct {
    t__int d__;
    t__int gen__;
        t__string name;
        t__string adapter_lib;
        struct s__l__string *aliases;
        t__int id;
        t__sn_agent_kind kind;
        t__bool tick_started;
        t__string sim_product;
        struct s__l__instance_path_t *sn_instances;
        struct s__sn_dynamic_call__sn_adap9735 *check_sig;
        struct s__sn_dynamic_call__sn_adap9736 *simulator_product;
        struct s__sn_dynamic_call__sn_adap9737 *simulator_kind;
        struct s__sn_dynamic_call__sn_adap9738 *get_sig;
        struct s__sn_dynamic_call__sn_adap9739 *put_sig;
        struct s__sn_dynamic_call__sn_adap9740 *get_hdl_scalar;
        struct s__sn_dynamic_call__sn_adap9741 *get_hdl_string;
        struct s__sn_dynamic_call__sn_adap9742 *fill_stub_handle;
        struct s__sn_dynamic_call__sn_adap9743 *create_driver;
        struct s__sn_dynamic_call__sn_adap9744 *restore_drivers;
        struct s__sn_dynamic_call__sn_adap9745 *fetch_value;
        struct s__sn_dynamic_call__sn_adap9746 *set_to_sig;
        struct s__sn_dynamic_call__sn_adap9747 *decanon_name;
        struct s__sn_dynamic_call__sn_adap9748 *append_full_name;
        struct s__sn_dynamic_call__sn_adap9749 *register_cb;
        struct s__sn_dynamic_call__sn_adap9750 *register_cb_param;
        struct s__sn_dynamic_call__sn_adap9751 *disable_cb;
        struct s__sn_dynamic_call__sn_adap9752 *disable_cb_param;
        struct s__sn_dynamic_call__sn_adap9753 *set_timer;
        struct s__sn_dynamic_call__sn_adap9754 *simulator_command;
        struct s__sn_dynamic_call__sn_adap9755 *simulator_restore;
        struct s__sn_dynamic_call__sn_adap9756 *simulator_log_write;
        struct s__sn_dynamic_call__sn_adap9757 *simulator_screen_write;
        struct s__sn_dynamic_call__sn_adap9758 *simulator_gui_mode;
        struct s__sn_dynamic_call__sn_adap9759 *refresh_simulator_gui;
        struct s__sn_dynamic_call__sn_adap9760 *simulator_screen_prompt;
        struct s__sn_dynamic_call__sn_adap9761 *simulator_gets;
        struct s__sn_dynamic_call__sn_adap9762 *simulator_exit;
        struct s__sn_dynamic_call__sn_adap9763 *simulator_finish;
        struct s__sn_dynamic_call__sn_adap9764 *set_elaborate;
        struct s__sn_dynamic_call__sn_adap9765 *create_sim_user_data;
        struct s__sn_dynamic_call__sn_adap9766 *set_ptr_sim_user_data;
        struct s__sn_dynamic_call__sn_adap9767 *check_legal_sensitivity_kind;
        struct s__sn_dynamic_call__sn_adap9768 *set_ptr_sig_param_callback_data;
        struct s__sn_dynamic_call__sn_adap9769 *call_subprogram;
        struct s__sn_dynamic_call__sn_adap9770 *get_subprogram_param;
        struct s__sn_dynamic_call__sn_adap9771 *get_specman_instance_path;
        struct s__sn_dynamic_call__sn_adap9772 *drive_bit;
        struct s__sn_dynamic_call__sn_adap9773 *drive_string;
        struct s__sn_dynamic_call__sn_adap9774 *drive_uint;
        struct s__sn_dynamic_call__sn_adap9775 *hdl_path_separator;
        struct s__sn_dynamic_call__sn_adap9776 *simulator_version;
        struct s__sn_dynamic_call__sn_adap9777 *get_argv;
        struct s__sn_dynamic_call__sn_adap9778 *create_sig_param_data_new_proc;
        struct s__sn_dynamic_call__sn_adap9779 *create_sig_param_data;
        struct s__sn_dynamic_call__sn_adap9780 *get_and_put;
        struct s__sn_dynamic_call__sn_adap9781 *alocate_in_simulator;
        struct s__sn_dynamic_call__sn_adap9782 *restore_adapter;
        struct s__sn_dynamic_call__sn_adap9783 *init_adapter;
        struct s__sn_dynamic_call__sn_adap9784 *set_time_scale;
        struct s__sn_dynamic_call__sn_adap9785 *get_time_scale;
        struct s__sn_dynamic_call__sn_adap9786 *receive_cb_denali;
        struct s__sn_dynamic_call__sn_adap9787 *denali_decanon_name;
        struct s__l__string *finish_msgs;
        t__bool isCallBackDeleted;
} *t__sn_adapter_struct;
#define d__sn_adapter_struct 18

/* line 1405 "/proj/specman/src/atomic_exp.e"  From 'struct definition' */
typedef struct s__instance_path_t {
    t__int d__;
    t__int gen__;
        struct s__sn_adapter_struct *adapter_struct;
        t__string sn_hdl_path;
        t__string sn_normal_path;
        t__string wave_hdl_path;
        t__string wave_normal_path;
        t__uint checksum;
        t__uint checksum_ref;
        t__uint version_date;
        t__bool generated_stub;
        t__bool stub_version_ok;
        t__uint sn_integer_num;
        t__uint sn_boolean_num;
        t__uint sn_error_num;
        t__uint sn_error_len;
        t__uint sn_message_num;
        t__uint sn_message_len;
        t__uint sn_string_num;
        t__uint sn_string_len;
        t__uint sn_event_num;
        t__uint sn_integer_offset;
        t__uint sn_boolean_offset;
        t__uint sn_error_offset;
        t__uint sn_message_offset;
        t__uint sn_string_offset;
        t__uint sn_event_offset;
        t__bool duplicated;
} *t__instance_path_t;
#define d__instance_path_t 572

/* line 81 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9735 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__check_sig;
#define d__sn_dynamic_call__sn_adapter_struct__check_sig 1593

/* line 214 "/proj/specman/src/c_agent_call.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call_addon {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sn_dynamic_call_addon;
#define d__sn_dynamic_call_addon 1511

/* line 31 "/proj/specman/src/shlibs.e"  From 'struct definition' */
typedef struct s__sn_library {
    t__int d__;
    t__int gen__;
        t__string name;
        t__external_pointer shlib_handler;
        t__bool loaded;
        t__bool close_upon_restore;
        t__sn_lib_resolve_mode resolve;
        t__sn_lib_scope_mode scope;
        struct s__l__sn_dynamic_call *calls;
} *t__sn_library;
#define d__sn_library 1505

/* line 408 "/proj/specman/src/shlibs.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call;
#define d__sn_dynamic_call 1509

/* line 83 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9736 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__simulator_product;
#define d__sn_dynamic_call__sn_adapter_struct__simulator_product 1594

/* line 85 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9737 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__simulator_kind;
#define d__sn_dynamic_call__sn_adapter_struct__simulator_kind 1595

/* line 87 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9738 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__get_sig;
#define d__sn_dynamic_call__sn_adapter_struct__get_sig 1596

/* line 90 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9739 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__put_sig;
#define d__sn_dynamic_call__sn_adapter_struct__put_sig 1597

/* line 93 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9740 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__get_hdl_scalar;
#define d__sn_dynamic_call__sn_adapter_struct__get_hdl_scalar 1598

/* line 95 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9741 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__get_hdl_string;
#define d__sn_dynamic_call__sn_adapter_struct__get_hdl_string 1599

/* line 97 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9742 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__fill_stub_handle;
#define d__sn_dynamic_call__sn_adapter_struct__fill_stub_handle 1600

/* line 99 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9743 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__create_driver;
#define d__sn_dynamic_call__sn_adapter_struct__create_driver 1601

/* line 102 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9744 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__restore_drivers;
#define d__sn_dynamic_call__sn_adapter_struct__restore_drivers 1602

/* line 104 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9745 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__fetch_value;
#define d__sn_dynamic_call__sn_adapter_struct__fetch_value 1603

/* line 107 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9746 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__set_to_sig;
#define d__sn_dynamic_call__sn_adapter_struct__set_to_sig 1604

/* line 109 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9747 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__decanon_name;
#define d__sn_dynamic_call__sn_adapter_struct__decanon_name 1605

/* line 111 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9748 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__append_full_name;
#define d__sn_dynamic_call__sn_adapter_struct__append_full_name 1606

/* line 113 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9749 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__register_cb;
#define d__sn_dynamic_call__sn_adapter_struct__register_cb 1607

/* line 115 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9750 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__register_cb_param;
#define d__sn_dynamic_call__sn_adapter_struct__register_cb_param 1608

/* line 117 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9751 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__disable_cb;
#define d__sn_dynamic_call__sn_adapter_struct__disable_cb 1609

/* line 119 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9752 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__disable_cb_param;
#define d__sn_dynamic_call__sn_adapter_struct__disable_cb_param 1610

/* line 121 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9753 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__set_timer;
#define d__sn_dynamic_call__sn_adapter_struct__set_timer 1611

/* line 123 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9754 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__simulator_command;
#define d__sn_dynamic_call__sn_adapter_struct__simulator_command 1612

/* line 125 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9755 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__simulator_restore;
#define d__sn_dynamic_call__sn_adapter_struct__simulator_restore 1613

/* line 127 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9756 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__simulator_log_write;
#define d__sn_dynamic_call__sn_adapter_struct__simulator_log_write 1614

/* line 129 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9757 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__simulator_screen_write;
#define d__sn_dynamic_call__sn_adapter_struct__simulator_screen_write 1615

/* line 131 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9758 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__simulator_gui_mode;
#define d__sn_dynamic_call__sn_adapter_struct__simulator_gui_mode 1616

/* line 133 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9759 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__refresh_simulator_gui;
#define d__sn_dynamic_call__sn_adapter_struct__refresh_simulator_gui 1617

/* line 135 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9760 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__simulator_screen_prompt;
#define d__sn_dynamic_call__sn_adapter_struct__simulator_screen_prompt 1618

/* line 137 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9761 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__simulator_gets;
#define d__sn_dynamic_call__sn_adapter_struct__simulator_gets 1619

/* line 139 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9762 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__simulator_exit;
#define d__sn_dynamic_call__sn_adapter_struct__simulator_exit 1620

/* line 141 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9763 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__simulator_finish;
#define d__sn_dynamic_call__sn_adapter_struct__simulator_finish 1621

/* line 144 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9764 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__set_elaborate;
#define d__sn_dynamic_call__sn_adapter_struct__set_elaborate 1622

/* line 146 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9765 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__create_sim_user_data;
#define d__sn_dynamic_call__sn_adapter_struct__create_sim_user_data 1623

/* line 149 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9766 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__set_ptr_sim_user_data;
#define d__sn_dynamic_call__sn_adapter_struct__set_ptr_sim_user_data 1624

/* line 152 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9767 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__check_legal_sensitivity_kind;
#define d__sn_dynamic_call__sn_adapter_struct__check_legal_sensitivity_kind 1625

/* line 155 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9768 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__set_ptr_sig_param_callback_data;
#define d__sn_dynamic_call__sn_adapter_struct__set_ptr_sig_param_callback_data 1626

/* line 157 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9769 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__call_subprogram;
#define d__sn_dynamic_call__sn_adapter_struct__call_subprogram 1627

/* line 159 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9770 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__get_subprogram_param;
#define d__sn_dynamic_call__sn_adapter_struct__get_subprogram_param 1628

/* line 162 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9771 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__get_specman_instance_path;
#define d__sn_dynamic_call__sn_adapter_struct__get_specman_instance_path 1629

/* line 164 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9772 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__drive_bit;
#define d__sn_dynamic_call__sn_adapter_struct__drive_bit 1630

/* line 167 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9773 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__drive_string;
#define d__sn_dynamic_call__sn_adapter_struct__drive_string 1631

/* line 170 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9774 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__drive_uint;
#define d__sn_dynamic_call__sn_adapter_struct__drive_uint 1632

/* line 173 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9775 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__hdl_path_separator;
#define d__sn_dynamic_call__sn_adapter_struct__hdl_path_separator 1633

/* line 175 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9776 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__simulator_version;
#define d__sn_dynamic_call__sn_adapter_struct__simulator_version 1634

/* line 177 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9777 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__get_argv;
#define d__sn_dynamic_call__sn_adapter_struct__get_argv 1635

/* line 179 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9778 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__create_sig_param_data_new_proc;
#define d__sn_dynamic_call__sn_adapter_struct__create_sig_param_data_new_proc 1636

/* line 181 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9779 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__create_sig_param_data;
#define d__sn_dynamic_call__sn_adapter_struct__create_sig_param_data 1637

/* line 183 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9780 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__get_and_put;
#define d__sn_dynamic_call__sn_adapter_struct__get_and_put 1638

/* line 185 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9781 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__alocate_in_simulator;
#define d__sn_dynamic_call__sn_adapter_struct__alocate_in_simulator 1639

/* line 187 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9782 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__restore_adapter;
#define d__sn_dynamic_call__sn_adapter_struct__restore_adapter 1640

/* line 189 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9783 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__init_adapter;
#define d__sn_dynamic_call__sn_adapter_struct__init_adapter 1641

/* line 191 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9784 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__set_time_scale;
#define d__sn_dynamic_call__sn_adapter_struct__set_time_scale 1642

/* line 192 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9785 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__get_time_scale;
#define d__sn_dynamic_call__sn_adapter_struct__get_time_scale 1643

/* line 198 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9786 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__receive_cb_denali;
#define d__sn_dynamic_call__sn_adapter_struct__receive_cb_denali 1644

/* line 199 "/proj/specman/src/agent.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_adap9787 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_adapter_struct__denali_decanon_name;
#define d__sn_dynamic_call__sn_adapter_struct__denali_decanon_name 1645

/* line 318 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__specman_config {
    t__int d__;
    t__int gen__;
        t__string version;
        t__string specman_version;
        t__config_os os;
        t__config_machine machine;
} *t__specman_config;
#define d__specman_config 40

/* line 335 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__symtab {
    t__int d__;
    t__int gen__;
        struct s__k__module__name *modules;
        struct s__l__form *all_forms;
        struct s__k__routine__name *all_routines;
        struct s__l__gen_constraint *all_constraints;
        struct s__l__method *all_methods;
        struct s__k__pseudo_m_r__name *all_pseudo_routines;
        struct s__k__pseudo_m_r__name *all_pseudo_methods;
        struct s__module *current_module;
        struct s__method *current_method;
        struct s__struct_descriptor *current_struct;
        t__int next_cgl_num;
        struct s__l__int *mask_bit_table;
        t__bool force_gc_after_load;
        struct s__l__sn_vec *long_constants;
        struct s__namer *namer;
        t__int last_sn_module;
        struct s__hang_type *hang_type;
        struct s__l__ntv *act_common_macros;
        struct s__l__ntv *exp_common_macros;
        t__bool warn_on_back33;
        t__int last_initialized_module;
        struct s__print_options *po4appendf;
        struct s__exceptions *exceptions;
        t__bool errors_on;
        t__bool is_short_signed;
        t__bool icfg_load;
        struct s__directed_graph *import_graph;
        struct s__l__scc_item *sccs;
        struct s__struct_descriptor *current_st;
        struct s__l__cast *casts;
        struct s__l__string *code_cast;
        struct s__l__bool *code_cast_is_call;
        struct s__l__bool *code_cast_needs_stack;
        struct s__l__n__exp *compiled_exps;
        t__int last_compiled_exp;
        struct s__l__bit *indexing_list;
        struct s__l__bit *indexing_list2;
        t__bool within_llwait;
        t__int bits_taken;
        t__bool use_bits_taken;
        t__int bit_offset;
        t__bool is_short_int;
        struct s__l__scalar_range_list *constant_range_lists;
        struct s__l__sn_uint_list_holder *const_lists;
        struct s__sn_stack_of_temp_long *stack_of_temp_long;
        struct s__l__script_descriptor *all_script_types;
        struct s__sn_deep_copy_info *deep_copy_info;
        struct s__l__check *all_checks;
        t__bool check_matching_string_compat;
        struct s__l__string *structs_with_quit;
        t__string default_event_name;
        struct s__int__MAX_INT *inf_vec_one;
        struct s__int__MAX_INT *inf_vec_minus_one;
        t__int time_d_index;
        struct s__sn_long *one_giga;
        t__untyped special_value_for_eval;
        struct s__print_options *temp_print_options;
        struct s__l__bit *lob_swap_temp;
        struct s__l__bit *lob_reorder_temp;
        struct s__l__int *powersOf2;
        t__string currently_packed_string;
        struct s__l__scalar_rl *new_constant_rls;
        struct s__l__string *abstr_gen_type_strings;
        t__uint long_max_width;
        struct s__pgen_parser *pgen_parser;
        struct s__source_item *temp_source_item;
        struct s__l__string *nested_struct_name;
        t__string cur_like_parent;
        struct s__l__sn_vec *verilog_string_constants;
        struct s__error_recovery_summary *error_recovery_summary;
        t__int max_error_recoveries;
        struct s__l__construct_keyword *all_keywords;
        t__int parsed_event;
        t__int last_sim_event;
        struct s__l__te_header_desc *all_temporals;
        struct s__l__event_only_compile_data *event_onlys_data;
        t__int time;
        t__bool seq_of_size_one;
        t__bool under_and_te;
        t__int sb_max_limit;
        struct s__k__struct_threads__stru30097 *all_struct_threads;
        struct s__l__a_role *all_roles;
        struct s__reduction *reduction;
        struct s__l__struct_descriptor *reachable_struct_types;
        struct s__l__field *reachable_fields;
        struct s__l__field *gotf_reachable_fields;
        struct s__struct_descriptor *gen_root_struct;
        struct s__a_role *gen_root_role;
        struct s__struct_descriptor *gen_root_list;
        struct s__a_role *gen_root_list_role;
        struct s__del_gcs_iterator *dgi;
        struct s__sn_fgr_iterator *sfi;
        struct s__sn_update_ranges_iterator *ufi;
        struct s__sn_create_extra_iterator *efi;
        struct s__field_relevancy_iterator *fri;
        struct s__create_edges_iterator *cei;
        t__index last_role_ind;
        struct s__inherite_edges_iterator *iei;
        struct s__finalize_iterator *fin;
} *t__symtab;
#define d__symtab 50

/* line 43 "../src/root_types.e"  From 'struct definition' */
typedef struct s__module {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__int lines_number;
        t__string name;
        t__int module_num;
        t__string file_name;
        t__string relative_path;
        t__int file_age;
        t__bool loaded;
        struct s__l__type_layer *type_layers;
        struct s__form *top_form;
        struct s__top_statement *top_statement;
        t__string specman_version;
        t__string parent;
        t__bool encrypted;
        t__bool isitornot;
        struct s__rf_structural_element *rf_object_;
} *t__module;
#define d__module 106

/* line 37 "../src/root_types.e"  From 'struct definition' */
typedef struct s__type_layer {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__type_descriptor *defined_type;
        struct s__rf_structural_element *rf_object_;
} *t__type_layer;
#define d__type_layer 104

/* line 195 "../src/root_types.e"  From 'struct definition' */
typedef struct s__type_descriptor {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string name;
        t__int size_in_bytes;
        t__short_type short_type;
        t__bool debug;
        t__string c_name;
        t__string predefined_declaration;
        struct s__type_descriptor *parent;
        t__int d_index;
        struct s__scalar_range_list *range_list;
        struct s__l__type_layer *layers;
        t__int size_in_bits;
        struct s__scalar_range_list *type_range_list;
        struct s__sn_struct *the_rl;
        struct s__rf_structural_element *rf_object_;
} *t__type_descriptor;
#define d__type_descriptor 109

/* line 314 "../src/root.e"  From 'struct definition' */
typedef struct s__scalar_range_list {
    t__int d__;
    t__int gen__;
        t__range_list_base_type type;
        t__int item_type;
} *t__scalar_range_list;
#define d__scalar_range_list 378

/* line 68 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__sn_struct {
    t__int d__;
    t__int gen__;
} *t__sn_struct;
#define d__sn_struct 15

/* line 34 "../src/root_types.e"  From 'struct definition' */
typedef struct s__rf_structural_element {
    t__int d__;
    t__int gen__;
} *t__rf_structural_element;
#define d__rf_structural_element 103

/* line 152 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__form {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string string;
        t__form_kind form_kind;
        struct s__l__form *sub_forms;
        t__int define_num;
        t__string prev;
} *t__form;
#define d__form 184

/* line 457 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__top_statement {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__ntv_extra *x;
        struct s__l__n__statement *n__statements;
} *t__top_statement;
#define d__top_statement 191

/* line 387 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__ntv_extra {
    t__int d__;
    t__int gen__;
        t__string string;
        struct s__form *form;
        struct s__ntv *super_ntv;
        t__int Depth;
        struct s__macro_descriptor *macro_descriptor;
        struct s__macro_descriptor *before_reparse;
        struct s__l__string *sub_matches;
        struct s__l__ntv *sub_ntvs;
        t__string error;
        t__string conv_orig_string;
} *t__ntv_extra;
#define d__ntv_extra 188

/* line 212 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__ntv {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__ntv_extra *x;
} *t__ntv;
#define d__ntv 185

/* line 75 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__macro_descriptor {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string name;
        t__int size_in_bytes;
        t__short_type short_type;
        t__bool debug;
        t__string c_name;
        t__string predefined_declaration;
        struct s__type_descriptor *parent;
        t__int d_index;
        struct s__scalar_range_list *range_list;
        struct s__l__type_layer *layers;
        t__int size_in_bits;
        struct s__scalar_range_list *type_range_list;
        struct s__sn_struct *the_rl;
        struct s__rf_structural_element *rf_object_;
        struct s__l__field *fields;
        struct s__l__method *methods;
        struct s__l__field *init_fields;
        struct s__l__struct_descriptor *children;
        t__bool need_call_init;
        t__bool instantiated;
        t__bool long_copy_required;
        t__int bit_fields_cnt;
        struct s__sd_gen_info *sgi;
        struct s__unit_info *unit_info;
        struct s__l__struct_descriptor *friends;
        struct s__l__event_descriptor *events;
        struct s__nt_descriptor *nt_descriptor;
        t__string macro_pattern;
        t__string re;
        t__pat pat;
        t__int max_submatches;
        t__bool enabled;
        t__int index_in_nt_list;
} *t__macro_descriptor;
#define d__macro_descriptor 180

/* line 1215 "../src/root_types.e"  From 'struct definition' */
typedef struct s__field {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__struct_descriptor *Context_struct;
        t__access_qualifier access_qualifier;
        t__string name;
        t__string short_name;
        t__int field_no;
        struct s__type_descriptor *base_type;
        t__bool is_physical;
        t__int module_num;
        t__gen_status gen_status;
        struct s__field_gen_info *fgi;
        struct s__local *script_local;
        t__int pack_size;
        t__bool is_instance;
        struct s__rf_structural_element *rf_object_;
} *t__field;
#define d__field 165

/* line 270 "../src/root_types.e"  From 'struct definition' */
typedef struct s__struct_descriptor {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string name;
        t__int size_in_bytes;
        t__short_type short_type;
        t__bool debug;
        t__string c_name;
        t__string predefined_declaration;
        struct s__type_descriptor *parent;
        t__int d_index;
        struct s__scalar_range_list *range_list;
        struct s__l__type_layer *layers;
        t__int size_in_bits;
        struct s__scalar_range_list *type_range_list;
        struct s__sn_struct *the_rl;
        struct s__rf_structural_element *rf_object_;
        struct s__l__field *fields;
        struct s__l__method *methods;
        struct s__l__field *init_fields;
        struct s__l__struct_descriptor *children;
        t__bool need_call_init;
        t__bool instantiated;
        t__bool long_copy_required;
        t__int bit_fields_cnt;
        struct s__sd_gen_info *sgi;
        struct s__unit_info *unit_info;
        struct s__l__struct_descriptor *friends;
        struct s__l__event_descriptor *events;
} *t__struct_descriptor;
#define d__struct_descriptor 120

/* line 715 "../src/root_types.e"  From 'struct definition' */
typedef struct s__method {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__struct_descriptor *Context_struct;
        t__access_qualifier access_qualifier;
        t__string name;
        t__method_kind kind;
        struct s__method *previous_method;
        struct s__method *next_method;
        struct s__method *sibling_method;
        struct s__method *copy_extend_method;
        struct s__interpreted_method *interpreted_method;
        struct s__scope *scope;
        struct s__type_descriptor *result_type;
        t__int index;
        t__int index_in_type;
        t__int extension_index;
        t__bool main;
        t__source_ref fst_action_srcref;
        struct s__routine *routine;
        t__bool untraceable;
        t__final_state final_state;
        struct s__rf_structural_element *rf_object_;
        t__bool need_match_list;
} *t__method;
#define d__method 136

/* line 840 "../src/root_types.e"  From 'struct definition' */
typedef struct s__interpreted_method {
    t__int d__;
    t__int gen__;
        struct s__method *method;
} *t__interpreted_method;
#define d__interpreted_method 137

/* line 866 "../src/root_types.e"  From 'struct definition' */
typedef struct s__scope {
    t__int d__;
    t__int gen__;
        struct s__l__local *locals;
        struct s__scope *previous;
        t__int total_num_of_locals;
        t__uint attributes;
} *t__scope;
#define d__scope 140

/* line 908 "../src/root_types.e"  From 'struct definition' */
typedef struct s__local {
    t__int d__;
    t__int gen__;
        t__string name;
        struct s__type_descriptor *base_type;
        t__bool indirect;
        t__int index;
        struct s__scope *scope;
        t__local_attribute att;
        t__int pack_size;
        t__int list_size;
} *t__local;
#define d__local 144

/* line 846 "../src/root_types.e"  From 'struct definition' */
typedef struct s__routine {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string name;
        t__bool is_a_method;
        struct s__scope *scope;
        struct s__type_descriptor *result_type;
        t__routine_pointer routine_pointer;
        t__string cname;
} *t__routine;
#define d__routine 138

/* line 247 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sd_gen_info {
    t__int d__;
    t__int gen__;
        struct s__struct_descriptor *sd;
        struct s__l__field *temp_fields;
        struct s__l__gen_constraint *gcs;
        struct s__l__role_edge *roles;
        struct s__l__a_role *me_roles;
        struct s__l__bool *temps_relevant;
        t__index last_reloced_temp;
        t__visited_status visited_status;
        t__bool added_to_reachable_list;
} *t__sd_gen_info;
#define d__sd_gen_info 112

/* line 1468 "../src/root_types.e"  From 'struct definition' */
typedef struct s__gen_constraint {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__struct_descriptor *Context_struct;
        t__access_qualifier access_qualifier;
        t__int index;
        struct s__n__exp *n__exp;
        struct s__n__exp *root_exp;
        t__gc_status status;
        struct s__l__gen_constraint *derived_from;
        t__count last_reduction;
        struct s__gen_constraint_or *top_or;
        t__index or_index;
        t__index and_index;
        struct s__gen_constraint_and *top_and;
        t__index index_in_me;
        t__index gen_fly_index;
        t__bool is_soft;
        struct s__l__index *soft_inds;
        struct s__constraint_path *for_each_list;
        t__bool do_not_order;
        struct s__l__gc_order_info *gcois;
        t__bool has_soft_temps;
        t__bool reloced_temps;
        t__bool needs_bit_paths;
} *t__gen_constraint;
#define d__gen_constraint 171

/* line 554 "/proj/specman/src/basic_action.e"  From 'struct definition' */
typedef struct s__n__exp {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__ntv_extra *x;
        struct s__n__action *action;
        struct s__scope *scope;
        struct s__type_descriptor *base_type;
        t__exp_kind kind;
        struct s__field *field;
        t__string code;
} *t__n__exp;
#define d__n__exp 414

/* line 213 "/proj/specman/src/basic_action.e"  From 'struct definition' */
typedef struct s__n__action {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__ntv_extra *x;
        struct s__scope *scope;
        struct s__method *method;
        t__int level;
        struct s__pre_actions *pre_actions;
        t__bool is_pre_action;
        struct s__entry *f__entry;
} *t__n__action;
#define d__n__action 401

/* line 209 "/proj/specman/src/basic_action.e"  From 'struct definition' */
typedef struct s__pre_actions {
    t__int d__;
    t__int gen__;
        struct s__l__n__action *act;
} *t__pre_actions;
#define d__pre_actions 399

/* line 359 "/proj/specman/src/basic_action.e"  From 'struct definition' */
typedef struct s__entry {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string name;
        struct s__entry *parent;
        t__int entry_index;
        t__index event_id;
        struct s__method *method;
        t__bool is_sub_extension;
        t__bool has_sub_scripts;
        t__bool uses_fields;
        t__imp_enum_entry__code_status code_status;
        t__int next_entry;
        t__int curr_break;
        t__int after_break;
        struct s__entry *on_return_action;
} *t__entry;
#define d__entry 405

/* line 351 "/proj/specman/src/gen_constraint_header.e"  From 'struct definition' */
typedef struct s__gen_constraint_or {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__struct_descriptor *Context_struct;
        t__access_qualifier access_qualifier;
        t__int index;
        struct s__n__exp *n__exp;
        struct s__n__exp *root_exp;
        t__gc_status status;
        struct s__l__gen_constraint *derived_from;
        t__count last_reduction;
        struct s__gen_constraint_or *top_or;
        t__index or_index;
        t__index and_index;
        struct s__gen_constraint_and *top_and;
        t__index index_in_me;
        t__index gen_fly_index;
        t__bool is_soft;
        struct s__l__index *soft_inds;
        struct s__constraint_path *for_each_list;
        t__bool do_not_order;
        struct s__l__gc_order_info *gcois;
        t__bool has_soft_temps;
        t__bool reloced_temps;
        t__bool needs_bit_paths;
        struct s__l__gen_constraint *constraints;
        t__bool is_imply;
        t__int from_when;
} *t__gen_constraint_or;
#define d__gen_constraint_or 1287

/* line 347 "/proj/specman/src/gen_constraint_header.e"  From 'struct definition' */
typedef struct s__gen_constraint_and {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__struct_descriptor *Context_struct;
        t__access_qualifier access_qualifier;
        t__int index;
        struct s__n__exp *n__exp;
        struct s__n__exp *root_exp;
        t__gc_status status;
        struct s__l__gen_constraint *derived_from;
        t__count last_reduction;
        struct s__gen_constraint_or *top_or;
        t__index or_index;
        t__index and_index;
        struct s__gen_constraint_and *top_and;
        t__index index_in_me;
        t__index gen_fly_index;
        t__bool is_soft;
        struct s__l__index *soft_inds;
        struct s__constraint_path *for_each_list;
        t__bool do_not_order;
        struct s__l__gc_order_info *gcois;
        t__bool has_soft_temps;
        t__bool reloced_temps;
        t__bool needs_bit_paths;
        struct s__l__gen_constraint *constraints;
} *t__gen_constraint_and;
#define d__gen_constraint_and 1286

/* line 20 "/proj/specman/src/gen_constraint_header.e"  From 'struct definition' */
typedef struct s__constraint_path {
    t__int d__;
    t__int gen__;
        struct s__l__field_holder *fields;
        struct s__field_holder *field;
        t__index role_id;
        t__constraint_path_start_kind start_kind;
        t__int value;
        struct s__any_rl *path_rl;
        struct s__temp_field *temp_field;
        t__int local_no;
        struct s__type_descriptor *local_base_type;
        t__string local_c_name;
        t__string local_name;
        t__bool local_indirect;
        t__string base_str;
        t__bool tmp;
        t__bool temp_soft;
} *t__constraint_path;
#define d__constraint_path 1255

/* line 81 "/proj/specman/src/gen_constraint_header.e"  From 'struct definition' */
typedef struct s__field_holder {
    t__int d__;
    t__int gen__;
        struct s__field *field;
        t__constraint_role_type role;
        t__index local_index;
} *t__field_holder;
#define d__field_holder 1259

/* line 19 "/proj/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__any_rl {
    t__int d__;
    t__int gen__;
} *t__any_rl;
#define d__any_rl 1099

/* line 530 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__temp_field {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__struct_descriptor *Context_struct;
        t__access_qualifier access_qualifier;
        t__string name;
        t__string short_name;
        t__int field_no;
        struct s__type_descriptor *base_type;
        t__bool is_physical;
        t__int module_num;
        t__gen_status gen_status;
        struct s__field_gen_info *fgi;
        struct s__local *script_local;
        t__int pack_size;
        t__bool is_instance;
        struct s__rf_structural_element *rf_object_;
        struct s__reloc_info_holder *rih;
        struct s__temp_field *replaced_by;
        t__int index;
        t__bool flag;
        t__bool in_for_each;
        t__int is_gen_on_the_fly_local;
        t__int gen_index;
} *t__temp_field;
#define d__temp_field 1332

/* line 1209 "../src/root_types.e"  From 'struct definition' */
typedef struct s__field_gen_info {
    t__int d__;
    t__int gen__;
        t__bool needs_bit_rl;
        struct s__field *fl;
        struct s__l__simple_gen_constraint *gcs;
        struct s__l__index *gc_inds;
        struct s__l__soft_gc *soft_gcs;
        struct s__any_rl *rl;
        t__bool is_when_determinant;
        t__bool ever_on_gotf_path;
        t__bool marked_as_reachable;
        t__count n_proccessed_constraints;
        t__uint geb_stamp;
        struct s__seed_domain *the_seed;
        struct s__any_rl *default_rl;
        struct s__any_rl *item_default_rl;
} *t__field_gen_info;
#define d__field_gen_info 163

/* line 243 "/proj/specman/src/gen_constraint_header.e"  From 'struct definition' */
typedef struct s__simple_gen_constraint {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__struct_descriptor *Context_struct;
        t__access_qualifier access_qualifier;
        t__int index;
        struct s__n__exp *n__exp;
        struct s__n__exp *root_exp;
        t__gc_status status;
        struct s__l__gen_constraint *derived_from;
        t__count last_reduction;
        struct s__gen_constraint_or *top_or;
        t__index or_index;
        t__index and_index;
        struct s__gen_constraint_and *top_and;
        t__index index_in_me;
        t__index gen_fly_index;
        t__bool is_soft;
        struct s__l__index *soft_inds;
        struct s__constraint_path *for_each_list;
        t__bool do_not_order;
        struct s__l__gc_order_info *gcois;
        t__bool has_soft_temps;
        t__bool reloced_temps;
        t__bool needs_bit_paths;
        t__bool one_path;
        struct s__l__any_rl *constant_ranges;
        struct s__l__constraint_path *constraint_paths;
        t__string pretty;
} *t__simple_gen_constraint;
#define d__simple_gen_constraint 1261

/* line 79 "/proj/specman/src/gen_constraint_header.e"  From 'struct definition' */
typedef struct s__gc_order_info {
    t__int d__;
    t__int gen__;
        struct s__simple_gen_constraint *gc;
        t__om_edge_reason reason;
        struct s__l__index *input_indices;
        struct s__l__index *output_indices;
        t__bool is_soft;
        t__bool has_dof;
} *t__gc_order_info;
#define d__gc_order_info 1258

/* line 1212 "../src/root_types.e"  From 'struct definition' */
typedef struct s__soft_gc {
    t__int d__;
    t__int gen__;
        struct s__a_role *a_role;
        struct s__simple_gen_constraint *gc;
} *t__soft_gc;
#define d__soft_gc 164

/* line 244 "../src/root_types.e"  From 'struct definition' */
typedef struct s__a_role {
    t__int d__;
    t__int gen__;
        struct s__struct_descriptor *start_type;
        t__index role_id;
        struct s__l__field_holder *fields;
        struct s__struct_descriptor *sd;
        t__index index_in_sd;
        t__bool is_list;
        t__bool debug_it;
        struct s__l__bool *debug_fields;
        t__bool for_debug_only;
        t__string role_name;
        t__int role_hashed;
        struct s__a_role *more_general_role;
        struct s__l__a_role *more_specific_roles;
        t__index gen_on_the_fly_index;
        t__index pos_in_gen_path;
        struct s__l__om_edge *when_om_edges;
        struct s__l__om_edge *om_edges;
        struct s__l__bool *is_dof;
        struct s__l__om_edge_reason *dof_reasons;
        t__bool cannot_be_statically_ordered;
        struct s__role_edge *re;
        struct s__l__field_gen_role *field_gen_roles;
        struct s__l__status_in_role *f_stats;
        t__bool might_change_gc_stats;
        struct s__l__index *start_parent_gcs;
        struct s__l__role_gc_stat *gc_stats;
        t__bool is_gotf_root;
        struct s__subtype_descriptor *subtype;
        t__count n_non_temp_fields;
        t__count n_fields;
        struct s__l__bool *has_down_gcs;
        struct s__l__a_role *sub_type_roles;
        struct s__a_role *super_type_role;
        t__bool is_like_hook;
        t__imp_enum_a_role__gc_proc_status gc_proc_status;
        struct s__l__final_fgr_info *final_fgr_infos;
        struct s__l__gen_command *gcoms;
} *t__a_role;
#define d__a_role 111

/* line 173 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__om_edge {
    t__int d__;
    t__int gen__;
        t__om_edge_reason om_edge_reason;
        struct s__source_item *source_item;
        t__bool soft;
        struct s__om_or_edge *in_or;
        struct s__a_role *originating_role;
        struct s__a_role *the_role;
        struct s__l__a_role *turned_off_roles;
} *t__om_edge;
#define d__om_edge 1307

/* line 193 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__source_item {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
} *t__source_item;
#define d__source_item 31

/* line 171 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__om_or_edge {
    t__int d__;
    t__int gen__;
        struct s__l__om_alt_edge *alt_edges;
        struct s__gen_constraint_or *orig_gc;
} *t__om_or_edge;
#define d__om_or_edge 1306

/* line 1432 "/proj/specman/src/gen_static_reorder.e"  From 'struct definition' */
typedef struct s__om_alt_edge {
    t__int d__;
    t__int gen__;
        struct s__l__om_edge *es;
} *t__om_alt_edge;
#define d__om_alt_edge 3508

/* line 241 "../src/root_types.e"  From 'struct definition' */
typedef struct s__role_edge {
    t__int d__;
    t__int gen__;
        struct s__a_role *a_role;
        struct s__l__field_holder *reverse_path;
        struct s__l__role_edge *more_specific_res;
        struct s__role_edge *more_general_re;
} *t__role_edge;
#define d__role_edge 110

/* line 226 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__field_gen_role {
    t__int d__;
    t__int gen__;
        struct s__field *f;
        struct s__a_role *parent_role;
        struct s__field_gen_role *more_general_fgr;
        t__bool debug_field;
        struct s__seed_domain *the_seed;
        struct s__l__simple_gen_constraint *gcs;
        struct s__l__index *par_inds;
        struct s__l__index *soft_inds;
        t__count last_reduction;
        t__bool in_reduction_list;
        t__role_range_status role_range_status;
} *t__field_gen_role;
#define d__field_gen_role 1311

/* line 146 "/proj/specman/src/script_rnd.e"  From 'struct definition' */
typedef struct s__seed_domain {
    t__int d__;
    t__int gen__;
        t__string name;
        t__int current_seed;
        t__int state_s1;
        t__int state_s2;
        t__count count;
} *t__seed_domain;
#define d__seed_domain 811

/* line 64 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__role_gc_stat {
    t__int d__;
    t__int gen__;
        t__gc_status gs;
        t__count lr;
        struct s__l__om_edge *derived_edges;
} *t__role_gc_stat;
#define d__role_gc_stat 1297

/* line 388 "../src/root_types.e"  From 'struct definition' */
typedef struct s__subtype_descriptor {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string name;
        t__int size_in_bytes;
        t__short_type short_type;
        t__bool debug;
        t__string c_name;
        t__string predefined_declaration;
        struct s__type_descriptor *parent;
        t__int d_index;
        struct s__scalar_range_list *range_list;
        struct s__l__type_layer *layers;
        t__int size_in_bits;
        struct s__scalar_range_list *type_range_list;
        struct s__sn_struct *the_rl;
        struct s__rf_structural_element *rf_object_;
        struct s__l__field *fields;
        struct s__l__method *methods;
        struct s__l__field *init_fields;
        struct s__l__struct_descriptor *children;
        t__bool need_call_init;
        t__bool instantiated;
        t__bool long_copy_required;
        t__int bit_fields_cnt;
        struct s__sd_gen_info *sgi;
        struct s__unit_info *unit_info;
        struct s__l__struct_descriptor *friends;
        struct s__l__event_descriptor *events;
        struct s__Context *Context;
        t__bool f__explicit;
        t__string d_name;
} *t__subtype_descriptor;
#define d__subtype_descriptor 124

/* line 253 "../src/root_types.e"  From 'struct definition' */
typedef struct s__unit_info {
    t__int d__;
    t__int gen__;
        struct s__l__any_unit *instances;
        struct s__l__verilog_variable_desc9788 *variables;
        struct s__l__vhdl_driver_descriptor *drivers;
        struct s__k__subprogram_definition9789 *subprograms;
} *t__unit_info;
#define d__unit_info 113

/* line 147 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__verilog_variable_descriptor {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__uint checksum;
        t__string properties;
        t__string name;
        t__string base;
        t__bool is_wire;
        t__bool is_drive_hold;
        t__bool is_forc;
        t__bool is_strobe;
        t__string strobe;
        t__string drive_hold;
        t__string drive;
        t__bool is_delta_delay;
        t__string bits;
        t__int minv;
        t__int maxv;
        t__bool direction;
        t__bool is_memory;
        t__bool is_vcs_mem;
        struct s__memory_var *mem;
        t__int memory_min;
        t__int memory_max;
        t__bool MemoryIsSmallToBig;
        struct s__any_unit *my_unit_inst;
} *t__verilog_variable_descriptor;
#define d__verilog_variable_descriptor 1539

/* line 135 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__memory_var {
    t__int d__;
    t__int gen__;
        t__uint min;
        t__uint max;
        t__bool is_small_to_big;
} *t__memory_var;
#define d__memory_var 1536

/* line 514 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__vhdl_driver_descriptor {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string name;
        t__string normal_name;
        t__uint delay;
        t__vhdl_set mode;
        t__string initial_str;
        t__string disconnect_str;
        t__bool is_absolut_name;
        struct s__any_unit *my_unit_inst;
} *t__vhdl_driver_descriptor;
#define d__vhdl_driver_descriptor 1584

/* line 312 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__subprogram_definition {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__uint checksum;
        t__string evaluated_declaration;
        struct s__struct_descriptor *desc;
        t__index index;
        t__string subprogram_name;
        t__string subprogram_clean_name;
        t__simulator_kind kind;
        t__bool is_canonical;
        t__string simple_name;
        t__string trig_name;
        t__string res_func;
        struct s__l__subprogram_param *params;
        t__bool is_function;
        t__int return_function_size;
        struct s__vhdl_using_param *vhdl_using_param;
        t__string merge_name;
        struct s__any_unit *my_unit_inst;
} *t__subprogram_definition;
#define d__subprogram_definition 1561

/* line 332 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__subprogram_param {
    t__int d__;
    t__int gen__;
        t__string name;
        t__int size_in_bits;
        t__bool input;
        t__bool output;
        t__bool is_literal;
        t__string sub_type;
        t__bool is_signal_type;
} *t__subprogram_param;
#define d__subprogram_param 1563

/* line 542 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__vhdl_using_param {
    t__int d__;
    t__int gen__;
        t__string library_name;
        t__string package_name;
        t__string alias_name;
        t__string declarative_item;
        t__string return_function_type;
} *t__vhdl_using_param;
#define d__vhdl_using_param 1585

/* line 1306 "../src/root_types.e"  From 'struct definition' */
typedef struct s__event_descriptor {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__struct_descriptor *Context_struct;
        t__access_qualifier access_qualifier;
        t__string name;
        struct s__rf_structural_element *rf_object_;
        struct s__rf_structural_element *rf_object1_;
        struct s__event_type *et;
} *t__event_descriptor;
#define d__event_descriptor 166

/* line 354 "/proj/specman/src/interp.e"  From 'struct definition' */
typedef struct s__event_type {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string event_name;
        struct s__struct_descriptor *parent_type;
        t__index event_id;
        t__sn_event_kind kind;
        t__int expression;
        struct s__l__int *depend;
        struct s__l__int *scc;
        t__int depth;
        t__bool has_dependency;
        t__int on_method_ind;
        t__on_method_status on_status;
        struct s__field *occurrence_field_l;
        struct s__field *event_struct_field;
        t__bool occurred_d;
        t__bool trace_emit;
        t__int tier;
        struct s__event_callback_info *callback_info;
        t__bool is_traceable;
        t__bool has_active_breakpoints;
        t__bool log_needed;
        t__bool copy_needed;
        t__int count;
        struct s__l__base_struct *traced_instances;
        t__int last_cleaned_we_size;
        struct s__basic_event_log *log_item;
        struct s__sn_cvr_main_group_descriptor *cover_descriptor;
        t__bool show_flag;
        t__bool collect_flag;
        t__bool is_wave_trace;
        struct s__l__wave_event_element *wave_event_elements;
        t__bool verilog_trace_stub;
        t__bool verilog_trace_write;
        t__int last_count;
} *t__event_type;
#define d__event_type 508

/* line 286 "/proj/specman/src/te_structs.e"  From 'struct definition' */
typedef struct s__event_callback_info {
    t__int d__;
    t__int gen__;
        t__index event_id;
        t__string base_signame;
        struct s__l__single_callback_info *cb_list;
} *t__event_callback_info;
#define d__event_callback_info 2043

/* line 554 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__single_callback_info {
    t__int d__;
    t__int gen__;
        t__callback_status status;
        t__int occurrence_time_counter;
        t__int wait_time_counter;
        struct s__translated_model_struct *tms;
        t__external_pointer sim_user_data;
} *t__single_callback_info;
#define d__single_callback_info 1587

/* line 447 "/proj/specman/src/scriptsim.e"  From 'struct definition' */
typedef struct s__translated_model_struct {
    t__int d__;
    t__int gen__;
        t__string source_line;
        t__string name;
        t__string normal_name;
        t__external_pointer ptr;
        t__int min;
        t__int max;
        t__bool IsSmallToBig;
        t__int size;
        t__bool is_variable;
        t__bool is_direction_to;
        t__bool is_driver;
        t__bool is_direct_need_to_set;
        t__uint pput_count;
        t__uint gput_count;
        t__bool is_event;
        t__int event_id;
        struct s__hdl_exp_info *info;
        struct s__verilog_variable_inst *ver_par;
        struct s__k__driver_handle__inst_id *driver_handles;
        struct s__vhdl_driver_inst *vhdl_par;
        t__bool is_std_logic;
        struct s__curr_calc *simple_calc;
        struct s__curr_calc *curr_calc;
        struct s__name_param *name_par;
        struct s__sn_adapter_struct *adapter_struct;
        t__string get_name;
        t__string put_name;
} *t__translated_model_struct;
#define d__translated_model_struct 831

/* line 103 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__hdl_exp_info {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__int d_index;
        t__bool has_index;
        t__hdl_data_type data_type;
        t__bool to_use_vec;
        t__bool was_computed;
        struct s__hdl_struct *the_hdl;
        struct s__computed_name *the_cms;
        struct s__desc_info *the_desc_info;
        t__string name;
        t__string original_string;
        t__bool IsBigToSmall;
        t__int Index;
        t__bool is_memory;
        t__sensitivity_kind sensitize;
        t__bool is_kind_checked;
        t__bool use_temp_local;
        t__uint value;
        t__string temp_string;
        t__bool is_unit;
        t__bool is_sys;
        struct s__struct_descriptor *the_desc;
        t__string struct_string;
        struct s__any_unit *the_inst;
        t__bool is_need_to_be_set;
        t__bool is_hdl_set;
        struct s__field *struct_field;
        struct s__local *local;
        t__bool debug_relative_mode;
} *t__hdl_exp_info;
#define d__hdl_exp_info 1535

/* line 290 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__hdl_struct {
    t__int d__;
    t__int gen__;
        struct s__hdl_exp_info *the_exp_info;
        t__string name;
        struct s__k__desc_info__the_desc *desc_list;
        struct s__name_param *name_par;
} *t__hdl_struct;
#define d__hdl_struct 1559

/* line 280 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__desc_info {
    t__int d__;
    t__int gen__;
        struct s__struct_descriptor *the_desc;
        struct s__l__hdl_element *elem_list;
} *t__desc_info;
#define d__desc_info 1556

/* line 285 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__hdl_element {
    t__int d__;
    t__int gen__;
        struct s__curr_calc *calc;
        struct s__translated_model_struct *tms;
} *t__hdl_element;
#define d__hdl_element 1558

/* line 89 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__curr_calc {
    t__int d__;
    t__int gen__;
        t__uint smax;
        t__uint smin;
        t__uint num_shift;
        t__uint mask_val;
        t__uint mode_high;
        t__uint index_val;
        t__uint num_val_use;
        t__bool is_slice;
        t__bool is_two;
        t__uint slice_size;
        t__uint rel_high;
} *t__curr_calc;
#define d__curr_calc 1534

/* line 71 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__name_param {
    t__int d__;
    t__int gen__;
        t__bool is_x;
        t__bool is_z;
        t__bool is_a;
        t__bool is_bin;
        t__bool to_force;
        t__bool to_release;
        t__bool is_strudel_n;
        t__bool is_slice;
        t__uint smax;
        t__uint smin;
        t__string full_name;
        t__string name;
} *t__name_param;
#define d__name_param 1533

/* line 11 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__computed_name {
    t__int d__;
    t__int gen__;
        t__string name;
        struct s__hdl_struct *the_hdl;
} *t__computed_name;
#define d__computed_name 1520

/* line 173 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__verilog_variable_inst {
    t__int d__;
    t__int gen__;
        struct s__verilog_variable_descriptor *desc;
        t__string name;
        t__string full_base;
        t__string normalized_full_base;
        t__string put_name;
        t__string strobe_name;
        t__string strobe;
        t__string drive;
        t__string drive_name;
        t__string drive_hold;
} *t__verilog_variable_inst;
#define d__verilog_variable_inst 1540

/* line 450 "/proj/specman/src/scriptsim.e"  From 'struct definition' */
typedef struct s__driver_handle {
    t__int d__;
    t__int gen__;
        t__uint inst_id;
        t__external_pointer ptr;
} *t__driver_handle;
#define d__driver_handle 832

/* line 508 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__vhdl_driver_inst {
    t__int d__;
    t__int gen__;
        struct s__vhdl_driver_descriptor *driver_desc;
        t__string name;
        t__string normal_name;
} *t__vhdl_driver_inst;
#define d__vhdl_driver_inst 1583

/* line 48 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__base_struct {
    t__int d__;
    t__int gen__;
} *t__base_struct;
#define d__base_struct 14

/* line 14 "/proj/specman/src/event_log.e"  From 'struct definition' */
typedef struct s__basic_event_log {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__uint time_l;
        t__uint time_h;
        t__index event_id;
} *t__basic_event_log;
#define d__basic_event_log 2610

/* line 301 "/proj/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__sn_cvr_main_group_descriptor {
    t__int d__;
    t__int gen__;
        t__int id;
        t__string name;
        t__source_ref source_ref;
        t__bool trace_only;
        t__bool started_trace_only;
        t__string text;
        t__string cvr_text;
        t__int weight;
        t__int cvr_weight;
        t__c_float c_weight;
        t__po_radix radix;
        t__sn_cvr_radix cvr_radix;
        t__c_float grading;
        t__bool for_report;
        t__bool rankable;
        struct s__l__sn_cvr_exp_wrapper *when_exps;
        struct s__struct_descriptor *first_definition_struct;
        t__bool is_defined;
        t__string first_definition_struct_name;
        t__bool ranges_created;
        t__bool dirty;
        struct s__k__sn_cvr_instance_grou22621 *instances;
        struct s__sn_cvr_original_instanc22622 *original;
        struct s__sn_cvr_original_instanc22622 *old_original;
        struct s__l__sn_cvr_item_attributes *items_definition_order;
        t__string struct_name;
        t__index when_mask_size;
        struct s__struct_descriptor *parent_type;
        struct s__field *parent_field;
        struct s__struct_descriptor *cover_struct_type;
        struct s__event_type *event_type;
        t__bool count_only;
        t__bool is_global;
        t__bool is_predefined;
        struct s__cover_info *temp_info;
        struct s__l__sn_cvr_item_descriptor *items_to_sample;
        struct s__l__sn_cvr_item_descriptor *simple_not_to_sample;
        struct s__l__sn_cvr_item_descriptor *non_simple_not_to_sample;
        t__sn_cvr_external_option external_mode;
} *t__sn_cvr_main_group_descriptor;
#define d__sn_cvr_main_group_descriptor 2558

/* line 15 "/proj/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__sn_cvr_exp_wrapper {
    t__int d__;
    t__int gen__;
        struct s__n__exp *exp;
        t__bool replaced;
} *t__sn_cvr_exp_wrapper;
#define d__sn_cvr_exp_wrapper 2553

/* line 487 "/proj/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__sn_cvr_instance_group_d22605 {
    t__int d__;
    t__int gen__;
        t__int id;
        t__string name;
        t__source_ref source_ref;
        t__bool trace_only;
        t__bool started_trace_only;
        t__string text;
        t__string cvr_text;
        t__int weight;
        t__int cvr_weight;
        t__c_float c_weight;
        t__po_radix radix;
        t__sn_cvr_radix cvr_radix;
        t__c_float grading;
        t__bool for_report;
        t__bool rankable;
        struct s__l__sn_cvr_exp_wrapper *when_exps;
        struct s__struct_descriptor *first_definition_struct;
        t__bool is_defined;
        t__string first_definition_struct_name;
        t__bool ranges_created;
        t__bool dirty;
        struct s__sn_cvr_main_group_descriptor *parent;
        struct s__l__sn_cvr_item_descriptor *items;
        t__int gui_id;
        t__bool has_samples;
        t__c_float sampled_items_weight;
        t__bool full;
        t__index index_in_when_mask;
} *t__sn_cvr_instance_group_descriptor;
#define d__sn_cvr_instance_group_descriptor 2565

/* line 649 "/proj/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__sn_cvr_item_descriptor {
    t__int d__;
    t__int gen__;
        t__int id;
        t__string name;
        t__source_ref source_ref;
        t__bool trace_only;
        t__bool started_trace_only;
        t__string text;
        t__string cvr_text;
        t__int weight;
        t__int cvr_weight;
        t__c_float c_weight;
        t__po_radix radix;
        t__sn_cvr_radix cvr_radix;
        t__c_float grading;
        t__bool for_report;
        t__bool rankable;
        struct s__l__sn_cvr_exp_wrapper *when_exps;
        struct s__struct_descriptor *first_definition_struct;
        t__string old_name;
        t__index index_in_when_mask;
        t__sn_cvr_item_kind kind;
        struct s__sn_cvr_instance_group_d22605 *parent;
        struct s__sn_cvr_main_group_descriptor *main_group;
        t__string type_string;
        struct s__type_descriptor *type_descriptor;
        struct s__field *field;
        struct s__field *parent_field;
        struct s__l__sn_cover_bucket_desc22618 *bucket_descriptors;
        t__int bucket_nums;
        t__int at_least;
        t__bool ranges_created;
        struct s__l__n__cover_range_params *ranges_preparse;
        struct s__l__sn_cvr_item_descriptor *sub_items;
        t__uint prev_value_for_transition;
        t__string string_prev_value_for_transition;
        t__uint save_prev_value;
        t__bool in_initial_state;
        struct s__sn_cover_distribution *distribution;
        struct s__sn_cover_show_distribution *show_distribution;
        struct s__l__sn_cover_item_inst *insts;
        struct s__l__sn_cover_distribution *i_dists;
        t__bool non_saved;
        t__int last_simple_ind;
        struct s__sn_cvr_item_descriptor *transition_item;
        t__string when_string;
        t__string exp_string;
        t__bool has_ignore;
        t__bool has_illegal;
        t__bool no_trace;
        t__bool is_string;
        t__bool simple_buckets;
        t__bool very_simple_buckets;
        t__int first_value;
        t__bool used_in_cross;
        t__bool with_ranges;
        t__string agent_options;
        t__int unique_id;
        struct s__sn_cover_bucket_descriptor *last_sampled_bucket;
        t__index last_sampled_index;
        t__bool has_samples;
        t__c_float sampled_buckets_weight;
        t__bool full;
        struct s__l__sn_cvr_exp_wrapper *ignore_exps;
        struct s__l__sn_cvr_exp_wrapper *illegal_exps;
        struct s__n__exp *type_exp;
        struct s__sn_cvr_item_descriptor *base_item;
        t__string from_inst;
        struct s__sn_cover_any_bucket_des22619 *any_bucket;
        struct s__sn_external_item *external_ptr;
        t__bool multi_group;
        t__bool has_transition_sub_item;
        struct s__l__sn_cvr_bucket_rank_d22620 *rank_bucket_descriptors;
        struct s__l__string *full_bucket_name;
        t__int flat_bkt_id;
} *t__sn_cvr_item_descriptor;
#define d__sn_cvr_item_descriptor 2569

/* line 1010 "/proj/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__sn_cover_bucket_descriptor {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__bool bingo;
        t__bool is_illegal;
        t__string name;
        t__index bucket_num;
        t__bool is_secondary;
        t__int at_least;
} *t__sn_cover_bucket_descriptor;
#define d__sn_cover_bucket_descriptor 2578

/* line 159 "/proj/specman/src/cover_basic.e"  From 'struct definition' */
typedef struct s__n__cover_range_params {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__ntv_extra *x;
        struct s__n__range_list *r_preparse;
        t__bool others_flag;
        t__string name;
        t__int every;
        t__int at_least;
        t__string orig_name;
} *t__n__cover_range_params;
#define d__n__cover_range_params 2550

/* line 270 "/proj/specman/src/range.e"  From 'struct definition' */
typedef struct s__n__range_list {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__ntv_extra *x;
        t__int constant_index;
        struct s__type_descriptor *type;
        t__bool forced_type;
} *t__n__range_list;
#define d__n__range_list 688

/* line 889 "/proj/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__sn_cover_distribution {
    t__int d__;
    t__int gen__;
        t__bool is_translated;
        t__bool has_sub;
        t__int samples;
        struct s__l__int *counts;
        struct s__l__int *abn_list;
        struct s__l__sn_cover_distribution *sub_distributions;
} *t__sn_cover_distribution;
#define d__sn_cover_distribution 2574

/* line 931 "/proj/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__sn_cover_show_distribution {
    t__int d__;
    t__int gen__;
        t__bool is_translated;
        t__bool has_sub;
        t__int samples;
        struct s__l__int *counts;
        struct s__l__int *abn_list;
        struct s__l__sn_cover_distribution *sub_distributions;
        t__bool is_open;
        struct s__l__int *test_count;
        t__bool is_transition;
        t__int from_bucket;
        t__int level;
        struct s__sn_cover_show_distribution *top_d;
        struct s__sn_cvr_item_descriptor *top_item;
        struct s__sn_cvr_item_descriptor *item;
        struct s__l__int *goals;
        struct s__l__bool *new_show_flags;
        t__bool new_show_flag;
        struct s__l__sn_cvr_show_status *show_statuses;
        struct s__l__sn_cover_bucket_desc22618 *actual_buckets;
        struct s__l__c_float *gradings;
        t__c_float grading;
        struct s__sn_cover_item_inst *i1890_inst;
        struct s__l__int *flat_bucket_ids;
} *t__sn_cover_show_distribution;
#define d__sn_cover_show_distribution 2575

/* line 1259 "/proj/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__sn_cover_item_inst {
    t__int d__;
    t__int gen__;
        t__string name;
        t__sn_cvr_item_kind kind;
        t__index index_in_when_mask;
        struct s__sn_cover_distribution *distribution;
        struct s__l__sn_cover_bucket_desc22618 *bucket_descriptors;
        struct s__l__uint *values;
        struct s__l__sn_cover_item_inst *sub_item_insts;
        t__int last_simple_ind;
        struct s__sn_cover_group_inst *parent_group;
        struct s__sn_cvr_item_descriptor *item_desc;
        t__bool non_saved;
} *t__sn_cover_item_inst;
#define d__sn_cover_item_inst 2584

/* line 1172 "/proj/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__sn_cover_group_inst {
    t__int d__;
    t__int gen__;
        t__string struct_name;
        t__string event_name;
        t__index event_id;
        t__string instance_name;
        struct s__l__sn_cover_item_inst *item_insts;
        struct s__sn_cvr_main_group_descriptor *group_desc;
        struct s__sn_cvr_instance_group_d22605 *instance_desc;
        t__bool count_only;
        struct s__sn_cover_test *parent_test;
        t__index index_in_when_mask;
} *t__sn_cover_group_inst;
#define d__sn_cover_group_inst 2583

/* line 1063 "/proj/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__sn_cover_test {
    t__int d__;
    t__int gen__;
        t__int id;
        struct s__l__sn_cover_group_inst *group_insts;
        t__string test_name;
        t__string tag_name;
        t__string run_name;
        t__string full_run_name;
        t__string file_name;
        t__bool disable;
        t__bool merged;
        struct s__l__int *seeds;
        struct s__time *test_time;
        t__int usr_time;
        t__int system_time;
        t__int dut_errs;
        struct s__l__cover_struct *collected_data;
} *t__sn_cover_test;
#define d__sn_cover_test 2579

/* line 13 "/proj/specman/src/script_type.e"  From 'struct definition' */
typedef struct s__time {
    t__int d__;
    t__int gen__;
        struct s__l__bit *bytes;
        t__int attributes;
} *t__time;
#define d__time 802

/* line 188 "/proj/specman/src/cover_com.e"  From 'struct definition' */
typedef struct s__cover_struct {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__uint time_l;
        t__uint time_h;
        t__index event_id;
        struct s__l__bool__8 *when_mask;
} *t__cover_struct;
#define d__cover_struct 2614

/* line 92 "/proj/specman/src/cover_bucket_structs.e"  From 'struct definition' */
typedef struct s__sn_cover_any_bucket_des22619 {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__bool bingo;
        t__bool is_illegal;
        t__string name;
        t__index bucket_num;
        t__bool is_secondary;
        t__int at_least;
} *t__sn_cover_any_bucket_descriptor;
#define d__sn_cover_any_bucket_descriptor 2587

/* line 51 "/proj/specman/src/cover_external_defs.e"  From 'struct definition' */
typedef struct s__sn_external_item {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__int id;
        t__string name;
        t__string text;
        t__string external_options;
        struct s__sn_external_group *group;
        t__int goal_value;
        t__int current_value;
        t__int opt_goal_value;
        t__int opt_current_value;
        t__string full_item_name;
} *t__sn_external_item;
#define d__sn_external_item 2606

/* line 47 "/proj/specman/src/cover_external_defs.e"  From 'struct definition' */
typedef struct s__sn_external_group {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__int id;
        t__string name;
        t__string text;
        t__string external_options;
        struct s__l__sn_external_instance *instances;
} *t__sn_external_group;
#define d__sn_external_group 2604

/* line 43 "/proj/specman/src/cover_external_defs.e"  From 'struct definition' */
typedef struct s__sn_external_instance {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__int id;
        t__string name;
        t__string text;
        t__string external_options;
        struct s__l__sn_external_item *items;
} *t__sn_external_instance;
#define d__sn_external_instance 2602

/* line 634 "/proj/specman/src/cover_rank_structs.e"  From 'struct definition' */
typedef struct s__sn_cvr_bucket_rank_desc22665 {
    t__int d__;
    t__int gen__;
        t__string name;
        t__int id;
        struct s__sn_cvr_item_descriptor *item_descriptor;
        t__int samples;
        t__int no_of_tests;
        t__int at_least;
        t__int weight;
        t__c_float c_weight;
        t__int required_samples;
        t__bool full;
        t__int fill_samples;
        t__c_float last_grade;
} *t__sn_cvr_bucket_rank_descriptor;
#define d__sn_cvr_bucket_rank_descriptor 2734

/* line 594 "/proj/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__sn_cvr_original_instanc22622 {
    t__int d__;
    t__int gen__;
        t__int id;
        t__string name;
        t__source_ref source_ref;
        t__bool trace_only;
        t__bool started_trace_only;
        t__string text;
        t__string cvr_text;
        t__int weight;
        t__int cvr_weight;
        t__c_float c_weight;
        t__po_radix radix;
        t__sn_cvr_radix cvr_radix;
        t__c_float grading;
        t__bool for_report;
        t__bool rankable;
        struct s__l__sn_cvr_exp_wrapper *when_exps;
        struct s__struct_descriptor *first_definition_struct;
        t__bool is_defined;
        t__string first_definition_struct_name;
        t__bool ranges_created;
        t__bool dirty;
        struct s__sn_cvr_main_group_descriptor *parent;
        struct s__l__sn_cvr_item_descriptor *items;
        t__int gui_id;
        t__bool has_samples;
        t__c_float sampled_items_weight;
        t__bool full;
        t__index index_in_when_mask;
        struct s__sn_external_instance *external_ptr;
} *t__sn_cvr_original_instance_group_descriptor;
#define d__sn_cvr_original_instance_group_descriptor 2566

/* line 636 "/proj/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__sn_cvr_item_attributes {
    t__int d__;
    t__int gen__;
        t__string instance_exp;
        struct s__sn_cvr_instance_group_d22605 *parent;
        struct s__sn_cvr_item_descriptor *item;
        t__string name;
        t__int id;
} *t__sn_cvr_item_attributes;
#define d__sn_cvr_item_attributes 2568

/* line 12 "/proj/specman/src/cover_base_structs.e"  From 'struct definition' */
typedef struct s__cover_info {
    t__int d__;
    t__int gen__;
        struct s__sn_cvr_instance_group_d22605 *instance;
        struct s__sn_cvr_main_group_descriptor *main_group;
        t__string when_exp;
        t__string instance_exp;
        t__bool is_when;
        t__bool is_only;
        t__bool is_also;
        t__string sub_type_name;
        t__int from_item;
        t__int to_item;
        t__string struct_name;
        t__bool is_also_or_empty;
        t__bool non_original;
        t__bool check_sub_type_later;
        t__string cover_struct_string;
        t__string cover_struct_name;
} *t__cover_info;
#define d__cover_info 2552

/* line 123 "/proj/specman/src/wave_cmd_mngr.e"  From 'struct definition' */
typedef struct s__wave_event_element {
    t__int d__;
    t__int gen__;
        struct s__wave_element_allocation *allocation;
        struct s__l__string *log_lines;
        struct s__event_type *event;
        t__wave_event_data event_data;
        t__bool trace_by_type;
        struct s__abs_wave_command_manager *parent;
} *t__wave_event_element;
#define d__wave_event_element 3051

/* line 1371 "/proj/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__wave_element_allocation {
    t__int d__;
    t__int gen__;
        struct s__l__abs_wave_entry *wave_entries;
} *t__wave_element_allocation;
#define d__wave_element_allocation 3046

/* line 316 "/proj/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__abs_wave_entry {
    t__int d__;
    t__int gen__;
        t__wave_entry_type entry_type;
        t__string new_name;
        t__int signal_id;
        struct s__wave_hdl_stub_info *hdl_stub_info;
        t__bool val_changed;
        t__bool val_is_undef;
} *t__abs_wave_entry;
#define d__abs_wave_entry 3035

/* line 310 "/proj/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__wave_hdl_stub_info {
    t__int d__;
    t__int gen__;
        struct s__translated_model_struct *signal_tms;
        t__uint relative_signal_id;
        struct s__instance_path_t *stub_instance;
} *t__wave_hdl_stub_info;
#define d__wave_hdl_stub_info 3034

/* line 918 "/proj/specman/src/wave_cmd_mngr.e"  From 'struct definition' */
typedef struct s__abs_wave_command_manager {
    t__int d__;
    t__int gen__;
        t__int id;
        t__string wave_cmd;
        t__string group_name;
} *t__abs_wave_command_manager;
#define d__abs_wave_command_manager 3058

/* line 1517 "../src/root_types.e"  From 'struct definition' */
typedef struct s__Context {
    t__int d__;
    t__int gen__;
        struct s__struct_descriptor *when_root;
        struct s__l__context_item *items;
} *t__Context;
#define d__Context 175

/* line 1512 "../src/root_types.e"  From 'struct definition' */
typedef struct s__context_item {
    t__int d__;
    t__int gen__;
        struct s__field *field;
        t__int value;
} *t__context_item;
#define d__context_item 173

/* line 6 "/proj/specman/src/gen_static_comms.e"  From 'struct definition' */
typedef struct s__final_fgr_info {
    t__int d__;
    t__int gen__;
        struct s__field *f;
        t__fg_stat fg_stat;
        struct s__field_gen_role *last_fgr;
        struct s__l__gen_constraint *all_gcs;
        t__abstract_gen_type agt;
        struct s__a_role *to_role;
} *t__final_fgr_info;
#define d__final_fgr_info 3540

/* line 43 "/proj/specman/src/gen_commands_def.e"  From 'struct definition' */
typedef struct s__gen_command {
    t__int d__;
    t__int gen__;
        struct s__a_role *the_role;
} *t__gen_command;
#define d__gen_command 3530

/* line 528 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__reloc_info_holder {
    t__int d__;
    t__int gen__;
        struct s__struct_descriptor *reloc_type;
        struct s__l__field_holder *reloc_path;
        struct s__l__constraint_path *paths;
        struct s__constraint_path *for_each_path;
} *t__reloc_info_holder;
#define d__reloc_info_holder 1331

/* line 67 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__nt_descriptor {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string name;
        t__int size_in_bytes;
        t__short_type short_type;
        t__bool debug;
        t__string c_name;
        t__string predefined_declaration;
        struct s__type_descriptor *parent;
        t__int d_index;
        struct s__scalar_range_list *range_list;
        struct s__l__type_layer *layers;
        t__int size_in_bits;
        struct s__scalar_range_list *type_range_list;
        struct s__sn_struct *the_rl;
        struct s__rf_structural_element *rf_object_;
        struct s__l__field *fields;
        struct s__l__method *methods;
        struct s__l__field *init_fields;
        struct s__l__struct_descriptor *children;
        t__bool need_call_init;
        t__bool instantiated;
        t__bool long_copy_required;
        t__int bit_fields_cnt;
        struct s__sd_gen_info *sgi;
        struct s__unit_info *unit_info;
        struct s__l__struct_descriptor *friends;
        struct s__l__event_descriptor *events;
        t__string chars;
        struct s__l__macro_descriptor *macro_descriptors;
        struct s__macro_finder *macro_finder;
        t__int max_macro_size;
} *t__nt_descriptor;
#define d__nt_descriptor 179

/* line 60 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__macro_finder {
    t__int d__;
    t__int gen__;
        struct s__l__bool *find_table;
        struct s__macro_finder_holder *res;
} *t__macro_finder;
#define d__macro_finder 177

/* line 56 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__macro_finder_holder {
    t__int d__;
    t__int gen__;
        struct s__l__bool *h;
} *t__macro_finder_holder;
#define d__macro_finder_holder 176

/* line 436 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__n__statement {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__ntv_extra *x;
} *t__n__statement;
#define d__n__statement 189

/* line 1824 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__pseudo_m_r {
    t__int d__;
    t__int gen__;
        t__string name;
        t__int d_index;
} *t__pseudo_m_r;
#define d__pseudo_m_r 98

/* line 122 "../src/root.e"  From 'struct definition' */
typedef struct s__sn_vec {
    t__int d__;
    t__int gen__;
        struct s__l__bit *bytes;
        t__int attributes;
} *t__sn_vec;
#define d__sn_vec 369

/* line 836 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__namer {
    t__int d__;
    t__int gen__;
        struct s__k__both__long_str *names;
} *t__namer;
#define d__namer 62

/* line 831 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__both {
    t__int d__;
    t__int gen__;
        t__string long_str;
        t__string cgl_str;
} *t__both;
#define d__both 60

/* line 326 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__hang_type {
    t__int d__;
    t__int gen__;
        struct s__int_range_list *irl;
} *t__hang_type;
#define d__hang_type 41

/* line 319 "../src/root.e"  From 'struct definition' */
typedef struct s__int_range_list {
    t__int d__;
    t__int gen__;
        t__range_list_base_type type;
        t__int item_type;
        struct s__l__int *rl_list;
} *t__int_range_list;
#define d__int_range_list 379

/* line 1705 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__print_options {
    t__int d__;
    t__int gen__;
        t__po_radix radix;
        t__int items;
        t__int line_size;
        t__int list_from;
        t__int level;
        t__string title;
        t__bool hide_title;
        t__bool raw_print;
        t__bool show_control_chars;
        t__bool hide_module_dividers;
        t__bool hide_list_index;
        t__bool window;
        struct s__l__string *root___title_list;
        struct s__l__string *root___value_list;
        t__int after_module_num;
        t__bool list_end_flag;
        t__bool list_is_horizontal;
        t__bool list_starts_on_right;
        t__int list_items_in_line;
        t__int list_grouping;
        t__bool list_of_bit_in_hex;
        t__radix list_index_radix;
        t__int list_lines;
        t__string win_title;
        t__int source_lines;
        t__string source_viewer;
        t__bool hide_time;
        t__bool print_two_lines;
        t__bool show_full_script;
        t__int width;
        t__string float_format;
        t__int float_precision;
        t__int event_chart_headers_width;
        t__int event_chart_headers_event_percent;
} *t__print_options;
#define d__print_options 93

/* line 155 "../src/root_excep.e"  From 'struct definition' */
typedef struct s__exceptions {
    t__int d__;
    t__int gen__;
        struct s__k__sn_exception__name *exceptions;
        t__string global_error_name;
        struct s__active_exception *active_exception;
        t__string try_string;
        t__int try_status;
        struct s__k__string__it *err_details_list;
        t__do_reload_t do_reload;
} *t__exceptions;
#define d__exceptions 329

/* line 51 "../src/root_excep.e"  From 'struct definition' */
typedef struct s__sn_exception {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string name;
        t__int index;
        t__severity severity;
        t__string message;
        struct s__l__string *params_types;
        t__string last_warn_msg;
} *t__sn_exception;
#define d__sn_exception 308

/* line 198 "../src/root_excep.e"  From 'struct definition' */
typedef struct s__active_exception {
    t__int d__;
    t__int gen__;
        t__int index;
        struct s__l__untyped *values;
        t__string last_message;
} *t__active_exception;
#define d__active_exception 331

/* line 169 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__directed_graph {
    t__int d__;
    t__int gen__;
        struct s__k__vertice__name *vertices;
        t__bool dfs_done;
        t__bool sccs_done;
        t__bool acyclic;
        struct s__l__vertice *torder;
        t__int scc_pos;
        t__int time;
        struct s__l__cyclic_import_pair *succ_cyclic;
} *t__directed_graph;
#define d__directed_graph 30

/* line 145 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__vertice {
    t__int d__;
    t__int gen__;
        t__string name;
        t__int scc_id;
        t__int finished;
        t__vertice_color color;
        struct s__l__vertice *pred;
        struct s__l__vertice *succ;
        struct s__l__int *succ_line;
        t__string relative_path;
} *t__vertice;
#define d__vertice 25

/* line 72 "/proj/specman/src/cyclic_import.e"  From 'struct definition' */
typedef struct s__cyclic_import_pair {
    t__int d__;
    t__int gen__;
        struct s__vertice *to;
        t__int id;
} *t__cyclic_import_pair;
#define d__cyclic_import_pair 1197

/* line 157 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__scc_item {
    t__int d__;
    t__int gen__;
        struct s__l__vertice *files;
        struct s__l__scc_item *succ;
        t__vertice_color color;
} *t__scc_item;
#define d__scc_item 26

/* line 1052 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn_uint_list_holder {
    t__int d__;
    t__int gen__;
        struct s__l__uint *value;
} *t__sn_uint_list_holder;
#define d__sn_uint_list_holder 157

/* line 199 "../src/root.e"  From 'struct definition' */
typedef struct s__sn_stack_of_temp_long {
    t__int d__;
    t__int gen__;
        struct s__l__sn_vec *l;
        t__int sp;
} *t__sn_stack_of_temp_long;
#define d__sn_stack_of_temp_long 372

/* line 382 "/proj/specman/src/basic_action.e"  From 'struct definition' */
typedef struct s__script_descriptor {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string name;
        t__int size_in_bytes;
        t__short_type short_type;
        t__bool debug;
        t__string c_name;
        t__string predefined_declaration;
        struct s__type_descriptor *parent;
        t__int d_index;
        struct s__scalar_range_list *range_list;
        struct s__l__type_layer *layers;
        t__int size_in_bits;
        struct s__scalar_range_list *type_range_list;
        struct s__sn_struct *the_rl;
        struct s__rf_structural_element *rf_object_;
        struct s__l__field *fields;
        struct s__l__method *methods;
        struct s__l__field *init_fields;
        struct s__l__struct_descriptor *children;
        t__bool need_call_init;
        t__bool instantiated;
        t__bool long_copy_required;
        t__int bit_fields_cnt;
        struct s__sd_gen_info *sgi;
        struct s__unit_info *unit_info;
        struct s__l__struct_descriptor *friends;
        struct s__l__event_descriptor *events;
        struct s__owning_struct_descriptor *owning_struct;
        t__string default_event_name;
        t__index default_event_id;
        struct s__l__entry *all_entries;
        t__script_lm_calculation lm_calculation;
        struct s__entry *base_entry;
        t__int delivery;
} *t__script_descriptor;
#define d__script_descriptor 407

/* line 377 "/proj/specman/src/basic_action.e"  From 'struct definition' */
typedef struct s__owning_struct_descriptor {
    t__int d__;
    t__int gen__;
        struct s__struct_descriptor *declared;
        struct s__struct_descriptor *current;
} *t__owning_struct_descriptor;
#define d__owning_struct_descriptor 406

/* line 31 "/proj/specman/src/deep_copy_mac.e"  From 'struct definition' */
typedef struct s__sn_deep_copy_info {
    t__int d__;
    t__int gen__;
        t__bool all_normal_compare;
} *t__sn_deep_copy_info;
#define d__sn_deep_copy_info 850

/* line 47 "/proj/specman/src/dut_error.e"  From 'struct definition' */
typedef struct s__check {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__struct_descriptor *struct_descriptor;
        struct s__method *method;
        t__string message;
        t__check_effect check_effect;
        t__count count;
        t__count count_pass;
        t__int index;
        struct s__l__sn_run_time_match_check *run_time_matches;
} *t__check;
#define d__check 881

/* line 42 "/proj/specman/src/dut_error.e"  From 'struct definition' */
typedef struct s__sn_run_time_match_check {
    t__int d__;
    t__int gen__;
        t__string reg_exp;
        t__check_effect effect;
} *t__sn_run_time_match_check;
#define d__sn_run_time_match_check 880

/* line 272 "/proj/specman/src/scriptsim.e"  From 'struct definition' */
typedef struct s__int__MAX_INT {
    t__int d__;
    t__int gen__;
        struct s__l__bit *bytes;
        t__int attributes;
} *t__int__MAX_INT;
#define d__int__MAX_INT 824

/* line 141 "../src/root.e"  From 'struct definition' */
typedef struct s__sn_long {
    t__int d__;
    t__int gen__;
        struct s__l__bit *bytes;
        t__int attributes;
} *t__sn_long;
#define d__sn_long 370

/* line 22 "/proj/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__scalar_rl {
    t__int d__;
    t__int gen__;
} *t__scalar_rl;
#define d__scalar_rl 1100

/* line 1324 "/proj/specman/src/gen_parse.e"  From 'struct definition' */
typedef struct s__pgen_parser {
    t__int d__;
    t__int gen__;
        struct s__l__local_frame *local_frame_list;
        t__bool debug;
        struct s__struct_descriptor *current_struct_context;
        struct s__activation_record *pgen_ar;
        t__int gen_fly_current_index;
        t__bool gen_on_the_fly;
        struct s__l__constraint_path *gen_paths;
        t__int for_each_nested;
        struct s__l__constraint_path *for_each_list_paths;
        t__untyped x;
        t__int max_ar_index;
} *t__pgen_parser;
#define d__pgen_parser 1355

/* line 1320 "/proj/specman/src/gen_parse.e"  From 'struct definition' */
typedef struct s__local_frame {
    t__int d__;
    t__int gen__;
        struct s__l__local_item *local_list;
} *t__local_frame;
#define d__local_frame 1353

/* line 1314 "/proj/specman/src/gen_parse.e"  From 'struct definition' */
typedef struct s__local_item {
    t__int d__;
    t__int gen__;
        struct s__local *local_ptr;
        struct s__constraint_path *cp;
        t__constraint_role_type role;
} *t__local_item;
#define d__local_item 1352

/* line 997 "../src/root_types.e"  From 'struct definition' */
typedef struct s__activation_record {
    t__int d__;
    t__int gen__;
        struct s__method *method;
        struct s__l__untyped *values;
        struct s__activation_record *caller;
        struct s__routine *routine;
        t__int call_num;
        t__int sub_call_num;
        t__source_ref lock_source_ref;
        t__bool already_stopped;
        struct s__l__int *list_of_traced_req_ids;
        t__int next_stop_sub_call;
        t__int next_stop_sub_return;
        struct s__n__action *current_action;
} *t__activation_record;
#define d__activation_record 148

/* line 483 "/proj/specman/src/disp_err_recovery.e"  From 'struct definition' */
typedef struct s__error_recovery_summary {
    t__int d__;
    t__int gen__;
        t__int err_counter;
        struct s__l__error_recovery *all_error_recoveries;
        struct s__l__form *all_statements_forms;
        t__int last_error_index;
        t__bool is_in_command;
} *t__error_recovery_summary;
#define d__error_recovery_summary 1982

/* line 140 "/proj/specman/src/disp_err_recovery.e"  From 'struct definition' */
typedef struct s__error_recovery {
    t__int d__;
    t__int gen__;
        t__string old_str;
        t__string desc1;
        t__string desc2;
        t__string mark_str;
        t__string command_original_string;
        t__string kind;
        struct s__ntv *main_ntv;
        struct s__form *curr_form;
        struct s__form *main_form;
        t__int priority;
        t__string apropos;
        t__bool was_handled;
        t__string file_name;
        t__int source_line_num;
        t__string marked_line;
        t__bool was_printed;
} *t__error_recovery;
#define d__error_recovery 1981

/* line 903 "/proj/specman/src/disp_err_recovery.e"  From 'struct definition' */
typedef struct s__construct_keyword {
    t__int d__;
    t__int gen__;
        t__string kind;
        t__string keyword;
        t__string full_keyword;
} *t__construct_keyword;
#define d__construct_keyword 1984

/* line 333 "/proj/specman/src/te_root.e"  From 'struct definition' */
typedef struct s__te_header_desc {
    t__int d__;
    t__int gen__;
        struct s__l__int *depend;
        t__source_ref source;
        t__int tier;
        t__int event_id;
        t__int num_of_states;
        t__int te_kind;
        t__int sense_size;
        t__bool single_clocked;
        t__bool optimized;
        t__bool in_expect;
        t__bool compile_wait;
        t__bool opt_fxrep;
        t__bool traced;
        struct s__l__bool *sub_exp_val;
        struct s__l__bool *fork_on_son;
        t__int state;
        t__int state2;
        t__int thread_start_time;
        t__bool neg_sensed;
        t__bool do_urgents;
} *t__te_header_desc;
#define d__te_header_desc 2021

/* line 503 "/proj/specman/src/te_root.e"  From 'struct definition' */
typedef struct s__event_only_compile_data {
    t__int d__;
    t__int gen__;
        t__int te_idx;
        t__string parent_name;
        t__string event_name;
} *t__event_only_compile_data;
#define d__event_only_compile_data 2032

/* line 1072 "/proj/specman/src/wave_services.e"  From 'struct definition' */
typedef struct s__struct_threads {
    t__int d__;
    t__int gen__;
        struct s__k__tcm__name *startable_tcms;
        t__string struct_name;
} *t__struct_threads;
#define d__struct_threads 3020

/* line 386 "/proj/specman/src/basic_action.e"  From 'struct definition' */
typedef struct s__tcm {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__struct_descriptor *Context_struct;
        t__access_qualifier access_qualifier;
        t__string name;
        t__method_kind kind;
        struct s__method *previous_method;
        struct s__method *next_method;
        struct s__method *sibling_method;
        struct s__method *copy_extend_method;
        struct s__interpreted_method *interpreted_method;
        struct s__scope *scope;
        struct s__type_descriptor *result_type;
        t__int index;
        t__int index_in_type;
        t__int extension_index;
        t__bool main;
        t__source_ref fst_action_srcref;
        struct s__routine *routine;
        t__bool untraceable;
        t__final_state final_state;
        struct s__rf_structural_element *rf_object_;
        t__bool need_match_list;
        struct s__script_descriptor *scd;
        t__bool is_empty_tcm;
        t__bool is_undefined_tcm;
} *t__tcm;
#define d__tcm 408

/* line 331 "/proj/specman/src/gen_roles.e"  From 'struct definition' */
typedef struct s__reduction {
    t__int d__;
    t__int gen__;
        t__string one_path_msg;
        t__string init_msg;
        struct s__l__gen_constraint *the_gcs;
        struct s__l__index *the_inds;
        struct s__l__index *the_soft_inds;
        t__bool debug_reduction;
        struct s__l__any_rl *orig_rls;
        struct s__l__any_rl *reduced_rls;
        struct s__l__any_rl *debug_rls;
        struct s__l__bool *changed;
        t__reduce_result reduce_result;
        t__bool in_reduction;
        t__bool recursive_reduction;
        t__graph_type graph_type;
        struct s__l__save_reduction_info *prev_reductions;
        t__index last_save;
        t__bool in_place;
        struct s__static_reduce_graph *static_reduce_graph;
        struct s__dynamic_reduce_graph *dynamic_reduce_graph;
        struct s__choose_reduce_graph *choose_reduce_graph;
        struct s__l__and_info *gcas;
        struct s__l__gen_constraint_range *the_one_paths_gcs;
        struct s__l__gen_constraint_or *possibly_contradicting_ors;
        struct s__l__derived_or_info *derived_ors;
        struct s__l__or_info *or_gcs_info;
        struct s__l__count *poset_in_degree;
        struct s__l__count *poset_out_degree;
        struct s__l__index *poset_ready_in;
        struct s__l__index *poset_ready_out;
        struct s__l__bool *poset_changed_min;
        struct s__l__bool *poset_changed_max;
        struct s__struct_rl *null_struct_rl;
        t__count reduction_time;
        t__string par_orig_str;
} *t__reduction;
#define d__reduction 3453

/* line 296 "/proj/specman/src/gen_reduce.e"  From 'struct definition' */
typedef struct s__save_reduction_info {
    t__int d__;
    t__int gen__;
        t__bool debug_reduction;
        struct s__l__bool *changed;
        t__reduce_result reduce_result;
        t__bool in_reduction;
        t__bool recursive_reduction;
        t__bool in_place;
        t__graph_type graph_type;
        struct s__l__any_rl *reduced_rls;
        struct s__l__any_rl *debug_rls;
        struct s__reduce_graph *the_graph;
} *t__save_reduction_info;
#define d__save_reduction_info 3466

/* line 457 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__reduce_graph {
    t__int d__;
    t__int gen__;
        t__count no_of_reduction_phases;
        t__count total_no_of_reductions;
        t__count no_of_reductions_in_phase;
        t__count max_no_of_reductions_in_phase;
        t__index contradiction_index;
        struct s__l__gendb_item *dbg_items;
        t__bool to_test;
        struct s__l__any_rl *rls;
        struct s__l__string *lines;
        t__bool debug_it;
        struct s__l__index *debug_pars;
} *t__reduce_graph;
#define d__reduce_graph 1472

/* line 454 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__gendb_item {
    t__int d__;
    t__int gen__;
        t__imp_enum_gendb_item__phase phase;
        t__bool changed;
        struct s__constraint_path *cp;
        t__bool accessible;
        t__bool fix;
        t__int item_ind;
        struct s__type_descriptor *td;
        struct s__any_rl *rl;
        struct s__any_rl *pre_rl;
} *t__gendb_item;
#define d__gendb_item 1471

/* line 506 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__static_reduce_graph {
    t__int d__;
    t__int gen__;
        t__count no_of_reduction_phases;
        t__count total_no_of_reductions;
        t__count no_of_reductions_in_phase;
        t__count max_no_of_reductions_in_phase;
        t__index contradiction_index;
        struct s__l__gendb_item *dbg_items;
        t__bool to_test;
        struct s__l__any_rl *rls;
        struct s__l__string *lines;
        t__bool debug_it;
        struct s__l__index *debug_pars;
        struct s__l__field_gen_role *croles;
        struct s__l__which_rl *which_rls_q;
        struct s__simple_gen_constraint *gc;
        struct s__l__field_gen_role *par_roles;
        struct s__l__which_rl *which_rls;
        struct s__field_gen_role *fgr;
        t__which_rl the_wr;
        struct s__field_gen_role *pfgr;
        t__index ind_in_crole;
        struct s__l__field_holder *extra_fields;
        struct s__a_role *me_role;
        t__bool in_base_role;
} *t__static_reduce_graph;
#define d__static_reduce_graph 1474

/* line 522 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__dynamic_reduce_graph {
    t__int d__;
    t__int gen__;
        t__count no_of_reduction_phases;
        t__count total_no_of_reductions;
        t__count no_of_reductions_in_phase;
        t__count max_no_of_reductions_in_phase;
        t__index contradiction_index;
        struct s__l__gendb_item *dbg_items;
        t__bool to_test;
        struct s__l__any_rl *rls;
        struct s__l__string *lines;
        t__bool debug_it;
        struct s__l__index *debug_pars;
        struct s__l__field_node *par_nodes;
        struct s__field_node *curr_par;
        struct s__sn_simple_constraint_ins6608 *ci;
        struct s__l__field_node *ci_par_nodes;
        t__index ci_index;
        t__index par_ind;
        struct s__l__field_node *orig_par_nodes;
        t__bool one_to_test;
        struct s__sn_compound_constraint_i6607 *curr_and_node;
        t__index curr_and_alt;
        struct s__sn_compound_constraint_i6607 *curr_or_node;
        t__index curr_or_alt;
        t__bool tmp_in_and;
        struct s__l__index *upto_cis;
        t__bool after_eval;
        t__index upto_ci;
        t__index last_changed_index;
        struct s__l__sn_simple_constraint37353 *to_mark_cis;
        struct s__l__sn_gen_event *reduction_events;
} *t__dynamic_reduce_graph;
#define d__dynamic_reduce_graph 1477

/* line 21 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__field_node {
    t__int d__;
    t__int gen__;
        t__index global_id;
        struct s__field *field;
        t__which_rl the_wr;
        t__bool debug_field;
        struct s__seed_domain *the_seed;
        struct s__struct_path_item *mpj;
        struct s__l__dangling_ci *dangling_cis;
        t__count inherited_dcis_len;
        t__bool has_constraints;
        t__pn_status pn_status;
        t__bool is_list;
        t__abstract_gen_type agt;
        struct s__int_rl *int_type__range;
        struct s__int_field_gen_role *int_type__range_fgr;
        struct s__uint_rl *uint_type__range;
        struct s__uint_field_gen_role *uint_type__range_fgr;
        struct s__long_rl *long_type__range;
        struct s__long_field_gen_role *long_type__range_fgr;
        struct s__struct_rl *struct_type__range;
        struct s__struct_field_gen_role *struct_type__range_fgr;
        struct s__string_rl *string_type__range;
        struct s__string_field_gen_role *string_type__range_fgr;
        struct s__l__untyped *real_list;
        struct s__list_of_int_rl *list_of_int_type__range;
        struct s__int_list_field_gen_role *list_of_int_type__range_fgr;
        struct s__list_of_uint_rl *list_of_uint_type__range;
        struct s__uint_list_field_gen_role *list_of_uint_type__range_fgr;
        struct s__list_of_long_rl *list_of_long_type__range;
        struct s__long_list_field_gen_role *list_of_long_type__range_fgr;
        struct s__list_of_struct_rl *list_of_struct_type__range;
        struct s__struct_list_field_gen_role *list_of_struct_type__range_fgr;
        struct s__list_of_string_rl *list_of_string_type__range;
        struct s__string_list_field_gen_role *list_of_string_type__range_fgr;
        t__index has_constraints__last_reduction;
        t__bool has_constraints__in_reduction_list;
        struct s__l__sn_cpi *has_constraints__exact_cpis;
        t__uint the_item__ind_in_list;
        struct s__field_node *the_item__of_list;
        struct s__field_node *is_list__the_item;
        struct s__l__list_ci *is_list__has_constraints__list_cis;
} *t__field_node;
#define d__field_node 1424

/* line 276 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__struct_path_item {
    t__int d__;
    t__int gen__;
        struct s__field *the_field;
        t__count depth;
        t__bool debug_it;
        struct s__l__a_role *active_roles;
        struct s__l__index *position_in_roles;
        struct s__l__compound_path_item *start_of_roles;
        struct s__l__a_role *relevant_roles;
        struct s__l__compound_path_item *start_of_relevant_roles;
        t__string path_str;
        struct s__field_node *pn_for_soft;
        struct s__l__field_node *pn_temps_list;
        t__bool above_gotf_root;
        struct s__l__dangling_ci *dangling_cis;
        t__count inherited_dcis_len;
        t__count no_of_uneval_fields;
        t__index curr_om_frame;
        struct s__struct_descriptor *struct_type;
        struct s__subtype_descriptor *sub_type;
        struct s__a_role *msr;
        struct s__field_node *fn;
        struct s__compound_path_item *next;
        struct s__any_struct *the_struct;
        struct s__l__field_node *field_nodes;
        t__index start_frame_id;
        struct s__l__sn_constraint_instance *me_cis;
        struct s__l__field_node *pending_dofs;
} *t__struct_path_item;
#define d__struct_path_item 1452

/* line 218 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__compound_path_item {
    t__int d__;
    t__int gen__;
        struct s__field *the_field;
        t__count depth;
        t__bool debug_it;
        struct s__l__a_role *active_roles;
        struct s__l__index *position_in_roles;
        struct s__l__compound_path_item *start_of_roles;
        struct s__l__a_role *relevant_roles;
        struct s__l__compound_path_item *start_of_relevant_roles;
        t__string path_str;
        struct s__field_node *pn_for_soft;
        struct s__l__field_node *pn_temps_list;
        t__bool above_gotf_root;
        struct s__l__dangling_ci *dangling_cis;
        t__count inherited_dcis_len;
        t__count no_of_uneval_fields;
        t__index curr_om_frame;
} *t__compound_path_item;
#define d__compound_path_item 1448

/* line 7 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__dangling_ci {
    t__int d__;
    t__int gen__;
        struct s__sn_simple_constraint_ins6608 *the_ci;
        struct s__l__sn_me_cpi *the_cpis;
} *t__dangling_ci;
#define d__dangling_ci 1422

/* line 387 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn_simple_constraint_ins6608 {
    t__int d__;
    t__int gen__;
        t__sn_ci_kind kind;
        t__sn_gen_status_type status;
        struct s__struct_path_item *spi;
        struct s__sn_compound_constraint_i6607 *top_or;
        t__int or_index;
        struct s__sn_compound_constraint_i6607 *top_and;
        t__int and_index;
        t__bool last_alternative;
        struct s__simple_gen_constraint *gc;
        t__index last_reduction;
        t__bool is_general;
        t__string pretty;
        struct s__l__sn_cpi *cpis;
} *t__sn_simple_constraint_instance;
#define d__sn_simple_constraint_instance 1463

/* line 400 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn_compound_constraint_i6607 {
    t__int d__;
    t__int gen__;
        t__sn_ci_kind kind;
        t__sn_gen_status_type status;
        struct s__struct_path_item *spi;
        struct s__sn_compound_constraint_i6607 *top_or;
        t__int or_index;
        struct s__sn_compound_constraint_i6607 *top_and;
        t__int and_index;
        t__bool last_alternative;
        struct s__gen_constraint_compound *gc;
        struct s__l__sn_constraint_instance *alternatives;
        t__sn_or_status_type or_status;
        struct s__l__sn_cpi *tmp_cpis;
        struct s__l__sn_constraint_instance *tmp_cpi_alts;
        struct s__l__index *tmp_cpis_alt_starts;
        struct s__l__count *tmp_cpis_alt_nos;
        struct s__l__index *tmp_cpis_alt_inds;
} *t__sn_compound_constraint_instance;
#define d__sn_compound_constraint_instance 1464

/* line 342 "/proj/specman/src/gen_constraint_header.e"  From 'struct definition' */
typedef struct s__gen_constraint_compound {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__struct_descriptor *Context_struct;
        t__access_qualifier access_qualifier;
        t__int index;
        struct s__n__exp *n__exp;
        struct s__n__exp *root_exp;
        t__gc_status status;
        struct s__l__gen_constraint *derived_from;
        t__count last_reduction;
        struct s__gen_constraint_or *top_or;
        t__index or_index;
        t__index and_index;
        struct s__gen_constraint_and *top_and;
        t__index index_in_me;
        t__index gen_fly_index;
        t__bool is_soft;
        struct s__l__index *soft_inds;
        struct s__constraint_path *for_each_list;
        t__bool do_not_order;
        struct s__l__gc_order_info *gcois;
        t__bool has_soft_temps;
        t__bool reloced_temps;
        t__bool needs_bit_paths;
        struct s__l__gen_constraint *constraints;
} *t__gen_constraint_compound;
#define d__gen_constraint_compound 1285

/* line 365 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn_constraint_instance {
    t__int d__;
    t__int gen__;
        t__sn_ci_kind kind;
        t__sn_gen_status_type status;
        struct s__struct_path_item *spi;
        struct s__sn_compound_constraint_i6607 *top_or;
        t__int or_index;
        struct s__sn_compound_constraint_i6607 *top_and;
        t__int and_index;
        t__bool last_alternative;
} *t__sn_constraint_instance;
#define d__sn_constraint_instance 1462

/* line 416 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn_cpi {
    t__int d__;
    t__int gen__;
        struct s__constraint_path *cp;
        t__index ind_in_ci;
        struct s__any_rl *rl;
        t__sn_gen_access_status access_status;
        t__bool fix;
        t__bool do_not_generate;
        t__bool evaluated;
        struct s__deffered_gendb_items *deffered_gendb_items;
        struct s__sn_simple_constraint_ins6608 *ci;
} *t__sn_cpi;
#define d__sn_cpi 1467

/* line 413 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__deffered_gendb_items {
    t__int d__;
    t__int gen__;
        struct s__l__deffered_gendb_item *items;
} *t__deffered_gendb_items;
#define d__deffered_gendb_items 1466

/* line 215 "/proj/specman/src/gen_debug_header.e"  From 'struct definition' */
typedef struct s__deffered_gendb_item {
    t__int d__;
    t__int gen__;
        t__imp_enum_gendb_item__phase phase;
        t__bool changed;
        struct s__constraint_path *cp;
        t__bool accessible;
        t__bool fix;
        t__int item_ind;
        struct s__type_descriptor *td;
        struct s__any_rl *rl;
        struct s__any_rl *pre_rl;
        struct s__base_struct *holder;
        t__string path_str;
} *t__deffered_gendb_item;
#define d__deffered_gendb_item 1493

/* line 1243 "/proj/specman/src/gen_cpi.e"  From 'struct definition' */
typedef struct s__sn_me_cpi {
    t__int d__;
    t__int gen__;
        struct s__constraint_path *cp;
        t__index ind_in_ci;
        struct s__any_rl *rl;
        t__sn_gen_access_status access_status;
        t__bool fix;
        t__bool do_not_generate;
        t__bool evaluated;
        struct s__deffered_gendb_items *deffered_gendb_items;
        struct s__sn_simple_constraint_ins6608 *ci;
        struct s__base_struct *the_me;
        struct s__base_struct *last_struct;
        t__index last_field_index;
        struct s__base_struct *holder;
        struct s__field_node *pn;
        t__int it_depth;
        t__int it_ind;
        t__count last_reduction;
} *t__sn_me_cpi;
#define d__sn_me_cpi 3697

/* line 24 "/proj/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__int_rl {
    t__int d__;
    t__int gen__;
        struct s__l__int *rl_list;
} *t__int_rl;
#define d__int_rl 1101

/* line 289 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__int_field_gen_role {
    t__int d__;
    t__int gen__;
        struct s__field *f;
        struct s__a_role *parent_role;
        struct s__field_gen_role *more_general_fgr;
        t__bool debug_field;
        struct s__seed_domain *the_seed;
        struct s__l__simple_gen_constraint *gcs;
        struct s__l__index *par_inds;
        struct s__l__index *soft_inds;
        t__count last_reduction;
        t__bool in_reduction_list;
        t__role_range_status role_range_status;
        struct s__int_rl *int_rl;
} *t__int_field_gen_role;
#define d__int_field_gen_role 1314

/* line 25 "/proj/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__uint_rl {
    t__int d__;
    t__int gen__;
        struct s__l__uint *rl_list;
} *t__uint_rl;
#define d__uint_rl 1102

/* line 291 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__uint_field_gen_role {
    t__int d__;
    t__int gen__;
        struct s__field *f;
        struct s__a_role *parent_role;
        struct s__field_gen_role *more_general_fgr;
        t__bool debug_field;
        struct s__seed_domain *the_seed;
        struct s__l__simple_gen_constraint *gcs;
        struct s__l__index *par_inds;
        struct s__l__index *soft_inds;
        t__count last_reduction;
        t__bool in_reduction_list;
        t__role_range_status role_range_status;
        struct s__uint_rl *uint_rl;
} *t__uint_field_gen_role;
#define d__uint_field_gen_role 1315

/* line 26 "/proj/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__long_rl {
    t__int d__;
    t__int gen__;
        struct s__l__sn_vec *rl_list;
        t__bool inf_hi;
        t__bool inf_lo;
} *t__long_rl;
#define d__long_rl 1103

/* line 293 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__long_field_gen_role {
    t__int d__;
    t__int gen__;
        struct s__field *f;
        struct s__a_role *parent_role;
        struct s__field_gen_role *more_general_fgr;
        t__bool debug_field;
        struct s__seed_domain *the_seed;
        struct s__l__simple_gen_constraint *gcs;
        struct s__l__index *par_inds;
        struct s__l__index *soft_inds;
        t__count last_reduction;
        t__bool in_reduction_list;
        t__role_range_status role_range_status;
        struct s__long_rl *long_rl;
} *t__long_field_gen_role;
#define d__long_field_gen_role 1316

/* line 99 "/proj/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__struct_rl {
    t__int d__;
    t__int gen__;
        t__bool is_complement;
        struct s__l__base_struct *rl_list;
} *t__struct_rl;
#define d__struct_rl 1111

/* line 295 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__struct_field_gen_role {
    t__int d__;
    t__int gen__;
        struct s__field *f;
        struct s__a_role *parent_role;
        struct s__field_gen_role *more_general_fgr;
        t__bool debug_field;
        struct s__seed_domain *the_seed;
        struct s__l__simple_gen_constraint *gcs;
        struct s__l__index *par_inds;
        struct s__l__index *soft_inds;
        t__count last_reduction;
        t__bool in_reduction_list;
        t__role_range_status role_range_status;
        struct s__struct_rl *struct_rl;
} *t__struct_field_gen_role;
#define d__struct_field_gen_role 1317

/* line 100 "/proj/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__string_rl {
    t__int d__;
    t__int gen__;
        t__bool is_complement;
        struct s__l__string *rl_list;
} *t__string_rl;
#define d__string_rl 1112

/* line 297 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__string_field_gen_role {
    t__int d__;
    t__int gen__;
        struct s__field *f;
        struct s__a_role *parent_role;
        struct s__field_gen_role *more_general_fgr;
        t__bool debug_field;
        struct s__seed_domain *the_seed;
        struct s__l__simple_gen_constraint *gcs;
        struct s__l__index *par_inds;
        struct s__l__index *soft_inds;
        t__count last_reduction;
        t__bool in_reduction_list;
        t__role_range_status role_range_status;
        struct s__string_rl *string_rl;
} *t__string_field_gen_role;
#define d__string_field_gen_role 1318

/* line 93 "/proj/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__list_of_int_rl {
    t__int d__;
    t__int gen__;
        struct s__l__uint *rl_list;
        struct s__l__uint_rl *inds;
        struct s__l__uint *single_inds;
        struct s__list_rl *in_list;
        struct s__uint_rl *in_list_inds;
        struct s__l__uint *in_list_inds_fast;
        struct s__l__int_rl *vals;
        struct s__l__int *single_vals;
        struct s__int_rl *single_vals_range;
        t__bool fast_in_list;
        struct s__int_rl *last_inds_query;
        struct s__uint_rl *last_inds_query_result;
        struct s__uint_rl *last_vals_query;
        struct s__int_rl *last_vals_query_result;
        t__uint last_search_stop;
        struct s__uint_rl *last_precise_inds;
        struct s__int_rl *last_precise_vals;
} *t__list_of_int_rl;
#define d__list_of_int_rl 1107

/* line 56 "/proj/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__list_rl {
    t__int d__;
    t__int gen__;
        struct s__l__uint *rl_list;
        struct s__l__uint_rl *inds;
        struct s__l__uint *single_inds;
        struct s__list_rl *in_list;
        struct s__uint_rl *in_list_inds;
        struct s__l__uint *in_list_inds_fast;
} *t__list_rl;
#define d__list_rl 1104

/* line 309 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__int_list_field_gen_role {
    t__int d__;
    t__int gen__;
        struct s__field *f;
        struct s__a_role *parent_role;
        struct s__field_gen_role *more_general_fgr;
        t__bool debug_field;
        struct s__seed_domain *the_seed;
        struct s__l__simple_gen_constraint *gcs;
        struct s__l__index *par_inds;
        struct s__l__index *soft_inds;
        t__count last_reduction;
        t__bool in_reduction_list;
        t__role_range_status role_range_status;
        struct s__l__simple_gen_constraint *item_gcs;
        struct s__l__index *item_par_inds;
        struct s__l__index *item_soft_inds;
        t__count item_last_reduction;
        t__bool item_in_reduction_list;
        t__role_range_status item_role_range_status;
        struct s__list_of_int_rl *list_of_int_rl;
} *t__int_list_field_gen_role;
#define d__int_list_field_gen_role 1320

/* line 92 "/proj/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__list_of_uint_rl {
    t__int d__;
    t__int gen__;
        struct s__l__uint *rl_list;
        struct s__l__uint_rl *inds;
        struct s__l__uint *single_inds;
        struct s__list_rl *in_list;
        struct s__uint_rl *in_list_inds;
        struct s__l__uint *in_list_inds_fast;
        struct s__l__uint_rl *vals;
        struct s__l__uint *single_vals;
        struct s__uint_rl *single_vals_range;
        t__bool fast_in_list;
        struct s__uint_rl *last_inds_query;
        struct s__uint_rl *last_inds_query_result;
        struct s__uint_rl *last_vals_query;
        struct s__uint_rl *last_vals_query_result;
        t__uint last_search_stop;
        struct s__uint_rl *last_precise_inds;
        struct s__uint_rl *last_precise_vals;
} *t__list_of_uint_rl;
#define d__list_of_uint_rl 1106

/* line 311 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__uint_list_field_gen_role {
    t__int d__;
    t__int gen__;
        struct s__field *f;
        struct s__a_role *parent_role;
        struct s__field_gen_role *more_general_fgr;
        t__bool debug_field;
        struct s__seed_domain *the_seed;
        struct s__l__simple_gen_constraint *gcs;
        struct s__l__index *par_inds;
        struct s__l__index *soft_inds;
        t__count last_reduction;
        t__bool in_reduction_list;
        t__role_range_status role_range_status;
        struct s__l__simple_gen_constraint *item_gcs;
        struct s__l__index *item_par_inds;
        struct s__l__index *item_soft_inds;
        t__count item_last_reduction;
        t__bool item_in_reduction_list;
        t__role_range_status item_role_range_status;
        struct s__list_of_uint_rl *list_of_uint_rl;
} *t__uint_list_field_gen_role;
#define d__uint_list_field_gen_role 1321

/* line 94 "/proj/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__list_of_long_rl {
    t__int d__;
    t__int gen__;
        struct s__l__uint *rl_list;
        struct s__l__uint_rl *inds;
        struct s__l__uint *single_inds;
        struct s__list_rl *in_list;
        struct s__uint_rl *in_list_inds;
        struct s__l__uint *in_list_inds_fast;
        struct s__l__long_rl *vals;
        struct s__l__sn_vec *single_vals;
        struct s__long_rl *single_vals_range;
        t__bool fast_in_list;
        struct s__long_rl *last_inds_query;
        struct s__uint_rl *last_inds_query_result;
        struct s__uint_rl *last_vals_query;
        struct s__long_rl *last_vals_query_result;
        t__uint last_search_stop;
        struct s__uint_rl *last_precise_inds;
        struct s__long_rl *last_precise_vals;
} *t__list_of_long_rl;
#define d__list_of_long_rl 1108

/* line 313 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__long_list_field_gen_role {
    t__int d__;
    t__int gen__;
        struct s__field *f;
        struct s__a_role *parent_role;
        struct s__field_gen_role *more_general_fgr;
        t__bool debug_field;
        struct s__seed_domain *the_seed;
        struct s__l__simple_gen_constraint *gcs;
        struct s__l__index *par_inds;
        struct s__l__index *soft_inds;
        t__count last_reduction;
        t__bool in_reduction_list;
        t__role_range_status role_range_status;
        struct s__l__simple_gen_constraint *item_gcs;
        struct s__l__index *item_par_inds;
        struct s__l__index *item_soft_inds;
        t__count item_last_reduction;
        t__bool item_in_reduction_list;
        t__role_range_status item_role_range_status;
        struct s__list_of_long_rl *list_of_long_rl;
} *t__long_list_field_gen_role;
#define d__long_list_field_gen_role 1322

/* line 95 "/proj/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__list_of_struct_rl {
    t__int d__;
    t__int gen__;
        struct s__l__uint *rl_list;
        struct s__l__uint_rl *inds;
        struct s__l__uint *single_inds;
        struct s__list_rl *in_list;
        struct s__uint_rl *in_list_inds;
        struct s__l__uint *in_list_inds_fast;
        struct s__l__struct_rl *vals;
        struct s__l__base_struct *single_vals;
        struct s__struct_rl *single_vals_range;
        t__bool fast_in_list;
        struct s__struct_rl *last_inds_query;
        struct s__uint_rl *last_inds_query_result;
        struct s__uint_rl *last_vals_query;
        struct s__struct_rl *last_vals_query_result;
        t__uint last_search_stop;
        struct s__uint_rl *last_precise_inds;
        struct s__struct_rl *last_precise_vals;
} *t__list_of_struct_rl;
#define d__list_of_struct_rl 1109

/* line 315 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__struct_list_field_gen_role {
    t__int d__;
    t__int gen__;
        struct s__field *f;
        struct s__a_role *parent_role;
        struct s__field_gen_role *more_general_fgr;
        t__bool debug_field;
        struct s__seed_domain *the_seed;
        struct s__l__simple_gen_constraint *gcs;
        struct s__l__index *par_inds;
        struct s__l__index *soft_inds;
        t__count last_reduction;
        t__bool in_reduction_list;
        t__role_range_status role_range_status;
        struct s__l__simple_gen_constraint *item_gcs;
        struct s__l__index *item_par_inds;
        struct s__l__index *item_soft_inds;
        t__count item_last_reduction;
        t__bool item_in_reduction_list;
        t__role_range_status item_role_range_status;
        struct s__list_of_struct_rl *list_of_struct_rl;
} *t__struct_list_field_gen_role;
#define d__struct_list_field_gen_role 1323

/* line 96 "/proj/specman/src/rl_interface.e"  From 'struct definition' */
typedef struct s__list_of_string_rl {
    t__int d__;
    t__int gen__;
        struct s__l__uint *rl_list;
        struct s__l__uint_rl *inds;
        struct s__l__uint *single_inds;
        struct s__list_rl *in_list;
        struct s__uint_rl *in_list_inds;
        struct s__l__uint *in_list_inds_fast;
        struct s__l__string_rl *vals;
        struct s__l__string *single_vals;
        struct s__string_rl *single_vals_range;
        t__bool fast_in_list;
        struct s__string_rl *last_inds_query;
        struct s__uint_rl *last_inds_query_result;
        struct s__uint_rl *last_vals_query;
        struct s__string_rl *last_vals_query_result;
        t__uint last_search_stop;
        struct s__uint_rl *last_precise_inds;
        struct s__string_rl *last_precise_vals;
} *t__list_of_string_rl;
#define d__list_of_string_rl 1110

/* line 317 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__string_list_field_gen_role {
    t__int d__;
    t__int gen__;
        struct s__field *f;
        struct s__a_role *parent_role;
        struct s__field_gen_role *more_general_fgr;
        t__bool debug_field;
        struct s__seed_domain *the_seed;
        struct s__l__simple_gen_constraint *gcs;
        struct s__l__index *par_inds;
        struct s__l__index *soft_inds;
        t__count last_reduction;
        t__bool in_reduction_list;
        t__role_range_status role_range_status;
        struct s__l__simple_gen_constraint *item_gcs;
        struct s__l__index *item_par_inds;
        struct s__l__index *item_soft_inds;
        t__count item_last_reduction;
        t__bool item_in_reduction_list;
        t__role_range_status item_role_range_status;
        struct s__list_of_string_rl *list_of_string_rl;
} *t__string_list_field_gen_role;
#define d__string_list_field_gen_role 1324

/* line 73 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__list_ci {
    t__int d__;
    t__int gen__;
        t__imp_enum_list_ci__ci_type ci_type;
        struct s__any_rl *index_rl;
        t__index ind_in_ci;
        struct s__sn_simple_constraint_ins6608 *ci;
} *t__list_ci;
#define d__list_ci 1426

/* line 71 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__any_struct {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__any_struct;
#define d__any_struct 16

/* line 787 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_gen_event {
    t__int d__;
    t__int gen__;
        t__int index;
        struct s__base_struct *holder_entity;
        t__int location_in_holder;
} *t__sn_gen_event;
#define d__sn_gen_event 3572

/* line 525 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__choose_reduce_graph {
    t__int d__;
    t__int gen__;
        t__count no_of_reduction_phases;
        t__count total_no_of_reductions;
        t__count no_of_reductions_in_phase;
        t__count max_no_of_reductions_in_phase;
        t__index contradiction_index;
        struct s__l__gendb_item *dbg_items;
        t__bool to_test;
        struct s__l__any_rl *rls;
        struct s__l__string *lines;
        t__bool debug_it;
        struct s__l__index *debug_pars;
        struct s__l__field_node *par_nodes;
        struct s__field_node *curr_par;
        struct s__sn_simple_constraint_ins6608 *ci;
        struct s__l__field_node *ci_par_nodes;
        t__index ci_index;
        t__index par_ind;
        struct s__l__sn_soft_testing_event *soft_testing_events;
        struct s__any_rl *save_rl;
        t__bool first_time;
        struct s__l__sn_simple_constraint37353 *soft_cis;
        struct s__l__sn_cpi *soft_cpis;
        struct s__any_rl *par_range;
        t__bool no_more;
        t__bool found_successful;
} *t__choose_reduce_graph;
#define d__choose_reduce_graph 1478

/* line 1500 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_soft_testing_event {
    t__int d__;
    t__int gen__;
        t__int index;
        struct s__base_struct *holder_entity;
        t__int location_in_holder;
        struct s__l__sn_gendb_item *parameters;
        struct s__sn_ci_status_changed *new_status;
        struct s__not_fix_me_gendb_item *item;
} *t__sn_soft_testing_event;
#define d__sn_soft_testing_event 3602

/* line 2397 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_gendb_item {
    t__int d__;
    t__int gen__;
        t__int parameter_index;
        struct s__any_rl *rl;
        struct s__type_descriptor *td;
        struct s__constraint_path *cp;
        struct s__sn_gen_event *holding_event;
} *t__sn_gendb_item;
#define d__sn_gendb_item 3656

/* line 2355 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_ci_status_changed {
    t__int d__;
    t__int gen__;
        t__int parameter_index;
        t__sn_status_result_kinds result;
        struct s__sn_gen_event *holding_event;
        struct s__gendb_constraint *ci;
        t__index index_in_cig;
} *t__sn_ci_status_changed;
#define d__sn_ci_status_changed 3654

/* line 2214 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__gendb_constraint {
    t__int d__;
    t__int gen__;
        struct s__gen_constraint *gc;
        t__index index;
        struct s__sn_set_status_event *set_status;
        struct s__l__sn_ci_status_changed *history;
} *t__gendb_constraint;
#define d__gendb_constraint 3643

/* line 1422 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_set_status_event {
    t__int d__;
    t__int gen__;
        t__int index;
        struct s__base_struct *holder_entity;
        t__int location_in_holder;
        struct s__sn_gen_event *direct_event_reason;
        t__sn_gendb_status kind;
        struct s__sn_ci_status_changed *changed_status;
} *t__sn_set_status_event;
#define d__sn_set_status_event 3599

/* line 2651 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__not_fix_me_gendb_item {
    t__int d__;
    t__int gen__;
        t__int parameter_index;
        struct s__any_rl *rl;
        struct s__type_descriptor *td;
        struct s__constraint_path *cp;
        struct s__sn_gen_event *holding_event;
        struct s__base_struct *holder;
        struct s__field *f;
        t__bool fixed;
        t__bool accessible;
        struct s__base_struct *initial_struct;
        struct s__l__int *path_indexes;
        t__int last_accessible_field;
        t__bool deffered;
        struct s__gendb_field_in_gen *fig;
        t__index index_in_fig;
} *t__not_fix_me_gendb_item;
#define d__not_fix_me_gendb_item 3666

/* line 2070 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__gendb_field_in_gen {
    t__int d__;
    t__int gen__;
        t__index index_in_holder;
        struct s__field *f;
        struct s__l__not_fix_me_gendb_item *history;
        struct s__sn_gen_root_event *holder;
        struct s__base_struct *instance;
        t__int order_index;
        struct s__gendb_field_in_role *static_field;
} *t__gendb_field_in_gen;
#define d__gendb_field_in_gen 3638

/* line 1045 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_gen_root_event {
    t__int d__;
    t__int gen__;
        t__int index;
        struct s__base_struct *holder_entity;
        t__int location_in_holder;
        struct s__me_gendb_item *item;
        t__bool trace_from_begining;
        t__bool trace_till_end;
        t__bool complete_trace;
        t__bool failed_because_try;
        t__gen_process_status status;
        struct s__k__gendb_field_in_gen__f *all_fields;
        struct s__l__sn_gen_event *all_events;
        struct s__k__gendb_ci_in_gen__gc *me_app_constraints;
        struct s__sn_role_info *role;
        t__bool is_gotf_path;
} *t__sn_gen_root_event;
#define d__sn_gen_root_event 3581

/* line 2607 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__me_gendb_item {
    t__int d__;
    t__int gen__;
        t__int parameter_index;
        struct s__any_rl *rl;
        struct s__type_descriptor *td;
        struct s__constraint_path *cp;
        struct s__sn_gen_event *holding_event;
        struct s__base_struct *holder;
        struct s__field *f;
        t__bool fixed;
        t__bool accessible;
        struct s__base_struct *initial_struct;
        struct s__l__int *path_indexes;
        t__int last_accessible_field;
} *t__me_gendb_item;
#define d__me_gendb_item 3663

/* line 2263 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__gendb_ci_in_gen {
    t__int d__;
    t__int gen__;
        struct s__gen_constraint *gc;
        t__index index;
        struct s__sn_set_status_event *set_status;
        struct s__l__sn_ci_status_changed *history;
        struct s__base_struct *instance;
        struct s__sn_gen_root_event *holder;
        struct s__gendb_ci_in_gen *parent;
        struct s__l__gendb_ci_in_gen *children;
        struct s__gendb_gc_in_role *static_constraint;
} *t__gendb_ci_in_gen;
#define d__gendb_ci_in_gen 3646

/* line 2243 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__gendb_gc_in_role {
    t__int d__;
    t__int gen__;
        struct s__gen_constraint *gc;
        t__index index;
        struct s__sn_set_status_event *set_status;
        struct s__l__sn_ci_status_changed *history;
        struct s__sn_role_info *holder;
} *t__gendb_gc_in_role;
#define d__gendb_gc_in_role 3645

/* line 1905 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_role_info {
    t__int d__;
    t__int gen__;
        struct s__a_role *role;
        struct s__k__gendb_field_in_role__f *all_fields;
        struct s__l__sn_static_edge_event *all_edges;
        struct s__k__gendb_gc_in_role__gc *app_constraints;
        struct s__l__sn_gen_event *all_events;
        t__uint role_id;
} *t__sn_role_info;
#define d__sn_role_info 3626

/* line 1993 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__gendb_field_in_role {
    t__int d__;
    t__int gen__;
        t__index index_in_holder;
        struct s__field *f;
        struct s__sn_role_info *holder;
        struct s__l__changed_static_gendb_item *history;
        struct s__l__gendb_gc_in_role *involved_in_constraint;
        struct s__l__index *location_in_constraints;
        struct s__any_rl *static_range;
} *t__gendb_field_in_role;
#define d__gendb_field_in_role 3631

/* line 2505 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__changed_static_gendb_item {
    t__int d__;
    t__int gen__;
        t__int parameter_index;
        struct s__any_rl *rl;
        struct s__type_descriptor *td;
        struct s__constraint_path *cp;
        struct s__sn_gen_event *holding_event;
        struct s__field *f;
        struct s__any_rl *pre_rl;
        struct s__gendb_field_in_role *fir;
        t__index index_in_fir;
} *t__changed_static_gendb_item;
#define d__changed_static_gendb_item 3660

/* line 1583 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_static_edge_event {
    t__int d__;
    t__int gen__;
        t__int index;
        struct s__base_struct *holder_entity;
        t__int location_in_holder;
        struct s__gendb_field *from;
        struct s__gendb_field *to;
        t__om_edge_reason reason;
        t__imp_enum_sn_create_edge_event__kind kind;
        t__bool is_soft;
        struct s__gendb_constraint *constraint;
} *t__sn_static_edge_event;
#define d__sn_static_edge_event 3609

/* line 1962 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__gendb_field {
    t__int d__;
    t__int gen__;
        t__index index_in_holder;
        struct s__field *f;
} *t__gendb_field;
#define d__gendb_field 3630

/* line 433 "/proj/specman/src/gen_reduce_or.e"  From 'struct definition' */
typedef struct s__and_info {
    t__int d__;
    t__int gen__;
        struct s__gen_constraint_and *gca;
        struct s__l__status_in_and *stats;
        struct s__l__gen_constraint *gcs;
        struct s__l__index *gcs_inds;
} *t__and_info;
#define d__and_info 3474

/* line 316 "/proj/specman/src/gen_constraint_header.e"  From 'struct definition' */
typedef struct s__gen_constraint_range {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__struct_descriptor *Context_struct;
        t__access_qualifier access_qualifier;
        t__int index;
        struct s__n__exp *n__exp;
        struct s__n__exp *root_exp;
        t__gc_status status;
        struct s__l__gen_constraint *derived_from;
        t__count last_reduction;
        struct s__gen_constraint_or *top_or;
        t__index or_index;
        t__index and_index;
        struct s__gen_constraint_and *top_and;
        t__index index_in_me;
        t__index gen_fly_index;
        t__bool is_soft;
        struct s__l__index *soft_inds;
        struct s__constraint_path *for_each_list;
        t__bool do_not_order;
        struct s__l__gc_order_info *gcois;
        t__bool has_soft_temps;
        t__bool reloced_temps;
        t__bool needs_bit_paths;
        t__bool one_path;
        struct s__l__any_rl *constant_ranges;
        struct s__l__constraint_path *constraint_paths;
        t__string pretty;
        struct s__any_rl *the_range_list;
        t__bool inverted;
} *t__gen_constraint_range;
#define d__gen_constraint_range 1279

/* line 397 "/proj/specman/src/gen_reduce_or.e"  From 'struct definition' */
typedef struct s__derived_or_info {
    t__int d__;
    t__int gen__;
        struct s__l__gen_constraint_range *gcrs;
        struct s__l__gen_constraint_or *gcos;
        struct s__l__gen_constraint *gcs;
} *t__derived_or_info;
#define d__derived_or_info 3471

/* line 481 "/proj/specman/src/gen_reduce_or.e"  From 'struct definition' */
typedef struct s__or_info {
    t__int d__;
    t__int gen__;
        struct s__gen_constraint_or *gco;
        struct s__l__status_in_or *stats;
        struct s__l__and_info *gcas;
        struct s__l__index *gcs_inds;
        struct s__gen_constraint_range *the_one_path_gc;
        struct s__a_role *me_role;
} *t__or_info;
#define d__or_info 3476

/* line 625 "/proj/specman/src/gen_static_collector.e"  From 'struct definition' */
typedef struct s__del_gcs_iterator {
    t__int d__;
    t__int gen__;
        struct s__role_collector *rc;
} *t__del_gcs_iterator;
#define d__del_gcs_iterator 3524

/* line 471 "/proj/specman/src/gen_static_collector.e"  From 'struct definition' */
typedef struct s__role_collector {
    t__int d__;
    t__int gen__;
        struct s__role_collector *prev;
        struct s__a_role *the_role;
} *t__role_collector;
#define d__role_collector 3520

/* line 292 "/proj/specman/src/gen_static_collector.e"  From 'struct definition' */
typedef struct s__sn_fgr_iterator {
    t__int d__;
    t__int gen__;
        t__count n_nt;
        t__count n_f;
        struct s__a_role *the_role;
        struct s__l__sn_field_collector *fcs;
        struct s__l__a_role *prevs;
} *t__sn_fgr_iterator;
#define d__sn_fgr_iterator 3515

/* line 101 "/proj/specman/src/gen_static_collector.e"  From 'struct definition' */
typedef struct s__sn_field_collector {
    t__int d__;
    t__int gen__;
        struct s__sn_field_collector *prev;
        t__index i;
        struct s__a_role *r;
} *t__sn_field_collector;
#define d__sn_field_collector 3511

/* line 393 "/proj/specman/src/gen_static_collector.e"  From 'struct definition' */
typedef struct s__sn_update_ranges_iterator {
    t__int d__;
    t__int gen__;
        t__count n_nt;
        t__count n_f;
        struct s__a_role *the_role;
        struct s__l__sn_field_collector *fcs;
        struct s__l__a_role *prevs;
} *t__sn_update_ranges_iterator;
#define d__sn_update_ranges_iterator 3517

/* line 450 "/proj/specman/src/gen_static_collector.e"  From 'struct definition' */
typedef struct s__sn_create_extra_iterator {
    t__int d__;
    t__int gen__;
        t__count n_nt;
        t__count n_f;
        struct s__a_role *the_role;
        struct s__l__sn_field_collector *fcs;
        struct s__l__a_role *prevs;
} *t__sn_create_extra_iterator;
#define d__sn_create_extra_iterator 3519

/* line 537 "/proj/specman/src/gen_static_collector.e"  From 'struct definition' */
typedef struct s__field_relevancy_iterator {
    t__int d__;
    t__int gen__;
        struct s__role_collector *rc;
} *t__field_relevancy_iterator;
#define d__field_relevancy_iterator 3522

/* line 899 "/proj/specman/src/gen_static_collector.e"  From 'struct definition' */
typedef struct s__create_edges_iterator {
    t__int d__;
    t__int gen__;
        struct s__role_collector *rc;
} *t__create_edges_iterator;
#define d__create_edges_iterator 3526

/* line 1154 "/proj/specman/src/gen_static_collector.e"  From 'struct definition' */
typedef struct s__inherite_edges_iterator {
    t__int d__;
    t__int gen__;
        struct s__role_collector *rc;
} *t__inherite_edges_iterator;
#define d__inherite_edges_iterator 3528

/* line 224 "/proj/specman/src/gen_static_comms.e"  From 'struct definition' */
typedef struct s__finalize_iterator {
    t__int d__;
    t__int gen__;
        t__count n_nt;
        t__count n_f;
        struct s__a_role *the_role;
        struct s__l__sn_field_collector *fcs;
        struct s__l__a_role *prevs;
} *t__finalize_iterator;
#define d__finalize_iterator 3544

/* line 417 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__units {
    t__int d__;
    t__int gen__;
        struct s__l__any_unit *instances;
        t__bool multi_unit_mode;
        t__bool some_unit_instantiated;
        struct s__unit_enclosing_descriptor *unit_enclosing_descriptor;
        struct s__globalComputedStructList *globalComputedStructList;
        struct s__l__struct_descriptor *all_units;
        t__bool is_elaborate_hdl_done;
        struct s__curr_calc *global_calc;
        struct s__l__unit_instance_info *instance_info_list;
        struct s__k__hdl_struct__name *hdl_structs;
        struct s__k__subprogram_handle__su9790 *subprogram_handles;
        struct s__k__subprogram_entry__sub9791 *subprogram_entries;
        struct s__k__subprogram_definition9789 *subprograms;
        struct s__l__string *orig_subprogram_name;
        struct s__l__subprogram_exp_info *subprograms_exp_info;
        struct s__globalComputedSubprogramList *globalComputedSubprogramsList;
        struct s__k__any_unit__root___norm9792 *units_by_noraml_hdl_path;
} *t__units;
#define d__units 52

/* line 257 "../src/root_types.e"  From 'struct definition' */
typedef struct s__unit_enclosing_descriptor {
    t__int d__;
    t__int gen__;
        struct s__k__string__it *global_enclosing_list;
        t__bool enclosing_list_was_enlarge;
} *t__unit_enclosing_descriptor;
#define d__unit_enclosing_descriptor 114

/* line 42 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__globalComputedStructList {
    t__int d__;
    t__int gen__;
        struct s__l__computed_struct_list *Table;
        t__uint str_counter;
        struct s__l__bool *is_first_unit;
} *t__globalComputedStructList;
#define d__globalComputedStructList 1529

/* line 29 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__computed_struct_list {
    t__int d__;
    t__int gen__;
        struct s__l__computed_name *lst;
} *t__computed_struct_list;
#define d__computed_struct_list 1524

/* line 141 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__unit_instance_info {
    t__int d__;
    t__int gen__;
        struct s__any_unit *unit_inst;
        struct s__k__subprogram_handle__su9797 *me_subprograms;
        struct s__k__subprogram_handle__su9797 *all_hilhul_subprograms;
} *t__unit_instance_info;
#define d__unit_instance_info 1537

/* line 453 "/proj/specman/src/scriptsim.e"  From 'struct definition' */
typedef struct s__subprogram_handle {
    t__int d__;
    t__int gen__;
        t__string subprogram_name;
        t__string subprogram_noraml_name;
        t__simulator_kind kind;
        struct s__all_tms_for_subprogram *all_tms_for_subprogram;
        t__string trig_in_name;
        t__string trig_out_name;
        t__string res_func_name;
        t__string return_name_type;
        t__string merge_name;
        t__string process_name;
        t__uint return_function_size;
        struct s__subprogram_definition *vtd;
        t__uint param_size;
        struct s__l__subprogram_param *params;
        struct s__subprogram_exp_info *info;
        struct s__any_unit *unit_inst;
        t__bool is_busy;
        struct s__sn_adapter_struct *adapter_struct;
        struct s__l__connecte_cell *connecte_cell_param;
        struct s__l__int *original_sig_param;
} *t__subprogram_handle;
#define d__subprogram_handle 833

/* line 365 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__all_tms_for_subprogram {
    t__int d__;
    t__int gen__;
        struct s__l__translated_model_struct *subprogram_params;
        struct s__translated_model_struct *trig_in;
} *t__all_tms_for_subprogram;
#define d__all_tms_for_subprogram 1566

/* line 346 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__subprogram_exp_info {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string name;
        t__string original_string;
        struct s__struct_descriptor *unit_desc;
        struct s__subprogram_entry *the_entry;
        struct s__computed_subprogram_name *the_cms;
        struct s__desc_subprogram_info *the_desc_info;
        t__bool is_unit;
        t__bool is_canonical;
        t__bool was_computed;
        struct s__l__hdl_data_type *data_types;
        struct s__l__type_descriptor *list_type;
        t__uint param_size;
        struct s__l__untyped *values;
        t__bool is_entry_set;
        t__string struct_string;
        struct s__any_unit *the_inst;
} *t__subprogram_exp_info;
#define d__subprogram_exp_info 1564

/* line 397 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__subprogram_entry {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string subprogram_name;
        t__string subprogram_full_name;
        t__bool is_canonical;
        struct s__k__desc_subprogram_info_9796 *descs;
} *t__subprogram_entry;
#define d__subprogram_entry 1569

/* line 392 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__desc_subprogram_info {
    t__int d__;
    t__int gen__;
        struct s__struct_descriptor *unit_desc;
        struct s__l__subprogram_handle *subprogram_handles;
} *t__desc_subprogram_info;
#define d__desc_subprogram_info 1567

/* line 33 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__computed_subprogram_name {
    t__int d__;
    t__int gen__;
        t__string name;
        struct s__subprogram_entry *the_entry;
} *t__computed_subprogram_name;
#define d__computed_subprogram_name 1526

/* line 426 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__connecte_cell {
    t__int d__;
    t__int gen__;
        t__bool is_free;
        struct s__translated_model_struct *conc_tms;
} *t__connecte_cell;
#define d__connecte_cell 1574

/* line 48 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__globalComputedSubprogramList {
    t__int d__;
    t__int gen__;
        struct s__l__computed_subprogram_list *Table;
        t__uint str_counter;
        struct s__l__bool *is_first_unit;
} *t__globalComputedSubprogramList;
#define d__globalComputedSubprogramList 1531

/* line 38 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__computed_subprogram_list {
    t__int d__;
    t__int gen__;
        struct s__l__computed_subprogram_name *lst;
} *t__computed_subprogram_list;
#define d__computed_subprogram_list 1527

/* line 926 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__session {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__int num_of_errors;
        t__string last_save_file_name;
        struct s__print_options *last_print_options;
        t__next_prev_op next_prev_op;
        t__bool exit_on_error;
        t__bool retain_state_across_restore;
        t__bool currently_in_simulator;
        struct s__l__external_pointer *saved_signal_handlers;
        t__uint pid;
        t__bool down_cast_warning;
        t__bool do_not_save_raw;
        struct s__l__bit *indexing_list;
        struct s__l__source_item *appendf_ref;
        struct s__src_on_runtime *src_on_runtime;
        t__string error_command;
        t__bool show_calls_on_error;
        struct s__script_instance *last_si;
        t__test_phase test_phase;
        t__on_event_type pre_event;
        t__string parent_type_name;
        t__string method_name;
        t__string output_string;
        t__string signal_name;
        t__bool during_run_dfs;
        struct s__k__any_struct__it *new_on_run_dfs;
        struct s__k__seed_domain__name *seed_domains;
        struct s__k__list_seed_domain__name *list_seed_domains;
        t__int run_tick_max;
        t__bool run_in_progress;
        t__bool test_command_in_progress;
        t__bool global_extract_in_progress;
        t__bool global_check_in_progress;
        t__bool end_of_test;
        t__bool do_automatic_check;
        t__bool some_script_started;
        t__run_status run_status;
        t__count tick_counter;
        t__bool check_ok;
        t__int num_of_dut_errors;
        t__int num_of_dut_warnings;
        t__bool use_manual_tick;
        t__count update_count;
        t__count update_count_simulator;
        t__bool check_traced;
        t__bool sim_read_traced;
        t__bool sim_write_traced;
        t__bool tcm_state_traced;
        t__bool output_traced;
        struct s__sn_config *sn_config;
        struct s__config_all *config;
        struct s__l__string *refresh_options;
        struct s__l__configuration_category *configuration_categories;
        struct s__tcm *started_tcm;
        struct s__script_instance *current_si;
        struct s__entry_instance *last_instance;
        t__int thread_handle_counter;
        struct s__entry_instance_pools *entry_instance_pools;
        struct s__longTime *longTime;
        t__int last_esv_module_num;
        t__bool TEs_at_sim;
        t__bool tick_started;
        t__bool on_event_exist;
        t__bool tcm_wait_traced;
        t__int sn_cmd_counter_in_tick;
        t__int last_sn_cmd_idx_on_prompt;
        t__int sn___start_of_test_occ_l;
        struct s__sn_event_struct *sn___start_of_test_event_struct;
        t__uint user_time;
        t__uint system_time;
        t__string host_name;
        t__uint specman_memory;
        t__uint break_on_alloc_prev_stop;
        t__uint break_on_alloc_curr_stop;
        t__uint break_on_alloc_next_stop;
        t__int break_on_alloc_step_size;
        t__int break_on_alloc_counter;
        t__string break_on_alloc_def_step_size_str;
        struct s__sn_prof_helper *sn_prof_helper;
        t__bool collect_prof;
        t__bool prof_dump_final_info;
        t__string prof_log_file_name;
        t__string prof_info_file_name;
        t__int prof_period_usec;
        t__int prof_sig_interupt_index;
        t__bool prof_memory;
        t__uint prof_memory_block_size;
        t__int sn___tcm_start_occ_l;
        struct s__sn_event_struct *sn___tcm_start_event_struct;
        t__int sn___tcm_end_occ_l;
        struct s__sn_event_struct *sn___tcm_end_event_struct;
        t__int sn___tcm_call_occ_l;
        struct s__sn_event_struct *sn___tcm_call_event_struct;
        t__int sn___tcm_return_occ_l;
        struct s__sn_event_struct *sn___tcm_return_event_struct;
        t__int sn___call_occ_l;
        struct s__sn_event_struct *sn___call_event_struct;
        t__int sn___return_occ_l;
        struct s__sn_event_struct *sn___return_event_struct;
        t__int sn___cvl_call_occ_l;
        struct s__sn_event_struct *sn___cvl_call_event_struct;
        t__int sn___cvl_return_occ_l;
        struct s__sn_event_struct *sn___cvl_return_event_struct;
        t__int sn___output_occ_l;
        struct s__sn_event_struct *sn___output_event_struct;
        t__int sn___line_occ_l;
        struct s__sn_event_struct *sn___line_event_struct;
        t__source_ref source_ref;
        struct s__base_struct *parent_struct;
        t__int sn___tcm_wait_occ_l;
        struct s__sn_event_struct *sn___tcm_wait_event_struct;
        t__int sn___tcm_state_occ_l;
        struct s__sn_event_struct *sn___tcm_state_event_struct;
        t__string from_state;
        t__string to_state;
        t__string signal_translation;
        t__string signal_val;
        t__int sn___sim_read_occ_l;
        struct s__sn_event_struct *sn___sim_read_event_struct;
        t__int sn___sim_write_occ_l;
        struct s__sn_event_struct *sn___sim_write_event_struct;
        t__int sn___check_occ_l;
        struct s__sn_event_struct *sn___check_event_struct;
        t__int check_index;
        t__int sn___dut_error_occ_l;
        struct s__sn_event_struct *sn___dut_error_event_struct;
        struct s__l__index *special_events;
        t__index max_special;
        t__int sn___end_of_test_occ_l;
        struct s__sn_event_struct *sn___end_of_test_event_struct;
        t__int sn___interactive_coverage_occ_l;
        struct s__sn_event_struct *sn___interactive_coverage_event_struct;
        t__int sn___events_occ_l;
        struct s__sn_event_struct *sn___events_event_struct;
} *t__session;
#define d__session 69

/* line 913 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__src_on_runtime {
    t__int d__;
    t__int gen__;
        struct s__l__source_item *error_msg_source_stack;
        t__bool use_error_message;
} *t__src_on_runtime;
#define d__src_on_runtime 66

/* line 293 "/proj/specman/src/basic_action.e"  From 'struct definition' */
typedef struct s__script_instance {
    t__int d__;
    t__int gen__;
        struct s__method *method;
        struct s__l__untyped *values;
        struct s__activation_record *caller;
        struct s__routine *routine;
        t__int call_num;
        t__int sub_call_num;
        t__source_ref lock_source_ref;
        t__bool already_stopped;
        struct s__l__int *list_of_traced_req_ids;
        t__int next_stop_sub_call;
        t__int next_stop_sub_return;
        struct s__n__action *current_action;
        struct s__any_struct *owner;
        t__bool top_level;
        struct s__any_struct *called_struct;
        t__int thread_handle;
        struct s__script_descriptor *script_descriptor;
        t__count visits;
        t__index branch;
        t__index branch_no;
        struct s__script_instance *caller_si;
        struct s__entry_instance *base_instance;
        struct s__entry_instance *last_instance;
        t__match_status match_status;
        t__int call_depth;
        struct s__entry_instance *ei;
        struct s__tcm *called_tcm;
        t__bool is_very_first;
        struct s__base_struct *gen_list_struct;
        struct s__field *gen_list_field;
        struct s__thread_info *thread_info;
        struct s__entry_instance *starter_ei;
} *t__script_instance;
#define d__script_instance 402

/* line 320 "/proj/specman/src/script.e"  From 'struct definition' */
typedef struct s__entry_instance {
    t__int d__;
    t__int gen__;
        struct s__entry *f__entry;
        struct s__entry_instance *parent;
        t__int index_in_parent;
        struct s__l__entry_instance *children;
        struct s__script_instance *script_instance;
        t__match_status status;
        t__int last_successful_child_index;
        struct s__entry_instance_leads *leads;
        t__int uid;
        t__int next_for_code;
        t__int cycles_in_child;
        t__int continue_gen;
} *t__entry_instance;
#define d__entry_instance 975

/* line 293 "/proj/specman/src/script.e"  From 'struct definition' */
typedef struct s__entry_instance_leads {
    t__int d__;
    t__int gen__;
        struct s__entry_instance *on_success;
        struct s__entry_instance *on_failure;
        struct s__entry_instance *on_terminate;
        struct s__entry_instance *on_continue;
        struct s__entry_instance *on_return;
        struct s__entry_instance *on_break;
        struct s__parallel_entry_instance *innermost_fork;
        t__index branch_id;
        t__index success_branch_id;
} *t__entry_instance_leads;
#define d__entry_instance_leads 974

/* line 603 "/proj/specman/src/script.e"  From 'struct definition' */
typedef struct s__parallel_entry_instance {
    t__int d__;
    t__int gen__;
        struct s__entry *f__entry;
        struct s__entry_instance *parent;
        t__int index_in_parent;
        struct s__l__entry_instance *children;
        struct s__script_instance *script_instance;
        t__match_status status;
        t__int last_successful_child_index;
        struct s__entry_instance_leads *leads;
        t__int uid;
        t__int next_for_code;
        t__int cycles_in_child;
        t__int continue_gen;
        struct s__l__entry_instance *last_bts;
        struct s__l__count *branch_visits;
        t__count no_of_success;
        t__count save_visits;
} *t__parallel_entry_instance;
#define d__parallel_entry_instance 987

/* line 88 "/proj/specman/src/script.e"  From 'struct definition' */
typedef struct s__thread_info {
    t__int d__;
    t__int gen__;
        t__source_ref start_source_ref;
        t__uint current_debug_level;
        t__uint start_time;
        t__index index_in_struct;
        struct s__script_instance *started_si;
} *t__thread_info;
#define d__thread_info 972

/* line 163 "/proj/specman/src/script_rnd.e"  From 'struct definition' */
typedef struct s__list_seed_domain {
    t__int d__;
    t__int gen__;
        t__string name;
        t__int current_seed;
        t__int state_s1;
        t__int state_s2;
        t__count count;
        struct s__seed_domain *size_domain;
} *t__list_seed_domain;
#define d__list_seed_domain 812

/* line 1126 "/proj/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__sn_config {
    t__int d__;
    t__int gen__;
        t__bool already_validate;
} *t__sn_config;
#define d__sn_config 926

/* line 737 "/proj/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__config_all {
    t__int d__;
    t__int gen__;
        struct s__config_options *print;
        struct s__config_options *cover;
        struct s__config_options *gen;
        struct s__config_options *run;
        struct s__config_options *memory;
        struct s__config_options *misc;
        t__bool prefix_suffix_set;
        t__string config_error_msg_prefix;
        t__string config_error_msg_suffix;
        struct s__config_options *debug;
        struct s__config_options *gui;
        struct s__config_options *wave;
        struct s__config_options *databrowser;
        struct s__config_options *back32;
        struct s__config_options *back33;
} *t__config_all;
#define d__config_all 922

/* line 522 "/proj/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__config_options {
    t__int d__;
    t__int gen__;
        t__config_categories category;
        t__string short_name;
        t__string category_title;
        t__int cover__at_least_multiplier;
        t__sn_cvr_grading_formula cover__grading_formula;
        t__sn_cfg_cover_mode cover__mode;
        t__bool cover__check_illegal_immediately;
        t__bool cover__verbose_interface;
        t__int cover__max_int_buckets;
        t__int cover__absolute_max_buckets;
        t__show_mode cover__show_mode;
        t__bool cover__sorted;
        t__bool cover__show_file_names;
        t__bool cover__show_sub_holes;
        t__bool cover__show_instances_only;
        t__bool cover__show_partial_grade;
        t__string cover__dir;
        t__string cover__file_name;
        t__string cover__test_name;
        t__string cover__run_name;
        t__string cover__tag_name;
        t__sn_cvr_cost_type cover__ranking_cost;
        t__int cover__ranking_precision;
        t__sn_cover_gui_sync_mode cover__gui_sync_mode;
        t__int gen__seed;
        t__int gen__default_max_list_size;
        t__int gen__absolute_max_list_size;
        t__int gen__max_depth;
        t__int gen__max_structs;
        t__bool gen__warn;
        t__sn_show_on_trace gen__show_on_trace;
        t__int gen__show_repeats;
        t__bool gen__reorder_fields;
        t__bool gen__resolve_cycles;
        t__bool gen__check_unsatisfied_cons;
        t__uint memory__gc_threshold;
        t__int memory__gc_increment;
        t__uint memory__otf_threshold;
        t__uint memory__max_size;
        t__uint memory__absolute_max_size;
        t__bool memory__print_msg;
        t__bool memory__print_otf_msg;
        t__po_radix print__radix;
        t__int print__items;
        t__int print__list_lines;
        t__int print__list_from;
        t__string print__title;
        t__bool print__raw_print;
        t__bool print__window;
        t__bool print__list_is_horizontal;
        t__bool print__list_starts_on_right;
        t__int print__list_grouping;
        t__bool print__list_of_bit_in_hex;
        t__radix print__list_index_radix;
        t__bool print__list_end_flag;
        t__bool print__full;
        t__int print__source_lines;
        t__int print__line_size;
        t__int run__tick_max;
        t__string run__error_command;
        t__bool run__error_is_fatal;
        t__bool run__use_manual_tick;
        t__bool run__quit_on_stop;
        t__bool misc__warn;
        t__string misc__pre_specman_path;
        t__string misc__post_specman_path;
        t__bool misc__short_is_signed;
        t__bool back32__implicit_pack;
        t__bool back33__old_struct_member_under_when;
        t__bool back33__old_method_extension;
        t__bool back33__tick_notation;
        t__bool back33__list_assign;
        t__bool back33__disable_otf_gc;
        t__int debug__watch_list_items;
        t__bool gui__auto_scroll;
        t__bool back32__old_error_handling;
        t__t_exit_on run__exit_on;
        t__bool run__finish_on_error;
        t__bool back32__enable_verilog_trace;
        t__uint gen__nesting;
        t__bool gen__prefix;
        t__bool gen__reduction_colors;
        t__bool back33__cover_mode;
        t__bool back33__disable_cover_events;
        t__bool back33__disable_illegal_ignore_check;
        t__bool back33__tree_window;
        t__bool databrowser__exp_as_root;
        t__int databrowser__list_first_items;
        t__bool databrowser__view_source;
        t__bool back33__no_gen_in_write_stub;
        t__bool back33__use_trace_gen_33;
        t__string wave__dumpfile_dir;
        t__bool back32__bit_slicing_is_uni_directional;
        t__bool gui__use_help_browser;
        t__bool back32__add_slashes_in_set_check;
        t__bool back32__allow_enum_as_index;
        t__bool back32__use_quotes_in_import_statements;
        t__wave_working_mode wave__working_mode;
        t__bool wave__register_structs;
        t__bool wave__auto_refresh;
        t__wave_event_data wave__event_data;
        t__int wave__list_items;
        t__bool wave__thread_code_line;
        t__bool wave__hierarchy_name;
        t__bool wave__use_wave;
        t__int wave__stub_output;
        t__int wave__stub_errors;
        t__int wave__stub_message_len;
        t__int wave__stub_events;
        t__int wave__stub_integers;
        t__int wave__stub_strings;
        t__int wave__stub_strings_len;
        t__int wave__stub_booleans;
        t__int wave__port;
        t__string wave__dump_file;
        t__int wave__timeout;
        t__string wave__path_separator;
        t__bool back33__no_reorder;
        t__bool back33__additional_eval;
        t__int print__event_chart_headers_width;
        t__int print__event_chart_headers_event_percent;
        t__bool back32__struct_eq_is_uni_directional;
        t__bool back32__index_is_uni_directional;
        t__bool back32__in_list_is_uni_directional;
} *t__config_options;
#define d__config_options 912

/* line 2007 "/proj/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__configuration_category {
    t__int d__;
    t__int gen__;
        t__string name;
        t__string label;
        struct s__l__configuration_option *customized_configuration_options;
} *t__configuration_category;
#define d__configuration_category 931

/* line 1790 "/proj/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__configuration_option {
    t__int d__;
    t__int gen__;
        t__string category;
        t__string field_name;
        t__string label;
        t__string tool_tip;
        t__string previous_item_field_name;
        t__string group;
        t__ui_type widget;
        t__int min;
        t__uint max;
        t__string re;
        t__config_option_status status;
} *t__configuration_option;
#define d__configuration_option 930

/* line 2824 "/proj/specman/src/script.e"  From 'struct definition' */
typedef struct s__entry_instance_pools {
    t__int d__;
    t__int gen__;
        t__int ei_uid_cnt;
        struct s__entry_instance *dummy_ei;
        struct s__l__simple_entry_instance *simple_ei_pool;
        struct s__l__script_call_entry_ins2458 *script_call_ei_pool;
        struct s__l__parallel_entry_instance *parallel_ei_pool;
} *t__entry_instance_pools;
#define d__entry_instance_pools 1008

/* line 356 "/proj/specman/src/script.e"  From 'struct definition' */
typedef struct s__simple_entry_instance {
    t__int d__;
    t__int gen__;
        struct s__entry *f__entry;
        struct s__entry_instance *parent;
        t__int index_in_parent;
        struct s__l__entry_instance *children;
        struct s__script_instance *script_instance;
        t__match_status status;
        t__int last_successful_child_index;
        struct s__entry_instance_leads *leads;
        t__int uid;
        t__int next_for_code;
        t__int cycles_in_child;
        t__int continue_gen;
} *t__simple_entry_instance;
#define d__simple_entry_instance 977

/* line 581 "/proj/specman/src/script.e"  From 'struct definition' */
typedef struct s__script_call_entry_instance {
    t__int d__;
    t__int gen__;
        struct s__entry *f__entry;
        struct s__entry_instance *parent;
        t__int index_in_parent;
        struct s__l__entry_instance *children;
        struct s__script_instance *script_instance;
        t__match_status status;
        t__int last_successful_child_index;
        struct s__entry_instance_leads *leads;
        t__int uid;
        t__int next_for_code;
        t__int cycles_in_child;
        t__int continue_gen;
        struct s__script_instance *called_script_instance;
} *t__script_call_entry_instance;
#define d__script_call_entry_instance 982

/* line 32 "/proj/specman/src/scheduler.e"  From 'struct definition' */
typedef struct s__longTime {
    t__int d__;
    t__int gen__;
        t__uint low;
        t__uint high;
        struct s__time *tmp_time;
        struct s__time *scale_time;
} *t__longTime;
#define d__longTime 1679

/* line 328 "/proj/specman/src/te_structs.e"  From 'struct definition' */
typedef struct s__sn_event_struct {
    t__int d__;
    t__int gen__;
        struct s__any_struct *inst;
        struct s__event_type *event;
        struct s__l__wait_entry *waiting;
        struct s__l__wait_entry *swap_waiting;
        t__bool evaluated;
        t__int tier;
        t__int last_cleaned_we_size;
} *t__sn_event_struct;
#define d__sn_event_struct 2046

/* line 355 "/proj/specman/src/te_structs.e"  From 'struct definition' */
typedef struct s__wait_entry {
    t__int d__;
    t__int gen__;
        t__int sig_entry;
        t__int start_eval_tick;
        t__int stop_eval_tick;
        struct s__waiting_thread *thread;
        t__int thread_generation;
} *t__wait_entry;
#define d__wait_entry 2048

/* line 403 "/proj/specman/src/te_structs.e"  From 'struct definition' */
typedef struct s__waiting_thread {
    t__int d__;
    t__int gen__;
        t__waiting_thread_kind kind;
        t__bool queued;
        t__int cur_generation;
        t__int prev_generation;
        t__int start_eval_tick;
        t__int quit_tick;
        t__int temporal_exp_id;
        t__int ind;
        t__int last_eval_gen;
        t__int last_eval_te_gen;
        struct s__entry_instance *f__entry;
        t__int uid;
        t__int visit;
        t__int branch;
        t__int tier;
        struct s__activation_record *context;
        struct s__any_struct *inst;
        struct s__te_memory *the_te_mem;
        t__int event_id;
        t__bool visited;
        t__int eval_sig_entry;
        t__int eval_inst;
        t__int next_sig_entry;
        t__int next_inst;
        t__int we_recycle_generation_in_wt;
} *t__waiting_thread;
#define d__waiting_thread 2050

/* line 255 "/proj/specman/src/te_root.e"  From 'struct definition' */
typedef struct s__te_memory {
    t__int d__;
    t__int gen__;
        struct s__l__bool__32 *table_curr_states;
        struct s__l__bool__32 *table_next_states;
        t__int last_evaluation;
        t__int previous_evaluation;
        struct s__l__counter_list *table_curr_cnts;
        struct s__l__counter_list *table_next_cnts;
        t__int trigger_tick;
        struct s__waiting_thread *the_waiting_thread;
} *t__te_memory;
#define d__te_memory 2016

/* line 38 "/proj/specman/src/fl_cnt.e"  From 'struct definition' */
typedef struct s__counter_list {
    t__int d__;
    t__int gen__;
} *t__counter_list;
#define d__counter_list 2002

/* line 95 "/proj/specman/src/dbg_stack_trace.e"  From 'struct definition' */
typedef struct s__sn_prof_helper {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__l__int *sig_table;
        struct s__l__int *setitimer_flag_table;
        t__bool during_collection;
} *t__sn_prof_helper;
#define d__sn_prof_helper 2893

/* line 231 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__debug {
    t__int d__;
    t__int gen__;
        t__bool root;
        t__bool parse;
        t__bool reparse;
        t__string reparse_match;
        t__bool alloc;
        t__bool vec_long;
        t__bool forms;
        t__bool empty;
        t__bool files;
        t__bool packing;
        t__bool deep;
        t__bool support;
        t__bool sched;
        t__bool report_script_state;
        t__bool pgen;
        t__bool pgen_full;
        t__bool trace;
        t__bool display;
        t__bool keep;
        t__bool guitest;
        t__bool output;
        t__bool help;
        t__bool parse_error;
        t__bool cvr_define2;
        t__bool cvr_define_reparse;
        t__bool server;
        t__bool interrupt;
        t__bool wakeup;
        t__bool edl;
        t__bool snorb;
        t__bool snorb2;
        t__int cvr;
        t__int cvr_action;
        t__int cvr_gci;
        t__int cvr_parse;
        t__int cvr_read;
        t__int cvr_cfg;
        t__int cvr_grad;
        t__int cvr_rank;
        t__int cvr_gui;
        t__bool threads;
        t__bool wave;
        t__bool jres;
        t__bool databrowser;
        t__bool capture;
        t__bool snfp;
} *t__debug;
#define d__debug 32

/* line 252 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__configuration {
    t__int d__;
    t__int gen__;
        struct s__misc_configuration *misc;
        t__bool refresh;
        struct s__print_configuration *print;
        struct s__cover_configuration *cover;
        struct s__gen_configuration *gen;
        struct s__memory_configuration *memory;
        struct s__run_configuration *run;
        struct s__debug_configuration *debug;
        struct s__gui_configuration *gui;
        struct s__wave_configuration *wave;
        struct s__databrowser_configuration *databrowser;
        struct s__back32_configuration *back32;
        struct s__back33_configuration *back33;
        t__bool restore;
} *t__configuration;
#define d__configuration 34

/* line 246 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__misc_configuration {
    t__int d__;
    t__int gen__;
        t__bool warn;
        t__string pre_specman_path;
        t__string post_specman_path;
} *t__misc_configuration;
#define d__misc_configuration 33

/* line 2913 "/proj/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__print_configuration {
    t__int d__;
    t__int gen__;
} *t__print_configuration;
#define d__print_configuration 933

/* line 2922 "/proj/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__cover_configuration {
    t__int d__;
    t__int gen__;
} *t__cover_configuration;
#define d__cover_configuration 936

/* line 2916 "/proj/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__gen_configuration {
    t__int d__;
    t__int gen__;
        t__uint nesting;
        t__bool prefix;
        t__bool reduction_colors;
} *t__gen_configuration;
#define d__gen_configuration 934

/* line 2919 "/proj/specman/src/config_main.e"  From 'struct definition' */
typedef struct s__memory_configuration {
    t__int d__;
    t__int gen__;
} *t__memory_configuration;
#define d__memory_configuration 935

/* line 23 "/proj/specman/src/config_run.e"  From 'struct definition' */
typedef struct s__run_configuration {
    t__int d__;
    t__int gen__;
        t__bool exit_on_stop;
        t__t_exit_on exit_on;
        t__bool finish_on_error;
} *t__run_configuration;
#define d__run_configuration 959

/* line 3 "/proj/specman/src/config_category_def.e"  From 'struct definition' */
typedef struct s__debug_configuration {
    t__int d__;
    t__int gen__;
        t__int watch_list_items;
} *t__debug_configuration;
#define d__debug_configuration 1020

/* line 4 "/proj/specman/src/config_category_def.e"  From 'struct definition' */
typedef struct s__gui_configuration {
    t__int d__;
    t__int gen__;
        t__bool auto_scroll;
        t__bool use_help_browser;
} *t__gui_configuration;
#define d__gui_configuration 1022

/* line 5 "/proj/specman/src/config_category_def.e"  From 'struct definition' */
typedef struct s__wave_configuration {
    t__int d__;
    t__int gen__;
        t__string dumpfile_dir;
        t__wave_working_mode working_mode;
        t__bool register_structs;
        t__bool auto_refresh;
        t__wave_event_data event_data;
        t__int list_items;
        t__bool thread_code_line;
        t__bool hierarchy_name;
        t__bool use_wave;
        t__int stub_output;
        t__int stub_errors;
        t__int stub_message_len;
        t__int stub_events;
        t__int stub_integers;
        t__int stub_strings;
        t__int stub_strings_len;
        t__int stub_booleans;
        t__int port;
        t__string dump_file;
        t__int timeout;
        t__string path_separator;
} *t__wave_configuration;
#define d__wave_configuration 1024

/* line 6 "/proj/specman/src/config_category_def.e"  From 'struct definition' */
typedef struct s__databrowser_configuration {
    t__int d__;
    t__int gen__;
        t__bool exp_as_root;
        t__int list_first_items;
        t__bool view_source;
} *t__databrowser_configuration;
#define d__databrowser_configuration 1026

/* line 7 "/proj/specman/src/config_category_def.e"  From 'struct definition' */
typedef struct s__back32_configuration {
    t__int d__;
    t__int gen__;
        t__bool implicit_pack;
        t__bool old_error_handling;
        t__bool enable_verilog_trace;
        t__bool bit_slicing_is_uni_directional;
        t__bool add_slashes_in_set_check;
        t__bool allow_enum_as_index;
        t__bool use_quotes_in_import_statements;
        t__bool struct_eq_is_uni_directional;
        t__bool index_is_uni_directional;
        t__bool in_list_is_uni_directional;
} *t__back32_configuration;
#define d__back32_configuration 1028

/* line 8 "/proj/specman/src/config_category_def.e"  From 'struct definition' */
typedef struct s__back33_configuration {
    t__int d__;
    t__int gen__;
        t__bool old_struct_member_under_when;
        t__bool old_method_extension;
        t__bool tick_notation;
        t__bool list_assign;
        t__bool disable_otf_gc;
        t__bool cover_mode;
        t__bool disable_cover_events;
        t__bool disable_illegal_ignore_check;
        t__bool tree_window;
        t__bool no_gen_in_write_stub;
        t__bool use_trace_gen_33;
        t__bool no_reorder;
        t__bool additional_eval;
} *t__back33_configuration;
#define d__back33_configuration 1030

/* line 267 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__on {
    t__int d__;
    t__int gen__;
        t__on_status status;
        t__bool break_on_interrupt;
        t__bool exception_is_error;
        t__bool suspect_threads_changed;
        t__int stopped_try_level;
        t__bool enabled;
        t__bool watch_enabled;
        t__string do_after_abort;
        struct s__method *method;
        struct s__base_struct *the_me;
        t__on_kind kind;
        t__on_stop_kind stop_kind;
        t__bool compiled_routine;
        t__bool main;
        t__untyped result;
        struct s__activation_record *initial_activation_record;
        struct s__activation_record *activation_record;
        struct s__scope *scope;
        struct s__n__action *n__action;
        t__int global_call_num;
        struct s__threads_forest *the_threads_forest;
        t__bool threads_forest_is_active;
        t__bool break_on_simulator;
        t__bool sim_stopped_by_break_sim;
        t__bool disable_br_on_err_flag;
        struct s__l__on_request *list_of_break_hit_requests;
        struct s__exceptions *tmp_exceptions;
        t__bool on_debugging_in_progress;
        t__bool on_dbg_use_dispatch_table;
        t__bool on_break_on_method_call;
        t__bool on_break_on_method_return;
        t__bool on_break_on_tcm_start;
        t__bool on_break_on_tcm_end;
        t__bool on_break_on_tcm_call;
        t__bool on_break_on_tcm_return;
        struct s__l__on_request *requests;
        t__int stopping_request_num;
        t__source_ref stopping_source_ref;
        t__request_type stopping_special_type;
        t__int stopping_count_back;
        t__bool watch_steps;
        t__bool watch_calls_to_routines;
        t__bool skip_flag;
        t__on_event_type event_type;
        t__int current_event_id;
        t__string current_error_message;
        t__string type_wildcard;
        t__string method_wildcard;
        t__on_step_mode step_mode;
        t__int step_line;
        struct s__method *step_method;
        struct s__base_struct *step_me;
        t__int step_ar_num;
        t__int step_depth;
        t__int step_thread_id;
        struct s__activation_record *eval_activation_record;
        t__int last_request_id;
        struct s__sn_stepping_context *stepping_context;
        t__bool inside_break_on_error;
        struct s__l__watch_item *watch_list;
        struct s__type_descriptor *the_nab_td;
        struct s__type_descriptor *the_a_td;
        t__int num_of_errors;
        t__string threads_forest_int_err_msg;
        t__string threads_forest_user_err_msg;
        t__bool debug_ttf;
        struct s__l__branch_node *tmp_all_calls;
        struct s__n__action *tmp_original_stopped_action;
        struct s__n__action *tmp_original_last_tcm_action;
        struct s__activation_record *tmp_original_last_tcm_ar;
        struct s__threads_forest *upcoming_threads_forest;
        t__int last_watch_id;
        t__bool auto_watch_internal_disable;
        t__bool auto_watch_active;
        t__string INTERACTIVE_SCOPE_STR;
        t__bool watch_list_changed;
        t__string debug_info_file_ext;
} *t__on;
#define d__on 36

/* line 75 "/proj/specman/src/interp.e"  From 'struct definition' */
typedef struct s__threads_forest {
    t__int d__;
    t__int gen__;
        t__bool is_active_scope;
        struct s__scope *curr_scope;
        struct s__activation_record *curr_activation_record;
        struct s__n__action *curr_action;
        struct s__thread *current_thread;
        struct s__thread_elem *PC_element;
        t__int max_thid_len;
        t__int browser_id_len;
        t__string thid_sf_str;
        t__string thid_space_str;
        t__string thid_dash_str;
        struct s__l__thread *all_threads;
        struct s__k__thread_elem__unique_id *all_elems;
        struct s__n__action *original_stopped_action;
        struct s__n__action *original_last_tcm_action;
        t__source_ref last_user_stopped_src_ref;
        struct s__activation_record *original_last_tcm_ar;
        struct s__l__ar_sr *all_source_refs;
        t__bool do_refresh_threads_list_windows;
        t__bool do_refresh_thread_tree_windows;
} *t__threads_forest;
#define d__threads_forest 502

/* line 63 "/proj/specman/src/dbg_thread_elem.e"  From 'struct definition' */
typedef struct s__thread {
    t__int d__;
    t__int gen__;
        t__int id_num;
        struct s__threads_forest *forest;
        struct s__thread_chain *current_chain;
        t__source_ref current_source_ref;
        struct s__thread_elem *started;
        t__source_ref starter_src_ref;
        struct s__thread_elem *invoked_by;
        struct s__time *invokation_time;
        struct s__time *start_time;
} *t__thread;
#define d__thread 2830

/* line 52 "/proj/specman/src/dbg_thread_elem.e"  From 'struct definition' */
typedef struct s__thread_chain {
    t__int d__;
    t__int gen__;
        struct s__l__thread_elem *all_elems;
        t__int curr_elem_index;
        struct s__thread *parent_thread;
} *t__thread_chain;
#define d__thread_chain 2828

/* line 86 "/proj/specman/src/dbg_thread_elem.e"  From 'struct definition' */
typedef struct s__thread_elem {
    t__int d__;
    t__int gen__;
        t__thread_elem_kind kind;
        struct s__thread_elem *caller;
        struct s__l__thread_elem *childs;
        t__int thread_id_num;
        struct s__thread *my_thread;
        t__int unique_id;
        struct s__thread_elem *tcm_elem;
        struct s__activation_record *the_ar;
        struct s__method *method;
        struct s__n__action *current_action;
        t__source_ref real_source_ref;
        struct s__base_struct *owner;
        t__string full_name;
        t__string params_str;
        t__bool is_compiled;
        t__bool yet_another_child;
} *t__thread_elem;
#define d__thread_elem 2831

/* line 61 "/proj/specman/src/dbg_threads_forest.e"  From 'struct definition' */
typedef struct s__ar_sr {
    t__int d__;
    t__int gen__;
        t__int call_num;
        t__source_ref sr;
} *t__ar_sr;
#define d__ar_sr 2839

/* line 312 "/proj/specman/src/interp.e"  From 'struct definition' */
typedef struct s__on_request {
    t__int d__;
    t__int gen__;
        t__string string;
        t__on_kind kind;
        t__on_stop_kind stop_kind;
        t__request_type special_type;
        t__on_event_type event_type;
        t__string type_wildcard;
        t__pat type_wildcard_pat;
        t__string method_wildcard;
        t__pat method_wildcard_pat;
        t__bool enabled;
        t__bool internal_enabled;
        t__int type_index;
        t__int method_index;
        t__bool main_only;
        t__bool break_temp;
        t__int line_no;
        struct s__module *requested_module;
        t__bool break_anywhere;
        struct s__n__exp *when_exp;
        t__string when_exp_string;
        struct s__n__exp *when_change_exp;
        t__string when_change_exp_string;
        t__untyped current_value;
        t__bool currently_exists;
        struct s__n__action_block *n__action_block;
        t__bool active_scope;
        t__int thread_id;
        t__int request_id;
        t__bool original_enabled;
        t__bool pending;
        t__string original_string;
        t__string original_method_name;
        struct s__trace_gen_request *trace_gen_request;
} *t__on_request;
#define d__on_request 507

/* line 499 "/proj/specman/src/basic_action.e"  From 'struct definition' */
typedef struct s__n__action_block {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__ntv_extra *x;
        struct s__scope *scope;
        t__int level;
        struct s__entry *f__entry;
} *t__n__action_block;
#define d__n__action_block 410

/* line 83 "/proj/specman/src/gen_debug_header.e"  From 'struct definition' */
typedef struct s__trace_gen_request {
    t__int d__;
    t__int gen__;
        t__string wildchar;
        t__bool disabled;
        struct s__l__string *sts;
} *t__trace_gen_request;
#define d__trace_gen_request 1486

/* line 291 "/proj/specman/src/interp.e"  From 'struct definition' */
typedef struct s__sn_stepping_context {
    t__int d__;
    t__int gen__;
        t__bool enabled;
        t__on_kind kind;
        t__on_step_mode step_mode;
        t__int step_line;
        struct s__method *step_method;
        struct s__base_struct *step_me;
        t__int step_ar_num;
        t__int step_depth;
        t__int step_thread_id;
        t__bool watch_steps;
} *t__sn_stepping_context;
#define d__sn_stepping_context 505

/* line 954 "/proj/specman/src/dbg_request.e"  From 'struct definition' */
typedef struct s__watch_item {
    t__int d__;
    t__int gen__;
        struct s__n__exp *exp;
        t__string exp_string;
        t__string val_str;
        t__int id;
        t__int thread_id;
        t__po_radix radix;
        t__bool use_radix;
        t__int list_items;
        t__untyped raw_value;
} *t__watch_item;
#define d__watch_item 2804

/* line 260 "/proj/specman/src/scheduler.e"  From 'struct definition' */
typedef struct s__branch_node {
    t__int d__;
    t__int gen__;
        struct s__branch_node *prev;
        struct s__entry_instance *ei;
        struct s__entry_instance *last_instance;
        struct s__n__action *n__action;
        struct s__activation_record *activation_record;
} *t__branch_node;
#define d__branch_node 1684

/* line 1603 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__no_save {
    t__int d__;
    t__int gen__;
        struct s__ntv *ntv_done_now;
        struct s__file_contents *current_file_contents;
        struct s__file_contents *memory_save;
        struct s__gc_struct *gc;
        struct s__l__type_translation *type_translations;
        struct s__l__bool *type_was_saved;
        struct s__l__string *h_code;
        struct s__l__string *late_h_code;
        struct s__l__string *list_h_code;
        struct s__l__string *routine_h_code;
        struct s__l__string *top_code;
        struct s__l__string *init0_code;
        struct s__l__string *init_code;
        struct s__l__string *routine_code;
        struct s__l__string *c_code;
        struct s__l__string *late_c_code;
        struct s__l__display_item *display_items;
        t__bool mark_rl_results;
        t__bool write_h_only;
        t__bool create_all_structs;
        struct s__l__base_struct *all_structs;
        struct s__k__type_descriptor__name *types_for_h_code;
        struct s__k__routine__name *routines_for_h_code;
        struct s__k__method__name *method_depth_stack;
        struct s__k__file_contents__file_name *file_cache;
        struct s__l__late_update_ntv *when_subtype___late_update;
        t__bool when_subtype___type_not_found;
        struct s__k__method_sp_var_pair__m1313 *list_of_sp_var;
        struct s__k__sn_user_dir_pair__use2883 *static_user_home_dir;
        t__string static_curr_dir;
        t__string static_curr_user_home_dir;
        struct s__l__n__gen_keeping__action *post_clean;
} *t__no_save;
#define d__no_save 88

/* line 1670 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__file_contents {
    t__int d__;
    t__int gen__;
        t__string file_name;
        t__int next_line;
        struct s__l__string *lines;
} *t__file_contents;
#define d__file_contents 89

/* line 1330 "../src/root_types.e"  From 'struct definition' */
typedef struct s__gc_struct {
    t__int d__;
    t__int gen__;
        t__uint threshold_size;
        t__uint otf_threshold_size;
        t__int increment_size;
        t__bool no_print_msg;
        t__bool print_otf_msg;
        t__uint max_size;
        t__uint absolute_max_size;
        t__int restore_generation;
        t__int current_generation;
        t__int otf_gc_idx;
        t__bool stress_otf_gc;
        t__uint stress_otf_gc_threshold;
        t__bool stress;
        t__uint stress_divisor;
        t__int stress_count;
        t__bool use_free_list;
        t__bool debug;
        t__uint tcalloc_size;
        t__uint make_new_size;
        t__uint talloc_list_size;
        t__uint talloc_size;
        t__uint trealloc_list_fast_size;
        t__uint trealloc_list_slow_size;
        t__uint trealloc_size;
        t__uint ts1_size;
} *t__gc_struct;
#define d__gc_struct 168

/* line 1679 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__type_translation {
    t__int d__;
    t__int gen__;
        t__int translation;
        struct s__l__int *field_translations;
} *t__type_translation;
#define d__type_translation 90

/* line 1778 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__display_item {
    t__int d__;
    t__int gen__;
        struct s__base_struct *the_struct;
        t__string initial;
        t__int field_no;
        t__int item_no;
        struct s__l__untyped *the_list;
} *t__display_item;
#define d__display_item 95

/* line 641 "/proj/specman/src/when_subtype.e"  From 'struct definition' */
typedef struct s__late_update_ntv {
    t__int d__;
    t__int gen__;
} *t__late_update_ntv;
#define d__late_update_ntv 755

/* line 483 "/proj/specman/src/rangelist.e"  From 'struct definition' */
typedef struct s__method_sp_var_pair {
    t__int d__;
    t__int gen__;
        struct s__method *method;
        t__string sp_var_name;
} *t__method_sp_var_pair;
#define d__method_sp_var_pair 791

/* line 20 "/proj/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__sn_user_dir_pair {
    t__int d__;
    t__int gen__;
        t__string user_name;
        t__string home_dir;
} *t__sn_user_dir_pair;
#define d__sn_user_dir_pair 1036

/* line 77 "/proj/specman/src/gen.e"  From 'struct definition' */
typedef struct s__n__gen_keeping__action {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__ntv_extra *x;
        struct s__scope *scope;
        struct s__method *method;
        t__int level;
        struct s__pre_actions *pre_actions;
        t__bool is_pre_action;
        struct s__entry *f__entry;
        struct s__gen_keeping_info *info;
        t__bool without_keeping;
        struct s__n__exp *n__exp;
        struct s__n__name *n__name;
        struct s__l__n__constraint *n__constraints;
} *t__n__gen_keeping__action;
#define d__n__gen_keeping__action 4018

/* line 57 "/proj/specman/src/gen.e"  From 'struct definition' */
typedef struct s__gen_keeping_info {
    t__int d__;
    t__int gen__;
        t__bool is_local;
        t__bool is_local_path;
        t__int gen_index;
        t__bool is_long;
        t__bool is_tcm;
        t__bool is_global_path;
        t__int it_path_index;
        struct s__local *it_var;
        t__int local_id;
        t__bool local_indirect;
        struct s__struct_descriptor *sd;
        struct s__constraint_path *it_path;
        t__string local_c_name;
        t__int source_r;
} *t__gen_keeping_info;
#define d__gen_keeping_info 4017

/* line 708 "../src/root_ntv.e"  From 'struct definition' */
typedef struct s__n__name {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__ntv_extra *x;
} *t__n__name;
#define d__n__name 224

/* line 396 "/proj/specman/src/gen_parse.e"  From 'struct definition' */
typedef struct s__n__constraint {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__ntv_extra *x;
        struct s__n__action *top_action;
} *t__n__constraint;
#define d__n__constraint 1346

/* line 1317 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn_memory_options {
    t__int d__;
    t__int gen__;
        t__uint threshold_size;
        t__uint otf_threshold_size;
        t__int increment_size;
        t__bool no_print_msg;
        t__bool print_otf_msg;
        t__uint max_size;
        t__uint absolute_max_size;
} *t__sn_memory_options;
#define d__sn_memory_options 167

/* line 1798 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__compatibility_options {
    t__int d__;
    t__int gen__;
        t__bool use_old_byte_array;
        t__bool use_colon_block;
        t__bool use_old_short_arithmetic;
        t__bool run_extra_half_cycle;
        t__bool do_initial_script_actions_immediately;
} *t__compatibility_options;
#define d__compatibility_options 96

/* line 853 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__files {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__l__file *open_files;
} *t__files;
#define d__files 63

/* line 861 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__file {
    t__int d__;
    t__int gen__;
        t__C_file cfile;
        t__string name;
        t__string role;
} *t__file;
#define d__file 64

/* line 887 "../src/root_types.e"  From 'struct definition' */
typedef struct s__interactive_scope {
    t__int d__;
    t__int gen__;
        struct s__l__local *locals;
        struct s__scope *previous;
        t__int total_num_of_locals;
        t__uint attributes;
        struct s__activation_record *activation_record;
        struct s__l__sn_value_holder *value_holders;
} *t__interactive_scope;
#define d__interactive_scope 142

/* line 1017 "../src/root_types.e"  From 'struct definition' */
typedef struct s__sn_value_holder {
    t__int d__;
    t__int gen__;
} *t__sn_value_holder;
#define d__sn_value_holder 149

/* line 21 "../src/root.e"  From 'struct definition' */
typedef struct s__pgen {
    t__int d__;
    t__int gen__;
} *t__pgen;
#define d__pgen 363

/* line 1085 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__pgen3 {
    t__int d__;
    t__int gen__;
        t__rnd_policy rnd_policy;
        struct s__seed_domain *user_domain;
        t__int user_seed;
        t__bool warn;
        t__imp_enum_pgen3__gen_static_phase gen_static_phase;
        struct s__role_manager *role_manager;
        struct s__static_order *static_order;
        t__bool error_occured_during_gen;
        struct s__pgen3_debug *pgen3_debug;
        struct s__field_holder *temp_fl;
        t__count default_min_list_size;
        t__count default_max_list_size;
        t__count absolute_max_list_size;
        struct s__uint_rl *default_list_size_rl;
        struct s__uint_rl *full_list_size_rl;
        t__count max_depth;
        t__count max_num_of_structs;
        t__bool bits_uni_directional;
        struct s__pgen_flags *flags;
        t__bool reorder_fields;
        t__bool struct_eq_is_uni_directional;
        t__bool index_is_uni_directional;
        t__bool in_list_is_uni_directional;
        t__count last_analysis_stamp;
        t__count max_structs;
        t__count default_max_structs;
        struct s__l__count *alloc_types;
        t__count alloc_struct_count;
        t__gen_phase current_phase;
        t__imp_enum_pgen3__gen_status gen_status;
        t__source_ref gotf_source_ref;
        t__bool skip_contradiction;
        t__count no_of_contradictions;
        struct s__l__source_item *sis;
        struct s__gen_constraint *related_gc;
        struct s__yolka_inhibitor *yolka_inhibitor;
        t__bool when_opt;
        struct s__pgen3_debug *deb;
        t__bool use_visual_deb;
        t__bool debug;
        struct s__gen_order_manager *om;
        struct s__field_gen_role *related_fgr;
        struct s__k__role_count__role_str *role_counts;
        struct s__l__gotf_info *gotf_infos;
        t__bool do_static_checks;
        struct s__a_role *role_to_order;
        struct s__l__static_om_f *static_om_fields;
        t__imp_enum_pgen3__visual_deb_level visual_deb_level;
        struct s__l__struct_path_item *curr_spis;
        struct s__l__sn_cpi *tmp_cpis;
        struct s__l__field_node *accessible_outputs;
        struct s__l__field_node *ci_outputs;
        struct s__l__field_node *ci_inputs;
        struct s__l__index *last_frame_id;
        struct s__gen_frame *curr_gen_frame;
        struct s__sn_gen_debugger *gen_debugger;
        t__bool in_list_temps;
        struct s__list_path_item *temps_list;
        t__bool event_browser_is_on;
        struct s__l__field_node *all_field_nodes;
        struct s__l__field_node *pending_list_items;
        struct s__l__sn_compute_select_struct *csss;
        struct s__sn_compute_select_struct *current_css;
        t__bool in_all_iterations;
        struct s__any_struct *alloc_for_iter;
} *t__pgen3;
#define d__pgen3 77

/* line 330 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__role_manager {
    t__int d__;
    t__int gen__;
        struct s__an_edge *e;
        struct s__rm_trace *rm_trace;
} *t__role_manager;
#define d__role_manager 1326

/* line 440 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__an_edge {
    t__int d__;
    t__int gen__;
        struct s__role_edge *start_point;
        struct s__role_edge *end_point;
        t__edge_relation er;
        t__index index_in_edge;
        t__index edge_no;
        t__index fls_pos;
        t__index min_fls_pos;
        t__bool cont;
} *t__an_edge;
#define d__an_edge 1330

/* line 1749 "/proj/specman/src/gen_roles.e"  From 'struct definition' */
typedef struct s__rm_trace {
    t__int d__;
    t__int gen__;
        t__bool trace_role_dag;
        struct s__l__trace_the_edge *trace_the_edges;
        struct s__l__an_edge *trace_es;
        struct s__an_edge *e;
        t__uint stamp;
} *t__rm_trace;
#define d__rm_trace 3457

/* line 1743 "/proj/specman/src/gen_roles.e"  From 'struct definition' */
typedef struct s__trace_the_edge {
    t__int d__;
    t__int gen__;
        struct s__an_edge *e;
        t__uint stamp;
        t__the_edge_place the_edge_place;
} *t__trace_the_edge;
#define d__trace_the_edge 3456

/* line 383 "/proj/specman/src/gen_static_header.e"  From 'struct definition' */
typedef struct s__static_order {
    t__int d__;
    t__int gen__;
        t__uint geb_stamp;
        struct s__l__constraint_path *cps;
        struct s__l__bool *from_b;
        struct s__l__bool *to_b;
        struct s__l__index *li;
        struct s__l__index *lo;
        struct s__prefix_tree_stat *prefix_tree_stat;
} *t__static_order;
#define d__static_order 1328

/* line 114 "/proj/specman/src/gen_static_reorder.e"  From 'struct definition' */
typedef struct s__prefix_tree_stat {
    t__int d__;
    t__int gen__;
        t__bool is_soft;
        t__om_edge_reason om_edge_reason;
        t__bool is_bid;
        struct s__simple_gen_constraint *gc;
        struct s__struct_descriptor *start_sd;
        t__uint stamp;
} *t__prefix_tree_stat;
#define d__prefix_tree_stat 3507

/* line 68 "/proj/specman/src/gen_parse.e"  From 'struct definition' */
typedef struct s__pgen3_debug {
    t__int d__;
    t__int gen__;
        t__imp_enum_pgen3_debug__phase phase;
        t__imp_enum_pgen3_debug__level level;
        t__bool static_warnings;
        t__bool dynamic_checking;
        t__bool should_issue_check;
        struct s__l__field *might_be_infinite;
        struct s__l__struct_descriptor *might_be_infinite_holder;
        struct s__l__field *two_output_fields;
        struct s__l__field *output_and_cons_fields;
        struct s__pgen3_debug_flags *flags;
        struct s__l__index *gen_struct_stack;
        struct s__debug_order *debug_order;
        struct s__pgen3_debug_tgrq_manager *tgrq_manager;
        t__bool expand_in_progress;
        t__bool check_unsatisfied_constraints;
        t__index end_static_time;
        t__index shown_msg_time;
        t__int current_nesting;
        t__uint depth;
        t__bool show_prefix_on_each_line;
        t__bool highlight_reductions;
        struct s__l__sn_msg_struct *msg_list;
        struct s__k__sn_msg_set_struct__value *msg_set_struct_list;
        struct s__l__a_role *roles_list;
        t__sn_show_on_trace show_on_trace;
        t__int show_repeats;
        t__bool fields_flag;
        t__bool details_flag;
        t__bool reordering_flag;
        t__bool reductions_flag;
        t__bool constraints_flag;
        t__bool in_place_flag;
        t__bool last_struct_flag;
        t__bool last_gen_flag;
        t__bool showing_now;
        struct s__l__sn_msg_show_request *show_requests;
        struct s__base_struct *show_gen_struct;
        struct s__k__sn_gen_repeat_counte42208 *repeat_counters;
        struct s__k__sn_gen_string_repeat42209 *string_repeat_counters;
        struct s__l__sn_msg_start_gen *start_gen_stack;
        struct s__k__base_struct__it *start_gen_finals;
} *t__pgen3_debug;
#define d__pgen3_debug 1335

/* line 17 "/proj/specman/src/gen_debug_header.e"  From 'struct definition' */
typedef struct s__pgen3_debug_flags {
    t__int d__;
    t__int gen__;
        t__bool dropped_constraints;
        t__bool display_order_graph;
        t__bool trace_gen_request_causes_static_analysis;
        t__bool pretty_print_simple_parenthesis;
} *t__pgen3_debug_flags;
#define d__pgen3_debug_flags 1483

/* line 61 "/proj/specman/src/gen_debug_header.e"  From 'struct definition' */
typedef struct s__debug_order {
    t__int d__;
    t__int gen__;
        struct s__gdo_graph *gdo_graph;
        t__index time;
        struct s__struct_descriptor *sd;
        t__index holder_time;
        struct s__base_struct *holder;
        struct s__l__field *fs_and_tfs;
        struct s__l__bool *active_fields;
        struct s__l__sn_msg_struct *ml;
        struct s__gdo_mw_find_generated_fields *gdo_mw_find_generated_fields;
        struct s__gdo_mw_find_active_edges *gdo_mw_find_active_edges;
} *t__debug_order;
#define d__debug_order 1485

/* line 56 "/proj/specman/src/gen_debug_header.e"  From 'struct definition' */
typedef struct s__gdo_graph {
    t__int d__;
    t__int gen__;
        struct s__l__gdo_node *nodes;
        struct s__l__gdo_edge *edges;
        struct s__l__gdo_frc *frcs;
        t__bool recursivly_check_cycle_in_frcs;
        struct s__sn_msg_struct *msg_gen_holder;
} *t__gdo_graph;
#define d__gdo_graph 1484

/* line 16 "/proj/specman/src/gen_debug_order_graph.e"  From 'struct definition' */
typedef struct s__gdo_node {
    t__int d__;
    t__int gen__;
        t__index index;
        t__string name;
        t__gdo_node_kind kind;
        struct s__gdo_frc *frc;
} *t__gdo_node;
#define d__gdo_node 3761

/* line 36 "/proj/specman/src/gen_debug_order_graph.e"  From 'struct definition' */
typedef struct s__gdo_frc {
    t__int d__;
    t__int gen__;
        struct s__l__gdo_node *nodes;
        t__index index;
        struct s__l__gdo_edge *internal_edges;
        struct s__l__gdo_edge *out_edges;
        t__bool in_stack;
        t__bool visited;
} *t__gdo_frc;
#define d__gdo_frc 3763

/* line 26 "/proj/specman/src/gen_debug_order_graph.e"  From 'struct definition' */
typedef struct s__gdo_edge {
    t__int d__;
    t__int gen__;
        t__bool contradicting;
        struct s__gdo_node *n1;
        struct s__gdo_node *n2;
        struct s__sn_msg_create_edge *msg;
        t__bool visited;
        struct s__simple_gen_constraint *gc;
} *t__gdo_edge;
#define d__gdo_edge 3762

/* line 2079 "/proj/specman/src/gen_debug.e"  From 'struct definition' */
typedef struct s__sn_msg_create_edge {
    t__int d__;
    t__int gen__;
        t__index index;
        struct s__sn_msg_start_gen *last_start_gen;
        t__bool soft;
        t__om_edge_reason reason;
        struct s__source_item *si;
        t__bool dynamic;
        struct s__base_struct *holder;
        t__string fs1;
        t__string fs2;
} *t__sn_msg_create_edge;
#define d__sn_msg_create_edge 3755

/* line 1476 "/proj/specman/src/gen_debug.e"  From 'struct definition' */
typedef struct s__sn_msg_start_gen {
    t__int d__;
    t__int gen__;
        t__index index;
        t__index end_order_index;
        struct s__source_item *si;
        struct s__base_struct *holder;
        t__string path;
        struct s__time *time;
        struct s__base_struct *final_holder;
        t__string final_holder_path;
        t__bool shown_already;
        t__sn_gen_boring_status boring_status;
} *t__sn_msg_start_gen;
#define d__sn_msg_start_gen 3746

/* line 187 "/proj/specman/src/gen_debug.e"  From 'struct definition' */
typedef struct s__sn_msg_struct {
    t__int d__;
    t__int gen__;
        t__index index;
} *t__sn_msg_struct;
#define d__sn_msg_struct 3732

/* line 339 "/proj/specman/src/gen_debug_order.e"  From 'struct definition' */
typedef struct s__gdo_mw_find_generated_fields {
    t__int d__;
    t__int gen__;
        struct s__debug_order *f__do;
} *t__gdo_mw_find_generated_fields;
#define d__gdo_mw_find_generated_fields 3769

/* line 358 "/proj/specman/src/gen_debug_order.e"  From 'struct definition' */
typedef struct s__gdo_mw_find_active_edges {
    t__int d__;
    t__int gen__;
        struct s__debug_order *f__do;
} *t__gdo_mw_find_active_edges;
#define d__gdo_mw_find_active_edges 3770

/* line 88 "/proj/specman/src/gen_debug_header.e"  From 'struct definition' */
typedef struct s__pgen3_debug_tgrq_manager {
    t__int d__;
    t__int gen__;
        struct s__l__trace_gen_request *trqs;
        t__bool changed;
} *t__pgen3_debug_tgrq_manager;
#define d__pgen3_debug_tgrq_manager 1487

/* line 1702 "/proj/specman/src/gen_debug.e"  From 'struct definition' */
typedef struct s__sn_msg_set_struct {
    t__int d__;
    t__int gen__;
        t__index index;
        t__index end_order_index;
        struct s__a_role *role;
        struct s__base_struct *holder;
        t__string fs;
        struct s__base_struct *value;
        t__string from_range;
        t__string struct_path;
        struct s__sn_msg_start_gen *last_start_gen;
        t__bool is_gotf_path_only;
        struct s__a_role *most_specific_role;
        t__bool shown_already;
        t__sn_gen_boring_status boring_status;
} *t__sn_msg_set_struct;
#define d__sn_msg_set_struct 3749

/* line 140 "/proj/specman/src/gen_debug_header.e"  From 'struct definition' */
typedef struct s__sn_msg_show_request {
    t__int d__;
    t__int gen__;
        t__sn_msg_show_request_kind kind;
        struct s__base_struct *the_struct;
        t__string type;
        t__string field;
        t__string type_re;
        t__pat type_pat;
        t__string field_re;
        t__pat field_pat;
        t__string chupchik_field;
        t__string chupchik_field_re;
        t__pat chupchik_field_pat;
} *t__sn_msg_show_request;
#define d__sn_msg_show_request 1488

/* line 1055 "/proj/specman/src/gen_debug.e"  From 'struct definition' */
typedef struct s__sn_gen_repeat_counter {
    t__int d__;
    t__int gen__;
        struct s__base_struct *unique_item;
        struct s__l__base_struct *repetitions;
        t__bool wrote_comment;
} *t__sn_gen_repeat_counter;
#define d__sn_gen_repeat_counter 3738

/* line 1064 "/proj/specman/src/gen_debug.e"  From 'struct definition' */
typedef struct s__sn_gen_string_repeat_counter {
    t__int d__;
    t__int gen__;
        t__string unique_item;
        struct s__l__string *repetitions;
        t__bool wrote_comment;
} *t__sn_gen_string_repeat_counter;
#define d__sn_gen_string_repeat_counter 3739

/* line 12 "/proj/specman/src/gen_basic.e"  From 'struct definition' */
typedef struct s__pgen_flags {
    t__int d__;
    t__int gen__;
        t__bool do_static_checks;
        t__bool show_structs_only;
        t__bool show_full_path;
        t__bool show_internal_info;
        t__bool show_unchanged_reduced_fields;
        t__bool show_other_reduced_fields;
} *t__pgen_flags;
#define d__pgen_flags 1417

/* line 554 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__yolka_inhibitor {
    t__int d__;
    t__int gen__;
} *t__yolka_inhibitor;
#define d__yolka_inhibitor 1479

/* line 19 "/proj/specman/src/gen_om_interface.e"  From 'struct definition' */
typedef struct s__gen_order_manager {
    t__int d__;
    t__int gen__;
        struct s__l__om_frame *frames;
        struct s__om_frame *cur_frame;
        t__int cur_frame_idx;
        t__bool reorder_fields;
        t__bool resolve_cycles;
        struct s__l__int *frame_idx_diff;
        struct s__l__om_item_node *nodes_map;
        t__int nodes_map_top;
        t__int last_id;
} *t__gen_order_manager;
#define d__gen_order_manager 1502

/* line 20 "/proj/specman/src/gen_om_frame.e"  From 'struct definition' */
typedef struct s__om_frame {
    t__int d__;
    t__int gen__;
        t__int min_id;
        t__int max_id;
        struct s__l__om_node *nodes_heap;
        t__int heap_size;
        struct s__l__om_node *all_frc_reprs;
} *t__om_frame;
#define d__om_frame 3689

/* line 16 "/proj/specman/src/gen_om_item.e"  From 'struct definition' */
typedef struct s__om_node {
    t__int d__;
    t__int gen__;
        t__int id;
        t__bool f__void;
        struct s__om_node *frc_repr;
        t__int in_degree;
        t__int soft_in_degree;
        struct s__l__om_item_node *in_edges;
        struct s__l__om_item_node *soft_in_edges;
        t__int frame_idx;
        t__int cur_in_degree;
        t__int cur_soft_in_degree;
        t__int cur_min_id;
        t__int heap_idx;
} *t__om_node;
#define d__om_node 3684

/* line 67 "/proj/specman/src/gen_om_item.e"  From 'struct definition' */
typedef struct s__om_item_node {
    t__int d__;
    t__int gen__;
        t__int id;
        t__bool f__void;
        struct s__om_node *frc_repr;
        t__int in_degree;
        t__int soft_in_degree;
        struct s__l__om_item_node *in_edges;
        struct s__l__om_item_node *soft_in_edges;
        t__int frame_idx;
        t__int cur_in_degree;
        t__int cur_soft_in_degree;
        t__int cur_min_id;
        t__int heap_idx;
        struct s__l__om_item_node *edges;
        struct s__l__om_item_node *soft_edges;
        struct s__om_item_node *right;
        struct s__om_item_node *left;
        struct s__om_item_node *right_dof;
        struct s__om_item_node *left_dof;
        t__imp_enum_om_item_node__color color;
        t__int min_id;
        struct s__om_item_node *min_id_root;
        t__int min_id_stamp;
        t__int min_id_root_stamp;
} *t__om_item_node;
#define d__om_item_node 3686

/* line 2851 "/proj/specman/src/gen_roles.e"  From 'struct definition' */
typedef struct s__role_count {
    t__int d__;
    t__int gen__;
        t__string role_str;
        t__count role_count;
} *t__role_count;
#define d__role_count 3460

/* line 2885 "/proj/specman/src/gen_roles.e"  From 'struct definition' */
typedef struct s__gotf_info {
    t__int d__;
    t__int gen__;
        t__string module_name;
        t__string method_name;
        t__index extension_no;
        struct s__method *the_method;
        struct s__field *first_field;
        struct s__field *generated_field;
        t__index gen_index;
        struct s__constraint_path *gen_path;
        t__bool has_keeping_gcs;
        struct s__a_role *gotf_role;
        t__source_ref sr;
        t__string id_str;
        struct s__a_role *holder_role;
        struct s__l__a_role *path_roles;
        struct s__k__field__it *relevant_temps;
} *t__gotf_info;
#define d__gotf_info 3463

/* line 761 "/proj/specman/src/gen_static_comms.e"  From 'struct definition' */
typedef struct s__static_om_f {
    t__int d__;
    t__int gen__;
        t__bool ordered;
        struct s__l__om_edge *non_exact_edges;
        struct s__l__index *non_exact_inds;
} *t__static_om_f;
#define d__static_om_f 3546

/* line 314 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__gen_frame {
    t__int d__;
    t__int gen__;
        struct s__compound_path_item *gotf_first;
        struct s__compound_path_item *gotf_root;
        t__bool gotf_is_scalar;
        struct s__field *gotf_field;
        t__index gotf_index;
        t__bool gotf_first_is_temp;
        struct s__activation_record *gotf_ar;
        struct s__compound_path_item *gotf_last;
        t__untyped gotf_generated_value;
        struct s__field_node *gotf_field_node;
        t__index gotf_first_ind;
        struct s__any_struct *gotf_the_me;
        struct s__seed_domain *the_seed_domain;
        struct s__compound_path_item *last;
        t__source_ref sr;
        struct s__compound_path_item *last_in_collect_stack;
        struct s__l__base_struct *curr_units;
        t__bool gotf_first_indirect;
        t__bool compiled;
} *t__gen_frame;
#define d__gen_frame 1456

/* line 20 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_gen_debugger {
    t__int d__;
    t__int gen__;
        struct s__gen_debug_data_manager *data;
        struct s__gen_debug_trace_manager *trace_manager;
        struct s__gen_debug_server *server;
} *t__sn_gen_debugger;
#define d__sn_gen_debugger 3548

/* line 189 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__gen_debug_data_manager {
    t__int d__;
    t__int gen__;
        struct s__sn_gen_debugger *parent;
        struct s__instanciated_fields_pool *all_instanciated_fields;
        struct s__l__sn_gen_event *all_events;
        struct s__k__sn_role_info__role_id *all_roles;
        struct s__l__sn_start_gen_event *all_roots;
        struct s__l__sn_gen_root_event *gen_op_stack;
        struct s__gen_debug_order_manager *order;
        t__int end_static_time;
        struct s__l__sn_set_value_event *set_value_stack;
        t__int last_refresh_time;
        t__bool needs_refresh;
        struct s__l__sn_event_parameter *all_event_parameters;
        struct s__k__sn_ci_to_fig__ci *ci_to_figs;
        struct s__k__sn_ci_to_deferred__ci *cis_to_deferred;
} *t__gen_debug_data_manager;
#define d__gen_debug_data_manager 3549

/* line 506 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__instanciated_fields_pool {
    t__int d__;
    t__int gen__;
        struct s__k__instanciated_fields_36402 *all_instances;
        struct s__l__sn_instanciated_field *all_objects;
} *t__instanciated_fields_pool;
#define d__instanciated_fields_pool 3556

/* line 529 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__instanciated_fields_of_36403 {
    t__int d__;
    t__int gen__;
        struct s__base_struct *instance;
        struct s__k__sn_instanciated_field__f *all_fields;
} *t__instanciated_fields_of_an_instance;
#define d__instanciated_fields_of_an_instance 3559

/* line 1829 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_instanciated_field {
    t__int d__;
    t__int gen__;
        t__int index_in_all_objects;
        struct s__base_struct *holder;
        struct s__field *f;
        struct s__l__gendb_field_in_gen *all_generations;
} *t__sn_instanciated_field;
#define d__sn_instanciated_field 3621

/* line 1150 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_start_gen_event {
    t__int d__;
    t__int gen__;
        t__int index;
        struct s__base_struct *holder_entity;
        t__int location_in_holder;
        struct s__me_gendb_item *item;
        t__bool trace_from_begining;
        t__bool trace_till_end;
        t__bool complete_trace;
        t__bool failed_because_try;
        t__gen_process_status status;
        struct s__k__gendb_field_in_gen__f *all_fields;
        struct s__l__sn_gen_event *all_events;
        struct s__k__gendb_ci_in_gen__gc *me_app_constraints;
        struct s__sn_role_info *role;
        t__bool is_gotf_path;
        struct s__source_item *si;
        t__uint sys_time;
        t__index serial_number;
        struct s__base_struct *final_holder;
        t__string final_holder_path;
} *t__sn_start_gen_event;
#define d__sn_start_gen_event 3584

/* line 668 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__gen_debug_order_manager {
    t__int d__;
    t__int gen__;
        struct s__sn_gdo_graph *graph;
        struct s__l__sn_gen_event *all_events;
        t__index current_time;
} *t__gen_debug_order_manager;
#define d__gen_debug_order_manager 3564

/* line 693 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_gdo_graph {
    t__int d__;
    t__int gen__;
        struct s__l__sn_gdo_edge *edges;
        struct s__l__sn_gdo_node *nodes;
        struct s__l__sn_gdo_frc *frcs;
} *t__sn_gdo_graph;
#define d__sn_gdo_graph 3565

/* line 730 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_gdo_edge {
    t__int d__;
    t__int gen__;
        struct s__sn_create_edge_event *value;
} *t__sn_gdo_edge;
#define d__sn_gdo_edge 3570

/* line 1565 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_create_edge_event {
    t__int d__;
    t__int gen__;
        t__int index;
        struct s__base_struct *holder_entity;
        t__int location_in_holder;
        struct s__gendb_field *from;
        struct s__gendb_field *to;
        t__om_edge_reason reason;
        t__imp_enum_sn_create_edge_event__kind kind;
        t__bool is_soft;
        struct s__gendb_constraint *constraint;
} *t__sn_create_edge_event;
#define d__sn_create_edge_event 3607

/* line 717 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_gdo_node {
    t__int d__;
    t__int gen__;
        struct s__sn_gdo_frc *frc;
} *t__sn_gdo_node;
#define d__sn_gdo_node 3569

/* line 742 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_gdo_frc {
    t__int d__;
    t__int gen__;
        t__index index;
        struct s__l__sn_gdo_node *nodes;
        struct s__l__sn_gdo_edge *internal_edges;
        struct s__l__sn_gdo_edge *out_edges;
} *t__sn_gdo_frc;
#define d__sn_gdo_frc 3571

/* line 889 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_set_value_event {
    t__int d__;
    t__int gen__;
        t__int index;
        struct s__base_struct *holder_entity;
        t__int location_in_holder;
        struct s__changed_gendb_item *item;
} *t__sn_set_value_event;
#define d__sn_set_value_event 3574

/* line 2687 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__changed_gendb_item {
    t__int d__;
    t__int gen__;
        t__int parameter_index;
        struct s__any_rl *rl;
        struct s__type_descriptor *td;
        struct s__constraint_path *cp;
        struct s__sn_gen_event *holding_event;
        struct s__base_struct *holder;
        struct s__field *f;
        t__bool fixed;
        t__bool accessible;
        struct s__base_struct *initial_struct;
        struct s__l__int *path_indexes;
        t__int last_accessible_field;
        t__bool deffered;
        struct s__gendb_field_in_gen *fig;
        t__index index_in_fig;
        struct s__any_rl *pre_rl;
} *t__changed_gendb_item;
#define d__changed_gendb_item 3667

/* line 2324 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_event_parameter {
    t__int d__;
    t__int gen__;
        t__int parameter_index;
} *t__sn_event_parameter;
#define d__sn_event_parameter 3652

/* line 2807 "/proj/specman/src/gen_gendb_interface.e"  From 'struct definition' */
typedef struct s__sn_ci_to_fig {
    t__int d__;
    t__int gen__;
        struct s__gendb_ci_in_gen *ci;
        struct s__l__gendb_field_in_gen *figs;
} *t__sn_ci_to_fig;
#define d__sn_ci_to_fig 3709

/* line 2938 "/proj/specman/src/gen_gendb_interface.e"  From 'struct definition' */
typedef struct s__sn_ci_to_deferred {
    t__int d__;
    t__int gen__;
        struct s__gendb_ci_in_gen *ci;
        struct s__k__deferred_par__par_no *deferred_pars;
} *t__sn_ci_to_deferred;
#define d__sn_ci_to_deferred 3713

/* line 2933 "/proj/specman/src/gen_gendb_interface.e"  From 'struct definition' */
typedef struct s__deferred_par {
    t__int d__;
    t__int gen__;
        t__index par_no;
        struct s__l__changed_gendb_item *deferred_items;
} *t__deferred_par;
#define d__deferred_par 3711

/* line 561 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__gen_debug_trace_manager {
    t__int d__;
    t__int gen__;
        struct s__sn_gen_debugger *parent;
        t__bool start_collect_from_begining;
        t__bool collect_now;
        t__bool was_collect_before;
        t__bool complete_collect;
        struct s__l__sn_skeleton_event *stop_tracing_storage;
        struct s__l__sn_gen_root_event *stop_tracing_stack;
} *t__gen_debug_trace_manager;
#define d__gen_debug_trace_manager 3561

/* line 856 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__sn_skeleton_event {
    t__int d__;
    t__int gen__;
        t__int index;
        struct s__base_struct *holder_entity;
        t__int location_in_holder;
} *t__sn_skeleton_event;
#define d__sn_skeleton_event 3573

/* line 640 "/proj/specman/src/gen_gendb_header.e"  From 'struct definition' */
typedef struct s__gen_debug_server {
    t__int d__;
    t__int gen__;
        struct s__sn_gen_debugger *parent;
        struct s__sn_gendebugger_deli *gendb_deli;
        struct s__sni_egendebugger_service *e_gendb_service;
} *t__gen_debug_server;
#define d__gen_debug_server 3563

/* line 435 "/proj/specman/src/japp/gendebugger/src/gendb_snorb_services.e"  From 'struct definition' */
typedef struct s__sn_gendebugger_deli {
    t__int d__;
    t__int gen__;
        struct s__sni_jgendebugger_service *j_gendb_service;
} *t__sn_gendebugger_deli;
#define d__sn_gendebugger_deli 4012

/* line 129 "/proj/specman/src/japp/gendebugger/jservice_edl.e"  From 'struct definition' */
typedef struct s__sni_jgendebugger_service {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sni_jgendebugger_service;
#define d__sni_jgendebugger_service 3860

/* line 22 "/proj/specman/src/japp/gendebugger/jservice_edl.e"  From 'struct definition' */
typedef struct s__sni_egendebugger_service {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sni_egendebugger_service;
#define d__sni_egendebugger_service 3859

/* line 231 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__list_path_item {
    t__int d__;
    t__int gen__;
        struct s__field *the_field;
        t__count depth;
        t__bool debug_it;
        struct s__l__a_role *active_roles;
        struct s__l__index *position_in_roles;
        struct s__l__compound_path_item *start_of_roles;
        struct s__l__a_role *relevant_roles;
        struct s__l__compound_path_item *start_of_relevant_roles;
        t__string path_str;
        struct s__field_node *pn_for_soft;
        struct s__l__field_node *pn_temps_list;
        t__bool above_gotf_root;
        struct s__l__dangling_ci *dangling_cis;
        t__count inherited_dcis_len;
        t__count no_of_uneval_fields;
        t__index curr_om_frame;
        struct s__struct_path_item *previous;
        t__count the_size;
        struct s__field_node *list_par_node;
        struct s__field_node *item_par_node;
        struct s__field_node *fn;
        t__count eval_items;
        struct s__any_rl *prev_item_rl;
        struct s__uint_rl *index_rl;
        struct s__uint_rl *curr_indices_rl;
        struct s__any_rl *curr_items_rl;
        struct s__any_rl *curr_item_rl;
        t__bool all_items_eq;
        struct s__l__sn_cpi *index_cpis;
        struct s__l__sn_cpi *prev_cpis;
        struct s__sn_save_cis_info *sci;
        t__sn_gen_list_kind sn_gen_list_kind;
        struct s__type_descriptor *item_type;
} *t__list_path_item;
#define d__list_path_item 1449

/* line 439 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn_save_cis_info {
    t__int d__;
    t__int gen__;
        struct s__l__sn_ci_info *cis;
        struct s__l__sn_cpi *cpis;
} *t__sn_save_cis_info;
#define d__sn_save_cis_info 1469

/* line 435 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__sn_ci_info {
    t__int d__;
    t__int gen__;
        struct s__sn_constraint_instance *orig_ci;
        t__sn_gen_status_type orig_status;
        t__bool orig_last_alternative;
        t__sn_or_status_type orig_or_status;
} *t__sn_ci_info;
#define d__sn_ci_info 1468

/* line 70 "/proj/specman/src/gen_select.e"  From 'struct definition' */
typedef struct s__sn_compute_select_struct {
    t__int d__;
    t__int gen__;
        struct s__gen_constraint *gc;
        t__bool in_use;
        struct s__any_rl *input_range_list;
        struct s__l__any_rl *range_lists;
        struct s__l__int *weights;
        struct s__seed_domain *seed_domain;
        t__bool OK;
        t__untyped res;
} *t__sn_compute_select_struct;
#define d__sn_compute_select_struct 3722

/* line 260 "../src/root.e"  From 'struct definition' */
typedef struct s__display {
    t__int d__;
    t__int gen__;
        t__bool on;
        t__bool retro_command;
        t__bool busy_by_specman;
        t__untyped last_printed_value;
        t__bool last_printed_value_is_legal;
        struct s__l__int *actual_printed_structs;
        struct s__k__base_struct__it *printed_structs;
        struct s__k__int__it *printed_struct_index;
        t__int next_printed_index;
        struct s__l__display_window *windows;
        struct s__global_gui_action_manager *global_action_manager;
        struct s__l__string *next_window_location;
        struct s__l__string *original_size;
        struct s__l__string *lst_windows_default_geo;
        struct s__l__index *next_window_width;
        t__bool replace_in_place;
        struct s__l__display_window *shown_windows;
        struct s__display_window *req_window;
        t__string req_window_name;
        t__string req_location;
        t__string req_tag;
        t__string req_tag_text;
        t__int req_line_num;
        t__string req_line_text;
        t__string req_button;
        struct s__l__string *p_lst_req_s_params;
        struct s__k__dbg_thread_geometry_13474 *dbg_locked_threads_geometry;
        t__display_kind kind;
        t__int max_tk_size;
        struct s__display_window *output_window;
        t__string req_entry_value;
        t__string toolbar_font;
        t__presentation_type toolbar_type;
        t__string menu_font;
        t__presentation_type menu_type;
        struct s__base_struct *parent_struct;
        t__int field_num;
        struct s__display_window *next_window;
        struct s__k__sn_gui_tag_info__s_name *p_ht_of_style_tags;
        t__bool show_source_on_stop;
        struct s__l__string *colours;
        struct s__display_window *disp_interrupt___prev_output_window;
        struct s__properties_manager *properties;
        t__bool wakeup;
        t__count display___index_for_new_window;
        t__bool simulator_exists_was_updated;
        struct s__threads_gui *threads_gui;
        t__bool do_refresh_debug_windows;
        struct s__l__int *refresh_bebug_threads_ids;
        t__bool refresh_debug_force_all;
        t__int refresh_bebug_raised_id;
        struct s__watch_display_window *the_watch_window;
        t__bool f_restore_winfo;
        t__on_status prev_on_status;
        t__bool p_add_style_help_tags_exist;
        t__string tk_module_name;
        t__string tk_debugger_mode;
        t__string tk_capture_mode;
        t__string tk_thread_name;
        t__string tk_debug_wname;
        t__bool use_one_long_cmd;
        t__bool auto_command_active;
        struct s__l__string *the_auto_command_sl;
        t__bool internal_auto_command_active;
        struct s__gen_debug_gui *gen_debug_gui;
        t__string p_s_encrypted_semicolon;
        t__string p_s_encrypted_l_curly_bracket;
        t__string p_s_encrypted_r_curly_bracket;
        t__string p_s_encrypted_new_line;
} *t__display;
#define d__display 376

/* line 50 "/proj/specman/src/disp_defs.e"  From 'struct definition' */
typedef struct s__display_window {
    t__int d__;
    t__int gen__;
        struct s__gui_action_manager *p_action_manager;
        t__string name;
        t__imp_enum_display_window__state state;
        t__index index;
        t__string title;
        t__main_window_kind kind;
        t__index window_set;
        t__index window_width;
        struct s__display_window *from;
        t__string next_location;
        t__index last_printed_item;
        t__bool f_initialized;
        t__bool main_window;
} *t__display_window;
#define d__display_window 1816

/* line 18 "/proj/specman/src/disp_defs.e"  From 'struct definition' */
typedef struct s__gui_action_manager {
    t__int d__;
    t__int gen__;
        struct s__k__sn_action__p_s_key *p_lst_action_table;
        struct s__display_window *p_display_window;
} *t__gui_action_manager;
#define d__gui_action_manager 1808

/* line 27 "/proj/specman/src/disp_defs.e"  From 'struct definition' */
typedef struct s__sn_action {
    t__int d__;
    t__int gen__;
        t__string p_s_key;
        t__string p_s_label;
        t__string p_s_short_label;
        t__bool p_f_checkable;
        t__string p_s_accelerator;
        t__string p_s_image_name;
        t__string p_s_help;
        t__bool p_f_global;
        t__bool p_f_check_val;
        struct s__l__sn_action_widget *p_lst_action_widgets;
        t__bool p_f_state;
        struct s__gui_action_manager *p_gui_action_manager;
} *t__sn_action;
#define d__sn_action 1811

/* line 36 "/proj/specman/src/disp_defs.e"  From 'struct definition' */
typedef struct s__sn_action_widget {
    t__int d__;
    t__int gen__;
        t__string p_s_widget_name;
        t__string p_s_full_path;
        t__widget_kind p_t_widget_kind;
        t__string p_s_compound_image;
        struct s__sn_action *p_t_action;
} *t__sn_action_widget;
#define d__sn_action_widget 1813

/* line 25 "/proj/specman/src/disp_defs.e"  From 'struct definition' */
typedef struct s__global_gui_action_manager {
    t__int d__;
    t__int gen__;
        struct s__k__sn_action__p_s_key *p_lst_action_table;
        struct s__display_window *p_display_window;
} *t__global_gui_action_manager;
#define d__global_gui_action_manager 1810

/* line 172 "/proj/specman/src/disp_defs.e"  From 'struct definition' */
typedef struct s__dbg_thread_geometry {
    t__int d__;
    t__int gen__;
        t__int p_thread_id;
        t__string p_s_geo;
        t__bool p_f_show_stack;
} *t__dbg_thread_geometry;
#define d__dbg_thread_geometry 1821

/* line 185 "/proj/specman/src/disp_gui.e"  From 'struct definition' */
typedef struct s__sn_gui_tag_info {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string s_name;
        t__string s_params;
        t__bool f_hyperlink;
} *t__sn_gui_tag_info;
#define d__sn_gui_tag_info 1948

/* line 121 "/proj/specman/src/disp_properties.e"  From 'struct definition' */
typedef struct s__properties_manager {
    t__int d__;
    t__int gen__;
        struct s__k__property_item__p_s_p13513 *p_list_items;
        t__string p_s_file_name;
} *t__properties_manager;
#define d__properties_manager 1988

/* line 6 "/proj/specman/src/disp_properties.e"  From 'struct definition' */
typedef struct s__property_item {
    t__int d__;
    t__int gen__;
        t__string p_s_property_name;
        t__string p_s_property_value;
        t__string p_s_property_type;
} *t__property_item;
#define d__property_item 1987

/* line 92 "/proj/specman/src/dbg_window.e"  From 'struct definition' */
typedef struct s__threads_gui {
    t__int d__;
    t__int gen__;
} *t__threads_gui;
#define d__threads_gui 2846

/* line 859 "/proj/specman/src/dbg_watch.e"  From 'struct definition' */
typedef struct s__watch_display_window {
    t__int d__;
    t__int gen__;
        struct s__gui_action_manager *p_action_manager;
        t__string name;
        t__imp_enum_display_window__state state;
        t__index index;
        t__string title;
        t__main_window_kind kind;
        t__index window_set;
        t__index window_width;
        struct s__display_window *from;
        t__string next_location;
        t__index last_printed_item;
        t__bool f_initialized;
        t__bool main_window;
} *t__watch_display_window;
#define d__watch_display_window 2884

/* line 53 "/proj/specman/src/ui_gen_debug.e"  From 'struct definition' */
typedef struct s__gen_debug_gui {
    t__int d__;
    t__int gen__;
} *t__gen_debug_gui;
#define d__gen_debug_gui 2937

/* line 444 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__parse {
    t__int d__;
    t__int gen__;
        struct s__const_controller *const_controller;
        t__bool fast_parse;
        struct s__l__string *initial_h_code;
        struct s__l__string *h_code;
        t__bool full_e;
        t__string trans_fname;
        struct s__inline_code *inline_code;
        struct s__l__post_load_detail *sn_post_load;
        struct s__l__post_load_detail *sn_inner_post_load;
        struct s__sn_filtered_blocks_manager *filtered_blocks_manager;
        struct s__k__string__it *method_full_names;
        struct s__l__int *method_indices;
        t__bool in_tcm;
        struct s__l__int *cashedList4finder;
        struct s__standalone_code *standalone_code;
        struct s__l__ntv *ntvs;
        t__bool define_version_macro_done;
        struct s__attr_info *attr_info;
        struct s__sn_NSS *sn_NSS;
        struct s__l__encrypt_module *eee_mmm;
        struct s__sn_encryptor *encryptor;
} *t__parse;
#define d__parse 58

/* line 80 "../src/root.e"  From 'struct definition' */
typedef struct s__const_controller {
    t__int d__;
    t__int gen__;
        struct s__const_table *const_table;
        struct s__const_table *first_const_table;
        t__int verilog_last_size;
        t__int verilog_deferred_last_size;
        struct s__empty_const *dummy;
        struct s__l__form *forms;
} *t__const_controller;
#define d__const_controller 368

/* line 69 "../src/root.e"  From 'struct definition' */
typedef struct s__const_table {
    t__int d__;
    t__int gen__;
        struct s__k__const__name *consts;
        t__int last_size;
} *t__const_table;
#define d__const_table 367

/* line 61 "../src/root.e"  From 'struct definition' */
typedef struct s__const {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string name;
        t__string file_name;
        t__int line;
        t__bool active;
        t__string value;
        t__int module_no;
} *t__const;
#define d__const 364

/* line 66 "../src/root.e"  From 'struct definition' */
typedef struct s__empty_const {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string name;
        t__string file_name;
        t__int line;
        t__bool active;
        t__string value;
        t__int module_no;
} *t__empty_const;
#define d__empty_const 365

/* line 682 "../src/root_types.e"  From 'struct definition' */
typedef struct s__inline_code {
    t__int d__;
    t__int gen__;
        struct s__k__inline_method__method_326 *method_code;
} *t__inline_code;
#define d__inline_code 134

/* line 675 "../src/root_types.e"  From 'struct definition' */
typedef struct s__inline_method {
    t__int d__;
    t__int gen__;
        t__int method_index;
        struct s__l__string *inline_method_body;
        struct s__l__string *final_inline_method_body;
} *t__inline_method;
#define d__inline_method 132

/* line 106 "../src/root_command.e"  From 'struct definition' */
typedef struct s__post_load_detail {
    t__int d__;
    t__int gen__;
        t__string post_load_string;
        t__int post_load_line;
} *t__post_load_detail;
#define d__post_load_detail 336

/* line 434 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__sn_filtered_blocks_manager {
    t__int d__;
    t__int gen__;
        struct s__l__sn_filter_level *C_run_time_flags;
        t__sn_filter_level default_level;
        struct s__l__source_ref *added_source_refs;
        struct s__l__int *filtered_blocks_run_level;
        struct s__l__method *filtered_block_methods;
} *t__sn_filtered_blocks_manager;
#define d__sn_filtered_blocks_manager 55

/* line 426 "/proj/specman/src/eval_explicit.e"  From 'struct definition' */
typedef struct s__standalone_code {
    t__int d__;
    t__int gen__;
        t__int max_case_items;
        t__int max_single_func;
        t__int max_case_code_line;
        t__int max_line_to_cash;
        t__bool debug;
        t__int code_id;
        t__int func_id;
        struct s__l__string *items;
        struct s__l__int *items_index;
        t__int lines_of_code;
        struct s__k__string__it *strings_of_cashed;
        struct s__l__int *code_id_of_cashed;
        struct s__l__int *func_id_of_cashed;
        t__int last_c_code;
} *t__standalone_code;
#define d__standalone_code 775

/* line 15 "/proj/specman/src/attr.e"  From 'struct definition' */
typedef struct s__attr_info {
    t__int d__;
    t__int gen__;
        struct s__k__attr_item_info__name *lh_name_mapping;
} *t__attr_info;
#define d__attr_info 854

/* line 10 "/proj/specman/src/attr.e"  From 'struct definition' */
typedef struct s__attr_item_info {
    t__int d__;
    t__int gen__;
        t__string name;
        t__string type_name;
} *t__attr_item_info;
#define d__attr_item_info 853

/* line 5 "/proj/specman/src/license.e"  From 'struct definition' */
typedef struct s__sn_NSS {
    t__int d__;
    t__int gen__;
} *t__sn_NSS;
#define d__sn_NSS 1733

/* line 8 "/proj/specman/src/encrypt_table.e"  From 'struct definition' */
typedef struct s__encrypt_module {
    t__int d__;
    t__int gen__;
        t__string name;
        t__string license;
        t__encrypt_attribute attribute;
} *t__encrypt_module;
#define d__encrypt_module 1735

/* line 518 "/proj/specman/src/encryptor.e"  From 'struct definition' */
typedef struct s__sn_encryptor {
    t__int d__;
    t__int gen__;
        struct s__sn_encryption_key *current_key;
        struct s__file *current_file;
        struct s__l__byte *buffer;
        struct s__sn_checksum *checksum;
} *t__sn_encryptor;
#define d__sn_encryptor 1740

/* line 28 "/proj/specman/src/encryptor.e"  From 'struct definition' */
typedef struct s__sn_encryption_key {
    t__int d__;
    t__int gen__;
        struct s__l__bit *bytes;
        t__int attributes;
} *t__sn_encryption_key;
#define d__sn_encryption_key 1737

/* line 9 "/proj/specman/src/checksum.e"  From 'struct definition' */
typedef struct s__sn_checksum {
    t__int d__;
    t__int gen__;
} *t__sn_checksum;
#define d__sn_checksum 1732

/* line 1061 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__simulator {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__k__verilog_macro__name *verilog_macros;
        struct s__k__deferred_macro__name *deferred_macros;
        t__bool exists;
        t__int simulator_gui_refresh_time;
        t__bool simulator_gui_refresh_needed;
        t__bool agent_mode;
        struct s__sn_adapter_manager *adapter_manager;
        t__simulator_product product;
        t__simulator_kind kind;
        t__string sim_product;
        t__simulator_kind stub_kind;
        t__simulator_product stub_product;
        t__simulator_gui_mode gui_mode_var;
        t__bool DUT_in_error_now;
        struct s__k__computed_name__name *computed_names;
        struct s__k__computed_subprogram_n9793 *computed_subprograms;
        struct s__k__vhdl_driver_inst__name *vhdl_drivers;
        t__uint valid_initial_time;
        t__uint driver_counter;
        t__bool to_set_driver_now;
        struct s__l__string *verilog_code_line;
        struct s__l__string *vhdl_code_line;
        struct s__l__int *list_for_mask;
        t__int checksum_vlog;
        t__int checksum_vhdl;
        struct s__l__hdl_exp_info *hdls_exp_info;
        struct s__k__translated_model_stru9794 *translated_model_structs;
        t__bool always_translate_names;
        struct s__l__translated_model_struct *list_tran_to_put_sig;
        t__string model_name;
        struct s__l__string *orig_name;
        struct s__k__verilog_variable_inst9795 *verilog_variables;
        struct s__l__sn_verilog_code_inst *verilog_codes;
        struct s__sn_verilog_time_inst *verilog_time;
        struct s__l__subprogram_param_info *all_subprogram_param_tms;
        struct s__l__external_pointer *free_process_mti;
        struct s__subprogram_cluster *subprogram_cluster;
        t__bool issued_warning_on_macro_translation;
        struct s__l__string *import_verilog_files;
        struct s__k__string__it *read_before;
        t__int tmpint;
        struct s__n__exp *tmpexp;
        t__string tran;
        t__bool proprietary;
        t__uint checkDateVerilogStubVersion;
        t__uint checkDateVHDLStubVersion;
        t__sn_back33_stub simulator___back33_stub_use;
        t__int unitsNum;
        t__int vhdlTimeUnit;
        t__bool vhdl_old_sync_mode;
        t__int sn___timer_occ_l;
        struct s__sn_event_struct *sn___timer_event_struct;
        struct s__delayList *delayList;
} *t__simulator;
#define d__simulator 76

/* line 1044 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__verilog_macro {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string name;
        t__string file_name;
        t__int line;
        t__bool active;
        t__string translation;
        t__bool in_use;
        t__uint file_key;
        t__int imp_line;
        t__string imp_file_name;
} *t__verilog_macro;
#define d__verilog_macro 72

/* line 1055 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__deferred_macro {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string name;
        t__string file_name;
        t__int line;
        t__bool active;
        t__string translation;
        t__bool in_use;
        t__uint file_key;
        t__int imp_line;
        t__string imp_file_name;
        struct s__sn_value_holder *value;
        t__string str_value;
} *t__deferred_macro;
#define d__deferred_macro 73

/* line 6 "/proj/specman/src/agent_manager_def.e"  From 'struct definition' */
typedef struct s__sn_adapter_manager {
    t__int d__;
    t__int gen__;
        struct s__l__sn_adapter_struct *adapter_structs;
        struct s__sn_adapter_struct *master_adapter;
        t__uint tick_request_count;
        struct s__translated_model_struct *standalone_generic_tms;
        t__bool agent_manager___coexistence;
        t__bool te_utils___finish_from_simulator_already_called;
} *t__sn_adapter_manager;
#define d__sn_adapter_manager 801

/* line 188 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn_verilog_code_inst {
    t__int d__;
    t__int gen__;
        struct s__l__string *lines;
        t__uint checksum;
        t__string source_ref;
        struct s__any_unit *unit_inst;
} *t__sn_verilog_code_inst;
#define d__sn_verilog_code_inst 1541

/* line 197 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__sn_verilog_time_inst {
    t__int d__;
    t__int gen__;
        t__string line;
        t__uint checksum;
        t__string source_ref;
} *t__sn_verilog_time_inst;
#define d__sn_verilog_time_inst 1542

/* line 417 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__subprogram_param_info {
    t__int d__;
    t__int gen__;
        struct s__translated_model_struct *my_tms;
        struct s__l__connecte_cell *tms_connected;
        t__external_pointer sig_param_callback_data;
        t__bool is_need_callback;
} *t__subprogram_param_info;
#define d__subprogram_param_info 1572

/* line 485 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__subprogram_cluster {
    t__int d__;
    t__int gen__;
        struct s__sn_vec *current_vec;
        t__uint current_value;
        t__untyped current_list;
        struct s__subprogram_exp_info *current_exp_info;
        struct s__subprogram_info_for_sig_9798 *current_subprogram_info_for_sig_param;
        struct s__subprogram_handle *current_suprogram_handle;
        struct s__translated_model_struct *current_tms_last_read;
} *t__subprogram_cluster;
#define d__subprogram_cluster 1581

/* line 405 "/proj/specman/src/hdl_struct.e"  From 'struct definition' */
typedef struct s__subprogram_info_for_sig_9798 {
    t__int d__;
    t__int gen__;
        t__uint index_parm;
        struct s__subprogram_handle *subprogram_handle;
} *t__subprogram_info_for_sig_param;
#define d__subprogram_info_for_sig_param 1571

/* line 29 "/proj/specman/src/te_utils.e"  From 'struct definition' */
typedef struct s__delayList {
    t__int d__;
    t__int gen__;
        struct s__l__low_high *lstt;
        struct s__low_high *lastlh;
        struct s__time *tmpt;
} *t__delayList;
#define d__delayList 2263

/* line 24 "/proj/specman/src/te_utils.e"  From 'struct definition' */
typedef struct s__low_high {
    t__int d__;
    t__int gen__;
        t__uint low;
        t__uint high;
} *t__low_high;
#define d__low_high 2262

/* line 1088 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__scheduler {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__bool scheduler___init_done;
        t__bool scheduler___allow_locking;
        t__match_status scheduler___ms;
        t__thread_handle scheduler___thread_counter;
        struct s__l__thread_list *all_structs;
        struct s__l__any_struct *quitted_structs;
        struct s__l__any_struct *rerun_structs;
        struct s__l__int *counters_scratch;
        struct s__l__uint *singleton_tmp;
        struct s__l__event_type *event_map;
        struct s__sched_ext *sched_ext;
        struct s__te_memory *curr_te_memory;
        struct s__l__sn_event_struct *sense;
        t__int sense_max_size;
        t__bool trigger_sense;
        t__bool forced_neg_sensitivity;
        struct s__l__int *sig_entries;
        t__int cur_sig_entry;
        t__bool compat_33_eval_order;
        t__bool compat_33_neg_sense;
        t__bool compat_33_sticky_true;
        struct s__l__sn_event_struct *event_que;
        struct s__sn_pri_queue *thread_que;
        struct s__l__waiting_thread *waiting_threads;
        struct s__activation_record *current_context;
        t__int emit_gen;
        t__int eval_te_gen;
        t__int tcm_gen;
        t__bool within_sync;
        t__bool first_sense;
        t__int eval_tick;
        struct s__l__entry_instance *tcms_que;
        struct s__l__int *ei_uids;
        struct s__l__int *tcms_branch;
        struct s__l__entry_instance *fallen_through_tcms;
        struct s__l__int *fallen_through_ei_uids;
        struct s__l__int *fallen_through_tcms_branch;
        t__int time_counter;
        t__int tick_counter;
        struct s__l__index *active_callbacks;
        struct s__l__entry_instance *init_callback_que;
        struct s__l__wait_entry *wait_entry_bank;
        struct s__l__waiting_thread *waiting_thread_bank;
        t__bool after_restore;
        t__int sn___NEG_occ_l;
        struct s__sn_event_struct *sn___NEG_event_struct;
        t__int sn___URG_occ_l;
        struct s__sn_event_struct *sn___URG_event_struct;
        struct s__l__tesv_store *tesv_free_store;
} *t__scheduler;
#define d__scheduler 78

/* line 195 "/proj/specman/src/scheduler.e"  From 'struct definition' */
typedef struct s__thread_list {
    t__int d__;
    t__int gen__;
        struct s__l__script_instance *threads;
} *t__thread_list;
#define d__thread_list 1681

/* line 463 "/proj/specman/src/te_structs.e"  From 'struct definition' */
typedef struct s__sched_ext {
    t__int d__;
    t__int gen__;
        t__int Entry_Recycle_Size;
        t__int Entry_Recycle_Rate;
        t__int Big_Recycle_Rate;
        t__int last_wt_cleaned_size;
        t__int recycle_counter;
        t__int wt_clean_size;
        t__bool trace_no_intermid;
        t__bool trace_on;
        t__int event_time;
        struct s__l__event_trace_type *event_trace;
        t__bool trace_main_loop;
        t__int we_recycle_generation;
        struct s__l__sn_event_struct *long_wes;
} *t__sched_ext;
#define d__sched_ext 2051

/* line 842 "/proj/specman/src/te_structs.e"  From 'struct definition' */
typedef struct s__event_trace_type {
    t__int d__;
    t__int gen__;
        struct s__base_struct *parent;
        t__index event;
        t__int time;
        t__sn_sched_phase phase;
} *t__event_trace_type;
#define d__event_trace_type 2060

/* line 541 "/proj/specman/src/te_structs.e"  From 'struct definition' */
typedef struct s__sn_pri_queue {
    t__int d__;
    t__int gen__;
        struct s__l__sn_queue *queues;
        t__int next_priority;
        t__int size;
} *t__sn_pri_queue;
#define d__sn_pri_queue 2056

/* line 493 "/proj/specman/src/te_structs.e"  From 'struct definition' */
typedef struct s__sn_queue {
    t__int d__;
    t__int gen__;
        struct s__l__sn_struct *entries;
        t__int next_entry;
} *t__sn_queue;
#define d__sn_queue 2054

/* line 328 "/proj/specman/src/te_utils.e"  From 'struct definition' */
typedef struct s__tesv_store {
    t__int d__;
    t__int gen__;
        struct s__l__te_memory *s;
} *t__tesv_store;
#define d__tesv_store 2265

/* line 2002 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__dual_line_buff {
    t__int d__;
    t__int gen__;
        struct s__l__byte *lobyte;
        struct s__phys_buff *phys_buff;
        t__int lines_num;
} *t__dual_line_buff;
#define d__dual_line_buff 102

/* line 1922 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__phys_buff {
    t__int d__;
    t__int gen__;
        t__int read;
        t__int current_size;
        t__string buff;
        struct s__file *file;
} *t__phys_buff;
#define d__phys_buff 99

/* line 1319 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__sn_communication {
    t__int d__;
    t__int gen__;
        t__int active_out_request_counter;
        t__int active_in_request_counter;
        t__int comm_busy_counter;
        struct s__comm_config *comm_config;
        t__int debug_comm;
        t__bool use_stub;
        t__bool quit_on_disconnect;
        t__bool error_on_disconnect;
        struct s__comm_in_request_manager *in_request_manager;
        struct s__comm_out_request_manager *out_request_manager;
        struct s__comm_message_manager *message_manager;
        struct s__comm_connection_manager *connection_manager;
        struct s__l__comm_client_applicat17628 *client_apps;
} *t__sn_communication;
#define d__sn_communication 82

/* line 4 "/proj/specman/src/comm_communication.e"  From 'struct definition' */
typedef struct s__comm_config {
    t__int d__;
    t__int gen__;
        t__int server_default_port;
        t__int port_search_range;
        t__string registration_file;
        t__int client_port;
} *t__comm_config;
#define d__comm_config 2349

/* line 8 "/proj/specman/src/comm_req_man.e"  From 'struct definition' */
typedef struct s__comm_in_request_manager {
    t__int d__;
    t__int gen__;
} *t__comm_in_request_manager;
#define d__comm_in_request_manager 2369

/* line 287 "/proj/specman/src/comm_req_man.e"  From 'struct definition' */
typedef struct s__comm_out_request_manager {
    t__int d__;
    t__int gen__;
        struct s__comm_transfered_out_req17630 *transfered_out_request_map;
        struct s__comm_waiting_in_reply_queue *waiting_replies;
} *t__comm_out_request_manager;
#define d__comm_out_request_manager 2376

/* line 225 "/proj/specman/src/comm_req_man.e"  From 'struct definition' */
typedef struct s__comm_transfered_out_req17630 {
    t__int d__;
    t__int gen__;
        struct s__k__comm_transfered_out_17631 *transfered_out_requests;
} *t__comm_transfered_out_request_map;
#define d__comm_transfered_out_request_map 2374

/* line 190 "/proj/specman/src/comm_req_man.e"  From 'struct definition' */
typedef struct s__comm_transfered_out_request {
    t__int d__;
    t__int gen__;
        t__int id;
        struct s__comm_out_request *out_request;
} *t__comm_transfered_out_request;
#define d__comm_transfered_out_request 2373

/* line 76 "/proj/specman/src/comm_request.e"  From 'struct definition' */
typedef struct s__comm_out_request {
    t__int d__;
    t__int gen__;
        struct s__comm_abs_basic_reply *the_reply_obj;
        struct s__comm_request_status *the_status_obj;
        t__comm_request_opcode opcode;
} *t__comm_out_request;
#define d__comm_out_request 2354

/* line 124 "/proj/specman/src/comm_request.e"  From 'struct definition' */
typedef struct s__comm_abs_basic_reply {
    t__int d__;
    t__int gen__;
} *t__comm_abs_basic_reply;
#define d__comm_abs_basic_reply 2355

/* line 168 "/proj/specman/src/comm_request.e"  From 'struct definition' */
typedef struct s__comm_request_status {
    t__int d__;
    t__int gen__;
        t__comm_status status;
        t__string error_message;
} *t__comm_request_status;
#define d__comm_request_status 2358

/* line 115 "/proj/specman/src/comm_req_man.e"  From 'struct definition' */
typedef struct s__comm_waiting_in_reply_queue {
    t__int d__;
    t__int gen__;
        struct s__k__comm_waiting_in_reply__id *waiting_in_reply_queue;
} *t__comm_waiting_in_reply_queue;
#define d__comm_waiting_in_reply_queue 2371

/* line 86 "/proj/specman/src/comm_req_man.e"  From 'struct definition' */
typedef struct s__comm_waiting_in_reply {
    t__int d__;
    t__int gen__;
        t__int id;
        struct s__comm_data_header *reply_data_header;
        struct s__comm_pack_unpackable *msg;
} *t__comm_waiting_in_reply;
#define d__comm_waiting_in_reply 2370

/* line 15 "/proj/specman/src/comm_data_header.e"  From 'struct definition' */
typedef struct s__comm_data_header {
    t__int d__;
    t__int gen__;
        t__int id;
        t__comm_request_opcode opcode;
        t__bool is_request;
        t__bool is_notification;
} *t__comm_data_header;
#define d__comm_data_header 2367

/* line 5 "/proj/specman/src/comm_packable.e"  From 'struct definition' */
typedef struct s__comm_pack_unpackable {
    t__int d__;
    t__int gen__;
} *t__comm_pack_unpackable;
#define d__comm_pack_unpackable 2347

/* line 10 "/proj/specman/src/comm_msg_man.e"  From 'struct definition' */
typedef struct s__comm_message_manager {
    t__int d__;
    t__int gen__;
        struct s__comm_data_header_factory *data_header_factory;
        struct s__comm_msg_dispatcher *msg_dispatcher;
        t__int next_out_message_id;
} *t__comm_message_manager;
#define d__comm_message_manager 2377

/* line 116 "/proj/specman/src/comm_data_header.e"  From 'struct definition' */
typedef struct s__comm_data_header_factory {
    t__int d__;
    t__int gen__;
        struct s__struct_descriptor *data_header_sd;
} *t__comm_data_header_factory;
#define d__comm_data_header_factory 2368

/* line 271 "/proj/specman/src/comm_msg_man.e"  From 'struct definition' */
typedef struct s__comm_msg_dispatcher {
    t__int d__;
    t__int gen__;
} *t__comm_msg_dispatcher;
#define d__comm_msg_dispatcher 2378

/* line 13 "/proj/specman/src/comm_con_man.e"  From 'struct definition' */
typedef struct s__comm_connection_manager {
    t__int d__;
    t__int gen__;
        struct s__comm_socket_interactor *data_socket;
} *t__comm_connection_manager;
#define d__comm_connection_manager 2379

/* line 6 "/proj/specman/src/comm_socket.e"  From 'struct definition' */
typedef struct s__comm_socket_interactor {
    t__int d__;
    t__int gen__;
        t__external_pointer interactor___itr_struct;
        t__string description;
        t__bool debug;
        t__int socket_id;
        struct s__l__byte *buffer;
        t__int port;
        t__sn_con_state state;
        struct s__file *file_stream;
        t__external_pointer file_stream_buffer;
        t__string server_ip_addr;
        struct s__comm_socket_interactor *original_comm_socket;
} *t__comm_socket_interactor;
#define d__comm_socket_interactor 2345

/* line 184 "/proj/specman/src/communication.e"  From 'struct definition' */
typedef struct s__comm_client_application_desc {
    t__int d__;
    t__int gen__;
        t__string name;
        t__string version;
} *t__comm_client_application_desc;
#define d__comm_client_application_desc 2386

/* line 1434 "/proj/specman/src/atomic_exp.e"  From 'struct definition' */
typedef struct s__sys {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__int root___instance_id;
        t__string root___e_path;
        t__string root___full_hdl_path;
        t__string root___converted_full_hdl_path;
        t__string root___normal_hdl_path;
        t__int root___relative_id;
        t__string atomic_exp___hdl_path;
        struct s__sn_adapter_struct *atomic_exp___adapter_struct;
        t__string atomic_exp___agent_name;
        struct s__any_unit *atomic_exp___parent_unit;
        struct s__l__any_unit *atomic_exp___enclosing_list;
        struct s__time *time;
        t__int sn___quit_occ_l;
        struct s__sn_event_struct *sn___quit_event_struct;
        t__int sn___tick_start_occ_l;
        struct s__sn_event_struct *sn___tick_start_event_struct;
        t__int sn___tick_end_occ_l;
        struct s__sn_event_struct *sn___tick_end_event_struct;
        t__int sn___any_occ_l;
        struct s__sn_event_struct *sn___any_event_struct;
        t__int sn___new_time_occ_l;
        struct s__sn_event_struct *sn___new_time_event_struct;
} *t__sys;
#define d__sys 573

/* line 49 "/proj/specman/src/list_addons.e"  From 'struct definition' */
typedef struct s__packing {
    t__int d__;
    t__int gen__;
        struct s__l__bit *lob_temp;
        struct s__pack_options *global_default;
        struct s__pack_options *high;
        struct s__pack_options *low;
        struct s__pack_options *high_big_endian;
        struct s__pack_options *low_big_endian;
        struct s__l__debug_item *pack_debug_info;
        struct s__l__debug_item *unpack_debug_info;
        struct s__l__any_unit *instances_list;
        t__bool show_pack;
        struct s__print_options *debug_print_options;
        struct s__print_options *save_print_options;
        struct s__string_stack *debug_names_stack;
        struct s__string_stack *unpack_debug_names_stack;
        struct s__l__pack_originate_from *source_of_current_pack;
        t__string temp_string;
        struct s__l__int *byte_mask;
        struct s__pack_options *network;
} *t__packing;
#define d__packing 781

/* line 127 "../src/root_basic.e"  From 'struct definition' */
typedef struct s__pack_options {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__bool reverse_fields;
        t__bool reverse_list_items;
        struct s__l__int *final_reorder;
        struct s__l__int *scalar_reorder;
} *t__pack_options;
#define d__pack_options 22

/* line 284 "/proj/specman/src/memory.e"  From 'struct definition' */
typedef struct s__debug_item {
    t__int d__;
    t__int gen__;
        t__string name;
        struct s__l__bit *lob;
} *t__debug_item;
#define d__debug_item 1080

/* line 341 "/proj/specman/src/memory.e"  From 'struct definition' */
typedef struct s__string_stack {
    t__int d__;
    t__int gen__;
        struct s__l__pack_string_item *names;
} *t__string_stack;
#define d__string_stack 1083

/* line 336 "/proj/specman/src/memory.e"  From 'struct definition' */
typedef struct s__pack_string_item {
    t__int d__;
    t__int gen__;
        t__string name;
        t__pack_originate_from pack_originate_from;
} *t__pack_string_item;
#define d__pack_string_item 1082

/* line 127 "/proj/specman/src/script_rnd.e"  From 'struct definition' */
typedef struct s__params {
    t__int d__;
    t__int gen__;
        t__int seed;
        t__random_policy random_policy;
} *t__params;
#define d__params 810

/* line 322 "/proj/specman/src/scriptsim.e"  From 'struct definition' */
typedef struct s__sn_capture {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__capture_mode capture_mode;
        t__bool is_in_record_mode;
        t__bool is_in_replay_mode;
        t__bool debug_mode;
        t__bool oncap;
        t__string capture_tar_file;
        t__string capture_pure_tar_file;
        t__string capture_top_dir;
        t__string capture_dir;
        t__capture_mode requested_mode;
        t__bool force_trans_files;
        t__int interaction_counter;
        t__int command_counter;
        t__int real_command_counter;
        t__int tick_command_counter;
        t__data_format capture_data_format;
        t__string capture_data_version;
        t__bool trace_file_eof;
        t__string next_interactions_line;
        t__bool has_line_waiting;
        t__bool capture_is_enabled;
        t__bool recording_through_redo;
        t__bool dont_record_current_command;
        t__bool ignore_retro_command;
        t__bool replay_stop_in_debugger;
        t__int recorded_method_nesting_level;
        t__string current_recorded_method_name;
        t__int redo_status_code;
        t__bool flush_each_writing;
        struct s__trans_table *files_trans_table;
        struct s__trans_table *symbols_trans_table;
        t__string starting_esv_file_name;
        t__string compiled_esv_file_name;
        struct s__l__string *handled_esv_list;
        t__bool replay_esv_was_saved;
        t__string last_command_line;
        t__bool do_read_verilog_defines;
        struct s__cap_info *info;
        struct s__l__string *sn_system_dirs;
        t__string sn_system_dirs_pat;
        struct s__l__string *sn_system_files;
        t__string sn_system_files_pat;
        t__string sn_temp_dir_pat;
        t__string specman_home;
        t__int replay_redo_first_index;
        t__int replay_commands_count;
        t__int replay_redo_last_index;
        t__int replay_redo_last_stop;
        t__int replay_redo_until_index;
        t__int replay_until_step;
        t__int replay_num_real_commands;
        t__bool saved_simulator_exists;
        t__simulator_kind saved_simulator_kind;
        t__simulator_product saved_simulator_product;
        t__bool faked_simulator_exists;
        t__simulator_kind faked_simulator_kind;
        t__simulator_product faked_simulator_product;
        struct s__sn_vec *global_old_ba;
        t__int initial_file;
        t__int redo_file;
        t__int trace_file;
        t__int readme_file;
        t__int tables_file;
        t__int load_modules_file;
        t__int makefile_file;
        t__int elist_file;
        t__int exec_name_file;
        t__int redo_buffer_file;
        t__int esv_info_file;
        t__int record_flag_file;
        t__int replay_continue_file;
        t__int run_redo_file;
        t__int restore_replay_file;
        t__string initial_file_name;
        t__string redo_file_name;
        t__string trace_file_name;
        t__string readme_file_name;
        t__string tables_file_name;
        t__string load_modules_file_name;
        t__string makefile_file_name;
        t__string elist_file_name;
        t__string exec_name_file_name;
        t__string redo_buffer_file_name;
        t__string esv_info_file_name;
        t__string record_flag_file_name;
        t__string replay_continue_file_name;
        t__string run_redo_file_name;
        t__string restore_replay_file_name;
        t__string recovery_file_name;
        t__string config_file_name;
        t__string bp_file_name;
        t__string backup_bp_file_name;
} *t__sn_capture;
#define d__sn_capture 826

/* line 61 "/proj/specman/src/cap_structs.e"  From 'struct definition' */
typedef struct s__trans_table {
    t__int d__;
    t__int gen__;
        struct s__l__trans_table_item *items_list;
} *t__trans_table;
#define d__trans_table 4149

/* line 51 "/proj/specman/src/cap_structs.e"  From 'struct definition' */
typedef struct s__trans_table_item {
    t__int d__;
    t__int gen__;
        t__string from_str;
        t__string to_str;
} *t__trans_table_item;
#define d__trans_table_item 4148

/* line 196 "/proj/specman/src/cap_structs.e"  From 'struct definition' */
typedef struct s__cap_info {
    t__int d__;
    t__int gen__;
        t__string user_name;
        t__string capture_file_name;
        t__string capture_dir;
        t__string capture_top_dir;
        t__string start_time;
        t__string end_time;
        t__string machine;
        t__string operation_system;
        struct s__l__string *capture_ls_dir;
        t__string current_dir;
        t__string record_command;
        struct s__l__string *first_ls_dir;
        struct s__l__string *end_ls_dir;
        struct s__time *sys_time;
        struct s__params *params;
        struct s__specman_config *specman_config;
        struct s__compatibility_options *compatibility_options;
        struct s__cap_info_simulator *simulator;
        struct s__cap_info_session *session;
        t__bool display_on;
        struct s__l__string *env_vars;
} *t__cap_info;
#define d__cap_info 4153

/* line 190 "/proj/specman/src/cap_structs.e"  From 'struct definition' */
typedef struct s__cap_info_simulator {
    t__int d__;
    t__int gen__;
        t__bool exists;
        t__simulator_kind kind;
        t__simulator_product product;
} *t__cap_info_simulator;
#define d__cap_info_simulator 4152

/* line 168 "/proj/specman/src/cap_structs.e"  From 'struct definition' */
typedef struct s__cap_info_session {
    t__int d__;
    t__int gen__;
        t__int num_of_errors;
        t__string last_save_file_name;
        t__next_prev_op next_prev_op;
        t__bool exit_on_error;
        t__string error_command;
        t__bool show_calls_on_error;
        t__bool check_ok;
        t__int num_of_dut_errors;
        t__int num_of_dut_warnings;
        t__test_phase test_phase;
        t__int run_tick_max;
        t__bool run_in_progress;
        t__bool test_command_in_progress;
        t__bool global_extract_in_progress;
        t__bool global_check_in_progress;
        t__bool end_of_test;
        t__bool do_automatic_check;
} *t__cap_info_session;
#define d__cap_info_session 4151

/* line 447 "/proj/specman/src/dut_error.e"  From 'struct definition' */
typedef struct s__sn_wave {
    t__int d__;
    t__int gen__;
        t__wave_execution_mode execution_mode;
        t__waveform_kind viewer;
        t__bool use_default_working_mode;
        struct s__sn_adapter_struct *wave_sim_adapter;
        struct s__wave_stub_services *wave_stub_services;
        struct s__wave_services *wave_services;
        struct s__file *global_cfg_file;
        t__string global_cfg_file_name;
        struct s__file *batch_cfg_file;
        t__string batch_cfg_file_name;
        struct s__wave_log_manager *log_mngr;
        struct s__wave_dump_manager *wave_dump_mngr;
        struct s__wave_viewers_api *api;
        t__string wave_shared_lib_name;
        t__int flush_at_tick;
        struct s__wave_commands_manager *wave_cmd_mngr;
        struct s__undertow_interface *undertow_interface;
} *t__sn_wave;
#define d__sn_wave 891

/* line 3 "/proj/specman/src/wave_stub_services.e"  From 'struct definition' */
typedef struct s__wave_stub_services {
    t__int d__;
    t__int gen__;
} *t__wave_stub_services;
#define d__wave_stub_services 3013

/* line 47 "/proj/specman/src/wave_services.e"  From 'struct definition' */
typedef struct s__wave_services {
    t__int d__;
    t__int gen__;
        struct s__wave_cfg_file_services *cfg_file_services;
} *t__wave_services;
#define d__wave_services 3018

/* line 499 "/proj/specman/src/wave_services.e"  From 'struct definition' */
typedef struct s__wave_cfg_file_services {
    t__int d__;
    t__int gen__;
} *t__wave_cfg_file_services;
#define d__wave_cfg_file_services 3019

/* line 2 "/proj/specman/src/wave_log.e"  From 'struct definition' */
typedef struct s__wave_log_manager {
    t__int d__;
    t__int gen__;
        t__bool should_log;
        t__string log_file_name;
        struct s__l__string *log_lines;
} *t__wave_log_manager;
#define d__wave_log_manager 3023

/* line 1497 "/proj/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__wave_dump_manager {
    t__int d__;
    t__int gen__;
        struct s__l__abs_wave_entry *modified_wave_entries;
} *t__wave_dump_manager;
#define d__wave_dump_manager 3048

/* line 23 "/proj/specman/src/wave_interface.e"  From 'struct definition' */
typedef struct s__wave_viewers_api {
    t__int d__;
    t__int gen__;
        t__string waveform_name;
        t__bool wave_is_connected;
        t__int wave_win_id;
        struct s__sn_library *sn_wave_shlib;
        t__external_pointer do_create_ptr;
        t__external_pointer do_connect_ptr;
        t__external_pointer do_command_ptr;
        t__external_pointer do_check_for_events_ptr;
        t__external_pointer do_set_abort_proc_ptr;
        t__external_pointer do_check_connection_ptr;
        t__external_pointer do_destroy_ptr;
        t__external_pointer do_add_event_callback_ptr;
        t__external_pointer do_refresh_display_ptr;
        t__external_pointer do_create_window_ptr;
        t__external_pointer do_get_current_window_ptr;
        t__external_pointer do_add_all_event_callbacks_ptr;
        t__external_pointer do_restore_signal;
        t__external_pointer do_restore_signal_ptr;
        t__external_pointer do_set_win_option_ptr;
        t__external_pointer do_dumpflush_ptr;
        t__external_pointer do_get_free_port_ptr;
} *t__wave_viewers_api;
#define d__wave_viewers_api 3049

/* line 1700 "/proj/specman/src/wave_cmd_mngr.e"  From 'struct definition' */
typedef struct s__wave_commands_manager {
    t__int d__;
    t__int gen__;
        struct s__l__abs_wave_command_manager *all_cmd_mngr;
        struct s__wave_output_command_manager *output_cmd_mngr;
        t__bool trace_output;
        struct s__wave_command_manager_id30100 *id_factory;
        struct s__wave_signal_allocators_30099 *allocation_mngr;
        t__bool any_wave_cmd_occur;
        t__string cfg_file_initial_session;
} *t__wave_commands_manager;
#define d__wave_commands_manager 3064

/* line 1113 "/proj/specman/src/wave_cmd_mngr.e"  From 'struct definition' */
typedef struct s__wave_output_command_manager {
    t__int d__;
    t__int gen__;
        t__int id;
        t__string wave_cmd;
        t__string group_name;
        struct s__wave_output_element *wave_output_element;
        struct s__wave_error_element *wave_error_element;
} *t__wave_output_command_manager;
#define d__wave_output_command_manager 3059

/* line 825 "/proj/specman/src/wave_cmd_mngr.e"  From 'struct definition' */
typedef struct s__wave_output_element {
    t__int d__;
    t__int gen__;
        struct s__wave_element_allocation *allocation;
        struct s__l__string *log_lines;
        t__bool free_entry_exist;
        t__string non_terminated_str;
} *t__wave_output_element;
#define d__wave_output_element 3055

/* line 855 "/proj/specman/src/wave_cmd_mngr.e"  From 'struct definition' */
typedef struct s__wave_error_element {
    t__int d__;
    t__int gen__;
        struct s__wave_element_allocation *allocation;
        struct s__l__string *log_lines;
        t__bool free_entry_exist;
        t__string non_terminated_str;
} *t__wave_error_element;
#define d__wave_error_element 3056

/* line 895 "/proj/specman/src/wave_cmd_mngr.e"  From 'struct definition' */
typedef struct s__wave_command_manager_id30100 {
    t__int d__;
    t__int gen__;
        t__int myNextId;
} *t__wave_command_manager_id_factory;
#define d__wave_command_manager_id_factory 3057

/* line 12 "/proj/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__wave_signal_allocators_30099 {
    t__int d__;
    t__int gen__;
        struct s__k__signal_naming_map__n30098 *signal_unique_naming_manager;
        struct s__wave_event_allocator *event_allocator;
        struct s__wave_scalar_allocator *scalar_allocator;
        struct s__wave_bool_allocator *bool_allocator;
        struct s__wave_str_allocator *str_allocator;
        struct s__wave_output_allocator *output_allocator;
        struct s__wave_error_allocator *error_allocator;
} *t__wave_signal_allocators_manager;
#define d__wave_signal_allocators_manager 3025

/* line 6 "/proj/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__signal_naming_map {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string new_name;
        t__int counter;
} *t__signal_naming_map;
#define d__signal_naming_map 3024

/* line 256 "/proj/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__wave_event_allocator {
    t__int d__;
    t__int gen__;
        t__int total;
        t__int next_id;
} *t__wave_event_allocator;
#define d__wave_event_allocator 3030

/* line 292 "/proj/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__wave_scalar_allocator {
    t__int d__;
    t__int gen__;
        t__int total;
        t__int next_id;
} *t__wave_scalar_allocator;
#define d__wave_scalar_allocator 3033

/* line 267 "/proj/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__wave_bool_allocator {
    t__int d__;
    t__int gen__;
        t__int total;
        t__int next_id;
} *t__wave_bool_allocator;
#define d__wave_bool_allocator 3031

/* line 279 "/proj/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__wave_str_allocator {
    t__int d__;
    t__int gen__;
        t__int total;
        t__int next_id;
} *t__wave_str_allocator;
#define d__wave_str_allocator 3032

/* line 213 "/proj/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__wave_output_allocator {
    t__int d__;
    t__int gen__;
        t__int total;
        t__int next_id;
} *t__wave_output_allocator;
#define d__wave_output_allocator 3028

/* line 235 "/proj/specman/src/wave_allocator.e"  From 'struct definition' */
typedef struct s__wave_error_allocator {
    t__int d__;
    t__int gen__;
        t__int total;
        t__int next_id;
} *t__wave_error_allocator;
#define d__wave_error_allocator 3029

/* line 2 "/proj/specman/src/wave_undertow.e"  From 'struct definition' */
typedef struct s__undertow_interface {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__undertow_interface;
#define d__undertow_interface 3073

/* line 475 "/proj/specman/src/dut_error.e"  From 'struct definition' */
typedef struct s__dut_error_struct {
    t__int d__;
    t__int gen__;
        struct s__check *dut_error___check;
        t__string message;
        struct s__any_struct *dut_error___source_struct;
        t__string dut_error___source_location;
        t__string dut_error___source_struct_name;
        t__string dut_error___source_method_name;
        t__check_effect dut_error___check_effect;
} *t__dut_error_struct;
#define d__dut_error_struct 892

/* line 268 "/proj/specman/src/scriptsim.e"  From 'struct definition' */
typedef struct s__fake_signal {
    t__int d__;
    t__int gen__;
        t__bool current_is_long;
        t__string name;
        t__uint value;
        struct s__int__MAX_INT *lvalue;
} *t__fake_signal;
#define d__fake_signal 823

/* line 150 "/proj/specman/src/memory.e"  From 'struct definition' */
typedef struct s__memory_globals {
    t__int d__;
    t__int gen__;
        struct s__l__select_list_with_prio *lists_with_prio;
        struct s__l__uint *free_weights_list;
        struct s__l__int *select_indices_list;
        struct s__l__sort_item *sort_list;
        struct s__l__int *dummy_ilist;
        struct s__l__uint *dummy_ulist;
} *t__memory_globals;
#define d__memory_globals 1077

/* line 138 "/proj/specman/src/memory.e"  From 'struct definition' */
typedef struct s__select_list_with_prio {
    t__int d__;
    t__int gen__;
        t__int priority;
        struct s__l__int *idx_list;
} *t__select_list_with_prio;
#define d__select_list_with_prio 1075

/* line 143 "/proj/specman/src/memory.e"  From 'struct definition' */
typedef struct s__sort_item {
    t__int d__;
    t__int gen__;
        t__int index;
        t__int field;
} *t__sort_item;
#define d__sort_item 1076

/* line 69 "/proj/specman/src/rl_rnd.e"  From 'struct definition' */
typedef struct s__random_info {
    t__int d__;
    t__int gen__;
} *t__random_info;
#define d__random_info 1177

/* line 1240 "/proj/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__rf_manager {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__type_descriptor *sn___last_type;
        struct s__rf_value_holder *sn___last_value;
} *t__rf_manager;
#define d__rf_manager 1230

/* line 1410 "/proj/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__rf_value_holder {
    t__int d__;
    t__int gen__;
        struct s__rf_type *reflection_imp___t;
} *t__rf_value_holder;
#define d__rf_value_holder 1231

/* line 44 "/proj/specman/src/reflection_imp.e"  From 'struct definition' */
typedef struct s__rf_type {
    t__int d__;
    t__int gen__;
} *t__rf_type;
#define d__rf_type 1201

/* line 294 "/proj/specman/src/gen_lang.e"  From 'struct definition' */
typedef struct s__untyped_list_to_scalar_c6589 {
    t__int d__;
    t__int gen__;
} *t__untyped_list_to_scalar_convertor;
#define d__untyped_list_to_scalar_convertor 1368

/* line 335 "/proj/specman/src/gen_run_structs.e"  From 'struct definition' */
typedef struct s__major_path {
    t__int d__;
    t__int gen__;
        struct s__gen_frame *curr_gen_frame;
        struct s__l__gen_frame *prev_frames;
} *t__major_path;
#define d__major_path 1457

/* line 231 "/proj/specman/src/shlibs.e"  From 'struct definition' */
typedef struct s__sn_shlibs {
    t__int d__;
    t__int gen__;
        struct s__l__sn_library *libraries;
        t__bool debug_mode;
} *t__sn_shlibs;
#define d__sn_shlibs 1507

/* line 15 "/proj/specman/src/pre_display.e"  From 'struct definition' */
typedef struct s__sn_util {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__k__sn_component__name *component_list;
        struct s__k__string__it *sn_util___evc_names;
} *t__sn_util;
#define d__sn_util 1591

/* line 414 "/proj/specman/src/patch.e"  From 'struct definition' */
typedef struct s__sn_component {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string name;
        t__string version;
} *t__sn_component;
#define d__sn_component 4213

/* line 181 "/proj/specman/src/pre_display.e"  From 'struct definition' */
typedef struct s__sn_patches {
    t__int d__;
    t__int gen__;
        struct s__k__sn_patch_info__id *all_patches;
        struct s__sn_command_option_parser *patch_parser;
} *t__sn_patches;
#define d__sn_patches 1592

/* line 12 "/proj/specman/src/patch.e"  From 'struct definition' */
typedef struct s__sn_patch_info {
    t__int d__;
    t__int gen__;
        t__uint id;
        struct s__l__string *releases;
        t__bool error_not_release;
        t__string product;
        struct s__l__string *product_releases;
        t__bool error_no_product;
        struct s__l__uint *defects;
        t__string date;
        struct s__l__string *authors;
        t__string description;
        t__string patch_file_name;
        struct s__l__string *contradict;
        struct s__l__string *requires;
        t__bool compiled;
} *t__sn_patch_info;
#define d__sn_patch_info 4208

/* line 14 "/proj/specman/src/command_with_options.e"  From 'struct definition' */
typedef struct s__sn_command_option_parser {
    t__int d__;
    t__int gen__;
        t__string context;
        struct s__k__sn_command_option_de44872 *descriptors;
} *t__sn_command_option_parser;
#define d__sn_command_option_parser 4203

/* line 3 "/proj/specman/src/command_with_options.e"  From 'struct definition' */
typedef struct s__sn_command_option_descriptor {
    t__int d__;
    t__int gen__;
        t__string name;
        t__bool just_one_value;
        t__bool required;
} *t__sn_command_option_descriptor;
#define d__sn_command_option_descriptor 4201

/* line 25 "/proj/specman/src/help_html.e"  From 'struct definition' */
typedef struct s__help_index {
    t__int d__;
    t__int gen__;
        struct s__l__string *lines;
        struct s__l__line_kind *kinds;
        struct s__l__int *levels;
        struct s__l__string *text;
        struct s__l__int *starts;
        struct s__l__string *word_patterns;
        struct s__l__bool *matched_words;
        t__string fast_pattern;
        t__int level;
        t__int max_level;
        struct s__l__bool *found;
        struct s__l__int *start_levels;
        struct s__l__word_indices *indices_stack;
        struct s__l__string *output_lines;
        t__string full_path;
        t__string index_file;
        t__bool none_found;
} *t__help_index;
#define d__help_index 1693

/* line 19 "/proj/specman/src/help_html.e"  From 'struct definition' */
typedef struct s__word_indices {
    t__int d__;
    t__int gen__;
        struct s__l__int *inds;
        t__int nleft;
        t__int line_no;
} *t__word_indices;
#define d__word_indices 1692

/* line 150 "/proj/specman/src/interactor.e"  From 'struct definition' */
typedef struct s__interact {
    t__int d__;
    t__int gen__;
        t__uint max_socket_buffer;
        t__bool stdin_is_ready;
} *t__interact;
#define d__interact 1719

/* line 17 "/proj/specman/src/cover.e"  From 'struct definition' */
typedef struct s__covers {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__c_float f_one;
        t__c_float f_minus_one;
        t__c_float f_zero;
        t__int at_least_multiplier;
        t__sn_cvr_grading_formula grading_formula;
        t__sn_cvr_mode mode;
        t__bool check_illegal_immediately;
        t__string dir;
        t__string file_name;
        t__string test_name;
        t__string run_name;
        t__string tag_name;
        t__count max_int_buckets;
        t__uint absolute_max_buckets;
        t__show_mode show_mode;
        t__bool sorted;
        t__bool show_file_names;
        t__bool show_sub_holes;
        t__bool show_instances_only;
        t__bool show_partial_grade;
        t__sn_cvr_cost_type ranking_cost;
        t__sn_cover_gui_sync_mode gui_sync_mode;
        struct s__l__string *parse_event_lines;
        t__c_float total_grade;
        struct s__check *cover_check;
        t__bool active;
        t__bool not_prepared;
        t__sn_cvr_xyz file_type;
        t__string file_extention;
        t__bool ranking_flag;
        struct s__l__string *full_bucket_name;
        t__bool allow_space_separator;
        struct s__time *last_update_time;
        t__bool control_dirty;
        t__bool data_dirty;
        t__bool structure_dirty;
        t__bool all_items;
        t__bool instances_only_dirty;
        struct s__l__int *ids_for_contributed;
        t__int max_contributing_tests;
        t__bool report_ungradable_only;
        t__bool report_leaf_buckts_only;
        t__bool report_summary_only;
        t__bool title_done;
        struct s__file *report_file;
        t__string report_file_name;
        t__bool is_ready;
        struct s__any_struct *parent_ptr;
        struct s__sn_cvr_instance_group_d22605 *cvr_gi;
        struct s__k__sn_cvr_main_group_de22606 *all_groups;
        struct s__l__sn_cover_test *tests;
        struct s__sn_cover_test *current_test;
        struct s__l__sn_cvr_main_group_de22607 *groups_report;
        t__string last_item_names;
        t__bool no_warn;
        struct s__k__sn_external_cover__kind *all_externals;
        struct s__enum_descriptor *external_entity_type;
        t__bool i1890_flag;
        struct s__sn_cover_item_inst *current_item_inst;
        struct s__l__cover_struct *empty_cs_list;
        struct s__l__cover_struct *lcs;
        t__bool doit;
        struct s__l__string *reparse_list;
        t__bool cvr_use_interval;
        t__string cvr_from_event;
        t__string cvr_to_event;
        t__bool cvr_only_simultaneous;
        struct s__sn_cross_searcher *cross_searcher;
        struct s__cover_struct *cs;
        struct s__struct_descriptor *cvr_struct_type;
        struct s__scalar_range_list *dummy_range_list;
        struct s__l__string *c_cross_items;
        struct s__l__string *c_interval_events;
        struct s__l__sn_cvr_external_type *all_to_restore;
        struct s__sn_ranker *ranker;
        struct s__jcover *jcover;
        t__c_float grading;
        t__int rank_gui_table_size;
        t__int rank_gui_buckets_size;
} *t__covers;
#define d__covers 1721

/* line 80 "/proj/specman/src/cover_external_defs.e"  From 'struct definition' */
typedef struct s__sn_external_cover {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__sn_cvr_external_type kind;
        struct s__l__sn_external_group *all_groups;
        struct s__l__string *all_keys;
        t__bool disabled;
        t__bool is_dirty;
} *t__sn_external_cover;
#define d__sn_external_cover 2607

/* line 486 "../src/root_types.e"  From 'struct definition' */
typedef struct s__enum_descriptor {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string name;
        t__int size_in_bytes;
        t__short_type short_type;
        t__bool debug;
        t__string c_name;
        t__string predefined_declaration;
        struct s__type_descriptor *parent;
        t__int d_index;
        struct s__scalar_range_list *range_list;
        struct s__l__type_layer *layers;
        t__int size_in_bits;
        struct s__scalar_range_list *type_range_list;
        struct s__sn_struct *the_rl;
        struct s__rf_structural_element *rf_object_;
        struct s__enum_names *enum_names;
        t__int prev_size;
} *t__enum_descriptor;
#define d__enum_descriptor 125

/* line 499 "../src/root_types.e"  From 'struct definition' */
typedef struct s__enum_names {
    t__int d__;
    t__int gen__;
        struct s__k__enum_item__name *items;
} *t__enum_names;
#define d__enum_names 127

/* line 503 "../src/root_types.e"  From 'struct definition' */
typedef struct s__enum_item {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        t__string name;
        t__int value;
} *t__enum_item;
#define d__enum_item 128

/* line 1043 "/proj/specman/src/cover_postrun.e"  From 'struct definition' */
typedef struct s__sn_cross_searcher {
    t__int d__;
    t__int gen__;
        t__bool end_of_test_terminates_interval;
        t__bool ignore_order_in_tick;
        struct s__l__cover_struct *data;
        struct s__l__sn_search_item *search_items;
        t__bool interval_mode;
        t__index interval_start_id;
        t__index interval_end_id;
        t__bool only_simultaneous;
        t__bool all_samples;
        struct s__l__cover_struct *curr_sample;
        struct s__l__index *curr_indexes;
        struct s__l__cover_struct *curr_predecessors;
        struct s__l__cover_struct *empty_list;
        t__index range_start;
        t__index range_end;
        t__index start_event_in_range;
        t__index end_event_in_range;
        t__bool inside_range;
} *t__sn_cross_searcher;
#define d__sn_cross_searcher 2619

/* line 1078 "/proj/specman/src/cover_postrun.e"  From 'struct definition' */
typedef struct s__sn_search_item {
    t__int d__;
    t__int gen__;
        struct s__sn_cvr_item_descriptor *parent;
        t__index event_id;
        t__index index_in_when_mask;
        t__index index_in_when_mask_for_transition;
        t__bool global;
} *t__sn_search_item;
#define d__sn_search_item 2620

/* line 173 "/proj/specman/src/cover_rank.e"  From 'struct definition' */
typedef struct s__sn_ranker {
    t__int d__;
    t__int gen__;
        struct s__sn_cvr_rank_config *config;
        t__bool gui;
        t__bool sort_only;
        t__bool omit_test_details;
        t__string item_names;
        t__string initial_list_file;
        struct s__l__sn_cvr_test_rank_info *init_tests;
        t__sn_ranker__grade_threshold grade_threshold;
        t__int cost_threshold;
        t__bool recover;
        struct s__sn_cvr_rank_recover *recover_info;
        t__string recover_file_name;
        t__uint recover_interval;
        t__bool modified_structure;
        struct s__k__sn_cvr_test_rank_info__id *tests;
        t__bool modified_attributes;
        struct s__l__sn_cvr_instance_grou22666 *groups_to_fill;
        struct s__k__sn_cvr_test_rank_info__id *ranked_tests;
        t__bool ranked;
        t__bool sorted;
        t__c_float max_grade;
        t__int average_cost;
        t__c_float sampled_groups_weight;
        struct s__l__sn_cvr_test_rank_info *optimal_tests;
        t__c_float cum_grade;
        t__int cum_cost;
        struct s__l__sn_cvr_instance_grou22666 *external_groups;
        struct s__k__sn_external_cover__kind *active_externals;
        struct s__k__string__it *test_full_names;
        struct s__k__string__it *test_file_names;
        struct s__sn_rank_window *rank_window;
} *t__sn_ranker;
#define d__sn_ranker 2736

/* line 771 "/proj/specman/src/cover_rank_structs.e"  From 'struct definition' */
typedef struct s__sn_cvr_rank_config {
    t__int d__;
    t__int gen__;
        t__int index_width;
        t__int name_width;
        t__int cum_grade_width;
        t__int rel_grade_width;
        t__int cum_cost_width;
        t__int cost_width;
        t__int abs_grade_width;
        t__int eff_width;
        t__int ubuckets_width;
        t__int dut_err_width;
        t__int seed_width;
} *t__sn_cvr_rank_config;
#define d__sn_cvr_rank_config 2735

/* line 105 "/proj/specman/src/cover_rank_structs.e"  From 'struct definition' */
typedef struct s__sn_cvr_test_rank_info {
    t__int d__;
    t__int gen__;
        t__int id;
        t__c_float opt_grade;
        struct s__sn_cover_test *inst;
        struct s__l__sn_cvr_group_rank_info *groups;
        t__bool in_init_list;
        t__string external_key;
        t__bool rankable;
        t__bool in_opt_list;
        t__int cost;
        t__c_float norm_cost;
        t__c_float efficiency;
        t__c_float abs_grade;
        struct s__l__sn_cvr_bucket_rank_d22620 *unique_buckets;
        t__c_float opt_efficiency;
        t__c_float cum_grade;
        t__int cum_cost;
} *t__sn_cvr_test_rank_info;
#define d__sn_cvr_test_rank_info 2726

/* line 397 "/proj/specman/src/cover_rank_structs.e"  From 'struct definition' */
typedef struct s__sn_cvr_group_rank_info {
    t__int d__;
    t__int gen__;
        t__int id;
        t__c_float opt_grade;
        struct s__sn_cover_group_inst *inst;
        struct s__sn_cvr_instance_group_d22605 *desc;
        struct s__l__sn_cvr_item_rank_info *items;
} *t__sn_cvr_group_rank_info;
#define d__sn_cvr_group_rank_info 2729

/* line 482 "/proj/specman/src/cover_rank_structs.e"  From 'struct definition' */
typedef struct s__sn_cvr_item_rank_info {
    t__int d__;
    t__int gen__;
        t__int id;
        t__c_float opt_grade;
        struct s__sn_cover_item_inst *inst;
        struct s__sn_cvr_item_descriptor *desc;
        struct s__l__sn_cvr_bucket_rank_info *buckets;
} *t__sn_cvr_item_rank_info;
#define d__sn_cvr_item_rank_info 2731

/* line 577 "/proj/specman/src/cover_rank_structs.e"  From 'struct definition' */
typedef struct s__sn_cvr_bucket_rank_info {
    t__int d__;
    t__int gen__;
        t__int id;
        t__c_float opt_grade;
        struct s__sn_cvr_bucket_rank_desc22665 *desc;
        t__int samples;
} *t__sn_cvr_bucket_rank_info;
#define d__sn_cvr_bucket_rank_info 2733

/* line 1308 "/proj/specman/src/cover_rank.e"  From 'struct definition' */
typedef struct s__sn_cvr_rank_recover {
    t__int d__;
    t__int gen__;
        struct s__sn_timer *timer;
        t__uint last_sample;
        t__string item_names;
        struct s__l__string *init_test_names;
        struct s__l__int *optimal_test_ids;
} *t__sn_cvr_rank_recover;
#define d__sn_cvr_rank_recover 2741

/* line 43 "/proj/specman/src/times.e"  From 'struct definition' */
typedef struct s__sn_timer {
    t__int d__;
    t__int gen__;
        struct s__tms *from;
        struct s__tms *to;
        struct s__timeval *micro_from;
        struct s__timeval *micro_to;
        struct s__timeval *accorate_time;
} *t__sn_timer;
#define d__sn_timer 2537

/* line 20 "/proj/specman/src/times.e"  From 'struct definition' */
typedef struct s__tms {
    t__int d__;
    t__int gen__;
        t__clock_t tms_utime;
        t__clock_t tms_stime;
        t__clock_t tms_cutime;
        t__clock_t tms_cstime;
} *t__tms;
#define d__tms 2535

/* line 27 "/proj/specman/src/times.e"  From 'struct definition' */
typedef struct s__timeval {
    t__int d__;
    t__int gen__;
        t__long tv_sec;
        t__long tv_usec;
} *t__timeval;
#define d__timeval 2536

/* line 352 "/proj/specman/src/cover_rank_gui.e"  From 'struct definition' */
typedef struct s__sn_rank_window {
    t__int d__;
    t__int gen__;
        struct s__l__string *initial_list;
        t__bool ignore;
        t__bool not_finished;
        t__bool recover;
        t__string grade_kind;
        t__string items;
        struct s__l__sn_cvr_gui_curr_page *checked_till_now;
        struct s__sn_cvr_gui_curr_page *curr_page;
        t__bool sort;
        struct s__sn_rank_html_table *table;
        struct s__vt_window *win;
        struct s__vt_window *single_win;
        struct s__vt_window *bucket_win;
        struct s__l__sn_cvr_gui_curr_page *gui_curr_bucket_pages;
        struct s__sn_cvr_gui_curr_page *curr_bucket_page;
        t__string curr_test_context;
} *t__sn_rank_window;
#define d__sn_rank_window 4250

/* line 344 "/proj/specman/src/cover_rank_gui.e"  From 'struct definition' */
typedef struct s__sn_cvr_gui_curr_page {
    t__int d__;
    t__int gen__;
        struct s__l__int *checked;
        t__int from;
        t__int to;
        t__int id;
} *t__sn_cvr_gui_curr_page;
#define d__sn_cvr_gui_curr_page 4249

/* line 155 "/proj/specman/src/cover_rank_gui.e"  From 'struct definition' */
typedef struct s__sn_rank_html_table {
    t__int d__;
    t__int gen__;
        struct s__l__sn_cvr_table_column *columns;
        t__string heading;
} *t__sn_rank_html_table;
#define d__sn_rank_html_table 4248

/* line 74 "/proj/specman/src/cover_rank_gui.e"  From 'struct definition' */
typedef struct s__sn_cvr_table_column {
    t__int d__;
    t__int gen__;
        t__string heading;
        struct s__l__string *f__entry;
        t__int width;
        t__int height;
} *t__sn_cvr_table_column;
#define d__sn_cvr_table_column 4245

/* line 7 "/proj/specman/src/japp/vt/vt_window.e"  From 'struct definition' */
typedef struct s__vt_window {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__vt_window_properties *p_props;
        struct s__vt_window_actions *p_actions;
        t__string p_s_html_file;
        struct s__sn_vtw_callback_handler *p_callback_handler;
        struct s__sn_vtw_listener *p_listener;
        t__bool p_f_page_loaded;
        struct s__sni_vt_jwindow *p_win;
} *t__vt_window;
#define d__vt_window 3445

/* line 207 "/proj/specman/src/japp/vt/vt_edl.e"  From 'struct definition' */
typedef struct s__vt_window_properties {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string title;
        struct s__sn_pair_nums *size;
        struct s__sn_pair_nums *location;
} *t__vt_window_properties;
#define d__vt_window_properties 3387

/* line 299 "/proj/specman/src/japp/vt/vt_edl.e"  From 'struct definition' */
typedef struct s__sn_pair_nums {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__int n1;
        t__int n2;
} *t__sn_pair_nums;
#define d__sn_pair_nums 3389

/* line 247 "/proj/specman/src/japp/vt/vt_edl.e"  From 'struct definition' */
typedef struct s__vt_window_actions {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__sn_vt_menubar *menubar;
        struct s__sn_vt_toolbar *toolbar;
        t__string s_pre_close_cmd;
} *t__vt_window_actions;
#define d__vt_window_actions 3388

/* line 78 "/proj/specman/src/japp/vt/vt_edl.e"  From 'struct definition' */
typedef struct s__sn_vt_menubar {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__l__sn_vt_menu *lst_menus;
} *t__sn_vt_menubar;
#define d__sn_vt_menubar 3381

/* line 131 "/proj/specman/src/japp/vt/vt_edl.e"  From 'struct definition' */
typedef struct s__sn_vt_menu {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string text;
        struct s__l__sn_vt_action *lst_actions;
} *t__sn_vt_menu;
#define d__sn_vt_menu 3383

/* line 188 "/proj/specman/src/japp/vt/vt_edl.e"  From 'struct definition' */
typedef struct s__sn_vt_action {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string text;
        t__string tooltip;
        t__string command;
        t__string icon_file;
} *t__sn_vt_action;
#define d__sn_vt_action 3386

/* line 167 "/proj/specman/src/japp/vt/vt_edl.e"  From 'struct definition' */
typedef struct s__sn_vt_toolbar {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__l__sn_vt_action *lst_actions;
} *t__sn_vt_toolbar;
#define d__sn_vt_toolbar 3385

/* line 275 "/proj/specman/src/japp/vt/vt_window.e"  From 'struct definition' */
typedef struct s__sn_vtw_callback_handler {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__vt_window *p_vtw;
} *t__sn_vtw_callback_handler;
#define d__sn_vtw_callback_handler 3446

/* line 295 "/proj/specman/src/japp/vt/vt_window.e"  From 'struct definition' */
typedef struct s__sn_vtw_listener {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sn_vtw_listener;
#define d__sn_vtw_listener 3447

/* line 32 "/proj/specman/src/japp/vt/vt_edl.e"  From 'struct definition' */
typedef struct s__sni_vt_jwindow {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sni_vt_jwindow;
#define d__sni_vt_jwindow 3379

/* line 249 "/proj/specman/src/cover_jcvr.e"  From 'struct definition' */
typedef struct s__jcover {
    t__int d__;
    t__int gen__;
        struct s__l__sn_cvr_instance_grou22666 *relevant_groups;
        t__c_float grading;
        struct s__jcvr_item_pack_object *item_obj;
        struct s__jcvr_item_type_pack_object *item_type_obj;
        struct s__jcvr_pack_object_tests *tests_obj;
        struct s__jcvr_category_pack_object *category_obj;
        struct s__jcvr_group_pack_object *group_obj;
        struct s__sn_flag *values_dirty;
        struct s__sn_flag *structure_dirty;
        struct s__sn_cover_jcvr_postrun_api *postrun;
} *t__jcover;
#define d__jcover 2751

/* line 227 "/proj/specman/src/cover_jcvr.e"  From 'struct definition' */
typedef struct s__jcvr_item_pack_object {
    t__int d__;
    t__int gen__;
        struct s__l__int *ids;
        t__jcvr_pack_mode mode;
        struct s__sn_cvr_item_descriptor *item;
} *t__jcvr_item_pack_object;
#define d__jcvr_item_pack_object 2749

/* line 239 "/proj/specman/src/cover_jcvr.e"  From 'struct definition' */
typedef struct s__jcvr_item_type_pack_object {
    t__int d__;
    t__int gen__;
        struct s__l__int *ids;
        t__jcvr_pack_mode mode;
        struct s__sn_cvr_item_descriptor *item;
} *t__jcvr_item_type_pack_object;
#define d__jcvr_item_type_pack_object 2750

/* line 95 "/proj/specman/src/cover_jcvr.e"  From 'struct definition' */
typedef struct s__jcvr_pack_object_tests {
    t__int d__;
    t__int gen__;
} *t__jcvr_pack_object_tests;
#define d__jcvr_pack_object_tests 2746

/* line 145 "/proj/specman/src/cover_jcvr.e"  From 'struct definition' */
typedef struct s__jcvr_category_pack_object {
    t__int d__;
    t__int gen__;
        struct s__l__int *ids;
        t__jcvr_pack_mode mode;
        t__int category_id;
} *t__jcvr_category_pack_object;
#define d__jcvr_category_pack_object 2747

/* line 215 "/proj/specman/src/cover_jcvr.e"  From 'struct definition' */
typedef struct s__jcvr_group_pack_object {
    t__int d__;
    t__int gen__;
        struct s__l__int *ids;
        t__jcvr_pack_mode mode;
        struct s__sn_cvr_instance_group_d22605 *group;
} *t__jcvr_group_pack_object;
#define d__jcvr_group_pack_object 2748

/* line 726 "/proj/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__sn_flag {
    t__int d__;
    t__int gen__;
        t__bool flag;
        t__bool notify_flag;
} *t__sn_flag;
#define d__sn_flag 1045

/* line 167 "/proj/specman/src/cover_jcvr_ext.e"  From 'struct definition' */
typedef struct s__sn_cover_jcvr_postrun_api {
    t__int d__;
    t__int gen__;
        struct s__sn_key_store *p_cross_store;
} *t__sn_cover_jcvr_postrun_api;
#define d__sn_cover_jcvr_postrun_api 2773

/* line 787 "/proj/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__sn_key_store {
    t__int d__;
    t__int gen__;
        t__bool p_initialized;
        t__int p_next_key;
        struct s__k__sn_p_key_store_entry__key *p_list;
} *t__sn_key_store;
#define d__sn_key_store 1047

/* line 775 "/proj/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__sn_p_key_store_entry {
    t__int d__;
    t__int gen__;
        t__int key;
        struct s__base_struct *value;
} *t__sn_p_key_store_entry;
#define d__sn_p_key_store_entry 1046

/* line 342 "/proj/specman/src/disp_defs.e"  From 'struct definition' */
typedef struct s__sn_guitest {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sn_guitest;
#define d__sn_guitest 1829

/* line 43 "/proj/specman/src/te_root.e"  From 'struct definition' */
typedef struct s__sn_formal_link {
    t__int d__;
    t__int gen__;
        t__string FSM_code;
        t__string FSM_init_code;
        t__bool tlint_mode;
        t__bool unsupported_te;
        struct s__sn_fl_bexp *one_bexp;
        struct s__sn_fl_bexp *zero_bexp;
        t__string te_string;
        t__bool warn_any;
        t__bool warn_clk;
        t__bool warn_big;
        t__uint fsm_big_edges;
        t__bool te_parsing_debug;
        t__bool te_FSM_debug;
        struct s__l__string *te_reparse;
        t__uint unfold_max_val;
        t__bool fsm_stat_only;
        t__uint fsm_max_edges;
        t__bool single_clk_opt;
        t__bool more_tprof;
        t__bool step_debug;
        t__bool check_id;
        struct s__l__sn_fl_te_node *tes;
        t__bool te_eval_debug;
        t__bool retain_FSM;
        t__bool expect_without_fail;
        t__int detach_event_no;
        struct s__l__sn_fl_top_node *top_tes;
        t__bool determ;
        t__bool first_for_change;
        t__bool split_fix_rep_flag;
        t__bool clean_all;
        t__string prolog_str1;
        t__string prolog_str2;
        struct s__l__uint *alpha_list;
        t__int any_id;
        t__int neg_id;
        struct s__sn_fl_var_event *any_var;
        struct s__sn_fl_var_event *neg_var;
        t__int scndry_no;
        t__bool ignore_load_opt;
        t__bool ignore_trigger_opt;
        struct s__sn_te_debugger *tdb;
} *t__sn_formal_link;
#define d__sn_formal_link 2009

/* line 26 "/proj/specman/src/fl_bexp.e"  From 'struct definition' */
typedef struct s__sn_fl_bexp {
    t__int d__;
    t__int gen__;
} *t__sn_fl_bexp;
#define d__sn_fl_bexp 2101

/* line 619 "/proj/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl_te_node {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__sn_fl_top_node *top;
        t__string id;
        struct s__sn_fl_var_event *sample;
        struct s__l__sn_fl_var_event *samples;
} *t__sn_fl_te_node;
#define d__sn_fl_te_node 2152

/* line 361 "/proj/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl_top_node {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__sn_fl_te_node *texp;
        struct s__sn_fl_state_table *stt;
        struct s__l__sn_fl_var_scndry *top_actions;
        struct s__sn_fl_var_event *sample;
        t__bool single_clk;
        t__int id;
        t__int te_kind;
        t__int event_id;
        t__imp_enum_sn_fl_v_top_node__is_sticky_true_cash is_sticky_true_cash;
        t__imp_enum_sn_fl_v_top_node__is_neg_over_sense_cash is_neg_over_sense_cash;
        struct s__sn_fl_var_event *trigger_event;
        struct s__l__sn_fl_detach_top_node *detach_list;
        struct s__sn_bdd_manager *mbdd;
        struct s__sn_fl_bdd_add_on *bdd_add_on;
        struct s__sn_fl_te_node *succ_te;
        struct s__sn_fl_te_node *stuck_te;
        struct s__l__sn_fl_var_exec *user_sdef;
        struct s__l__sn_fl_var_true *all_trues;
        struct s__sn_fl_cache_top_node *all_fails;
        struct s__l__sn_fl_var_event *var_events;
        t__int neg_ind;
        t__int any_ind;
        t__bool any_sense;
        t__uint edges_num;
        t__uint states_num;
} *t__sn_fl_top_node;
#define d__sn_fl_top_node 2137

/* line 528 "/proj/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl_state_table {
    t__int d__;
    t__int gen__;
        struct s__sn_fl_base_top_node *top_node;
        struct s__k__sn_fl_fsm_entry__id *sts;
        struct s__l__sn_fl_fsm_edge *all_edges;
        t__int first_state;
        t__int fake_state_num;
        struct s__l__sn_fl_var_alpha *alphas;
        t__string res_name;
} *t__sn_fl_state_table;
#define d__sn_fl_state_table 2146

/* line 62 "/proj/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl_base_top_node {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__sn_fl_te_node *texp;
        struct s__sn_fl_state_table *stt;
        struct s__l__sn_fl_var_scndry *top_actions;
        struct s__sn_fl_var_event *sample;
        t__bool single_clk;
} *t__sn_fl_base_top_node;
#define d__sn_fl_base_top_node 2123

/* line 1291 "/proj/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl_var_scndry {
    t__int d__;
    t__int gen__;
        t__string name;
        t__int id;
} *t__sn_fl_var_scndry;
#define d__sn_fl_var_scndry 2201

/* line 1142 "/proj/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl_var_event {
    t__int d__;
    t__int gen__;
        t__string name;
        t__string path_str;
        t__string event_name;
        t__int event_id;
        t__string event_field_name;
        t__int ind_in_te;
} *t__sn_fl_var_event;
#define d__sn_fl_var_event 2193

/* line 546 "/proj/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl_fsm_entry {
    t__int d__;
    t__int gen__;
        struct s__sn_fl_state_table *stt;
        t__int ind;
        t__string id;
        struct s__sn_fl_te_node *texp;
        t__bool determ;
        t__bool visit;
        t__sn_fl_state_status status;
        t__int last_edge;
        struct s__l__sn_fl_fsm_edge *succs;
        struct s__l__sn_fl_fsm_edge *preds;
        struct s__l__bool *sense;
        struct s__l__sn_fl_var_alpha *sdef;
        struct s__sn_fl_state_dec *dec;
        struct s__l__sn_fl_var_true *true_vars;
        struct s__sn_bdd *bddexp;
} *t__sn_fl_fsm_entry;
#define d__sn_fl_fsm_entry 2147

/* line 551 "/proj/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl_fsm_edge {
    t__int d__;
    t__int gen__;
        struct s__sn_bdd *bddexp;
        struct s__sn_fl_bexp *bexp;
        struct s__sn_fl_bexp *r_bexp;
        struct s__sn_fl_fsm_entry *pred;
        struct s__sn_fl_fsm_entry *succ;
        struct s__l__sn_fl_var_scndry *sdef;
        struct s__l__sn_fl_var_exec *user_sdef;
        t__bool visit;
} *t__sn_fl_fsm_edge;
#define d__sn_fl_fsm_edge 2148

/* line 34 "/proj/specman/src/bdd.e"  From 'struct definition' */
typedef struct s__sn_bdd {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__external_pointer bdd;
        struct s__sn_bdd_manager *mbdd;
} *t__sn_bdd;
#define d__sn_bdd 2111

/* line 49 "/proj/specman/src/bdd.e"  From 'struct definition' */
typedef struct s__sn_bdd_manager {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__k__sn_bdd_var__name *vars;
        struct s__k__sn_bdd_var__id *bdd_vars;
        t__external_pointer bdd__manager;
        struct s__sn_bdd *one_bdd;
        struct s__sn_bdd *zero_bdd;
} *t__sn_bdd_manager;
#define d__sn_bdd_manager 2113

/* line 39 "/proj/specman/src/bdd.e"  From 'struct definition' */
typedef struct s__sn_bdd_var {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string name;
        t__int ind;
        t__int id;
        struct s__sn_bdd *bdd;
        struct s__sn_fl_var_bexp *bexp;
} *t__sn_bdd_var;
#define d__sn_bdd_var 2112

/* line 51 "/proj/specman/src/fl_bexp.e"  From 'struct definition' */
typedef struct s__sn_fl_var_bexp {
    t__int d__;
    t__int gen__;
        t__string name;
} *t__sn_fl_var_bexp;
#define d__sn_fl_var_bexp 2105

/* line 1484 "/proj/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl_var_exec {
    t__int d__;
    t__int gen__;
        t__string name;
        t__int id;
        t__string action_str;
        t__uint ind;
        t__bool multi;
        t__int consumed_event_id;
} *t__sn_fl_var_exec;
#define d__sn_fl_var_exec 2206

/* line 1325 "/proj/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl_var_alpha {
    t__int d__;
    t__int gen__;
        t__string name;
        t__int id;
        t__int num;
        t__bool is_const;
        t__string exp_str;
        struct s__sn_fl_var_loop *loop;
        struct s__sn_fl_var_loop *loop2;
        struct s__sn_fl_var_alpha *f__double;
} *t__sn_fl_var_alpha;
#define d__sn_fl_var_alpha 2203

/* line 1405 "/proj/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl_var_loop {
    t__int d__;
    t__int gen__;
        t__string name;
        t__int id;
        t__int num;
        t__bool is_const;
        t__string exp_str;
        struct s__sn_fl_var_alpha *alpha;
        t__bool merge_only;
        struct s__sn_fl_var_loop_dummy *dummy_act;
} *t__sn_fl_var_loop;
#define d__sn_fl_var_loop 2204

/* line 1453 "/proj/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl_var_loop_dummy {
    t__int d__;
    t__int gen__;
        t__string name;
        t__int id;
        t__int num;
        t__bool is_const;
        t__string exp_str;
        struct s__sn_fl_var_alpha *alpha;
} *t__sn_fl_var_loop_dummy;
#define d__sn_fl_var_loop_dummy 2205

/* line 12 "/proj/specman/src/fl_sm.e"  From 'struct definition' */
typedef struct s__sn_fl_state_dec {
    t__int d__;
    t__int gen__;
} *t__sn_fl_state_dec;
#define d__sn_fl_state_dec 2210

/* line 1231 "/proj/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl_var_true {
    t__int d__;
    t__int gen__;
        t__string name;
        struct s__l__sn_fl_fsm_entry *src_states;
        t__int occur_num;
        t__int id;
        t__sn_fl_true_occ_kind kind;
        t__bool sticky;
        t__bool neg_sense;
} *t__sn_fl_var_true;
#define d__sn_fl_var_true 2197

/* line 504 "/proj/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl_detach_top_node {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__sn_fl_te_node *texp;
        struct s__sn_fl_state_table *stt;
        struct s__l__sn_fl_var_scndry *top_actions;
        struct s__sn_fl_var_event *sample;
        t__bool single_clk;
        struct s__sn_fl_top_node *parent_top;
        t__int detach_id;
        t__uint offset;
} *t__sn_fl_detach_top_node;
#define d__sn_fl_detach_top_node 2142

/* line 54 "/proj/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl_bdd_add_on {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__sn_bdd *all_vars_not;
} *t__sn_fl_bdd_add_on;
#define d__sn_fl_bdd_add_on 2122

/* line 522 "/proj/specman/src/fl_struct.e"  From 'struct definition' */
typedef struct s__sn_fl_cache_top_node {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__sn_fl_te_node *texp;
        struct s__sn_fl_state_table *stt;
        struct s__l__sn_fl_var_scndry *top_actions;
        struct s__sn_fl_var_event *sample;
        t__bool single_clk;
        struct s__sn_fl_top_node *parent_top;
} *t__sn_fl_cache_top_node;
#define d__sn_fl_cache_top_node 2145

/* line 18 "/proj/specman/src/fl_debug.e"  From 'struct definition' */
typedef struct s__sn_te_debugger {
    t__int d__;
    t__int gen__;
        t__tdb_print_level print_level;
        t__uint breaks_uid;
        struct s__l__tdb_break_point *break_points;
        struct s__l__string *scratch;
        struct s__sn_hp_fsm_eval *hp_sig_fsm_eval;
        struct s__sn_hp_fsm_eval_opt_wait *hp_sig_fsm_eval_opt_wait;
} *t__sn_te_debugger;
#define d__sn_te_debugger 2219

/* line 67 "/proj/specman/src/fl_debug.e"  From 'struct definition' */
typedef struct s__tdb_break_point {
    t__int d__;
    t__int gen__;
        t__uint id;
        t__bool trace_only;
} *t__tdb_break_point;
#define d__tdb_break_point 2221

/* line 102 "/proj/specman/src/fl_debug.e"  From 'struct definition' */
typedef struct s__sn_hp_fsm_eval {
    t__int d__;
    t__int gen__;
        t__int te_id;
        struct s__te_memory *mem;
        struct s__base_struct *inst;
        t__imp_enum_sn_hp_fsm_eval__location location;
} *t__sn_hp_fsm_eval;
#define d__sn_hp_fsm_eval 2224

/* line 184 "/proj/specman/src/fl_debug.e"  From 'struct definition' */
typedef struct s__sn_hp_fsm_eval_opt_wait {
    t__int d__;
    t__int gen__;
        t__int te_id;
        struct s__te_memory *mem;
        struct s__base_struct *inst;
        t__imp_enum_sn_hp_fsm_eval__location location;
} *t__sn_hp_fsm_eval_opt_wait;
#define d__sn_hp_fsm_eval_opt_wait 2228

/* line 229 "/proj/specman/src/any_order_define.e"  From 'struct definition' */
typedef struct s__sn_define2_descriptor {
    t__int d__;
    t__int gen__;
        t__string name;
        struct s__k__def2_name_string__name *options;
        t__int opt_num;
} *t__sn_define2_descriptor;
#define d__sn_define2_descriptor 2293

/* line 225 "/proj/specman/src/any_order_define.e"  From 'struct definition' */
typedef struct s__def2_name_string {
    t__int d__;
    t__int gen__;
        t__string name;
        t__int place;
} *t__def2_name_string;
#define d__def2_name_string 2292

/* line 265 "/proj/specman/src/seamless_def.e"  From 'struct definition' */
typedef struct s__seamless {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__bool spi_trace;
        struct s__k__seamless_connection__tag *connections;
        struct s__sn_adapter_struct *adapter_struct;
        t__bool did_spi_init;
        t__external_pointer client_id;
        t__int num_models;
        t__external_pointer models;
        t__bool debug;
        t__bool trace;
} *t__seamless;
#define d__seamless 2301

/* line 348 "/proj/specman/src/seamless_def.e"  From 'struct definition' */
typedef struct s__seamless_connection {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string tag;
        t__string cpu;
        t__string addr_space;
        t__bool is_real;
        t__bool little_endian;
        t__bool connection_opened;
        t__external_pointer spi_id;
        struct s__k__sw_obj__descr *objs;
} *t__seamless_connection;
#define d__seamless_connection 2302

/* line 789 "/proj/specman/src/seamless_impl.e"  From 'struct definition' */
typedef struct s__sw_obj {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string descr;
        t__external_pointer addr;
        t__uint size;
        t__string full_descr;
        t__bool auto_addr_calc;
        t__bool was_accessed;
        struct s__seamless_connection *connection;
        struct s__l__bit *value;
        t__bool trace;
} *t__sw_obj;
#define d__sw_obj 2305

/* line 181 "/proj/specman/src/cvl_defs.e"  From 'struct definition' */
typedef struct s__cvl {
    t__int d__;
    t__int gen__;
        struct s__l__cvl_connection *cons;
        t__bool trace;
        t__bool data_trace;
        struct s__type_descriptor *cvl_connection_type;
        t__uint server_port;
        t__uint buffers_init_size;
        t__uint buffers_max_size;
        t__uint checksum;
        t__uint close_timeout;
        t__bool compatibility323;
        struct s__l__sn_checksum_t *cons_checksum;
        struct s__sn_socket_interactor *main_sock;
        t__bool user_set_trace;
        struct s__l__sn_cvl_method *all_cvl_methods;
        struct s__l__sn_cvl_method *all_cvl_callbacks;
        struct s__l__sn_cvl_method *all_stub_cvl_calls;
        struct s__l__sn_cvl_method *all_stub_cvl_methods;
        struct s__sn_cvl_method *first_method_with_arg_struct;
        t__uint next_id;
        struct s__l__string *cvl_structs;
} *t__cvl;
#define d__cvl 2315

/* line 51 "/proj/specman/src/cvl_defs.e"  From 'struct definition' */
typedef struct s__cvl_connection {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__int sn___connection_closed_occ_l;
        struct s__waiting_thread *sn___connection_closed_thread;
        struct s__sn_event_struct *sn___connection_closed_event_struct;
        t__int sn___connection_opened_occ_l;
        struct s__waiting_thread *sn___connection_opened_thread;
        struct s__sn_event_struct *sn___connection_opened_event_struct;
        t__string name;
        t__bool used;
        t__bool trace;
        t__bool data_trace;
        t__bool specman_initiate_close;
        t__sn_connection_type kind;
        t__bool need_to_resume_listening;
        t__test_phase connected_process_phase;
        t__uint server_port;
        t__string server_host;
        t__uint timeout;
        t__uint stack_ptr;
        struct s__l__queued_cvl_call *waiting_list;
        t__bool need_to_consume_event;
        struct s__sn_cvl_buffer *ib;
        struct s__sn_cvl_output_buffer *ob;
        t__int sn___quit_occ_l;
        struct s__sn_event_struct *sn___quit_event_struct;
        struct s__sn_socket_interactor *sock;
        t__sn_callmode_type previous_callmode;
        t__bool in_resync_context;
        struct s__any_struct *owner_struct;
} *t__cvl_connection;
#define d__cvl_connection 2312

/* line 170 "/proj/specman/src/cvl_defs.e"  From 'struct definition' */
typedef struct s__queued_cvl_call {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__int sn___lifo_occ_l;
        struct s__waiting_thread *sn___lifo_thread;
        struct s__sn_event_struct *sn___lifo_event_struct;
        t__int sn___quit_occ_l;
        struct s__sn_event_struct *sn___quit_event_struct;
} *t__queued_cvl_call;
#define d__queued_cvl_call 2314

/* line 272 "/proj/specman/src/cvl_defs.e"  From 'struct definition' */
typedef struct s__sn_cvl_buffer {
    t__int d__;
    t__int gen__;
        struct s__l__byte *buf;
        t__uint buf_start;
        t__uint buf_end;
        t__uint item_count;
        t__uint last_buffer_size;
} *t__sn_cvl_buffer;
#define d__sn_cvl_buffer 2319

/* line 350 "/proj/specman/src/cvl_defs.e"  From 'struct definition' */
typedef struct s__sn_cvl_output_buffer {
    t__int d__;
    t__int gen__;
        struct s__l__byte *buf;
        t__uint buf_start;
        t__uint buf_end;
        t__uint item_count;
        t__uint last_buffer_size;
} *t__sn_cvl_output_buffer;
#define d__sn_cvl_output_buffer 2320

/* line 26 "/proj/specman/src/cvl_socket_interactor.e"  From 'struct definition' */
typedef struct s__sn_socket_interactor {
    t__int d__;
    t__int gen__;
        t__external_pointer interactor___itr_struct;
        t__string description;
        t__bool debug;
        t__int socket_id;
        struct s__l__byte *buffer;
        t__int port;
        t__sn_con_state state;
} *t__sn_socket_interactor;
#define d__sn_socket_interactor 2323

/* line 261 "/proj/specman/src/cvl_defs.e"  From 'struct definition' */
typedef struct s__sn_checksum_t {
    t__int d__;
    t__int gen__;
        t__string struct_name;
        t__uint checksum;
} *t__sn_checksum_t;
#define d__sn_checksum_t 2318

/* line 24 "/proj/specman/src/cvl_statements.e"  From 'struct definition' */
typedef struct s__sn_cvl_method {
    t__int d__;
    t__int gen__;
        struct s__method *method;
        t__string method_name;
        t__uint id;
        t__string c_function_name;
        t__string target_struct;
        t__string c_args;
        t__string collect_all_arg_names;
        t__sn_cvl_method_type kind;
        t__sn_callmode_type calltype;
        t__string interface;
        t__string callback_named_event;
} *t__sn_cvl_method;
#define d__sn_cvl_method 2331

/* line 89 "/proj/specman/src/comm_all_req.e"  From 'struct definition' */
typedef struct s__sn_comm_api {
    t__int d__;
    t__int gen__;
        struct s__comm_all_in_requests *all_in_requests;
        struct s__comm_all_out_requests *all_out_requests;
        struct s__comm_all_in_notifications *all_in_notifications;
        struct s__comm_all_out_notifications *all_out_notifications;
} *t__sn_comm_api;
#define d__sn_comm_api 2366

/* line 7 "/proj/specman/src/comm_all_req.e"  From 'struct definition' */
typedef struct s__comm_all_in_requests {
    t__int d__;
    t__int gen__;
        struct s__comm_get_application_de17629 *get_application_desc_request;
        struct s__comm_general_in_request *general_in_request;
        struct s__icover_initialize_request *initialize_request;
        struct s__icover_get_dir_contents22608 *get_dir_contents_request;
        struct s__icover_read_cover_request *read_cover_request;
        struct s__icover_clear_cover_request *clear_cover_request;
        struct s__icover_get_initial_file22609 *get_initial_file_system_info_request;
        struct s__icover_get_cover_elemen22610 *get_cover_element_data_request;
        struct s__icover_get_item_type_request *get_item_type_request;
        struct s__icover_get_cover_tests_22611 *get_cover_tests_request;
        struct s__icover_get_contributed_22612 *get_contributed_tests_request;
        struct s__icover_report_request *report_request;
        struct s__icover_set_cover_config22613 *set_cover_config_request;
        struct s__icover_get_cover_config22614 *get_cover_config_request;
} *t__comm_all_in_requests;
#define d__comm_all_in_requests 2362

/* line 237 "/proj/specman/src/communication.e"  From 'struct definition' */
typedef struct s__comm_get_application_de17629 {
    t__int d__;
    t__int gen__;
        struct s__comm_abs_basic_reply *the_reply_obj;
        struct s__comm_request_status *the_status_obj;
        t__string app_name;
} *t__comm_get_application_desc_request;
#define d__comm_get_application_desc_request 2388

/* line 104 "/proj/specman/src/snorb/orb/snorb_general_messages.e"  From 'struct definition' */
typedef struct s__comm_general_in_request {
    t__int d__;
    t__int gen__;
        struct s__comm_abs_basic_reply *the_reply_obj;
        struct s__comm_request_status *the_status_obj;
        struct s__snorb_object_id *object_id;
        struct s__snorb_method_id *method_id;
        struct s__snorb_param_demarshaller *in_params;
} *t__comm_general_in_request;
#define d__comm_general_in_request 2511

/* line 16 "/proj/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__snorb_object_id {
    t__int d__;
    t__int gen__;
        t__int n_home_orb;
        t__int n_id;
        t__string p_s_hash_code;
        struct s__sn_string_hashable *p_string_hash_key;
} *t__snorb_object_id;
#define d__snorb_object_id 2471

/* line 489 "/proj/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__sn_string_hashable {
    t__int d__;
    t__int gen__;
        t__string p_s_hash_code;
} *t__sn_string_hashable;
#define d__sn_string_hashable 1041

/* line 209 "/proj/specman/src/snorb/orb/snorb_id.e"  From 'struct definition' */
typedef struct s__snorb_method_id {
    t__int d__;
    t__int gen__;
        t__string s_string;
} *t__snorb_method_id;
#define d__snorb_method_id 2505

/* line 71 "/proj/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__snorb_param_demarshaller {
    t__int d__;
    t__int gen__;
        struct s__comm_socket_interactor *input_stream;
} *t__snorb_param_demarshaller;
#define d__snorb_param_demarshaller 2481

/* line 377 "/proj/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__icover_initialize_request {
    t__int d__;
    t__int gen__;
        struct s__comm_abs_basic_reply *the_reply_obj;
        struct s__comm_request_status *the_status_obj;
} *t__icover_initialize_request;
#define d__icover_initialize_request 2781

/* line 59 "/proj/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__icover_get_dir_contents22608 {
    t__int d__;
    t__int gen__;
        struct s__comm_abs_basic_reply *the_reply_obj;
        struct s__comm_request_status *the_status_obj;
        t__string dir_path;
        t__string default_filter;
} *t__icover_get_dir_contents_request;
#define d__icover_get_dir_contents_request 2775

/* line 473 "/proj/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__icover_read_cover_request {
    t__int d__;
    t__int gen__;
        struct s__comm_abs_basic_reply *the_reply_obj;
        struct s__comm_request_status *the_status_obj;
        struct s__l__string *filenames;
} *t__icover_read_cover_request;
#define d__icover_read_cover_request 2783

/* line 575 "/proj/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__icover_clear_cover_request {
    t__int d__;
    t__int gen__;
        struct s__comm_abs_basic_reply *the_reply_obj;
        struct s__comm_request_status *the_status_obj;
} *t__icover_clear_cover_request;
#define d__icover_clear_cover_request 2785

/* line 314 "/proj/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__icover_get_initial_file22609 {
    t__int d__;
    t__int gen__;
        struct s__comm_abs_basic_reply *the_reply_obj;
        struct s__comm_request_status *the_status_obj;
} *t__icover_get_initial_file_system_info_request;
#define d__icover_get_initial_file_system_info_request 2779

/* line 643 "/proj/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__icover_get_cover_elemen22610 {
    t__int d__;
    t__int gen__;
        struct s__comm_abs_basic_reply *the_reply_obj;
        struct s__comm_request_status *the_status_obj;
        t__jcvr_pack_mode mode;
        struct s__icover_idpath *id_path;
} *t__icover_get_cover_element_data_request;
#define d__icover_get_cover_element_data_request 2787

/* line 27 "/proj/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__icover_idpath {
    t__int d__;
    t__int gen__;
        struct s__l__int *p_path;
} *t__icover_idpath;
#define d__icover_idpath 2774

/* line 718 "/proj/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__icover_get_item_type_request {
    t__int d__;
    t__int gen__;
        struct s__comm_abs_basic_reply *the_reply_obj;
        struct s__comm_request_status *the_status_obj;
        struct s__icover_idpath *id_path;
} *t__icover_get_item_type_request;
#define d__icover_get_item_type_request 2789

/* line 781 "/proj/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__icover_get_cover_tests_22611 {
    t__int d__;
    t__int gen__;
        struct s__comm_abs_basic_reply *the_reply_obj;
        struct s__comm_request_status *the_status_obj;
} *t__icover_get_cover_tests_request;
#define d__icover_get_cover_tests_request 2791

/* line 834 "/proj/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__icover_get_contributed_22612 {
    t__int d__;
    t__int gen__;
        struct s__comm_abs_basic_reply *the_reply_obj;
        struct s__comm_request_status *the_status_obj;
        struct s__icover_idpath *id_path;
} *t__icover_get_contributed_tests_request;
#define d__icover_get_contributed_tests_request 2793

/* line 907 "/proj/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__icover_report_request {
    t__int d__;
    t__int gen__;
        struct s__comm_abs_basic_reply *the_reply_obj;
        struct s__comm_request_status *the_status_obj;
        struct s__icover_idpath *id_path;
        t__string file_name;
        t__sn_cover_report_kind kind;
        t__show_mode filter;
        t__int tests;
} *t__icover_report_request;
#define d__icover_report_request 2795

/* line 987 "/proj/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__icover_set_cover_config22613 {
    t__int d__;
    t__int gen__;
        struct s__comm_abs_basic_reply *the_reply_obj;
        struct s__comm_request_status *the_status_obj;
        t__sn_cvr_grading_formula grade_type;
        t__int at_least_multiplier;
} *t__icover_set_cover_config_request;
#define d__icover_set_cover_config_request 2797

/* line 1086 "/proj/specman/src/icover_request.e"  From 'struct definition' */
typedef struct s__icover_get_cover_config22614 {
    t__int d__;
    t__int gen__;
        struct s__comm_abs_basic_reply *the_reply_obj;
        struct s__comm_request_status *the_status_obj;
} *t__icover_get_cover_config_request;
#define d__icover_get_cover_config_request 2799

/* line 28 "/proj/specman/src/comm_all_req.e"  From 'struct definition' */
typedef struct s__comm_all_out_requests {
    t__int d__;
    t__int gen__;
        struct s__comm_general_out_request *general_out_request;
} *t__comm_all_out_requests;
#define d__comm_all_out_requests 2363

/* line 117 "/proj/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__comm_general_out_request {
    t__int d__;
    t__int gen__;
        struct s__comm_abs_basic_reply *the_reply_obj;
        struct s__comm_request_status *the_status_obj;
        t__comm_request_opcode opcode;
        struct s__snorb_object_id *object_id;
        struct s__snorb_method_id *method_id;
        struct s__snorb_param_marshaller *request_params;
        struct s__comm_general_in_reply *general_reply;
} *t__comm_general_out_request;
#define d__comm_general_out_request 2501

/* line 66 "/proj/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__snorb_param_marshaller {
    t__int d__;
    t__int gen__;
        struct s__l__comm_pack_unpackable *params;
} *t__snorb_param_marshaller;
#define d__snorb_param_marshaller 2480

/* line 299 "/proj/specman/src/snorb/orb/snorb_general_messages.e"  From 'struct definition' */
typedef struct s__comm_general_in_reply {
    t__int d__;
    t__int gen__;
        struct s__snorb_param_demarshaller *returned_params;
        struct s__struct_descriptor *demarshaller_sd;
} *t__comm_general_in_reply;
#define d__comm_general_in_reply 2512

/* line 49 "/proj/specman/src/comm_all_req.e"  From 'struct definition' */
typedef struct s__comm_all_in_notifications {
    t__int d__;
    t__int gen__;
        struct s__comm_general_in_notification *general_in_notification;
        struct s__sn_cancel_wakeup_in_not34683 *cancel_wakeup_in_notification;
} *t__comm_all_in_notifications;
#define d__comm_all_in_notifications 2364

/* line 339 "/proj/specman/src/snorb/orb/snorb_general_messages.e"  From 'struct definition' */
typedef struct s__comm_general_in_notification {
    t__int d__;
    t__int gen__;
        struct s__snorb_object_id *object_id;
        struct s__snorb_method_id *method_id;
        struct s__snorb_param_demarshaller *in_params;
} *t__comm_general_in_notification;
#define d__comm_general_in_notification 2513

/* line 62 "/proj/specman/src/japp/jspecview_deli/jspecview_wakeup.e"  From 'struct definition' */
typedef struct s__sn_cancel_wakeup_in_not34683 {
    t__int d__;
    t__int gen__;
} *t__sn_cancel_wakeup_in_notification;
#define d__sn_cancel_wakeup_in_notification 3089

/* line 69 "/proj/specman/src/comm_all_req.e"  From 'struct definition' */
typedef struct s__comm_all_out_notifications {
    t__int d__;
    t__int gen__;
        struct s__comm_general_out_notifi19725 *general_out_notification;
} *t__comm_all_out_notifications;
#define d__comm_all_out_notifications 2365

/* line 399 "/proj/specman/src/snorb/orb/snorb_general_messages.e"  From 'struct definition' */
typedef struct s__comm_general_out_notifi19725 {
    t__int d__;
    t__int gen__;
        t__comm_request_opcode opcode;
        struct s__snorb_object_id *object_id;
        struct s__snorb_method_id *method_id;
        struct s__snorb_param_marshaller *request_params;
} *t__comm_general_out_notification;
#define d__comm_general_out_notification 2514

/* line 23 "/proj/specman/src/snorb/edl/edl_parser.e"  From 'struct definition' */
typedef struct s__sn_edl_parser {
    t__int d__;
    t__int gen__;
        struct s__k__sn_edl_struct_info__p_td *all_structs;
        struct s__k__string__it *loaded_gen_structs_registry;
} *t__sn_edl_parser;
#define d__sn_edl_parser 2403

/* line 241 "/proj/specman/src/snorb/edl/edl_parser.e"  From 'struct definition' */
typedef struct s__sn_edl_struct_info {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *p_td;
        struct s__struct_descriptor *p_sd_base;
        t__bool p_f_enum;
        t__bool p_f_interface;
        t__bool p_f_exported;
        t__string p_s_package;
        t__string p_s_e_parallel_struct;
        t__string p_s_j_parallel_struct;
        t__string p_s_is_abstract;
        t__string p_s_java_ext;
        struct s__k__sn_edl_method_info__18151 *all_methods;
        struct s__k__sn_edl_const_info__p18152 *all_consts;
} *t__sn_edl_struct_info;
#define d__sn_edl_struct_info 2405

/* line 365 "/proj/specman/src/snorb/edl/edl_parser.e"  From 'struct definition' */
typedef struct s__sn_edl_method_info {
    t__int d__;
    t__int gen__;
        struct s__method *p_method;
        t__bool p_f_async;
        t__bool p_f_notifier;
} *t__sn_edl_method_info;
#define d__sn_edl_method_info 2409

/* line 353 "/proj/specman/src/snorb/edl/edl_parser.e"  From 'struct definition' */
typedef struct s__sn_edl_const_info {
    t__int d__;
    t__int gen__;
        t__string p_s_name;
        t__string p_s_type;
        t__string p_s_value;
} *t__sn_edl_const_info;
#define d__sn_edl_const_info 2408

/* line 104 "/proj/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__sn_edl_code_generator {
    t__int d__;
    t__int gen__;
} *t__sn_edl_code_generator;
#define d__sn_edl_code_generator 2416

/* line 316 "/proj/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__EDLGlobal {
    t__int d__;
    t__int gen__;
        struct s__EDLRoot *p_edl_root;
        struct s__EDLUtils *p_edl_utils;
        struct s__BasicTypesManager *p_primitive_types_manager;
        t__bool initialized;
        struct s__EDLGenerator *p_edl_generator;
} *t__EDLGlobal;
#define d__EDLGlobal 2419

/* line 385 "/proj/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__EDLRoot {
    t__int d__;
    t__int gen__;
        struct s__l__EDLPackage *p_list_of_packages;
} *t__EDLRoot;
#define d__EDLRoot 2423

/* line 467 "/proj/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__EDLPackage {
    t__int d__;
    t__int gen__;
        t__string p_s_name;
        struct s__l__EDLAbsUserType *p_list_of_user_types;
} *t__EDLPackage;
#define d__EDLPackage 2425

/* line 727 "/proj/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__EDLAbsUserType {
    t__int d__;
    t__int gen__;
        t__typeKind p_kind;
        struct s__EDLPackage *p_package;
        struct s__k__EDLAbsUserType__it *list_of_related_user_types;
        struct s__EDLBaseStruct *p_base_struct;
        struct s__sn_edl_struct_info *p_struct_info;
        t__bool p_gen_it;
} *t__EDLAbsUserType;
#define d__EDLAbsUserType 2432

/* line 1420 "/proj/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__EDLBaseStruct {
    t__int d__;
    t__int gen__;
        struct s__EDLAbsType *p_type;
        t__bool p_f_list;
        struct s__EDLAbsUserType *p_original_struct;
} *t__EDLBaseStruct;
#define d__EDLBaseStruct 2443

/* line 655 "/proj/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__EDLAbsType {
    t__int d__;
    t__int gen__;
        t__typeKind p_kind;
} *t__EDLAbsType;
#define d__EDLAbsType 2428

/* line 230 "/proj/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__EDLUtils {
    t__int d__;
    t__int gen__;
} *t__EDLUtils;
#define d__EDLUtils 2418

/* line 1880 "/proj/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__BasicTypesManager {
    t__int d__;
    t__int gen__;
        struct s__l__EDLAbsBasicType *p_list_of_basic_types;
} *t__BasicTypesManager;
#define d__BasicTypesManager 2451

/* line 674 "/proj/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__EDLAbsBasicType {
    t__int d__;
    t__int gen__;
        t__typeKind p_kind;
        struct s__type_descriptor *p_td;
} *t__EDLAbsBasicType;
#define d__EDLAbsBasicType 2429

/* line 328 "/proj/specman/src/snorb/edl/edl_generate.e"  From 'struct definition' */
typedef struct s__EDLGenerator {
    t__int d__;
    t__int gen__;
        t__EDLLanguage LANGUAGE;
        t__string HOME_DIR;
        t__string TOP_NAME;
        t__string DEFAULT_E_HOME_DIR;
        t__string DEFAULT_JAVA_HOME_DIR;
} *t__EDLGenerator;
#define d__EDLGenerator 2420

/* line 29 "/proj/specman/src/snorb/orb/snorb.e"  From 'struct definition' */
typedef struct s__snorb {
    t__int d__;
    t__int gen__;
        struct s__snorb_all_descriptors *descriptor;
        struct s__snorb_all_flags *flags;
        struct s__snorb_data_helper *data_helper;
        struct s__snorb_object_helper *obj_helper;
        struct s__snorb_sender *sender;
        struct s__snorb_receiver *receiver;
        struct s__snorb_service_repository *p_service_repository;
        struct s__snorb_service_finder *p_service_finder_default;
} *t__snorb;
#define d__snorb 2502

/* line 111 "/proj/specman/src/snorb/orb/snorb.e"  From 'struct definition' */
typedef struct s__snorb_all_descriptors {
    t__int d__;
    t__int gen__;
        struct s__sni_service_repository_19726 *sni_service_repository;
        struct s__sn_object_id_data_descriptor *sn_object_id_data;
        struct s__sn_jcvr_id_path_descriptor *sn_jcvr_id_path;
        struct s__sn_jcvr_cross_interval_22615 *sn_jcvr_cross_interval;
        struct s__sni_jcvr_change_listene22616 *sni_jcvr_change_listener;
        struct s__sni_jcvr_service_descriptor *sni_jcvr_service;
        struct s__sni_jcvrgui_service_des22617 *sni_jcvrgui_service;
        struct s__show_mode_descriptor *show_mode;
        struct s__sni_specman_command_des29188 *sni_specman_command;
        struct s__sn_specman_status_descriptor *sn_specman_status;
        struct s__sni_specview_service_de29189 *sni_specview_service;
        struct s__sn_font_data_descriptor *sn_font_data;
        struct s__sn_color_data_descriptor *sn_color_data;
        struct s__sn_gui_resources_descriptor *sn_gui_resources;
        struct s__sn_specview_socket_data29190 *sn_specview_socket_data;
        struct s__sni_remote_appl_manager29191 *sni_remote_appl_manager;
        struct s__sni_remote_appl_descriptor *sni_remote_appl;
        struct s__sni_jspecview_service_d34684 *sni_jspecview_service;
        struct s__sni_e_jcvr_external_ser34685 *sni_e_jcvr_external_service;
        struct s__sn_jcvr_external_proper34686 *sn_jcvr_external_properties;
        struct s__sn_jcvr_external_descriptor *sn_jcvr_external;
        struct s__sni_e_jutils_service_de34687 *sni_e_jutils_service;
        struct s__sn_source_ref_descriptor *sn_source_ref;
        struct s__sn_source_descriptor *sn_source;
        struct s__sn_module_descriptor *sn_module;
        struct s__sn_file_descriptor *sn_file;
        struct s__sn_e_file_descriptor *sn_e_file;
        struct s__file_status_descriptor *file_status;
        struct s__sni_jsource_viewer_serv34688 *sni_jsource_viewer_service;
        struct s__sni_jconfig_service_des34689 *sni_jconfig_service;
        struct s__sni_econfig_service_des34690 *sni_econfig_service;
        struct s__sn_jconfig_data_descriptor *sn_jconfig_data;
        struct s__sn_jconfig_category_val34691 *sn_jconfig_category_val;
        struct s__sn_jconfig_item_val_des34692 *sn_jconfig_item_val;
        struct s__sni_jmini_guitest_servi34693 *sni_jmini_guitest_service;
        struct s__sn_abs_val_identifier_d34694 *sn_abs_val_identifier;
        struct s__sn_val_ref_descriptor *sn_val_ref;
        struct s__sn_scalar_val_ref_descriptor *sn_scalar_val_ref;
        struct s__sn_abs_val_descriptor *sn_abs_val;
        struct s__sn_abs_scalar_val_descriptor *sn_abs_scalar_val;
        struct s__sn_event_val_descriptor *sn_event_val;
        struct s__sn_abs_container_val_de34695 *sn_abs_container_val;
        struct s__sn_list_val_descriptor *sn_list_val;
        struct s__sn_instance_val_descriptor *sn_instance_val;
        struct s__sn_instance_null_val_de34696 *sn_instance_null_val;
        struct s__sn_string_val_descriptor *sn_string_val;
        struct s__sn_specman_special_type34697 *sn_specman_special_type_val;
        struct s__sn_specman_special_type34698 *sn_specman_special_type_val_group;
        struct s__sn_int_val_descriptor *sn_int_val;
        struct s__sn_uint_val_descriptor *sn_uint_val;
        struct s__sn_bool_val_descriptor *sn_bool_val;
        struct s__sn_sized_int_val_descriptor *sn_sized_int_val;
        struct s__sn_enum_val_descriptor *sn_enum_val;
        struct s__sn_abs_structual_segmen34699 *sn_abs_structual_segment;
        struct s__sn_abs_extension_descriptor *sn_abs_extension;
        struct s__sn_abs_descriptor_descriptor *sn_abs_descriptor;
        struct s__sn_type_descriptor_desc34700 *sn_type_descriptor;
        struct s__sn_scalar_descriptor_de34701 *sn_scalar_descriptor;
        struct s__sn_enum_extension_descr34702 *sn_enum_extension_descriptor;
        struct s__sn_enum_descriptor_desc34703 *sn_enum_descriptor;
        struct s__sn_list_descriptor_desc34704 *sn_list_descriptor;
        struct s__sn_struct_descriptor_de34705 *sn_struct_descriptor;
        struct s__sn_unit_descriptor_desc34706 *sn_unit_descriptor;
        struct s__sn_struct_storage_descriptor *sn_struct_storage;
        struct s__sn_struct_storage_detai34707 *sn_struct_storage_details;
        struct s__sn_struct_member_descri34708 *sn_struct_member_descriptor;
        struct s__sn_field_descriptor_des34709 *sn_field_descriptor;
        struct s__sn_method_extension_des34710 *sn_method_extension_descriptor;
        struct s__sn_event_descriptor_des34711 *sn_event_descriptor;
        struct s__sn_method_descriptor_de34712 *sn_method_descriptor;
        struct s__sn_tcm_descriptor_descriptor *sn_tcm_descriptor;
        struct s__sn_on_descriptor_descriptor *sn_on_descriptor;
        struct s__sn_constraint_descripto34713 *sn_constraint_descriptor;
        struct s__sn_type_update_descriptor *sn_type_update;
        struct s__sn_struct_storage_updat34714 *sn_struct_storage_update;
        struct s__sn_enum_update_descriptor *sn_enum_update;
        struct s__gen_status_descriptor *gen_status;
        struct s__method_kind_descriptor *method_kind;
        struct s__sn_event_kind_descriptor *sn_event_kind;
        struct s__sni_jdatabrowser_servic34715 *sni_jdatabrowser_service;
        struct s__sni_edatabrowser_servic34716 *sni_edatabrowser_service;
        struct s__sn_masked_val_descriptor *sn_masked_val;
        struct s__e_val_change_descriptor *e_val_change;
        struct s__e_root_refresh_result_d34717 *e_root_refresh_result;
        struct s__sn_root_di_info_descriptor *sn_root_di_info;
        struct s__change_type_descriptor *change_type;
        struct s__sn_exp_descriptor *sn_exp;
        struct s__sn_declared_exp_descriptor *sn_declared_exp;
        struct s__sni_jvt_service_descriptor *sni_jvt_service;
        struct s__sni_evt_service_descriptor *sni_evt_service;
        struct s__sni_vt_jwindow_descriptor *sni_vt_jwindow;
        struct s__sni_vtw_callback_handle34718 *sni_vtw_callback_handler;
        struct s__sn_vt_menubar_descriptor *sn_vt_menubar;
        struct s__sn_vt_menu_descriptor *sn_vt_menu;
        struct s__sn_vt_toolbar_descriptor *sn_vt_toolbar;
        struct s__sn_vt_action_descriptor *sn_vt_action;
        struct s__vt_window_properties_de34719 *vt_window_properties;
        struct s__vt_window_actions_descriptor *vt_window_actions;
        struct s__sn_pair_nums_descriptor *sn_pair_nums;
        struct s__sn_pair_strings_descriptor *sn_pair_strings;
        struct s__sn_abs_key_descriptor *sn_abs_key;
        struct s__sn_event_parameter_key_42210 *sn_event_parameter_key;
        struct s__sn_event_key_descriptor *sn_event_key;
        struct s__sn_gendb_item_in_gen_ke42211 *sn_gendb_item_in_gen_key;
        struct s__sn_gendb_list_temp_key_42212 *sn_gendb_list_temp_key;
        struct s__sn_instanciated_field_k42213 *sn_instanciated_field_key;
        struct s__sn_instanciated_list_it42214 *sn_instanciated_list_item_key;
        struct s__sn_role_info_key_descriptor *sn_role_info_key;
        struct s__item_in_gen_kind_descriptor *item_in_gen_kind;
        struct s__abs_range_props_descriptor *abs_range_props;
        struct s__regular_range_props_des42215 *regular_range_props;
        struct s__bit_range_props_descriptor *bit_range_props;
        struct s__list_range_props_descriptor *list_range_props;
        struct s__sni_egendebugger_servic42216 *sni_egendebugger_service;
        struct s__sni_jgendebugger_servic42217 *sni_jgendebugger_service;
        struct s__sn_gen_event_props_desc42218 *sn_gen_event_props;
        struct s__sn_set_value_event_prop42219 *sn_set_value_event_props;
        struct s__sn_set_scalar_event_pro42220 *sn_set_scalar_event_props;
        struct s__sn_set_struct_event_pro42221 *sn_set_struct_event_props;
        struct s__sn_set_list_event_props42222 *sn_set_list_event_props;
        struct s__sn_gen_root_event_props42223 *sn_gen_root_event_props;
        struct s__sn_gen_root_event_props42224 *sn_gen_root_event_props_flags;
        struct s__sn_start_gen_event_prop42225 *sn_start_gen_event_props;
        struct s__sn_gen_struct_event_pro42226 *sn_gen_struct_event_props;
        struct s__sn_gen_list_event_props42227 *sn_gen_list_event_props;
        struct s__sn_end_event_props_desc42228 *sn_end_event_props;
        struct s__sn_end_gen_event_props_42229 *sn_end_gen_event_props;
        struct s__sn_end_struct_event_pro42230 *sn_end_struct_event_props;
        struct s__sn_end_list_event_props42231 *sn_end_list_event_props;
        struct s__sn_testing_event_props_42232 *sn_testing_event_props;
        struct s__sn_constraint_testing_e42233 *sn_constraint_testing_event_props;
        struct s__sn_dynamic_reduction_ev42234 *sn_dynamic_reduction_event_props;
        struct s__sn_static_reduction_eve42235 *sn_static_reduction_event_props;
        struct s__sn_soft_testing_event_p42236 *sn_soft_testing_event_props;
        struct s__sn_soft_reduction_event42237 *sn_soft_reduction_event_props;
        struct s__sn_reset_soft_event_pro42238 *sn_reset_soft_event_props;
        struct s__sn_set_status_event_pro42239 *sn_set_status_event_props;
        struct s__sn_create_edge_event_pr42240 *sn_create_edge_event_props;
        struct s__sn_dynamic_edge_event_p42241 *sn_dynamic_edge_event_props;
        struct s__sn_start_collect_event_42242 *sn_start_collect_event_props;
        struct s__sn_stop_collect_event_p42243 *sn_stop_collect_event_props;
        struct s__sn_instanciated_field_p42244 *sn_instanciated_field_props;
        struct s__sn_instanciated_list_pr42245 *sn_instanciated_list_props;
        struct s__sn_instanciated_list_it42246 *sn_instanciated_list_item_props;
        struct s__sn_role_info_props_desc42247 *sn_role_info_props;
        struct s__gendb_item_in_gen_props42248 *gendb_item_in_gen_props;
        struct s__gendb_field_in_role_pro42249 *gendb_field_in_role_props;
        struct s__gendb_list_in_role_prop42250 *gendb_list_in_role_props;
        struct s__gendb_field_in_gen_prop42251 *gendb_field_in_gen_props;
        struct s__gendb_list_item_in_gen_42252 *gendb_list_item_in_gen_props;
        struct s__gendb_gc_in_role_props_42253 *gendb_gc_in_role_props;
        struct s__gendb_ci_in_gen_props_d42254 *gendb_ci_in_gen_props;
        struct s__gendb_item_props_descriptor *gendb_item_props;
        struct s__constant_gendb_item_pro42255 *constant_gendb_item_props;
        struct s__simple_local_gendb_item42256 *simple_local_gendb_item_props;
        struct s__static_gendb_item_props42257 *static_gendb_item_props;
        struct s__changed_static_gendb_it42258 *changed_static_gendb_item_props;
        struct s__held_gendb_item_props_d42259 *held_gendb_item_props;
        struct s__me_gendb_item_props_des42260 *me_gendb_item_props;
        struct s__fix_me_gendb_item_props42261 *fix_me_gendb_item_props;
        struct s__not_fix_me_gendb_item_p42262 *not_fix_me_gendb_item_props;
        struct s__changed_gendb_item_prop42263 *changed_gendb_item_props;
        struct s__sn_arrow_props_descriptor *sn_arrow_props;
        struct s__abs_query_result_props_42264 *abs_query_result_props;
        struct s__history_result_props_de42265 *history_result_props;
        struct s__reason_result_props_des42266 *reason_result_props;
        struct s__closure_result_props_de42267 *closure_result_props;
        struct s__effect_result_props_des42268 *effect_result_props;
        struct s__abs_ci_status_props_des42269 *abs_ci_status_props;
        struct s__sn_ci_status_unchanged_42270 *sn_ci_status_unchanged_props;
        struct s__sn_ci_status_changed_pr42271 *sn_ci_status_changed_props;
        struct s__sn_status_result_kinds_42272 *sn_status_result_kinds;
} *t__snorb_all_descriptors;
#define d__snorb_all_descriptors 2503

/* line 15 "/proj/specman/src/snorb/orb/services/gencode/sni_service_repository_declare.e"  From 'struct definition' */
typedef struct s__sni_service_repository_19726 {
    t__int d__;
    t__int gen__;
} *t__sni_service_repository_descriptor;
#define d__sni_service_repository_descriptor 2521

/* line 15 "/proj/specman/src/snorb/orb/services/gencode/sn_object_id_data_declare.e"  From 'struct definition' */
typedef struct s__sn_object_id_data_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_object_id_data_descriptor;
#define d__sn_object_id_data_descriptor 2522

/* line 15 "/proj/specman/src/japp/jcvr/gencode/sn_jcvr_id_path_declare.e"  From 'struct definition' */
typedef struct s__sn_jcvr_id_path_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_jcvr_id_path_descriptor;
#define d__sn_jcvr_id_path_descriptor 2758

/* line 15 "/proj/specman/src/japp/jcvr/gencode/sn_jcvr_cross_interval_declare.e"  From 'struct definition' */
typedef struct s__sn_jcvr_cross_interval_22615 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_jcvr_cross_interval_descriptor;
#define d__sn_jcvr_cross_interval_descriptor 2759

/* line 15 "/proj/specman/src/japp/jcvr/gencode/sni_jcvr_change_listener_declare.e"  From 'struct definition' */
typedef struct s__sni_jcvr_change_listene22616 {
    t__int d__;
    t__int gen__;
} *t__sni_jcvr_change_listener_descriptor;
#define d__sni_jcvr_change_listener_descriptor 2760

/* line 15 "/proj/specman/src/japp/jcvr/gencode/sni_jcvr_service_declare.e"  From 'struct definition' */
typedef struct s__sni_jcvr_service_descriptor {
    t__int d__;
    t__int gen__;
} *t__sni_jcvr_service_descriptor;
#define d__sni_jcvr_service_descriptor 2761

/* line 15 "/proj/specman/src/japp/jcvr/gencode/sni_jcvrgui_service_declare.e"  From 'struct definition' */
typedef struct s__sni_jcvrgui_service_des22617 {
    t__int d__;
    t__int gen__;
} *t__sni_jcvrgui_service_descriptor;
#define d__sni_jcvrgui_service_descriptor 2762

/* line 15 "/proj/specman/src/japp/jcvr/gencode/show_mode_declare.e"  From 'struct definition' */
typedef struct s__show_mode_descriptor {
    t__int d__;
    t__int gen__;
} *t__show_mode_descriptor;
#define d__show_mode_descriptor 2763

/* line 14 "/proj/specman/src/snorb/pub_services/sni_specman_command/gencode/sni_specman_command_declare.e"  From 'struct definition' */
typedef struct s__sni_specman_command_des29188 {
    t__int d__;
    t__int gen__;
} *t__sni_specman_command_descriptor;
#define d__sni_specman_command_descriptor 2956

/* line 14 "/proj/specman/src/snorb/pub_services/sni_specman_command/gencode/sn_specman_status_declare.e"  From 'struct definition' */
typedef struct s__sn_specman_status_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_specman_status_descriptor;
#define d__sn_specman_status_descriptor 2957

/* line 15 "/proj/specman/src/snorb/pub_services/sni_specview_service/gencode/sni_specview_service_declare.e"  From 'struct definition' */
typedef struct s__sni_specview_service_de29189 {
    t__int d__;
    t__int gen__;
} *t__sni_specview_service_descriptor;
#define d__sni_specview_service_descriptor 2967

/* line 15 "/proj/specman/src/snorb/pub_services/sni_specview_service/gencode/sn_font_data_declare.e"  From 'struct definition' */
typedef struct s__sn_font_data_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_font_data_descriptor;
#define d__sn_font_data_descriptor 2968

/* line 15 "/proj/specman/src/snorb/pub_services/sni_specview_service/gencode/sn_color_data_declare.e"  From 'struct definition' */
typedef struct s__sn_color_data_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_color_data_descriptor;
#define d__sn_color_data_descriptor 2969

/* line 15 "/proj/specman/src/snorb/pub_services/sni_specview_service/gencode/sn_gui_resources_declare.e"  From 'struct definition' */
typedef struct s__sn_gui_resources_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_gui_resources_descriptor;
#define d__sn_gui_resources_descriptor 2970

/* line 15 "/proj/specman/src/snorb/pub_services/sni_specview_service/gencode/sn_specview_socket_data_declare.e"  From 'struct definition' */
typedef struct s__sn_specview_socket_data29190 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_specview_socket_data_descriptor;
#define d__sn_specview_socket_data_descriptor 2971

/* line 15 "/proj/specman/src/snorb/pub_services/sni_remote_appl_manager/gencode/sni_remote_appl_manager_declare.e"  From 'struct definition' */
typedef struct s__sni_remote_appl_manager29191 {
    t__int d__;
    t__int gen__;
} *t__sni_remote_appl_manager_descriptor;
#define d__sni_remote_appl_manager_descriptor 2985

/* line 15 "/proj/specman/src/snorb/pub_services/sni_remote_appl_manager/gencode/sni_remote_appl_declare.e"  From 'struct definition' */
typedef struct s__sni_remote_appl_descriptor {
    t__int d__;
    t__int gen__;
} *t__sni_remote_appl_descriptor;
#define d__sni_remote_appl_descriptor 2986

/* line 15 "/proj/specman/src/japp/jspecview_deli/gencode/sni_jspecview_service_declare.e"  From 'struct definition' */
typedef struct s__sni_jspecview_service_d34684 {
    t__int d__;
    t__int gen__;
} *t__sni_jspecview_service_descriptor;
#define d__sni_jspecview_service_descriptor 3084

/* line 15 "/proj/specman/src/japp/jcvr/gencode/sni_e_jcvr_external_service_declare.e"  From 'struct definition' */
typedef struct s__sni_e_jcvr_external_ser34685 {
    t__int d__;
    t__int gen__;
} *t__sni_e_jcvr_external_service_descriptor;
#define d__sni_e_jcvr_external_service_descriptor 3099

/* line 15 "/proj/specman/src/japp/jcvr/gencode/sn_jcvr_external_properties_declare.e"  From 'struct definition' */
typedef struct s__sn_jcvr_external_proper34686 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_jcvr_external_properties_descriptor;
#define d__sn_jcvr_external_properties_descriptor 3100

/* line 15 "/proj/specman/src/japp/jcvr/gencode/sn_jcvr_external_declare.e"  From 'struct definition' */
typedef struct s__sn_jcvr_external_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_jcvr_external_descriptor;
#define d__sn_jcvr_external_descriptor 3101

/* line 15 "/proj/specman/src/japp/jutils/gencode/sni_e_jutils_service_declare.e"  From 'struct definition' */
typedef struct s__sni_e_jutils_service_de34687 {
    t__int d__;
    t__int gen__;
} *t__sni_e_jutils_service_descriptor;
#define d__sni_e_jutils_service_descriptor 3114

/* line 15 "/proj/specman/src/japp/jutils/gencode/sn_source_ref_declare.e"  From 'struct definition' */
typedef struct s__sn_source_ref_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_source_ref_descriptor;
#define d__sn_source_ref_descriptor 3115

/* line 15 "/proj/specman/src/japp/jutils/gencode/sn_source_declare.e"  From 'struct definition' */
typedef struct s__sn_source_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_source_descriptor;
#define d__sn_source_descriptor 3116

/* line 15 "/proj/specman/src/japp/jutils/gencode/sn_module_declare.e"  From 'struct definition' */
typedef struct s__sn_module_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_module_descriptor;
#define d__sn_module_descriptor 3117

/* line 15 "/proj/specman/src/japp/jutils/gencode/sn_file_declare.e"  From 'struct definition' */
typedef struct s__sn_file_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_file_descriptor;
#define d__sn_file_descriptor 3118

/* line 15 "/proj/specman/src/japp/jutils/gencode/sn_e_file_declare.e"  From 'struct definition' */
typedef struct s__sn_e_file_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_e_file_descriptor;
#define d__sn_e_file_descriptor 3119

/* line 15 "/proj/specman/src/japp/jutils/gencode/file_status_declare.e"  From 'struct definition' */
typedef struct s__file_status_descriptor {
    t__int d__;
    t__int gen__;
} *t__file_status_descriptor;
#define d__file_status_descriptor 3120

/* line 15 "/proj/specman/src/japp/jsource_viewer/gencode/sni_jsource_viewer_service_declare.e"  From 'struct definition' */
typedef struct s__sni_jsource_viewer_serv34688 {
    t__int d__;
    t__int gen__;
} *t__sni_jsource_viewer_service_descriptor;
#define d__sni_jsource_viewer_service_descriptor 3131

/* line 15 "/proj/specman/src/japp/jconfig/gencode/sni_jconfig_service_declare.e"  From 'struct definition' */
typedef struct s__sni_jconfig_service_des34689 {
    t__int d__;
    t__int gen__;
} *t__sni_jconfig_service_descriptor;
#define d__sni_jconfig_service_descriptor 3145

/* line 15 "/proj/specman/src/japp/jconfig/gencode/sni_econfig_service_declare.e"  From 'struct definition' */
typedef struct s__sni_econfig_service_des34690 {
    t__int d__;
    t__int gen__;
} *t__sni_econfig_service_descriptor;
#define d__sni_econfig_service_descriptor 3146

/* line 15 "/proj/specman/src/japp/jconfig/gencode/sn_jconfig_data_declare.e"  From 'struct definition' */
typedef struct s__sn_jconfig_data_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_jconfig_data_descriptor;
#define d__sn_jconfig_data_descriptor 3147

/* line 15 "/proj/specman/src/japp/jconfig/gencode/sn_jconfig_category_val_declare.e"  From 'struct definition' */
typedef struct s__sn_jconfig_category_val34691 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_jconfig_category_val_descriptor;
#define d__sn_jconfig_category_val_descriptor 3148

/* line 15 "/proj/specman/src/japp/jconfig/gencode/sn_jconfig_item_val_declare.e"  From 'struct definition' */
typedef struct s__sn_jconfig_item_val_des34692 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_jconfig_item_val_descriptor;
#define d__sn_jconfig_item_val_descriptor 3149

/* line 14 "/proj/specman/src/japp/mini_guitest/gencode/sni_jmini_guitest_service_declare.e"  From 'struct definition' */
typedef struct s__sni_jmini_guitest_servi34693 {
    t__int d__;
    t__int gen__;
} *t__sni_jmini_guitest_service_descriptor;
#define d__sni_jmini_guitest_service_descriptor 3164

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_abs_val_identifier_declare.e"  From 'struct definition' */
typedef struct s__sn_abs_val_identifier_d34694 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_abs_val_identifier_descriptor;
#define d__sn_abs_val_identifier_descriptor 3240

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_val_ref_declare.e"  From 'struct definition' */
typedef struct s__sn_val_ref_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_val_ref_descriptor;
#define d__sn_val_ref_descriptor 3241

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_scalar_val_ref_declare.e"  From 'struct definition' */
typedef struct s__sn_scalar_val_ref_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_scalar_val_ref_descriptor;
#define d__sn_scalar_val_ref_descriptor 3242

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_abs_val_declare.e"  From 'struct definition' */
typedef struct s__sn_abs_val_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_abs_val_descriptor;
#define d__sn_abs_val_descriptor 3243

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_abs_scalar_val_declare.e"  From 'struct definition' */
typedef struct s__sn_abs_scalar_val_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_abs_scalar_val_descriptor;
#define d__sn_abs_scalar_val_descriptor 3244

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_event_val_declare.e"  From 'struct definition' */
typedef struct s__sn_event_val_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_event_val_descriptor;
#define d__sn_event_val_descriptor 3245

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_abs_container_val_declare.e"  From 'struct definition' */
typedef struct s__sn_abs_container_val_de34695 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_abs_container_val_descriptor;
#define d__sn_abs_container_val_descriptor 3246

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_list_val_declare.e"  From 'struct definition' */
typedef struct s__sn_list_val_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_list_val_descriptor;
#define d__sn_list_val_descriptor 3247

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_instance_val_declare.e"  From 'struct definition' */
typedef struct s__sn_instance_val_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_instance_val_descriptor;
#define d__sn_instance_val_descriptor 3248

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_instance_null_val_declare.e"  From 'struct definition' */
typedef struct s__sn_instance_null_val_de34696 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_instance_null_val_descriptor;
#define d__sn_instance_null_val_descriptor 3249

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_string_val_declare.e"  From 'struct definition' */
typedef struct s__sn_string_val_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_string_val_descriptor;
#define d__sn_string_val_descriptor 3250

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_specman_special_type_val_declare.e"  From 'struct definition' */
typedef struct s__sn_specman_special_type34697 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_specman_special_type_val_descriptor;
#define d__sn_specman_special_type_val_descriptor 3251

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_specman_special_type_val_group_declare.e"  From 'struct definition' */
typedef struct s__sn_specman_special_type34698 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_specman_special_type_val_group_descriptor;
#define d__sn_specman_special_type_val_group_descriptor 3252

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_int_val_declare.e"  From 'struct definition' */
typedef struct s__sn_int_val_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_int_val_descriptor;
#define d__sn_int_val_descriptor 3253

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_uint_val_declare.e"  From 'struct definition' */
typedef struct s__sn_uint_val_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_uint_val_descriptor;
#define d__sn_uint_val_descriptor 3254

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_bool_val_declare.e"  From 'struct definition' */
typedef struct s__sn_bool_val_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_bool_val_descriptor;
#define d__sn_bool_val_descriptor 3255

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_sized_int_val_declare.e"  From 'struct definition' */
typedef struct s__sn_sized_int_val_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_sized_int_val_descriptor;
#define d__sn_sized_int_val_descriptor 3256

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_enum_val_declare.e"  From 'struct definition' */
typedef struct s__sn_enum_val_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_enum_val_descriptor;
#define d__sn_enum_val_descriptor 3257

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_abs_structual_segment_declare.e"  From 'struct definition' */
typedef struct s__sn_abs_structual_segmen34699 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_abs_structual_segment_descriptor;
#define d__sn_abs_structual_segment_descriptor 3258

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_abs_extension_declare.e"  From 'struct definition' */
typedef struct s__sn_abs_extension_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_abs_extension_descriptor;
#define d__sn_abs_extension_descriptor 3259

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_abs_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn_abs_descriptor_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_abs_descriptor_descriptor;
#define d__sn_abs_descriptor_descriptor 3260

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_type_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn_type_descriptor_desc34700 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_type_descriptor_descriptor;
#define d__sn_type_descriptor_descriptor 3261

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_scalar_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn_scalar_descriptor_de34701 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_scalar_descriptor_descriptor;
#define d__sn_scalar_descriptor_descriptor 3262

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_enum_extension_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn_enum_extension_descr34702 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_enum_extension_descriptor_descriptor;
#define d__sn_enum_extension_descriptor_descriptor 3263

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_enum_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn_enum_descriptor_desc34703 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_enum_descriptor_descriptor;
#define d__sn_enum_descriptor_descriptor 3264

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_list_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn_list_descriptor_desc34704 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_list_descriptor_descriptor;
#define d__sn_list_descriptor_descriptor 3265

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_struct_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn_struct_descriptor_de34705 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_struct_descriptor_descriptor;
#define d__sn_struct_descriptor_descriptor 3266

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_unit_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn_unit_descriptor_desc34706 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_unit_descriptor_descriptor;
#define d__sn_unit_descriptor_descriptor 3267

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_struct_storage_declare.e"  From 'struct definition' */
typedef struct s__sn_struct_storage_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_struct_storage_descriptor;
#define d__sn_struct_storage_descriptor 3268

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_struct_storage_details_declare.e"  From 'struct definition' */
typedef struct s__sn_struct_storage_detai34707 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_struct_storage_details_descriptor;
#define d__sn_struct_storage_details_descriptor 3269

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_struct_member_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn_struct_member_descri34708 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_struct_member_descriptor_descriptor;
#define d__sn_struct_member_descriptor_descriptor 3270

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_field_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn_field_descriptor_des34709 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_field_descriptor_descriptor;
#define d__sn_field_descriptor_descriptor 3271

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_method_extension_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn_method_extension_des34710 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_method_extension_descriptor_descriptor;
#define d__sn_method_extension_descriptor_descriptor 3272

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_event_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn_event_descriptor_des34711 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_event_descriptor_descriptor;
#define d__sn_event_descriptor_descriptor 3273

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_method_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn_method_descriptor_de34712 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_method_descriptor_descriptor;
#define d__sn_method_descriptor_descriptor 3274

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_tcm_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn_tcm_descriptor_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_tcm_descriptor_descriptor;
#define d__sn_tcm_descriptor_descriptor 3275

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_on_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn_on_descriptor_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_on_descriptor_descriptor;
#define d__sn_on_descriptor_descriptor 3276

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_constraint_descriptor_declare.e"  From 'struct definition' */
typedef struct s__sn_constraint_descripto34713 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_constraint_descriptor_descriptor;
#define d__sn_constraint_descriptor_descriptor 3277

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_type_update_declare.e"  From 'struct definition' */
typedef struct s__sn_type_update_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_type_update_descriptor;
#define d__sn_type_update_descriptor 3278

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_struct_storage_update_declare.e"  From 'struct definition' */
typedef struct s__sn_struct_storage_updat34714 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_struct_storage_update_descriptor;
#define d__sn_struct_storage_update_descriptor 3279

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_enum_update_declare.e"  From 'struct definition' */
typedef struct s__sn_enum_update_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_enum_update_descriptor;
#define d__sn_enum_update_descriptor 3280

/* line 14 "/proj/specman/src/japp/databrowser/gencode/gen_status_declare.e"  From 'struct definition' */
typedef struct s__gen_status_descriptor {
    t__int d__;
    t__int gen__;
} *t__gen_status_descriptor;
#define d__gen_status_descriptor 3281

/* line 14 "/proj/specman/src/japp/databrowser/gencode/method_kind_declare.e"  From 'struct definition' */
typedef struct s__method_kind_descriptor {
    t__int d__;
    t__int gen__;
} *t__method_kind_descriptor;
#define d__method_kind_descriptor 3283

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_event_kind_declare.e"  From 'struct definition' */
typedef struct s__sn_event_kind_descriptor {
    t__int d__;
    t__int gen__;
} *t__sn_event_kind_descriptor;
#define d__sn_event_kind_descriptor 3285

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sni_jdatabrowser_service_declare.e"  From 'struct definition' */
typedef struct s__sni_jdatabrowser_servic34715 {
    t__int d__;
    t__int gen__;
} *t__sni_jdatabrowser_service_descriptor;
#define d__sni_jdatabrowser_service_descriptor 3287

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sni_edatabrowser_service_declare.e"  From 'struct definition' */
typedef struct s__sni_edatabrowser_servic34716 {
    t__int d__;
    t__int gen__;
} *t__sni_edatabrowser_service_descriptor;
#define d__sni_edatabrowser_service_descriptor 3288

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_masked_val_declare.e"  From 'struct definition' */
typedef struct s__sn_masked_val_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_masked_val_descriptor;
#define d__sn_masked_val_descriptor 3289

/* line 14 "/proj/specman/src/japp/databrowser/gencode/e_val_change_declare.e"  From 'struct definition' */
typedef struct s__e_val_change_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__e_val_change_descriptor;
#define d__e_val_change_descriptor 3290

/* line 14 "/proj/specman/src/japp/databrowser/gencode/e_root_refresh_result_declare.e"  From 'struct definition' */
typedef struct s__e_root_refresh_result_d34717 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__e_root_refresh_result_descriptor;
#define d__e_root_refresh_result_descriptor 3291

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_root_di_info_declare.e"  From 'struct definition' */
typedef struct s__sn_root_di_info_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_root_di_info_descriptor;
#define d__sn_root_di_info_descriptor 3292

/* line 14 "/proj/specman/src/japp/databrowser/gencode/change_type_declare.e"  From 'struct definition' */
typedef struct s__change_type_descriptor {
    t__int d__;
    t__int gen__;
} *t__change_type_descriptor;
#define d__change_type_descriptor 3293

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_exp_declare.e"  From 'struct definition' */
typedef struct s__sn_exp_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_exp_descriptor;
#define d__sn_exp_descriptor 3295

/* line 14 "/proj/specman/src/japp/databrowser/gencode/sn_declared_exp_declare.e"  From 'struct definition' */
typedef struct s__sn_declared_exp_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_declared_exp_descriptor;
#define d__sn_declared_exp_descriptor 3296

/* line 15 "/proj/specman/src/japp/vt/gencode/sni_jvt_service_declare.e"  From 'struct definition' */
typedef struct s__sni_jvt_service_descriptor {
    t__int d__;
    t__int gen__;
} *t__sni_jvt_service_descriptor;
#define d__sni_jvt_service_descriptor 3392

/* line 15 "/proj/specman/src/japp/vt/gencode/sni_evt_service_declare.e"  From 'struct definition' */
typedef struct s__sni_evt_service_descriptor {
    t__int d__;
    t__int gen__;
} *t__sni_evt_service_descriptor;
#define d__sni_evt_service_descriptor 3393

/* line 15 "/proj/specman/src/japp/vt/gencode/sni_vt_jwindow_declare.e"  From 'struct definition' */
typedef struct s__sni_vt_jwindow_descriptor {
    t__int d__;
    t__int gen__;
} *t__sni_vt_jwindow_descriptor;
#define d__sni_vt_jwindow_descriptor 3394

/* line 15 "/proj/specman/src/japp/vt/gencode/sni_vtw_callback_handler_declare.e"  From 'struct definition' */
typedef struct s__sni_vtw_callback_handle34718 {
    t__int d__;
    t__int gen__;
} *t__sni_vtw_callback_handler_descriptor;
#define d__sni_vtw_callback_handler_descriptor 3395

/* line 15 "/proj/specman/src/japp/vt/gencode/sn_vt_menubar_declare.e"  From 'struct definition' */
typedef struct s__sn_vt_menubar_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_vt_menubar_descriptor;
#define d__sn_vt_menubar_descriptor 3396

/* line 15 "/proj/specman/src/japp/vt/gencode/sn_vt_menu_declare.e"  From 'struct definition' */
typedef struct s__sn_vt_menu_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_vt_menu_descriptor;
#define d__sn_vt_menu_descriptor 3397

/* line 15 "/proj/specman/src/japp/vt/gencode/sn_vt_toolbar_declare.e"  From 'struct definition' */
typedef struct s__sn_vt_toolbar_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_vt_toolbar_descriptor;
#define d__sn_vt_toolbar_descriptor 3398

/* line 15 "/proj/specman/src/japp/vt/gencode/sn_vt_action_declare.e"  From 'struct definition' */
typedef struct s__sn_vt_action_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_vt_action_descriptor;
#define d__sn_vt_action_descriptor 3399

/* line 15 "/proj/specman/src/japp/vt/gencode/vt_window_properties_declare.e"  From 'struct definition' */
typedef struct s__vt_window_properties_de34719 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__vt_window_properties_descriptor;
#define d__vt_window_properties_descriptor 3400

/* line 15 "/proj/specman/src/japp/vt/gencode/vt_window_actions_declare.e"  From 'struct definition' */
typedef struct s__vt_window_actions_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__vt_window_actions_descriptor;
#define d__vt_window_actions_descriptor 3401

/* line 15 "/proj/specman/src/japp/vt/gencode/sn_pair_nums_declare.e"  From 'struct definition' */
typedef struct s__sn_pair_nums_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_pair_nums_descriptor;
#define d__sn_pair_nums_descriptor 3402

/* line 15 "/proj/specman/src/japp/vt/gencode/sn_pair_strings_declare.e"  From 'struct definition' */
typedef struct s__sn_pair_strings_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_pair_strings_descriptor;
#define d__sn_pair_strings_descriptor 3403

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_abs_key_declare.e"  From 'struct definition' */
typedef struct s__sn_abs_key_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_abs_key_descriptor;
#define d__sn_abs_key_descriptor 3864

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_event_parameter_key_declare.e"  From 'struct definition' */
typedef struct s__sn_event_parameter_key_42210 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_event_parameter_key_descriptor;
#define d__sn_event_parameter_key_descriptor 3865

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_event_key_declare.e"  From 'struct definition' */
typedef struct s__sn_event_key_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_event_key_descriptor;
#define d__sn_event_key_descriptor 3866

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_gendb_item_in_gen_key_declare.e"  From 'struct definition' */
typedef struct s__sn_gendb_item_in_gen_ke42211 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_gendb_item_in_gen_key_descriptor;
#define d__sn_gendb_item_in_gen_key_descriptor 3867

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_gendb_list_temp_key_declare.e"  From 'struct definition' */
typedef struct s__sn_gendb_list_temp_key_42212 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_gendb_list_temp_key_descriptor;
#define d__sn_gendb_list_temp_key_descriptor 3868

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_instanciated_field_key_declare.e"  From 'struct definition' */
typedef struct s__sn_instanciated_field_k42213 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_instanciated_field_key_descriptor;
#define d__sn_instanciated_field_key_descriptor 3869

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_instanciated_list_item_key_declare.e"  From 'struct definition' */
typedef struct s__sn_instanciated_list_it42214 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_instanciated_list_item_key_descriptor;
#define d__sn_instanciated_list_item_key_descriptor 3870

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_role_info_key_declare.e"  From 'struct definition' */
typedef struct s__sn_role_info_key_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_role_info_key_descriptor;
#define d__sn_role_info_key_descriptor 3871

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/item_in_gen_kind_declare.e"  From 'struct definition' */
typedef struct s__item_in_gen_kind_descriptor {
    t__int d__;
    t__int gen__;
} *t__item_in_gen_kind_descriptor;
#define d__item_in_gen_kind_descriptor 3872

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/abs_range_props_declare.e"  From 'struct definition' */
typedef struct s__abs_range_props_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__abs_range_props_descriptor;
#define d__abs_range_props_descriptor 3874

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/regular_range_props_declare.e"  From 'struct definition' */
typedef struct s__regular_range_props_des42215 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__regular_range_props_descriptor;
#define d__regular_range_props_descriptor 3875

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/bit_range_props_declare.e"  From 'struct definition' */
typedef struct s__bit_range_props_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__bit_range_props_descriptor;
#define d__bit_range_props_descriptor 3876

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/list_range_props_declare.e"  From 'struct definition' */
typedef struct s__list_range_props_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__list_range_props_descriptor;
#define d__list_range_props_descriptor 3877

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sni_egendebugger_service_declare.e"  From 'struct definition' */
typedef struct s__sni_egendebugger_servic42216 {
    t__int d__;
    t__int gen__;
} *t__sni_egendebugger_service_descriptor;
#define d__sni_egendebugger_service_descriptor 3878

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sni_jgendebugger_service_declare.e"  From 'struct definition' */
typedef struct s__sni_jgendebugger_servic42217 {
    t__int d__;
    t__int gen__;
} *t__sni_jgendebugger_service_descriptor;
#define d__sni_jgendebugger_service_descriptor 3879

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_gen_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_gen_event_props_desc42218 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_gen_event_props_descriptor;
#define d__sn_gen_event_props_descriptor 3880

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_set_value_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_set_value_event_prop42219 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_set_value_event_props_descriptor;
#define d__sn_set_value_event_props_descriptor 3881

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_set_scalar_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_set_scalar_event_pro42220 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_set_scalar_event_props_descriptor;
#define d__sn_set_scalar_event_props_descriptor 3882

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_set_struct_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_set_struct_event_pro42221 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_set_struct_event_props_descriptor;
#define d__sn_set_struct_event_props_descriptor 3883

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_set_list_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_set_list_event_props42222 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_set_list_event_props_descriptor;
#define d__sn_set_list_event_props_descriptor 3884

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_gen_root_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_gen_root_event_props42223 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_gen_root_event_props_descriptor;
#define d__sn_gen_root_event_props_descriptor 3885

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_gen_root_event_props_flags_declare.e"  From 'struct definition' */
typedef struct s__sn_gen_root_event_props42224 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_gen_root_event_props_flags_descriptor;
#define d__sn_gen_root_event_props_flags_descriptor 3886

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_start_gen_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_start_gen_event_prop42225 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_start_gen_event_props_descriptor;
#define d__sn_start_gen_event_props_descriptor 3887

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_gen_struct_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_gen_struct_event_pro42226 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_gen_struct_event_props_descriptor;
#define d__sn_gen_struct_event_props_descriptor 3888

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_gen_list_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_gen_list_event_props42227 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_gen_list_event_props_descriptor;
#define d__sn_gen_list_event_props_descriptor 3889

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_end_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_end_event_props_desc42228 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_end_event_props_descriptor;
#define d__sn_end_event_props_descriptor 3890

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_end_gen_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_end_gen_event_props_42229 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_end_gen_event_props_descriptor;
#define d__sn_end_gen_event_props_descriptor 3891

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_end_struct_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_end_struct_event_pro42230 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_end_struct_event_props_descriptor;
#define d__sn_end_struct_event_props_descriptor 3892

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_end_list_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_end_list_event_props42231 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_end_list_event_props_descriptor;
#define d__sn_end_list_event_props_descriptor 3893

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_testing_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_testing_event_props_42232 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_testing_event_props_descriptor;
#define d__sn_testing_event_props_descriptor 3894

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_constraint_testing_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_constraint_testing_e42233 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_constraint_testing_event_props_descriptor;
#define d__sn_constraint_testing_event_props_descriptor 3895

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_dynamic_reduction_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_dynamic_reduction_ev42234 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_dynamic_reduction_event_props_descriptor;
#define d__sn_dynamic_reduction_event_props_descriptor 3896

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_static_reduction_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_static_reduction_eve42235 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_static_reduction_event_props_descriptor;
#define d__sn_static_reduction_event_props_descriptor 3897

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_soft_testing_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_soft_testing_event_p42236 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_soft_testing_event_props_descriptor;
#define d__sn_soft_testing_event_props_descriptor 3898

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_soft_reduction_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_soft_reduction_event42237 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_soft_reduction_event_props_descriptor;
#define d__sn_soft_reduction_event_props_descriptor 3899

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_reset_soft_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_reset_soft_event_pro42238 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_reset_soft_event_props_descriptor;
#define d__sn_reset_soft_event_props_descriptor 3900

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_set_status_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_set_status_event_pro42239 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_set_status_event_props_descriptor;
#define d__sn_set_status_event_props_descriptor 3901

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_create_edge_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_create_edge_event_pr42240 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_create_edge_event_props_descriptor;
#define d__sn_create_edge_event_props_descriptor 3902

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_dynamic_edge_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_dynamic_edge_event_p42241 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_dynamic_edge_event_props_descriptor;
#define d__sn_dynamic_edge_event_props_descriptor 3903

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_start_collect_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_start_collect_event_42242 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_start_collect_event_props_descriptor;
#define d__sn_start_collect_event_props_descriptor 3904

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_stop_collect_event_props_declare.e"  From 'struct definition' */
typedef struct s__sn_stop_collect_event_p42243 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_stop_collect_event_props_descriptor;
#define d__sn_stop_collect_event_props_descriptor 3905

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_instanciated_field_props_declare.e"  From 'struct definition' */
typedef struct s__sn_instanciated_field_p42244 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_instanciated_field_props_descriptor;
#define d__sn_instanciated_field_props_descriptor 3906

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_instanciated_list_props_declare.e"  From 'struct definition' */
typedef struct s__sn_instanciated_list_pr42245 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_instanciated_list_props_descriptor;
#define d__sn_instanciated_list_props_descriptor 3907

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_instanciated_list_item_props_declare.e"  From 'struct definition' */
typedef struct s__sn_instanciated_list_it42246 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_instanciated_list_item_props_descriptor;
#define d__sn_instanciated_list_item_props_descriptor 3908

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_role_info_props_declare.e"  From 'struct definition' */
typedef struct s__sn_role_info_props_desc42247 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_role_info_props_descriptor;
#define d__sn_role_info_props_descriptor 3909

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/gendb_item_in_gen_props_declare.e"  From 'struct definition' */
typedef struct s__gendb_item_in_gen_props42248 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__gendb_item_in_gen_props_descriptor;
#define d__gendb_item_in_gen_props_descriptor 3910

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/gendb_field_in_role_props_declare.e"  From 'struct definition' */
typedef struct s__gendb_field_in_role_pro42249 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__gendb_field_in_role_props_descriptor;
#define d__gendb_field_in_role_props_descriptor 3911

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/gendb_list_in_role_props_declare.e"  From 'struct definition' */
typedef struct s__gendb_list_in_role_prop42250 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__gendb_list_in_role_props_descriptor;
#define d__gendb_list_in_role_props_descriptor 3912

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/gendb_field_in_gen_props_declare.e"  From 'struct definition' */
typedef struct s__gendb_field_in_gen_prop42251 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__gendb_field_in_gen_props_descriptor;
#define d__gendb_field_in_gen_props_descriptor 3913

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/gendb_list_item_in_gen_props_declare.e"  From 'struct definition' */
typedef struct s__gendb_list_item_in_gen_42252 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__gendb_list_item_in_gen_props_descriptor;
#define d__gendb_list_item_in_gen_props_descriptor 3914

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/gendb_gc_in_role_props_declare.e"  From 'struct definition' */
typedef struct s__gendb_gc_in_role_props_42253 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__gendb_gc_in_role_props_descriptor;
#define d__gendb_gc_in_role_props_descriptor 3915

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/gendb_ci_in_gen_props_declare.e"  From 'struct definition' */
typedef struct s__gendb_ci_in_gen_props_d42254 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__gendb_ci_in_gen_props_descriptor;
#define d__gendb_ci_in_gen_props_descriptor 3916

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__gendb_item_props_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__gendb_item_props_descriptor;
#define d__gendb_item_props_descriptor 3917

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/constant_gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__constant_gendb_item_pro42255 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__constant_gendb_item_props_descriptor;
#define d__constant_gendb_item_props_descriptor 3918

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/simple_local_gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__simple_local_gendb_item42256 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__simple_local_gendb_item_props_descriptor;
#define d__simple_local_gendb_item_props_descriptor 3919

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/static_gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__static_gendb_item_props42257 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__static_gendb_item_props_descriptor;
#define d__static_gendb_item_props_descriptor 3920

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/changed_static_gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__changed_static_gendb_it42258 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__changed_static_gendb_item_props_descriptor;
#define d__changed_static_gendb_item_props_descriptor 3921

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/held_gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__held_gendb_item_props_d42259 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__held_gendb_item_props_descriptor;
#define d__held_gendb_item_props_descriptor 3922

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/me_gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__me_gendb_item_props_des42260 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__me_gendb_item_props_descriptor;
#define d__me_gendb_item_props_descriptor 3923

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/fix_me_gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__fix_me_gendb_item_props42261 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__fix_me_gendb_item_props_descriptor;
#define d__fix_me_gendb_item_props_descriptor 3924

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/not_fix_me_gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__not_fix_me_gendb_item_p42262 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__not_fix_me_gendb_item_props_descriptor;
#define d__not_fix_me_gendb_item_props_descriptor 3925

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/changed_gendb_item_props_declare.e"  From 'struct definition' */
typedef struct s__changed_gendb_item_prop42263 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__changed_gendb_item_props_descriptor;
#define d__changed_gendb_item_props_descriptor 3926

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_arrow_props_declare.e"  From 'struct definition' */
typedef struct s__sn_arrow_props_descriptor {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_arrow_props_descriptor;
#define d__sn_arrow_props_descriptor 3927

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/abs_query_result_props_declare.e"  From 'struct definition' */
typedef struct s__abs_query_result_props_42264 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__abs_query_result_props_descriptor;
#define d__abs_query_result_props_descriptor 3928

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/history_result_props_declare.e"  From 'struct definition' */
typedef struct s__history_result_props_de42265 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__history_result_props_descriptor;
#define d__history_result_props_descriptor 3929

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/reason_result_props_declare.e"  From 'struct definition' */
typedef struct s__reason_result_props_des42266 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__reason_result_props_descriptor;
#define d__reason_result_props_descriptor 3930

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/closure_result_props_declare.e"  From 'struct definition' */
typedef struct s__closure_result_props_de42267 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__closure_result_props_descriptor;
#define d__closure_result_props_descriptor 3931

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/effect_result_props_declare.e"  From 'struct definition' */
typedef struct s__effect_result_props_des42268 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__effect_result_props_descriptor;
#define d__effect_result_props_descriptor 3932

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/abs_ci_status_props_declare.e"  From 'struct definition' */
typedef struct s__abs_ci_status_props_des42269 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__abs_ci_status_props_descriptor;
#define d__abs_ci_status_props_descriptor 3933

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_ci_status_unchanged_props_declare.e"  From 'struct definition' */
typedef struct s__sn_ci_status_unchanged_42270 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_ci_status_unchanged_props_descriptor;
#define d__sn_ci_status_unchanged_props_descriptor 3934

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_ci_status_changed_props_declare.e"  From 'struct definition' */
typedef struct s__sn_ci_status_changed_pr42271 {
    t__int d__;
    t__int gen__;
        struct s__type_descriptor *data_type;
        struct s__struct_descriptor *p_sd_packer;
} *t__sn_ci_status_changed_props_descriptor;
#define d__sn_ci_status_changed_props_descriptor 3935

/* line 14 "/proj/specman/src/japp/gendebugger/gencode/sn_status_result_kinds_declare.e"  From 'struct definition' */
typedef struct s__sn_status_result_kinds_42272 {
    t__int d__;
    t__int gen__;
} *t__sn_status_result_kinds_descriptor;
#define d__sn_status_result_kinds_descriptor 3936

/* line 134 "/proj/specman/src/snorb/orb/snorb.e"  From 'struct definition' */
typedef struct s__snorb_all_flags {
    t__int d__;
    t__int gen__;
        t__bool impl_repository_debug;
        t__bool USE_LOOPBACK;
} *t__snorb_all_flags;
#define d__snorb_all_flags 2504

/* line 36 "/proj/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__snorb_data_helper {
    t__int d__;
    t__int gen__;
        struct s__k__name_id_pair__name *type_name_to_id;
        struct s__l__snorb_data_descriptor *id_to_desc;
} *t__snorb_data_helper;
#define d__snorb_data_helper 2478

/* line 38 "/proj/specman/src/snorb/orb/snorb_helpers.e"  From 'struct definition' */
typedef struct s__name_id_pair {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string name;
        t__int id;
} *t__name_id_pair;
#define d__name_id_pair 2515

/* line 27 "/proj/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__snorb_data_descriptor {
    t__int d__;
    t__int gen__;
} *t__snorb_data_descriptor;
#define d__snorb_data_descriptor 2474

/* line 50 "/proj/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__snorb_object_helper {
    t__int d__;
    t__int gen__;
} *t__snorb_object_helper;
#define d__snorb_object_helper 2479

/* line 101 "/proj/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__snorb_sender {
    t__int d__;
    t__int gen__;
        struct s__snorb_stub_factory *p_factory;
} *t__snorb_sender;
#define d__snorb_sender 2498

/* line 112 "/proj/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__snorb_stub_factory {
    t__int d__;
    t__int gen__;
        struct s__p_snorb_stub_cache *p_cache;
} *t__snorb_stub_factory;
#define d__snorb_stub_factory 2499

/* line 150 "/proj/specman/src/snorb/orb/snorb_stub_factory.e"  From 'struct definition' */
typedef struct s__p_snorb_stub_cache {
    t__int d__;
    t__int gen__;
        struct s__sn_string_hash_table *p_hash_oid_to_data;
        struct s__sn_map *p_map_stub_to_desc;
} *t__p_snorb_stub_cache;
#define d__p_snorb_stub_cache 2507

/* line 538 "/proj/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__sn_string_hash_table {
    t__int d__;
    t__int gen__;
        struct s__k__p_sn_string_hash_tabl2885 *p_data;
        t__bool p_initialized;
} *t__sn_string_hash_table;
#define d__sn_string_hash_table 1043

/* line 512 "/proj/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__p_sn_string_hash_table_entry {
    t__int d__;
    t__int gen__;
        struct s__sn_string_hashable *p_key;
        struct s__base_struct *p_value;
        t__string p_internal_key;
} *t__p_sn_string_hash_table_entry;
#define d__p_sn_string_hash_table_entry 1042

/* line 423 "/proj/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__sn_map {
    t__int d__;
    t__int gen__;
        t__bool initialized;
        struct s__k__p_map_entry__key *p_list;
} *t__sn_map;
#define d__sn_map 1039

/* line 412 "/proj/specman/src/general_utils.e"  From 'struct definition' */
typedef struct s__p_map_entry {
    t__int d__;
    t__int gen__;
        struct s__base_struct *key;
        struct s__base_struct *value;
} *t__p_map_entry;
#define d__p_map_entry 1038

/* line 96 "/proj/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__snorb_receiver {
    t__int d__;
    t__int gen__;
        t__int p_n_orbid;
        struct s__snorb_impl_repository *p_repository;
        struct s__snorb_impl_adapter_factory *p_adapter_factory;
} *t__snorb_receiver;
#define d__snorb_receiver 2497

/* line 16 "/proj/specman/src/snorb/orb/snorb_impl_repository.e"  From 'struct definition' */
typedef struct s__snorb_impl_repository {
    t__int d__;
    t__int gen__;
        t__int p_n_orb_id;
        t__int p_n_object_id_count;
        struct s__snorb_object_id *p_objid_bootstrap;
        struct s__sn_string_hash_table *p_hash_id_to_impl;
        struct s__sn_map *p_hash_impl_to_id;
} *t__snorb_impl_repository;
#define d__snorb_impl_repository 2508

/* line 95 "/proj/specman/src/snorb/orb/snorb_predef.e"  From 'struct definition' */
typedef struct s__snorb_impl_adapter_factory {
    t__int d__;
    t__int gen__;
        struct s__p_snorb_adapter_cache *p_cache;
} *t__snorb_impl_adapter_factory;
#define d__snorb_impl_adapter_factory 2496

/* line 87 "/proj/specman/src/snorb/orb/snorb_impl_adapter_factory.e"  From 'struct definition' */
typedef struct s__p_snorb_adapter_cache {
    t__int d__;
    t__int gen__;
        struct s__sn_map *p_map;
} *t__p_snorb_adapter_cache;
#define d__p_snorb_adapter_cache 2509

/* line 19 "/proj/specman/src/snorb/orb/services/snorb_service_repository.e"  From 'struct definition' */
typedef struct s__snorb_service_repository {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__sn_string_hash_table *p_map_key_to_id;
} *t__snorb_service_repository;
#define d__snorb_service_repository 2528

/* line 130 "/proj/specman/src/snorb/orb/services/snorb_service_repository.e"  From 'struct definition' */
typedef struct s__snorb_service_finder {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__int p_n_id_peer_orb;
        struct s__sni_service_repository *p_isr_remote;
} *t__snorb_service_finder;
#define d__snorb_service_finder 2529

/* line 11 "/proj/specman/src/snorb/orb/services/sni_service_repository_edl.e"  From 'struct definition' */
typedef struct s__sni_service_repository {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sni_service_repository;
#define d__sni_service_repository 2519

/* line 59 "/proj/specman/src/eve.e"  From 'struct definition' */
typedef struct s__event_viewer {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__l__basic_event_log *collected;
        t__int prev_shown_time;
        t__string last_time_ref_str;
        t__string last_events_str;
        struct s__l__sn_ec_point_environment *last_environments;
        struct s__time *last_chart_start_time;
        struct s__time *last_chart_end_time;
        t__bool last_chart_prev_info_exists;
        t__bool last_chart_next_info_exists;
        struct s__l__int *last_chart_events;
        struct s__l__string *last_chart_selectors;
        t__bool shown_prev_syntax;
        t__bool shown_next_syntax;
} *t__event_viewer;
#define d__event_viewer 2687

/* line 222 "/proj/specman/src/eve_chart.e"  From 'struct definition' */
typedef struct s__sn_ec_point_environment {
    t__int d__;
    t__int gen__;
        struct s__time *point_time;
        struct s__time *env_beginnig;
        struct s__time *env_end;
} *t__sn_ec_point_environment;
#define d__sn_ec_point_environment 2702

/* line 5 "/proj/specman/src/snorb/pub_services/pub_services.e"  From 'struct definition' */
typedef struct s__sn_pub_services {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__l__any_interface *lst_services;
        struct s__sn_specman_command_service *p_specman_command;
        struct s__sn_specview_service *p_specview_service;
        struct s__sn_service_deli_manager *service_deli_manager;
        struct s__sn_remote_appl_manager_29214 *remote_appl_manager;
        struct s__sn_jcvr_service_impl *p_jcvr;
        struct s__sn_e_jcvr_external_service *p_e_jcvr_external_service;
        struct s__sn_e_jutils_service *p_e_jutils_service;
} *t__sn_pub_services;
#define d__sn_pub_services 2952

/* line 19 "/proj/specman/src/snorb/edl/edl_parser.e"  From 'struct definition' */
typedef struct s__any_interface {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__any_interface;
#define d__any_interface 2402

/* line 7 "/proj/specman/src/snorb/pub_services/sni_specman_command/sni_specman_command.e"  From 'struct definition' */
typedef struct s__sn_specman_command_service {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sn_specman_command_service;
#define d__sn_specman_command_service 2961

/* line 18 "/proj/specman/src/snorb/pub_services/sni_specview_service/specview_service.e"  From 'struct definition' */
typedef struct s__sn_specview_service {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__sn_gui_resources *p_resources;
} *t__sn_specview_service;
#define d__sn_specview_service 2978

/* line 53 "/proj/specman/src/snorb/pub_services/sni_specview_service/specview_service_edl.e"  From 'struct definition' */
typedef struct s__sn_gui_resources {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__sn_color_data *text_area_bg_color;
        struct s__sn_color_data *text_area_fg_color;
        struct s__sn_color_data *text_area_sel_bg_color;
        struct s__sn_color_data *text_area_sel_fg_color;
        struct s__sn_color_data *text_area_cursor_color;
        struct s__sn_font_data *toolbar_font;
        struct s__sn_font_data *menu_font;
        struct s__sn_font_data *default_font;
        t__int text_icon_mixed_mode;
        t__int tab_size;
} *t__sn_gui_resources;
#define d__sn_gui_resources 2964

/* line 32 "/proj/specman/src/snorb/pub_services/sni_specview_service/specview_service_edl.e"  From 'struct definition' */
typedef struct s__sn_color_data {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__int r;
        t__int g;
        t__int b;
} *t__sn_color_data;
#define d__sn_color_data 2963

/* line 16 "/proj/specman/src/snorb/pub_services/sni_specview_service/specview_service_edl.e"  From 'struct definition' */
typedef struct s__sn_font_data {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string s_name;
        t__int n_style;
        t__int n_size;
} *t__sn_font_data;
#define d__sn_font_data 2962

/* line 27 "/proj/specman/src/snorb/pub_services/sni_remote_appl_manager/service_deli_manager.e"  From 'struct definition' */
typedef struct s__sn_service_deli_manager {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__k__sn_service_deli_entr29218 *lst_service_entries;
} *t__sn_service_deli_manager;
#define d__sn_service_deli_manager 2983

/* line 14 "/proj/specman/src/snorb/pub_services/sni_remote_appl_manager/service_deli_manager.e"  From 'struct definition' */
typedef struct s__sn_service_deli_entry {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__abs_remote_service_deli *p_service_deli;
        t__string p_s_name;
} *t__sn_service_deli_entry;
#define d__sn_service_deli_entry 2982

/* line 3 "/proj/specman/src/snorb/pub_services/sni_remote_appl_manager/service_deli_manager.e"  From 'struct definition' */
typedef struct s__abs_remote_service_deli {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__abs_remote_service_deli;
#define d__abs_remote_service_deli 2981

/* line 9 "/proj/specman/src/snorb/pub_services/sni_remote_appl_manager/sni_remote_appl_manager.e"  From 'struct definition' */
typedef struct s__sn_remote_appl_manager_29214 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__k__string__it *lst_applications;
} *t__sn_remote_appl_manager_service;
#define d__sn_remote_appl_manager_service 2991

/* line 34 "/proj/specman/src/japp/jcvr/jcvr.e"  From 'struct definition' */
typedef struct s__sn_jcvr_service_impl {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__l__sni_jcvr_change_listener *p_listeners;
} *t__sn_jcvr_service_impl;
#define d__sn_jcvr_service_impl 3092

/* line 45 "/proj/specman/src/japp/jcvr/jcvr_edl.e"  From 'struct definition' */
typedef struct s__sni_jcvr_change_listener {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sni_jcvr_change_listener;
#define d__sni_jcvr_change_listener 2754

/* line 12 "/proj/specman/src/japp/jcvr/jcvr_external.e"  From 'struct definition' */
typedef struct s__sn_e_jcvr_external_service {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sn_e_jcvr_external_service;
#define d__sn_e_jcvr_external_service 3106

/* line 31 "/proj/specman/src/japp/jutils/jutils.e"  From 'struct definition' */
typedef struct s__sn_e_jutils_service {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string p_private_src_dir;
} *t__sn_e_jutils_service;
#define d__sn_e_jutils_service 3129

/* line 8 "/proj/specman/src/japp/jspecview_deli/jspecview_main.e"  From 'struct definition' */
typedef struct s__sn_japp {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__sn_jcvrgui_deli *p_jcvrgui_deli;
} *t__sn_japp;
#define d__sn_japp 3087

/* line 20 "/proj/specman/src/japp/jcvr/jcvrgui.e"  From 'struct definition' */
typedef struct s__sn_jcvrgui_deli {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__sni_jcvrgui_service *p_sn_jcvrgui_deli;
} *t__sn_jcvrgui_deli;
#define d__sn_jcvrgui_deli 3094

/* line 17 "/proj/specman/src/japp/jcvr/jcvrgui_edl.e"  From 'struct definition' */
typedef struct s__sni_jcvrgui_service {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sni_jcvrgui_service;
#define d__sni_jcvrgui_service 2757

/* line 17 "/proj/specman/src/japp/jspecview_deli/jspecview_main.e"  From 'struct definition' */
typedef struct s__sn_jspecview_deli {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__comm_socket_interactor *p_socket;
        struct s__sni_jspecview_service *p_jspecview_service;
        t__string p_s_user_classpath;
        t__int n_comm_timout;
        t__int n_comm_msg_interval;
        t__bool p_f_stay_awake;
} *t__sn_jspecview_deli;
#define d__sn_jspecview_deli 3088

/* line 5 "/proj/specman/src/japp/jspecview_deli/jspecview_service_edl.e"  From 'struct definition' */
typedef struct s__sni_jspecview_service {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sni_jspecview_service;
#define d__sni_jspecview_service 3083

/* line 27 "/proj/specman/src/japp/jsource_viewer/source_viewer.e"  From 'struct definition' */
typedef struct s__sn_source_viewer {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__sni_jsource_viewer_service *p_jsource_viewer_service;
} *t__sn_source_viewer;
#define d__sn_source_viewer 3137

/* line 6 "/proj/specman/src/japp/jsource_viewer/source_viewer_edl.e"  From 'struct definition' */
typedef struct s__sni_jsource_viewer_service {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sni_jsource_viewer_service;
#define d__sni_jsource_viewer_service 3130

/* line 124 "/proj/specman/src/japp/jconfig/jconfig.e"  From 'struct definition' */
typedef struct s__sn_jconfig {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__jconfig_service_deli *p_jconfig_deli;
        struct s__sni_econfig_service *p_econfig_service;
        struct s__sn_jconfig_utils *p_jconfig_utils;
        struct s__k__sn_config_full_item_34733 *p_lst_registered_items;
        struct s__sn_jconfig_data *p_new_data_buffer;
        t__bool f_initial_data_sent;
} *t__sn_jconfig;
#define d__sn_jconfig 3159

/* line 8 "/proj/specman/src/japp/jconfig/jconfig.e"  From 'struct definition' */
typedef struct s__jconfig_service_deli {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__sni_jconfig_service *p_jconfig_service;
} *t__jconfig_service_deli;
#define d__jconfig_service_deli 3157

/* line 5 "/proj/specman/src/japp/jconfig/jconfig_edl.e"  From 'struct definition' */
typedef struct s__sni_jconfig_service {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sni_jconfig_service;
#define d__sni_jconfig_service 3138

/* line 18 "/proj/specman/src/japp/jconfig/jconfig_edl.e"  From 'struct definition' */
typedef struct s__sni_econfig_service {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sni_econfig_service;
#define d__sni_econfig_service 3139

/* line 253 "/proj/specman/src/japp/jconfig/jconfig.e"  From 'struct definition' */
typedef struct s__sn_jconfig_utils {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sn_jconfig_utils;
#define d__sn_jconfig_utils 3161

/* line 365 "/proj/specman/src/japp/jconfig/jconfig.e"  From 'struct definition' */
typedef struct s__sn_config_full_item {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string p_s_category;
        t__string p_s_item;
        t__string p_s_key;
} *t__sn_config_full_item;
#define d__sn_config_full_item 3162

/* line 33 "/proj/specman/src/japp/jconfig/jconfig_edl.e"  From 'struct definition' */
typedef struct s__sn_jconfig_data {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__l__sn_jconfig_category_val *lst_category_vals;
} *t__sn_jconfig_data;
#define d__sn_jconfig_data 3140

/* line 40 "/proj/specman/src/japp/jconfig/jconfig_edl.e"  From 'struct definition' */
typedef struct s__sn_jconfig_category_val {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string s_category;
        struct s__l__sn_jconfig_item_val *lst_item_vals;
} *t__sn_jconfig_category_val;
#define d__sn_jconfig_category_val 3142

/* line 53 "/proj/specman/src/japp/jconfig/jconfig_edl.e"  From 'struct definition' */
typedef struct s__sn_jconfig_item_val {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string s_item;
        t__string s_value;
} *t__sn_jconfig_item_val;
#define d__sn_jconfig_item_val 3144

/* line 16 "/proj/specman/src/japp/mini_guitest/mini_guitest.e"  From 'struct definition' */
typedef struct s__sn_gt {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__sni_jmini_guitest_service *jservice;
        t__bool p_pending_gt_cmd;
        t__bool p_pending_gt_on;
} *t__sn_gt;
#define d__sn_gt 3167

/* line 3 "/proj/specman/src/japp/mini_guitest/mini_guitest_edl.e"  From 'struct definition' */
typedef struct s__sni_jmini_guitest_service {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sni_jmini_guitest_service;
#define d__sni_jmini_guitest_service 3163

/* line 11 "/proj/specman/src/japp/databrowser/db_defs.e"  From 'struct definition' */
typedef struct s__sn_databrowser {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__bool db_raw_print_config_flag;
        t__bool db_raw_print_config_flag_was_initialized;
        struct s__sn_jdatabrowser_deligator *p_jdatabrowser_deli;
        struct s__sn_edatabrowser_service *p_edatabrowser_service;
} *t__sn_databrowser;
#define d__sn_databrowser 3168

/* line 4 "/proj/specman/src/japp/databrowser/db_jdatabrowser_deligator.e"  From 'struct definition' */
typedef struct s__sn_jdatabrowser_deligator {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__sni_jdatabrowser_service *p_jdatabrowser_service;
} *t__sn_jdatabrowser_deligator;
#define d__sn_jdatabrowser_deligator 3370

/* line 7 "/proj/specman/src/japp/databrowser/db_services_edl.e"  From 'struct definition' */
typedef struct s__sni_jdatabrowser_service {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sni_jdatabrowser_service;
#define d__sni_jdatabrowser_service 3226

/* line 13 "/proj/specman/src/japp/databrowser/db_edatabrowser_service.e"  From 'struct definition' */
typedef struct s__sn_edatabrowser_service {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__databrowser_cache_manager *p_cache_manager;
} *t__sn_edatabrowser_service;
#define d__sn_edatabrowser_service 3369

/* line 186 "/proj/specman/src/japp/databrowser/db_cache.e"  From 'struct definition' */
typedef struct s__databrowser_cache_manager {
    t__int d__;
    t__int gen__;
        struct s__scalar_nodes_cache *scalar_nodes_cache;
        struct s__non_scalar_nodes_cache *non_scalar_nodes_cache;
        t__int entries_id_fetcher;
        struct s__l__cache_entry *curr_roots;
        struct s__k__int__it *ids_of_types_that_were_transfered_to_java;
        struct s__k__int__it *ids_of_type_details_that_were_transfered_to_java;
} *t__databrowser_cache_manager;
#define d__databrowser_cache_manager 3359

/* line 557 "/proj/specman/src/japp/databrowser/db_cache.e"  From 'struct definition' */
typedef struct s__scalar_nodes_cache {
    t__int d__;
    t__int gen__;
        struct s__k__scalars_holders__par34754 *all_scalar_val_nodes;
        struct s__databrowser_cache_manager *global_cache_manager;
} *t__scalar_nodes_cache;
#define d__scalar_nodes_cache 3361

/* line 792 "/proj/specman/src/japp/databrowser/db_cache.e"  From 'struct definition' */
typedef struct s__scalars_holders {
    t__int d__;
    t__int gen__;
        t__int parent_id;
        struct s__k__scalar_cache_node__c34755 *all_parent_scalar_childs;
} *t__scalars_holders;
#define d__scalars_holders 3363

/* line 105 "/proj/specman/src/japp/databrowser/db_defs.e"  From 'struct definition' */
typedef struct s__scalar_cache_node {
    t__int d__;
    t__int gen__;
        t__int parent_id;
        t__int child_index;
        struct s__rf_value_holder_wrapper *val;
} *t__scalar_cache_node;
#define d__scalar_cache_node 3174

/* line 34 "/proj/specman/src/japp/databrowser/db_defs.e"  From 'struct definition' */
typedef struct s__rf_value_holder_wrapper {
    t__int d__;
    t__int gen__;
        struct s__rf_value_holder *holder;
        struct s__rf_type *actual_type;
        t__string str_val;
} *t__rf_value_holder_wrapper;
#define d__rf_value_holder_wrapper 3169

/* line 830 "/proj/specman/src/japp/databrowser/db_cache.e"  From 'struct definition' */
typedef struct s__non_scalar_nodes_cache {
    t__int d__;
    t__int gen__;
        struct s__databrowser_cache_manager *global_cache_manager;
        t__int id_fetcher;
        struct s__k__container_cache_node34756 *untyped_val_to_cache_container_cache_node;
        struct s__k__null_container_cache34757 *null_struct_to_container_cache_node;
        struct s__k__container_cache_node__id *id_to_container_cache_node;
} *t__non_scalar_nodes_cache;
#define d__non_scalar_nodes_cache 3365

/* line 108 "/proj/specman/src/japp/databrowser/db_defs.e"  From 'struct definition' */
typedef struct s__container_cache_node {
    t__int d__;
    t__int gen__;
        t__bool gc_flag;
        t__node_refresh_status refresh_flag;
        t__bool should_be_refreshed_flag;
        struct s__l__abs_cache_node *children;
        t__bool were_children_initialized;
        struct s__rf_value_holder_wrapper *val;
        t__int id;
        t__int unique_key;
} *t__container_cache_node;
#define d__container_cache_node 3175

/* line 99 "/proj/specman/src/japp/databrowser/db_defs.e"  From 'struct definition' */
typedef struct s__abs_cache_node {
    t__int d__;
    t__int gen__;
} *t__abs_cache_node;
#define d__abs_cache_node 3172

/* line 111 "/proj/specman/src/japp/databrowser/db_defs.e"  From 'struct definition' */
typedef struct s__null_container_cache_node {
    t__int d__;
    t__int gen__;
        t__bool gc_flag;
        t__node_refresh_status refresh_flag;
        t__bool should_be_refreshed_flag;
        struct s__l__abs_cache_node *children;
        t__bool were_children_initialized;
        struct s__rf_value_holder_wrapper *val;
        t__int id;
        t__int unique_key;
        struct s__rf_type *val_type;
} *t__null_container_cache_node;
#define d__null_container_cache_node 3176

/* line 102 "/proj/specman/src/japp/databrowser/db_defs.e"  From 'struct definition' */
typedef struct s__cache_entry {
    t__int d__;
    t__int gen__;
        t__string s_exp;
        struct s__abs_cache_node *child;
        t__int id;
        t__node_refresh_status refresh_flag;
} *t__cache_entry;
#define d__cache_entry 3173

/* line 11 "/proj/specman/src/japp/databrowser/db_evaluator.e"  From 'struct definition' */
typedef struct s__sn_evaluator {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sn_evaluator;
#define d__sn_evaluator 3349

/* line 33 "/proj/specman/src/japp/vt/vt_utils.e"  From 'struct definition' */
typedef struct s__sn_vt {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__k__sn_vt_buffer__name *buffers;
        struct s__l__sn_vt_buffer *list_buffers;
        struct s__sn_vt_buffer *current_buffer;
        t__string et_dir;
        t__imp_enum_sn_vt__trace trace;
        struct s__l__string *p_pseudo_methods;
        t__int counter;
        t__string html_path_re;
        t__string html_img_pref_re;
        t__string html_href_pref_re;
        t__string html_img_re;
        t__string html_href_re;
        t__string encode_str;
        struct s__jvt_service_deli *p_jvt_deli;
        struct s__sni_evt_service *p_evt_service;
        struct s__l__sn_vt_box *boxes;
} *t__sn_vt;
#define d__sn_vt 3430

/* line 14 "/proj/specman/src/japp/vt/vt_utils.e"  From 'struct definition' */
typedef struct s__sn_vt_buffer {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string name;
        struct s__l__string *lines;
        struct s__module *module;
        t__int line_no;
        struct s__sn_vt_buffer *prev;
} *t__sn_vt_buffer;
#define d__sn_vt_buffer 3429

/* line 308 "/proj/specman/src/japp/vt/vt_window.e"  From 'struct definition' */
typedef struct s__jvt_service_deli {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__sni_jvt_service *p_jvt_service;
} *t__jvt_service_deli;
#define d__jvt_service_deli 3448

/* line 5 "/proj/specman/src/japp/vt/vt_edl.e"  From 'struct definition' */
typedef struct s__sni_jvt_service {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sni_jvt_service;
#define d__sni_jvt_service 3377

/* line 20 "/proj/specman/src/japp/vt/vt_edl.e"  From 'struct definition' */
typedef struct s__sni_evt_service {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sni_evt_service;
#define d__sni_evt_service 3378

/* line 56 "/proj/specman/src/japp/vt/vt_chart.e"  From 'struct definition' */
typedef struct s__sn_vt_box {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__bool is_divider;
        t__string title;
        t__string value;
        t__string color;
} *t__sn_vt_box;
#define d__sn_vt_box 3450

/* line 12 "/proj/specman/src/denali_unit_h.e"  From 'struct definition' */
typedef struct s__sn_denali {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__k__sn_denali_unit__dena44063 *all_sn_denali_units;
        struct s__sn_denali_call_manager *denali_call_manager;
        struct s__libdenalisn_call_manager *libdenalisn_call_manager;
        t__uint cb_datasize_limit;
} *t__sn_denali;
#define d__sn_denali 4086

/* line 28 "/proj/specman/src/denali_unit_h.e"  From 'struct definition' */
typedef struct s__sn_denali_unit {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__int root___instance_id;
        t__string root___e_path;
        t__string root___full_hdl_path;
        t__string root___converted_full_hdl_path;
        t__string root___normal_hdl_path;
        t__int root___relative_id;
        t__string atomic_exp___hdl_path;
        struct s__sn_adapter_struct *atomic_exp___adapter_struct;
        t__string atomic_exp___agent_name;
        struct s__any_unit *atomic_exp___parent_unit;
        struct s__l__any_unit *atomic_exp___enclosing_list;
        struct s__sn_denali_add_on *add_on;
        t__string denali_unit___name;
        t__string denali_unit___type;
        t__uint denali_unit___width;
        t__uint denali_unit___wwidth;
        t__uint denali_unit___depth;
        t__uint denali_unit___id;
        t__uint denali_unit___swidth;
        t__bool denali_unit___initialized;
        t__index denali_unit___access_cb_method_index;
        struct s__struct_descriptor *denali_unit___den_type;
        t__int sn___access_event_occ_l;
        struct s__waiting_thread *sn___access_event_thread;
        struct s__sn_event_struct *sn___access_event_event_struct;
        struct s__l__sn_denali_cb_data_item *denali_unit___cb_list;
        t__uint denali_unit___cb_num;
        t__int denali_unit___last_tick_count;
        t__bool denali_unit___sn_is_immediate_callback_enabled;
        t__int sn___quit_occ_l;
        struct s__sn_event_struct *sn___quit_event_struct;
} *t__sn_denali_unit;
#define d__sn_denali_unit 4088

/* line 24 "/proj/specman/src/denali_unit_h.e"  From 'struct definition' */
typedef struct s__sn_denali_add_on {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
} *t__sn_denali_add_on;
#define d__sn_denali_add_on 4087

/* line 747 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_denali_cb_data_item {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__uint addr;
        t__sn_denali_access_type access_type;
        t__external_pointer data_ptr;
} *t__sn_denali_cb_data_item;
#define d__sn_denali_cb_data_item 4122

/* line 43 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_denali_call_manager {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__sn_dynamic_call__sn_den44064 *DENALIaccessClearCallback;
        struct s__sn_dynamic_call__sn_den44065 *DENALIaccessSetCallback;
        struct s__sn_dynamic_call__sn_den44066 *DENALIgetIdByName;
        struct s__sn_dynamic_call__sn_den44067 *DENALIgetInfoById;
        struct s__sn_dynamic_call__sn_den44068 *DENALIinitialize;
        struct s__sn_dynamic_call__sn_den44069 *DENALIload;
        struct s__sn_dynamic_call__sn_den44070 *DENALIsave;
        struct s__sn_dynamic_call__sn_den44071 *DENALIread;
        struct s__sn_dynamic_call__sn_den44072 *DENALIwrite;
        struct s__sn_dynamic_call__sn_den44073 *DENALIgetIds;
} *t__sn_denali_call_manager;
#define d__sn_denali_call_manager 4093

/* line 45 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_den44064 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_denali_call_manager__DENALIaccessClearCallback;
#define d__sn_dynamic_call__sn_denali_call_manager__DENALIaccessClearCallback 4094

/* line 46 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_den44065 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_denali_call_manager__DENALIaccessSetCallback;
#define d__sn_dynamic_call__sn_denali_call_manager__DENALIaccessSetCallback 4095

/* line 47 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_den44066 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_denali_call_manager__DENALIgetIdByName;
#define d__sn_dynamic_call__sn_denali_call_manager__DENALIgetIdByName 4096

/* line 48 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_den44067 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_denali_call_manager__DENALIgetInfoById;
#define d__sn_dynamic_call__sn_denali_call_manager__DENALIgetInfoById 4097

/* line 50 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_den44068 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_denali_call_manager__DENALIinitialize;
#define d__sn_dynamic_call__sn_denali_call_manager__DENALIinitialize 4098

/* line 52 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_den44069 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_denali_call_manager__DENALIload;
#define d__sn_dynamic_call__sn_denali_call_manager__DENALIload 4099

/* line 53 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_den44070 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_denali_call_manager__DENALIsave;
#define d__sn_dynamic_call__sn_denali_call_manager__DENALIsave 4100

/* line 54 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_den44071 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_denali_call_manager__DENALIread;
#define d__sn_dynamic_call__sn_denali_call_manager__DENALIread 4101

/* line 56 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_den44072 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_denali_call_manager__DENALIwrite;
#define d__sn_dynamic_call__sn_denali_call_manager__DENALIwrite 4102

/* line 57 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__sn_den44073 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__sn_denali_call_manager__DENALIgetIds;
#define d__sn_dynamic_call__sn_denali_call_manager__DENALIgetIds 4103

/* line 113 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__libdenalisn_call_manager {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__sn_dynamic_call__libden44074 *sn_denali_init;
        struct s__sn_dynamic_call__libden44075 *sn_denali_init_cb_data;
        struct s__sn_dynamic_call__libden44076 *sn_denali_setIdByName;
        struct s__sn_dynamic_call__libden44077 *sn_denali_setInfoById;
        struct s__sn_dynamic_call__libden44078 *sn_denali_read;
        struct s__sn_dynamic_call__libden44079 *sn_denali_read_unk;
        struct s__sn_dynamic_call__libden44080 *sn_denali_write;
        struct s__sn_dynamic_call__libden44081 *sn_denali_write_unk;
        struct s__sn_dynamic_call__libden44082 *sn_set_sndi_by_id;
        struct s__sn_dynamic_call__libden44083 *sn_get_all_denali_ids;
        struct s__sn_dynamic_call__libden44084 *sn_denali_enable_callback;
        struct s__sn_dynamic_call__libden44085 *sn_denali_disable_callback;
        struct s__sn_dynamic_call__libden44086 *sn_denali_save;
        struct s__sn_dynamic_call__libden44087 *sn_denali_load;
} *t__libdenalisn_call_manager;
#define d__libdenalisn_call_manager 4104

/* line 114 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__libden44074 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__libdenalisn_call_manager__sn_denali_init;
#define d__sn_dynamic_call__libdenalisn_call_manager__sn_denali_init 4105

/* line 115 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__libden44075 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__libdenalisn_call_manager__sn_denali_init_cb_data;
#define d__sn_dynamic_call__libdenalisn_call_manager__sn_denali_init_cb_data 4106

/* line 116 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__libden44076 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__libdenalisn_call_manager__sn_denali_setIdByName;
#define d__sn_dynamic_call__libdenalisn_call_manager__sn_denali_setIdByName 4107

/* line 117 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__libden44077 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__libdenalisn_call_manager__sn_denali_setInfoById;
#define d__sn_dynamic_call__libdenalisn_call_manager__sn_denali_setInfoById 4108

/* line 118 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__libden44078 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__libdenalisn_call_manager__sn_denali_read;
#define d__sn_dynamic_call__libdenalisn_call_manager__sn_denali_read 4109

/* line 120 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__libden44079 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__libdenalisn_call_manager__sn_denali_read_unk;
#define d__sn_dynamic_call__libdenalisn_call_manager__sn_denali_read_unk 4110

/* line 123 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__libden44080 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__libdenalisn_call_manager__sn_denali_write;
#define d__sn_dynamic_call__libdenalisn_call_manager__sn_denali_write 4111

/* line 125 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__libden44081 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__libdenalisn_call_manager__sn_denali_write_unk;
#define d__sn_dynamic_call__libdenalisn_call_manager__sn_denali_write_unk 4112

/* line 128 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__libden44082 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__libdenalisn_call_manager__sn_set_sndi_by_id;
#define d__sn_dynamic_call__libdenalisn_call_manager__sn_set_sndi_by_id 4113

/* line 130 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__libden44083 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__libdenalisn_call_manager__sn_get_all_denali_ids;
#define d__sn_dynamic_call__libdenalisn_call_manager__sn_get_all_denali_ids 4114

/* line 132 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__libden44084 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__libdenalisn_call_manager__sn_denali_enable_callback;
#define d__sn_dynamic_call__libdenalisn_call_manager__sn_denali_enable_callback 4115

/* line 133 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__libden44085 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__libdenalisn_call_manager__sn_denali_disable_callback;
#define d__sn_dynamic_call__libdenalisn_call_manager__sn_denali_disable_callback 4116

/* line 134 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__libden44086 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__libdenalisn_call_manager__sn_denali_save;
#define d__sn_dynamic_call__libdenalisn_call_manager__sn_denali_save 4117

/* line 135 "/proj/specman/src/denali_unit.e"  From 'struct definition' */
typedef struct s__sn_dynamic_call__libden44087 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__string lib_name;
        t__string call_name;
        t__sn_lib_resolve_mode lazy_mode;
        t__sn_lib_scope_mode scope_mode;
        struct s__sn_dynamic_call_addon *addon;
        t__string c_agent_call___name;
        t__external_pointer c_agent_call___func_ptr;
        struct s__sn_library *c_agent_call___lib_struct;
} *t__sn_dynamic_call__libdenalisn_call_manager__sn_denali_load;
#define d__sn_dynamic_call__libdenalisn_call_manager__sn_denali_load 4118

/* line 89 "/proj/specman/src/cap_main.e"  From 'struct definition' */
typedef struct s__capture_helper {
    t__int d__;
    t__int gen__;
        struct s__file *dummy_file;
} *t__capture_helper;
#define d__capture_helper 4164

/* line 48 "e/vrst_snfp_h.e"  From 'struct definition' */
typedef struct s__snfp_floating_point_s {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__snfp_floating_point_t kind;
        t__snfp_floating_point_number_t number_type;
        t__string str_rep;
        t__snfp_fmt_t fmt_to_use;
        t__snfp_sign_t sign;
        t__uint exp;
        t__uint mantisa0;
        t__uint mantisa1;
        t__uint low;
        t__uint high;
        t__uint ext;
        t__string str_fmt;
        struct s__snfp_floating_point_fun44965 *fpfn;
} *t__snfp_floating_point_s;
#define d__snfp_floating_point_s 4269

/* line 62 "e/vrst_snfp_h.e"  From 'struct definition' */
typedef struct s__snfp_floating_point_fun44965 {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        struct s__snfp_floating_point_s *op1;
        struct s__snfp_floating_point_s *op2;
        struct s__snfp_floating_point_s *res;
        t__snfp_efp_function_t its_type;
} *t__snfp_floating_point_function_s;
#define d__snfp_floating_point_function_s 4270

/* line 75 "e/vrst_snfp_h.e"  From 'struct definition' */
typedef struct s__n__fpnum__exp {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__ntv_extra *x;
        struct s__n__action *action;
        struct s__scope *scope;
        struct s__type_descriptor *base_type;
        t__exp_kind kind;
        struct s__field *field;
        t__string code;
} *t__n__fpnum__exp;
#define d__n__fpnum__exp 4261

/* line 78 "e/vrst_snfp_h.e"  From 'struct definition' */
typedef struct s__n__fp_str_assign__action {
    t__int d__;
    t__int gen__;
        t__source_ref source_ref;
        struct s__ntv_extra *x;
        struct s__scope *scope;
        struct s__method *method;
        t__int level;
        struct s__pre_actions *pre_actions;
        t__bool is_pre_action;
        struct s__entry *f__entry;
} *t__n__fp_str_assign__action;
#define d__n__fp_str_assign__action 4262

/* line 117 "e/vrst_snfp_h.e"  From 'struct definition' */
typedef struct s__snfp_rnd_fp_s {
    t__int d__;
    t__int gen__;
        struct s__any_unit *root___unit;
        t__snfp_random_fp_kind kind;
        t__bool no_zeros;
        t__bool no_ones;
        t__bit sign;
        t__uint int_len;
        struct s__l__byte *integer;
        t__uint frac_len;
        struct s__l__byte *fraction;
        t__string str_rep;
} *t__snfp_rnd_fp_s;
#define d__snfp_rnd_fp_s 4272

/* line 1124 "/proj/specman/src/basic_action.e"  From 'struct definition' */
typedef struct s__ref_param {
    t__int d__;
    t__int gen__;
        struct s__sn_value_holder *value_holder;
} *t__ref_param;
#define d__ref_param 424

/* line 16 "/proj/specman/src/num.e"  From 'H code' */
#define BASE_TYPE(_exp) (MY(_exp)->base_type)
#define MY_ELEM_TYPE(_ntv) ELEM_TYPE(MY(_ntv)->base_type)
#define IS_LIST_EXP(_exp) IS_A_LIST(MY(_exp)->base_type)
#define IS_NUMERIC(_v) ((IS_LONG(_v)) || \
 		((_v)->short_type == short_type__INT_TYPE || \
 		 (_v)->short_type == short_type__UINT_TYPE))
 	/* This type_descriptor is a scalar, so can have ranges */
/* line 12 "/proj/specman/src/basic_action.e"  From 'H code' */
SN_EXTERNAL t__global the_global_struct;
/* line 410 "/proj/specman/src/basic_action.e"  From 'H code' */
#define ACTION_SCD(_me)	DISPATCH(script_descriptor,(_me)->scope,scope,((_me)->scope))
#define ACTION_IN_SCRIPT(_me)	(ACTION_SCD(_me) != NULL)
/* line 655 "/proj/specman/src/basic_action.e"  From 'H code' */
#define EVAL(_type, _exp) ((_type)DISPATCH1(eval,_exp,n__exp))
#define UNTYPE(_exp) AS(t__untyped,_exp)
#define GLOB_CAR ((GLOB->CAR))
#define CAR_VALUE(_local) (*car_value(_local))
#define ON_AR_VALUE(_local) (*on_ar_value(_local))
#define GLOB_ON_AR ((t__activation_record)((t__on)GLOB->on)->activation_record)
#define GLOB_MASK(_e) (GLOB_MASK1(_e->size_in_bits))
#define DIFF_BIT_SIZE(_a,_b) ((_a) != (_b))
#define WAS_SPECIFIED(_exp) (STRUCT_TYPE(_exp)->d__ != d__nt_descriptor)
      /* Was specified here (not empty) */
#define SET_CODE(_s) if (!load_in_progress) me->code = (_s)
      /* Sets the code the requested value */
#define MAX_ROUTINE_PARAMS 15  
#define IS_CONSTANT_EXP(exp) ((exp)->kind == exp_kind__constant ||		\
			      (exp)->kind == exp_kind__constant_call)
#define IS_CALL_EXP(exp) ((exp)->kind == exp_kind__call ||              	\
                              (exp)->kind == exp_kind__constant_call)

#define EVAL2NUMERIC(_op,_func)							\
	{									\
	    t__untyped v1 = EVAL(t__untyped,MY(e1__exp));			\
	    t__untyped v2 = EVAL(t__untyped,MY(e2__exp));			\
        EVAL2NUMERIC_WITH_VALS(v1, v2, _op, _func)              \
	}

#define EVAL2NUMERIC_WITH_VALS(_val1, _val2, _op, _func) \
    {                                              \
	    t__untyped _local_v1 = _val1;			\
	    t__untyped _local_v2 = _val2;			\
	    _local_v1 = EVAL_CAST_UNTYPED(_local_v1,me->numeric2cast->cast1);			\
	    _local_v2 = EVAL_CAST_UNTYPED(_local_v2,me->numeric2cast->cast2);			\
	    switch (me->numeric2cast->cast1) {					\
	        case cast__none:						\
	        case cast__int:							\
	        case cast__uint2int:						\
	        case cast__long2int:						\
	        case cast__ulong2int:						\
		    return (t__untyped)((int)(_local_v1) _op (int)(_local_v2));		\
	        case cast__uint:						\
	        case cast__int2uint:						\
	        case cast__long2uint:						\
	        case cast__ulong2uint:						\
		    return (t__untyped)((t__uint)(_local_v1) _op (t__uint)(_local_v2));	\
	        default:							\
		    return (t__untyped)_func(_local_v1,_local_v2,NULL);				\
	    }									\
	}
 

#define EVAL_REL2NUMERIC(_op,_func)							\
	{									\
	    t__untyped v1 = EVAL(t__untyped,MY(e1__exp));			\
	    t__untyped v2 = EVAL(t__untyped,MY(e2__exp));			\
	    v1 = EVAL_CAST_UNTYPED(v1,me->numeric2cast->cast1);			\
	    v2 = EVAL_CAST_UNTYPED(v2,me->numeric2cast->cast2);			\
	    switch (me->numeric2cast->cast1) {					\
	        case cast__none:						\
	        case cast__int:							\
	        case cast__uint2int:						\
	        case cast__long2int:						\
	        case cast__ulong2int:						\
		    return (t__untyped)((int)(v1) _op (int)(v2));		\
	        case cast__uint:						\
	        case cast__int2uint:						\
	        case cast__long2uint:						\
	        case cast__ulong2uint:						\
		    return (t__untyped)((t__uint)(v1) _op (t__uint)(v2));	\
	        default:							\
		    return (t__untyped)_func(v1,v2);				\
	    }									\
	}


#define EVAL_CAST_UNTYPED(_val,_cast) (                       \
        _cast == cast__none        ||			      \
	_cast == cast__int         ||				\
	_cast == cast__uint        ||				\
        _cast == cast__int2uint    ||                         \
        _cast == cast__uint2int    ||                         \
        _cast == cast__int2float   ||                         \
        _cast == cast__float2int   ||                         \
        _cast == cast__uint2float  ||                         \
        _cast == cast__float2uint   ? (t__untyped)(_val) :		      \
        (_cast == cast__int2long   ||                         \
         _cast == cast__int2ulong   ? (t__untyped)sn_int2long(_val,NULL)    :  \
        (_cast == cast__uint2long  ||                         \
         _cast == cast__uint2ulong  ? (t__untyped)sn_uint2long(_val,NULL)   :  \
        (_cast == cast__float2long ||                         \
         _cast == cast__float2ulong ? (t__untyped)sn_float2long(_val,NULL)  :  \
        (_cast == cast__long2int   ||                         \
         _cast == cast__ulong2int   ? (t__untyped)sn_long2int(_val)    :  \
        (_cast == cast__long2uint  ||                         \
         _cast == cast__ulong2uint  ? (t__untyped)sn_long2uint(_val)   :  \
        (_cast == cast__long2float ||                         \
         _cast == cast__ulong2float ? (t__untyped)sn_long2float(_val)  :  \
                                      (t__untyped)(_val)   )))))))

      /* Max no. of params in a routine including me. When changed, update */
      /* manually in call_anything() and call_from_dispatch_table() */
int *car_value();
int *on_ar_value();
t__untyped call_anything();
void sn_show_source();
void sn_show_source_item();
t__list and_range_list(); 
t__list or_range_list(); 
t__list remove_range_list();
t__module source_item_module();
t__file_contents get_file_contents();
void change_exp();

/* line 289 "/proj/specman/src/basic_exp.e"  From 'H code' */

extern int sn_developer_mode;

#define ASSERT_LIST_ITEM_EXISTS(list,index,src) \
        (LIST_ITEM_EXISTS(list, index) ? 1 : \
         (SN_ERR(ACCESS_ITEM_IN_LIST, \
                 ((LIST_IS_EMPTY(list) ? "is empty" : \
                   sf("has only %d items", LIST_SIZE(list))), index, \
                   src)), 0))

#define SN_CHECK_BIT_EXTRACT_INDEX(low,high,hexp,lexp,src) \
        ((low)>(high) ? (SN_ERR(ERR_REXP_SMALLER_LEXP,(hexp,lexp,src)), 0) :\
         (low)<0 ? (SN_ERR(NEG_NO,(hexp,src)), 0) : 1)

#define SN_CHECK_INDEX_RANGE(low,high,size,what1,what2,type_name,hexp,lexp,src) \
        (SN_CHECK_BIT_EXTRACT_INDEX(low,high,hexp,lexp,src),\
         ((high) >= (size) ? (SN_ERR(RANGE_TOO_WIDE,(high,low,sf(type_name,size),src)), 0) : 1))

/* line 513 "/proj/specman/src/indexing.e"  From 'H code' */

#define SN_GET_CHECKED_WRAPPER_WRAPPER(routine,err,hexp,lexp,exp_src,src,size_shift,low,high,width,real_low,real_high) \
    (SN_CHECK_INDEX_RANGE(real_low,real_high,width,"extract","from",sf(err,width),hexp,lexp,exp_src),\
     routine(src,real_low,(real_high)-(real_low)+1))

#define SN_GET_CHECKED_WRAPPER(routine,err,hexp,lexp,exp_src,src,size_shift,low,high,width) \
    SN_GET_CHECKED_WRAPPER_WRAPPER(routine,err,hexp,lexp,exp_src,src,size_shift,low,high,width,(low)*(size_shift),((high) + 1) * (size_shift) - 1)

#define SN_GET_CHECKED_WRAPPER_NOSIZESHIFT(routine,err,hexp,lexp,exp_src,src,low,high,width) \
    SN_GET_CHECKED_WRAPPER_WRAPPER(routine,err,hexp,lexp,exp_src,src,1,low,high,width,low,high)

#define SN_GET_BITS_CHECKED(source_uint,size_shift,low,high,width,hexp,lexp,exp_src) \
    SN_GET_CHECKED_WRAPPER(sn_get_bits,"uint(bits: %d)",hexp,lexp,exp_src,source_uint,size_shift,low,high,width)

#define SN_FIXED_VEC_GET_BITS_CHECKED(sv,size_shift,low,high,width,hexp,lexp,exp_src) \
    SN_GET_CHECKED_WRAPPER(fixed_sn_vec_get_bits,"long(%d)",hexp,lexp,exp_src,sv,size_shift,low,high,width)

#define SN_GET_BITS_CHECKED_NOSIZESHIFT(source_uint,size_shift,low,high,width,hexp,lexp,exp_src) \
    SN_GET_CHECKED_WRAPPER_NOSIZESHIFT(sn_get_bits,"uint(bits: %d)",hexp,lexp,exp_src,source_uint,low,high,width)

#define SN_FIXED_VEC_GET_BITS_CHECKED_NOSIZESHIFT(sv,size_shift,low,high,width,hexp,lexp,exp_src) \
    SN_GET_CHECKED_WRAPPER_NOSIZESHIFT(fixed_sn_vec_get_bits,"long(%d)",hexp,lexp,exp_src,sv,low,high,width)

#define SN_GET_FROM_LIST_CHECKED_WRAPPER_WRAPPER(routine,err,hexp,lexp,exp_src,src,size_shift,low,high,width,is_signed,st,real_low,real_high) \
    (SN_CHECK_INDEX_RANGE(real_low,real_high,width,"extract","from",sf(err,width),hexp,lexp,exp_src),\
     routine(src,real_low,(real_high)-(real_low)+1,is_signed,st))

#define SN_GET_FROM_LIST_CHECKED_WRAPPER(routine,err,hexp,lexp,exp_src,src,size_shift,low,high,width,is_signed,st) \
    SN_GET_FROM_LIST_CHECKED_WRAPPER_WRAPPER(routine,err,hexp,lexp,exp_src,src,size_shift,low,high,width,is_signed,st,(low)*(size_shift),((high) + 1) * (size_shift) - 1)

#define SN_GET_FROM_LIST_CHECKED_WRAPPER_NOSIZESHIFT(routine,err,hexp,lexp,exp_src,src,low,high,width,is_signed,st) \
    SN_GET_FROM_LIST_CHECKED_WRAPPER_WRAPPER(routine,err,hexp,lexp,exp_src,src,1,low,high,width,is_signed,st,low,high)

#define SN_GET_LONG_FROM_LIST_CHECKED(src,low,high,is_signed,size_shift,st,width,err,hexp,lexp,exp_src) \
    SN_GET_FROM_LIST_CHECKED_WRAPPER(sn_get_long_from_list,err,hexp,lexp,exp_src,src,size_shift,low,high,width,is_signed,st)

#define SN_GET_LONG_FROM_LIST_CHECKED_NOSIZESHIFT(src,low,high,is_signed,size_shift,st,width,err,hexp,lexp,exp_src) \
    SN_GET_FROM_LIST_CHECKED_WRAPPER_NOSIZESHIFT(sn_get_long_from_list,err,hexp,lexp,exp_src,src,low,high,width,is_signed,st)

#define SN_VEC_GET_VEC_CHECKED(src,low,high,is_signed,size_shift,st,width,err,hexp,lexp,exp_src) \
    SN_GET_FROM_LIST_CHECKED_WRAPPER(sn_vec_get_vec,err,hexp,lexp,exp_src,src,size_shift,low,high,width,is_signed,st)

#define SN_VEC_GET_VEC_CHECKED_NOSIZESHIFT(src,low,high,is_signed,size_shift,st,width,err,hexp,lexp,exp_src) \
    SN_GET_FROM_LIST_CHECKED_WRAPPER_NOSIZESHIFT(sn_vec_get_vec,err,hexp,lexp,exp_src,src,low,high,width,is_signed,st)

#define SN_VEC_GET_VEC_FAST_CHECKED(src,low,high,is_signed,size_shift,st,width,err,hexp,lexp,exp_src) \
    SN_GET_FROM_LIST_CHECKED_WRAPPER(sn_vec_get_vec_fast,err,hexp,lexp,exp_src,src,size_shift,low,high,width,is_signed,st)

#define SN_VEC_GET_VEC_FAST_CHECKED_NOSIZESHIFT(src,low,high,is_signed,size_shift,st,width,err,hexp,lexp,exp_src) \
    SN_GET_FROM_LIST_CHECKED_WRAPPER_NOSIZESHIFT(sn_vec_get_vec_fast,err,hexp,lexp,exp_src,src,low,high,width,is_signed,st)

#define SN_VEC_GET_FROM_LBYTE_CHECKED(src,low,high,is_signed,size_shift,st,width,err,hexp,lexp,exp_src) \
    SN_GET_FROM_LIST_CHECKED_WRAPPER(sn_vec_get_from_lbyte,err,hexp,lexp,exp_src,src,size_shift,low,high,width,is_signed,st)

#define SN_VEC_GET_FROM_LBYTE_CHECKED_NOSIZESHIFT(src,low,high,is_signed,size_shift,st,width,err,hexp,lexp,exp_src) \
    SN_GET_FROM_LIST_CHECKED_WRAPPER_NOSIZESHIFT(sn_vec_get_from_lbyte,err,hexp,lexp,exp_src,src,low,high,width,is_signed,st)

#define SN_VEC_GET_FROM_LBIT_CHECKED(src,low,high,is_signed,size_shift,st,width,err,hexp,lexp,exp_src) \
    SN_GET_FROM_LIST_CHECKED_WRAPPER(sn_vec_get_from_lbit,err,hexp,lexp,exp_src,src,size_shift,low,high,width,is_signed,st)

#define SN_VEC_GET_FROM_LBIT_CHECKED_NOSIZESHIFT(src,low,high,is_signed,size_shift,st,width,err,hexp,lexp,exp_src) \
    SN_GET_FROM_LIST_CHECKED_WRAPPER_NOSIZESHIFT(sn_vec_get_from_lbit,err,hexp,lexp,exp_src,src,low,high,width,is_signed,st)

/* line 100 "/proj/specman/src/range.e"  From 'H code' */
#define EVAL_CONSTANT_EXP(_e,_t)	(sn_constant2holder((_e),(_t)))
#define IS_TYPE_RANGE_COMPAT(_td) ((_td) && (IS_NUMERIC(_td) || IS_ENUM(_td)))

/* line 118 "/proj/specman/src/range.e"  From 'H code' */
#define CONSTANT_RANGE_LIST(_d)	(LIST_ITEM(GLOB_ST->constant_range_lists,(_d)))
/* line 52 "/proj/specman/src/named_exp.e"  From 'H code' */
extern t__symtab sn_symtab;
extern t__session sn_session;
extern t__files sn_files;
extern t__pgen sn_pgen;
extern t__simulator sn_simulator;
extern t__scheduler sn_scheduler;
extern t__pgen3 sn_pgen3;
/* line 34 "/proj/specman/src/exp_assign.e"  From 'H code' */

#define SN_PUT_CHECKED_WRAPPER_WRAPPER(routine,err,hexp,lexp,exp_src,dest,src,size_shift,low,high,width,real_low,real_high) \
    (SN_CHECK_INDEX_RANGE(real_low,real_high,width,"assign","of",sf(err,width),hexp,lexp,exp_src),\
     routine(dest,real_low,(real_high)-(real_low)+1,src))

#define SN_PUT_CHECKED_WRAPPER(routine,err,hexp,lexp,exp_src,dest,src,size_shift,low,high,width) \
    SN_PUT_CHECKED_WRAPPER_WRAPPER(routine,err,hexp,lexp,exp_src,dest,src,size_shift,low,high,width,(low)*(size_shift),((high) + 1) * (size_shift) - 1)

#define SN_PUT_CHECKED_WRAPPER_NOSIZESHIFT(routine,err,hexp,lexp,exp_src,dest,src,low,high,width) \
    SN_PUT_CHECKED_WRAPPER_WRAPPER(routine,err,hexp,lexp,exp_src,dest,src,1,low,high,width,low,high)

#define SN_PUT_BITS_CHECKED(dest,size_shift,low,high,value,width,hexp,lexp,exp_src) \
    SN_PUT_CHECKED_WRAPPER(sn_put_bits,"[u]int(bits: %d)",hexp,lexp,exp_src,dest,value,size_shift,low,high,width)

#define SN_PUT_BITS_CHECKED_NOSIZESHIFT(dest,size_shift,low,high,value,width,hexp,lexp,exp_src) \
    SN_PUT_CHECKED_WRAPPER_NOSIZESHIFT(sn_put_bits,"[u]int(bits: %d)",hexp,lexp,exp_src,dest,value,low,high,width)

#define SN_PUT_VEC_CHECKED_WRAPPER_WRAPPER(routine,err,hexp,lexp,exp_src,dest,src,size_shift,low,high,width,st,real_low,real_high) \
    (SN_CHECK_INDEX_RANGE(real_low,real_high,width,"assign","of",sf(err,width),hexp,lexp,exp_src),\
     routine(dest,real_low,(real_high)-(real_low)+1,src,st))

#define SN_PUT_VEC_CHECKED_WRAPPER(routine,err,hexp,lexp,exp_src,dest,src,size_shift,low,high,width,st) \
    SN_PUT_VEC_CHECKED_WRAPPER_WRAPPER(routine,err,hexp,lexp,exp_src,dest,src,size_shift,low,high,width,st,(low)*(size_shift),((high) + 1) * (size_shift) - 1)

#define SN_PUT_VEC_CHECKED_WRAPPER_NOSIZESHIFT(routine,err,hexp,lexp,exp_src,dest,src,low,high,width,st) \
    SN_PUT_VEC_CHECKED_WRAPPER_WRAPPER(routine,err,hexp,lexp,exp_src,dest,src,1,low,high,width,st,low,high)

#define SN_VEC_PUT_VEC_CHECKED(dest,size_shift,low,high,value,width,st,hexp,lexp,exp_src) \
    SN_PUT_VEC_CHECKED_WRAPPER(sn_vec_put_vec,"long(%d)",hexp,lexp,exp_src,dest,value,size_shift,low,high,width,st)

#define SN_VEC_PUT_VEC_CHECKED_NOSIZESHIFT(dest,size_shift,low,high,value,width,st,hexp,lexp,exp_src) \
    SN_PUT_VEC_CHECKED_WRAPPER_NOSIZESHIFT(sn_vec_put_vec,"long(%d)",hexp,lexp,exp_src,dest,value,low,high,width,st)

/* line 8 "/proj/specman/src/version.e"  From 'H code' */
#define SPECMAN_VERSION_4_0_OR_LATER
#define SPECMAN_VERSION_4_0_1_OR_LATER
/* line 170 "/proj/specman/src/err_script.e"  From 'H code' */
#define SPECMAN_VERSION_4_0_1
/* line 47 "/proj/specman/src/scriptsim.e"  From 'H code' */
#define GLOB_UNITS    ((t__units)(GLOB->units))
/* line 70 "/proj/specman/src/scriptsim.e"  From 'H code' */
#define SYS ((t__sys)(GLOB->sys))
SN_STRING sn_str_expand_dots();
#define COMPAT ((t__compatibility_options)(GLOB->compatibility_options))
/* line 279 "/proj/specman/src/scriptsim.e"  From 'H code' */
    extern struct s__l__untyped *sn_signal_locals;
/* line 359 "/proj/specman/src/script.e"  From 'H code' */
#define IS_BREAK_ENTRY(e)	(((e)->d__ == d__while_true_entry) \
				||((e)->d__ == d__for_each_entry))

/* line 772 "/proj/specman/src/script.e"  From 'H code' */
#define MY_EI		    (me->ei)
#define BASE_ENTRY          (LIST_ITEM(((t__sequence_entry)(me->script_descriptor->base_entry))->children,1)->entry_index)
#define GET_ENTRY(ind)      ((t__entry)LIST_ITEM(me->script_descriptor->all_entries,ind))
#define NEXT_ENTRY 	    ((MY_EI)->next_for_code)
#define ENTRY_CYCLES	    ((MY_EI)->cycles_in_child)
#define SET_ENTRY_CYCLES(n) (ENTRY_CYCLES=(n))
#define DEC_ENTRY_CYCLES    (ENTRY_CYCLES -= 1)
#define EXIT_ENTRY	    {SET_ENTRY_CYCLES(0);(MY_EI)->status=match_status__SUCCEEDED;}
#define MOVE_TO_ENTRY(n)    {INCR_VISITS;EXIT_ENTRY;NEXT_ENTRY=(n);break;}
#define RETURN_TO_ENTRY(n)  {INCR_VISITS;SET_ENTRY_CYCLES(1);NEXT_ENTRY=(n);break;}
#define INCR_ENTRY_CYCLES   ENTRY_CYCLES++;
#define RETURN_ENTRY(st)    {me->match_status=(st);(MY_EI)->status=(st);INCR_ENTRY_CYCLES; return;}
#define FIRST_TIME_IN_ENTRY (ENTRY_CYCLES<=0)
#define CHECK_BREAK	    ((MY_EI)->status==match_status__BREAK)
#define INCR_VISITS         ((MY_EI)->script_instance->visits)++
/* line 12 "/proj/specman/src/scriptact.e"  From 'H code' */
#define SCRIPT_CAR_VALUE(si,sd,ind)	((ind)>=0?(CAR_VALUE(ind))\
				:GET_FIELD((si),(sd)->fields[-(ind)]))
/* line 89 "/proj/specman/src/rl_lang.e"  From 'H code' */
#define SN_NEW_CONSTANT_RANGE_LIST(_d)	(LIST_ITEM(GLOB_ST->new_constant_rls,(_d)))
/* line 562 "/proj/specman/src/hdl_struct.e"  From 'H code' */
#include <sys/types.h>
typedef struct sn_call_back_struct{
     void *ptr;
     void *ud;
     int event_id;
     int index_in_info;
     time_t  valid_initial_time;
 } sn_call_back_struct,*psn_call_back_struct;
/* line 34 "/proj/specman/src/hdl_access.e"  From 'H code' */
#define GLOB_SIM_EXPS ((t__simulator)(GLOB->simulator))->hdls_exp_info
#define GLOB_UNITS    ((t__units)(GLOB->units))    
/* line 29 "/proj/specman/src/scheduler.e"  From 'H code' */
#define GLOB_SESS_TIME  ((t__longTime)(GLOB->session->longTime))  
/* line 166 "/proj/specman/src/te_tick.e"  From 'H code' */
#define GLOB_SCHED ((t__scheduler)(GLOB->scheduler))
/* line 18 "/proj/specman/src/te_utils.e"  From 'H code' */
#define SIM_DELST ((t__delayList)(GLOB_SIM->delayList))
#define LAST_DELST ((t__low_high)(GLOB_SIM->delayList->lastlh))
#define GLOB_SCED  ((t__scheduler)(GLOB->scheduler))       
/* line 108 "/proj/specman/src/times.e"  From 'H code' */
#ifdef SUN_C
#undef  ushort
#undef  uint
#endif
#include <limits.h>
#define m__snfp_floating_point_s__set 23
#define m__snfp_floating_point_s__as_bin 24
#define m__snfp_floating_point_s__lt 25
#define m__snfp_floating_point_s__eq 26
#define m__snfp_floating_point_function_s__do_fp 23
#define m__snfp_floating_point_function_s__lt 24
#define m__snfp_floating_point_function_s__lte 25
#define m__snfp_floating_point_function_s__eq 26
#define m__snfp_rnd_fp_s__init 0
#define m__snfp_rnd_fp_s__do_unpack_field 15
#define m__snfp_rnd_fp_s__to_str_rep 23
#define m__snfp_rnd_fp_s__post_generate 12
#define m__sn_compute_select_struct__compute_select_single 10
#define m__sn_compute_select_struct__compute_select_rl 9
#define m__sn_compute_select_struct__compute_select_others 12
#define m__snfp_floating_point_s__to_str 27
#define m__snfp_floating_point_s__snfp_to_efp_rep 28
#define m__snfp_floating_point_s__str_rep_to_snfp 29
#define m__snfp_floating_point_s__efp_to_snfp_rep 30
#define m__snfp_floating_point_s__c_str_to_efp 31
#define m__SINGLE__kind__snfp_floating_point_s__snfp_to_efp_rep 28
#define m__SINGLE__kind__snfp_floating_point_s__efp_to_snfp_rep 30
#define m__SINGLE__kind__snfp_floating_point_s__to_str 27
#define m__SINGLE__kind__snfp_floating_point_s__as_bin 24
#define m__SINGLE__kind__snfp_floating_point_s__post_generate 12
#define m__SINGLE__kind__snfp_floating_point_s__init 0
#define m__DOUBLE__kind__snfp_floating_point_s__snfp_to_efp_rep 28
#define m__DOUBLE__kind__snfp_floating_point_s__efp_to_snfp_rep 30
#define m__DOUBLE__kind__snfp_floating_point_s__to_str 27
#define m__DOUBLE__kind__snfp_floating_point_s__as_bin 24
#define m__DOUBLE__kind__snfp_floating_point_s__post_generate 12
#define m__DOUBLE__kind__snfp_floating_point_s__init 0
#define m__snfp_floating_point_s__post_generate 12
#define m__snfp_floating_point_function_s__snfp_fn 27
#define m__snfp_floating_point_function_s__alloc 28
#define m__snfp_floating_point_function_s__init 0
#define m__any_struct__root___run 18
#define m__scalar_range_list__in_range_list_unsafe 9
#define m__pgen3__gen_on_the_fly 150
#define m__pgen_parser__get_the_ar 20
#define m__ref_param__eval4get 7
#define m__ref_param__eval4set 9
#define m__ref_param__eval4get_ref 8

/* l__string */ 
typedef struct s__l__string {
    t__int d__;
    t__int gen__;
    t__string*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__string;
#define d__l__string 56   


/* l__instance_path_t */ 
typedef struct s__l__instance_path_t {
    t__int d__;
    t__int gen__;
    struct s__instance_path_t **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__instance_path_t;
#define d__l__instance_path_t 1554   


/* l__sn_dynamic_call */ 
typedef struct s__l__sn_dynamic_call {
    t__int d__;
    t__int gen__;
    struct s__sn_dynamic_call **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_dynamic_call;
#define d__l__sn_dynamic_call 1506   


/* l__any_unit */ 
typedef struct s__l__any_unit {
    t__int d__;
    t__int gen__;
    struct s__any_unit **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__any_unit;
#define d__l__any_unit 51   


/* k__module__name */ 
typedef struct s__k__module__name {
    t__int d__;
    t__int gen__;
    struct s__module **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__module__name;
#define d__k__module__name 42   


/* l__type_layer */ 
typedef struct s__l__type_layer {
    t__int d__;
    t__int gen__;
    struct s__type_layer **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__type_layer;
#define d__l__type_layer 105   


/* l__form */ 
typedef struct s__l__form {
    t__int d__;
    t__int gen__;
    struct s__form **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__form;
#define d__l__form 43   


/* l__field */ 
typedef struct s__l__field {
    t__int d__;
    t__int gen__;
    struct s__field **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__field;
#define d__l__field 117   


/* l__method */ 
typedef struct s__l__method {
    t__int d__;
    t__int gen__;
    struct s__method **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__method;
#define d__l__method 46   


/* l__local */ 
typedef struct s__l__local {
    t__int d__;
    t__int gen__;
    struct s__local **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__local;
#define d__l__local 139   


/* l__struct_descriptor */ 
typedef struct s__l__struct_descriptor {
    t__int d__;
    t__int gen__;
    struct s__struct_descriptor **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__struct_descriptor;
#define d__l__struct_descriptor 118   


/* l__gen_constraint */ 
typedef struct s__l__gen_constraint {
    t__int d__;
    t__int gen__;
    struct s__gen_constraint **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__gen_constraint;
#define d__l__gen_constraint 45   


/* l__n__action */ 
typedef struct s__l__n__action {
    t__int d__;
    t__int gen__;
    struct s__n__action **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__n__action;
#define d__l__n__action 400   


/* l__index */ 
typedef struct s__l__index {
    t__int d__;
    t__int gen__;
    t__index*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__index;
#define d__l__index 1155   


/* l__field_holder */ 
typedef struct s__l__field_holder {
    t__int d__;
    t__int gen__;
    struct s__field_holder **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__field_holder;
#define d__l__field_holder 1301   


/* l__simple_gen_constraint */ 
typedef struct s__l__simple_gen_constraint {
    t__int d__;
    t__int gen__;
    struct s__simple_gen_constraint **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__simple_gen_constraint;
#define d__l__simple_gen_constraint 1290   


/* l__gc_order_info */ 
typedef struct s__l__gc_order_info {
    t__int d__;
    t__int gen__;
    struct s__gc_order_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__gc_order_info;
#define d__l__gc_order_info 1260   


/* l__any_rl */ 
typedef struct s__l__any_rl {
    t__int d__;
    t__int gen__;
    struct s__any_rl **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__any_rl;
#define d__l__any_rl 1262   


/* l__constraint_path */ 
typedef struct s__l__constraint_path {
    t__int d__;
    t__int gen__;
    struct s__constraint_path **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__constraint_path;
#define d__l__constraint_path 1263   


/* l__soft_gc */ 
typedef struct s__l__soft_gc {
    t__int d__;
    t__int gen__;
    struct s__soft_gc **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__soft_gc;
#define d__l__soft_gc 1291   


/* l__bool */ 
typedef struct s__l__bool {
    t__int d__;
    t__int gen__;
    t__bool*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__bool;
#define d__l__bool 84   


/* l__a_role */ 
typedef struct s__l__a_role {
    t__int d__;
    t__int gen__;
    struct s__a_role **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__a_role;
#define d__l__a_role 1254   


/* l__om_edge */ 
typedef struct s__l__om_edge {
    t__int d__;
    t__int gen__;
    struct s__om_edge **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__om_edge;
#define d__l__om_edge 1298   


/* l__om_alt_edge */ 
typedef struct s__l__om_alt_edge {
    t__int d__;
    t__int gen__;
    struct s__om_alt_edge **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__om_alt_edge;
#define d__l__om_alt_edge 3509   


/* l__om_edge_reason */ 
typedef struct s__l__om_edge_reason {
    t__int d__;
    t__int gen__;
    t__om_edge_reason*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__om_edge_reason;
#define d__l__om_edge_reason 1302   


/* l__role_edge */ 
typedef struct s__l__role_edge {
    t__int d__;
    t__int gen__;
    struct s__role_edge **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__role_edge;
#define d__l__role_edge 1253   


/* l__field_gen_role */ 
typedef struct s__l__field_gen_role {
    t__int d__;
    t__int gen__;
    struct s__field_gen_role **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__field_gen_role;
#define d__l__field_gen_role 1303   


/* l__status_in_role */ 
typedef struct s__l__status_in_role {
    t__int d__;
    t__int gen__;
    t__status_in_role*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__status_in_role;
#define d__l__status_in_role 1304   


/* l__role_gc_stat */ 
typedef struct s__l__role_gc_stat {
    t__int d__;
    t__int gen__;
    struct s__role_gc_stat **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__role_gc_stat;
#define d__l__role_gc_stat 1305   


/* l__verilog_variable_descriptor */ 
typedef struct s__l__verilog_variable_desc9788 {
    t__int d__;
    t__int gen__;
    struct s__verilog_variable_descriptor **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__verilog_variable_descriptor;
#define d__l__verilog_variable_descriptor 1550   


/* l__vhdl_driver_descriptor */ 
typedef struct s__l__vhdl_driver_descriptor {
    t__int d__;
    t__int gen__;
    struct s__vhdl_driver_descriptor **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__vhdl_driver_descriptor;
#define d__l__vhdl_driver_descriptor 1551   


/* k__subprogram_definition__s6623 */ 
typedef struct s__k__subprogram_definition9789 {
    t__int d__;
    t__int gen__;
    struct s__subprogram_definition **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__subprogram_definition__s6623;
#define d__k__subprogram_definition__s6623 1579   


/* l__subprogram_param */ 
typedef struct s__l__subprogram_param {
    t__int d__;
    t__int gen__;
    struct s__subprogram_param **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__subprogram_param;
#define d__l__subprogram_param 1562   


/* l__event_descriptor */ 
typedef struct s__l__event_descriptor {
    t__int d__;
    t__int gen__;
    struct s__event_descriptor **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__event_descriptor;
#define d__l__event_descriptor 119   


/* l__int */ 
typedef struct s__l__int {
    t__int d__;
    t__int gen__;
    t__int*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__int;
#define d__l__int 21   


/* l__single_callback_info */ 
typedef struct s__l__single_callback_info {
    t__int d__;
    t__int gen__;
    struct s__single_callback_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__single_callback_info;
#define d__l__single_callback_info 2044   


/* k__desc_info__the_desc */ 
typedef struct s__k__desc_info__the_desc {
    t__int d__;
    t__int gen__;
    struct s__desc_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__desc_info__the_desc;
#define d__k__desc_info__the_desc 1560   


/* l__hdl_element */ 
typedef struct s__l__hdl_element {
    t__int d__;
    t__int gen__;
    struct s__hdl_element **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__hdl_element;
#define d__l__hdl_element 1557   


/* k__driver_handle__inst_id */ 
typedef struct s__k__driver_handle__inst_id {
    t__int d__;
    t__int gen__;
    struct s__driver_handle **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__driver_handle__inst_id;
#define d__k__driver_handle__inst_id 1555   


/* l__base_struct */ 
typedef struct s__l__base_struct {
    t__int d__;
    t__int gen__;
    struct s__base_struct **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__base_struct;
#define d__l__base_struct 86   


/* l__sn_cvr_exp_wrapper */ 
typedef struct s__l__sn_cvr_exp_wrapper {
    t__int d__;
    t__int gen__;
    struct s__sn_cvr_exp_wrapper **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cvr_exp_wrapper;
#define d__l__sn_cvr_exp_wrapper 2556   


/* k__sn_cvr_instance_group_d19807 */ 
typedef struct s__k__sn_cvr_instance_grou22621 {
    t__int d__;
    t__int gen__;
    struct s__sn_cvr_instance_group_d22605 **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_cvr_instance_group_d19807;
#define d__k__sn_cvr_instance_group_d19807 2559   


/* l__sn_cvr_item_descriptor */ 
typedef struct s__l__sn_cvr_item_descriptor {
    t__int d__;
    t__int gen__;
    struct s__sn_cvr_item_descriptor **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cvr_item_descriptor;
#define d__l__sn_cvr_item_descriptor 2561   


/* l__sn_cover_bucket_descriptor */ 
typedef struct s__l__sn_cover_bucket_desc22618 {
    t__int d__;
    t__int gen__;
    struct s__sn_cover_bucket_descriptor **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cover_bucket_descriptor;
#define d__l__sn_cover_bucket_descriptor 2570   


/* l__n__cover_range_params */ 
typedef struct s__l__n__cover_range_params {
    t__int d__;
    t__int gen__;
    struct s__n__cover_range_params **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__n__cover_range_params;
#define d__l__n__cover_range_params 2571   


/* l__sn_cover_distribution */ 
typedef struct s__l__sn_cover_distribution {
    t__int d__;
    t__int gen__;
    struct s__sn_cover_distribution **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cover_distribution;
#define d__l__sn_cover_distribution 2573   


/* l__sn_cvr_show_status */ 
typedef struct s__l__sn_cvr_show_status {
    t__int d__;
    t__int gen__;
    t__sn_cvr_show_status*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cvr_show_status;
#define d__l__sn_cvr_show_status 2576   


/* l__c_float */ 
typedef struct s__l__c_float {
    t__int d__;
    t__int gen__;
    t__c_float*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__c_float;
#define d__l__c_float 2577   


/* l__uint */ 
typedef struct s__l__uint {
    t__int d__;
    t__int gen__;
    t__uint*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__uint;
#define d__l__uint 156   


/* l__sn_cover_item_inst */ 
typedef struct s__l__sn_cover_item_inst {
    t__int d__;
    t__int gen__;
    struct s__sn_cover_item_inst **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cover_item_inst;
#define d__l__sn_cover_item_inst 2572   


/* l__sn_cover_group_inst */ 
typedef struct s__l__sn_cover_group_inst {
    t__int d__;
    t__int gen__;
    struct s__sn_cover_group_inst **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cover_group_inst;
#define d__l__sn_cover_group_inst 2580   


/* l__bit */ 
typedef struct s__l__bit {
    t__int d__;
    t__int gen__;
    t__bit*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__bit;
#define d__l__bit 68   


/* l__cover_struct */ 
typedef struct s__l__cover_struct {
    t__int d__;
    t__int gen__;
    struct s__cover_struct **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__cover_struct;
#define d__l__cover_struct 2617   


/* l__bool__8 */ 
typedef struct s__l__bool__8 {
    t__int d__;
    t__int gen__;
    t__bool__8*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__bool__8;
#define d__l__bool__8 2616   


/* l__sn_external_instance */ 
typedef struct s__l__sn_external_instance {
    t__int d__;
    t__int gen__;
    struct s__sn_external_instance **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_external_instance;
#define d__l__sn_external_instance 2605   


/* l__sn_external_item */ 
typedef struct s__l__sn_external_item {
    t__int d__;
    t__int gen__;
    struct s__sn_external_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_external_item;
#define d__l__sn_external_item 2603   


/* l__sn_cvr_bucket_rank_desc21734 */ 
typedef struct s__l__sn_cvr_bucket_rank_d22620 {
    t__int d__;
    t__int gen__;
    struct s__sn_cvr_bucket_rank_desc22665 **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cvr_bucket_rank_desc21734;
#define d__l__sn_cvr_bucket_rank_desc21734 2728   


/* l__sn_cvr_item_attributes */ 
typedef struct s__l__sn_cvr_item_attributes {
    t__int d__;
    t__int gen__;
    struct s__sn_cvr_item_attributes **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cvr_item_attributes;
#define d__l__sn_cvr_item_attributes 2560   


/* l__wave_event_element */ 
typedef struct s__l__wave_event_element {
    t__int d__;
    t__int gen__;
    struct s__wave_event_element **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__wave_event_element;
#define d__l__wave_event_element 3060   


/* l__abs_wave_entry */ 
typedef struct s__l__abs_wave_entry {
    t__int d__;
    t__int gen__;
    struct s__abs_wave_entry **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__abs_wave_entry;
#define d__l__abs_wave_entry 3047   


/* l__context_item */ 
typedef struct s__l__context_item {
    t__int d__;
    t__int gen__;
    struct s__context_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__context_item;
#define d__l__context_item 174   


/* l__final_fgr_info */ 
typedef struct s__l__final_fgr_info {
    t__int d__;
    t__int gen__;
    struct s__final_fgr_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__final_fgr_info;
#define d__l__final_fgr_info 3542   


/* l__gen_command */ 
typedef struct s__l__gen_command {
    t__int d__;
    t__int gen__;
    struct s__gen_command **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__gen_command;
#define d__l__gen_command 3545   


/* l__macro_descriptor */ 
typedef struct s__l__macro_descriptor {
    t__int d__;
    t__int gen__;
    struct s__macro_descriptor **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__macro_descriptor;
#define d__l__macro_descriptor 178   


/* l__ntv */ 
typedef struct s__l__ntv {
    t__int d__;
    t__int gen__;
    struct s__ntv **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__ntv;
#define d__l__ntv 49   


/* l__n__statement */ 
typedef struct s__l__n__statement {
    t__int d__;
    t__int gen__;
    struct s__n__statement **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__n__statement;
#define d__l__n__statement 190   


/* k__routine__name */ 
typedef struct s__k__routine__name {
    t__int d__;
    t__int gen__;
    struct s__routine **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__routine__name;
#define d__k__routine__name 44   


/* k__pseudo_m_r__name */ 
typedef struct s__k__pseudo_m_r__name {
    t__int d__;
    t__int gen__;
    struct s__pseudo_m_r **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__pseudo_m_r__name;
#define d__k__pseudo_m_r__name 47   


/* l__sn_vec */ 
typedef struct s__l__sn_vec {
    t__int d__;
    t__int gen__;
    struct s__sn_vec **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_vec;
#define d__l__sn_vec 48   


/* k__both__long_str */ 
typedef struct s__k__both__long_str {
    t__int d__;
    t__int gen__;
    struct s__both **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__both__long_str;
#define d__k__both__long_str 61   


/* k__sn_exception__name */ 
typedef struct s__k__sn_exception__name {
    t__int d__;
    t__int gen__;
    struct s__sn_exception **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_exception__name;
#define d__k__sn_exception__name 327   


/* l__untyped */ 
typedef struct s__l__untyped {
    t__int d__;
    t__int gen__;
    t__untyped*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__untyped;
#define d__l__untyped 94   


/* k__string__it */ 
typedef struct s__k__string__it {
    t__int d__;
    t__int gen__;
    t__string*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__string__it;
#define d__k__string__it 328   


/* k__vertice__name */ 
typedef struct s__k__vertice__name {
    t__int d__;
    t__int gen__;
    struct s__vertice **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__vertice__name;
#define d__k__vertice__name 29   


/* l__vertice */ 
typedef struct s__l__vertice {
    t__int d__;
    t__int gen__;
    struct s__vertice **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__vertice;
#define d__l__vertice 24   


/* l__cyclic_import_pair */ 
typedef struct s__l__cyclic_import_pair {
    t__int d__;
    t__int gen__;
    struct s__cyclic_import_pair **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__cyclic_import_pair;
#define d__l__cyclic_import_pair 1198   


/* l__scc_item */ 
typedef struct s__l__scc_item {
    t__int d__;
    t__int gen__;
    struct s__scc_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__scc_item;
#define d__l__scc_item 27   


/* l__cast */ 
typedef struct s__l__cast {
    t__int d__;
    t__int gen__;
    t__cast*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__cast;
#define d__l__cast 422   


/* l__n__exp */ 
typedef struct s__l__n__exp {
    t__int d__;
    t__int gen__;
    struct s__n__exp **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__n__exp;
#define d__l__n__exp 425   


/* l__scalar_range_list */ 
typedef struct s__l__scalar_range_list {
    t__int d__;
    t__int gen__;
    struct s__scalar_range_list **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__scalar_range_list;
#define d__l__scalar_range_list 685   


/* l__sn_uint_list_holder */ 
typedef struct s__l__sn_uint_list_holder {
    t__int d__;
    t__int gen__;
    struct s__sn_uint_list_holder **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_uint_list_holder;
#define d__l__sn_uint_list_holder 742   


/* l__script_descriptor */ 
typedef struct s__l__script_descriptor {
    t__int d__;
    t__int gen__;
    struct s__script_descriptor **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__script_descriptor;
#define d__l__script_descriptor 819   


/* l__entry */ 
typedef struct s__l__entry {
    t__int d__;
    t__int gen__;
    struct s__entry **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__entry;
#define d__l__entry 979   


/* l__check */ 
typedef struct s__l__check {
    t__int d__;
    t__int gen__;
    struct s__check **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__check;
#define d__l__check 883   


/* l__sn_run_time_match_check */ 
typedef struct s__l__sn_run_time_match_check {
    t__int d__;
    t__int gen__;
    struct s__sn_run_time_match_check **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_run_time_match_check;
#define d__l__sn_run_time_match_check 882   


/* l__scalar_rl */ 
typedef struct s__l__scalar_rl {
    t__int d__;
    t__int gen__;
    struct s__scalar_rl **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__scalar_rl;
#define d__l__scalar_rl 1134   


/* l__local_frame */ 
typedef struct s__l__local_frame {
    t__int d__;
    t__int gen__;
    struct s__local_frame **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__local_frame;
#define d__l__local_frame 1356   


/* l__local_item */ 
typedef struct s__l__local_item {
    t__int d__;
    t__int gen__;
    struct s__local_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__local_item;
#define d__l__local_item 1354   


/* l__error_recovery */ 
typedef struct s__l__error_recovery {
    t__int d__;
    t__int gen__;
    struct s__error_recovery **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__error_recovery;
#define d__l__error_recovery 1983   


/* l__construct_keyword */ 
typedef struct s__l__construct_keyword {
    t__int d__;
    t__int gen__;
    struct s__construct_keyword **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__construct_keyword;
#define d__l__construct_keyword 1986   


/* l__te_header_desc */ 
typedef struct s__l__te_header_desc {
    t__int d__;
    t__int gen__;
    struct s__te_header_desc **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__te_header_desc;
#define d__l__te_header_desc 2028   


/* l__event_only_compile_data */ 
typedef struct s__l__event_only_compile_data {
    t__int d__;
    t__int gen__;
    struct s__event_only_compile_data **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__event_only_compile_data;
#define d__l__event_only_compile_data 2033   


/* k__struct_threads__struct_name */ 
typedef struct s__k__struct_threads__stru30097 {
    t__int d__;
    t__int gen__;
    struct s__struct_threads **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__struct_threads__struct_name;
#define d__k__struct_threads__struct_name 3022   


/* k__tcm__name */ 
typedef struct s__k__tcm__name {
    t__int d__;
    t__int gen__;
    struct s__tcm **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__tcm__name;
#define d__k__tcm__name 3021   


/* l__save_reduction_info */ 
typedef struct s__l__save_reduction_info {
    t__int d__;
    t__int gen__;
    struct s__save_reduction_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__save_reduction_info;
#define d__l__save_reduction_info 3467   


/* l__gendb_item */ 
typedef struct s__l__gendb_item {
    t__int d__;
    t__int gen__;
    struct s__gendb_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__gendb_item;
#define d__l__gendb_item 1473   


/* l__which_rl */ 
typedef struct s__l__which_rl {
    t__int d__;
    t__int gen__;
    t__which_rl*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__which_rl;
#define d__l__which_rl 3529   


/* l__field_node */ 
typedef struct s__l__field_node {
    t__int d__;
    t__int gen__;
    struct s__field_node **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__field_node;
#define d__l__field_node 1476   


/* l__compound_path_item */ 
typedef struct s__l__compound_path_item {
    t__int d__;
    t__int gen__;
    struct s__compound_path_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__compound_path_item;
#define d__l__compound_path_item 1446   


/* l__dangling_ci */ 
typedef struct s__l__dangling_ci {
    t__int d__;
    t__int gen__;
    struct s__dangling_ci **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__dangling_ci;
#define d__l__dangling_ci 1425   


/* l__sn_constraint_instance */ 
typedef struct s__l__sn_constraint_instance {
    t__int d__;
    t__int gen__;
    struct s__sn_constraint_instance **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_constraint_instance;
#define d__l__sn_constraint_instance 1453   


/* l__sn_cpi */ 
typedef struct s__l__sn_cpi {
    t__int d__;
    t__int gen__;
    struct s__sn_cpi **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cpi;
#define d__l__sn_cpi 1439   


/* l__deffered_gendb_item */ 
typedef struct s__l__deffered_gendb_item {
    t__int d__;
    t__int gen__;
    struct s__deffered_gendb_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__deffered_gendb_item;
#define d__l__deffered_gendb_item 3606   


/* l__count */ 
typedef struct s__l__count {
    t__int d__;
    t__int gen__;
    t__count*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__count;
#define d__l__count 988   


/* l__sn_me_cpi */ 
typedef struct s__l__sn_me_cpi {
    t__int d__;
    t__int gen__;
    struct s__sn_me_cpi **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_me_cpi;
#define d__l__sn_me_cpi 3698   


/* l__uint_rl */ 
typedef struct s__l__uint_rl {
    t__int d__;
    t__int gen__;
    struct s__uint_rl **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__uint_rl;
#define d__l__uint_rl 1105   


/* l__int_rl */ 
typedef struct s__l__int_rl {
    t__int d__;
    t__int gen__;
    struct s__int_rl **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__int_rl;
#define d__l__int_rl 1165   


/* l__long_rl */ 
typedef struct s__l__long_rl {
    t__int d__;
    t__int gen__;
    struct s__long_rl **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__long_rl;
#define d__l__long_rl 1166   


/* l__struct_rl */ 
typedef struct s__l__struct_rl {
    t__int d__;
    t__int gen__;
    struct s__struct_rl **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__struct_rl;
#define d__l__struct_rl 1167   


/* l__string_rl */ 
typedef struct s__l__string_rl {
    t__int d__;
    t__int gen__;
    struct s__string_rl **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__string_rl;
#define d__l__string_rl 1168   


/* l__list_ci */ 
typedef struct s__l__list_ci {
    t__int d__;
    t__int gen__;
    struct s__list_ci **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__list_ci;
#define d__l__list_ci 1444   


/* l__sn_simple_constraint_in37190 */ 
typedef struct s__l__sn_simple_constraint37353 {
    t__int d__;
    t__int gen__;
    struct s__sn_simple_constraint_ins6608 **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_simple_constraint_in37190;
#define d__l__sn_simple_constraint_in37190 3701   


/* l__sn_gen_event */ 
typedef struct s__l__sn_gen_event {
    t__int d__;
    t__int gen__;
    struct s__sn_gen_event **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_gen_event;
#define d__l__sn_gen_event 3550   


/* l__sn_soft_testing_event */ 
typedef struct s__l__sn_soft_testing_event {
    t__int d__;
    t__int gen__;
    struct s__sn_soft_testing_event **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_soft_testing_event;
#define d__l__sn_soft_testing_event 3702   


/* l__sn_gendb_item */ 
typedef struct s__l__sn_gendb_item {
    t__int d__;
    t__int gen__;
    struct s__sn_gendb_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_gendb_item;
#define d__l__sn_gendb_item 3593   


/* l__sn_ci_status_changed */ 
typedef struct s__l__sn_ci_status_changed {
    t__int d__;
    t__int gen__;
    struct s__sn_ci_status_changed **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_ci_status_changed;
#define d__l__sn_ci_status_changed 3644   


/* l__not_fix_me_gendb_item */ 
typedef struct s__l__not_fix_me_gendb_item {
    t__int d__;
    t__int gen__;
    struct s__not_fix_me_gendb_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__not_fix_me_gendb_item;
#define d__l__not_fix_me_gendb_item 3586   


/* k__gendb_field_in_gen__f */ 
typedef struct s__k__gendb_field_in_gen__f {
    t__int d__;
    t__int gen__;
    struct s__gendb_field_in_gen **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__gendb_field_in_gen__f;
#define d__k__gendb_field_in_gen__f 3582   


/* k__gendb_ci_in_gen__gc */ 
typedef struct s__k__gendb_ci_in_gen__gc {
    t__int d__;
    t__int gen__;
    struct s__gendb_ci_in_gen **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__gendb_ci_in_gen__gc;
#define d__k__gendb_ci_in_gen__gc 3583   


/* l__gendb_ci_in_gen */ 
typedef struct s__l__gendb_ci_in_gen {
    t__int d__;
    t__int gen__;
    struct s__gendb_ci_in_gen **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__gendb_ci_in_gen;
#define d__l__gendb_ci_in_gen 3647   


/* k__gendb_field_in_role__f */ 
typedef struct s__k__gendb_field_in_role__f {
    t__int d__;
    t__int gen__;
    struct s__gendb_field_in_role **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__gendb_field_in_role__f;
#define d__k__gendb_field_in_role__f 3627   


/* l__changed_static_gendb_item */ 
typedef struct s__l__changed_static_gendb_item {
    t__int d__;
    t__int gen__;
    struct s__changed_static_gendb_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__changed_static_gendb_item;
#define d__l__changed_static_gendb_item 3632   


/* l__gendb_gc_in_role */ 
typedef struct s__l__gendb_gc_in_role {
    t__int d__;
    t__int gen__;
    struct s__gendb_gc_in_role **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__gendb_gc_in_role;
#define d__l__gendb_gc_in_role 3633   


/* l__sn_static_edge_event */ 
typedef struct s__l__sn_static_edge_event {
    t__int d__;
    t__int gen__;
    struct s__sn_static_edge_event **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_static_edge_event;
#define d__l__sn_static_edge_event 3628   


/* k__gendb_gc_in_role__gc */ 
typedef struct s__k__gendb_gc_in_role__gc {
    t__int d__;
    t__int gen__;
    struct s__gendb_gc_in_role **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__gendb_gc_in_role__gc;
#define d__k__gendb_gc_in_role__gc 3629   


/* l__and_info */ 
typedef struct s__l__and_info {
    t__int d__;
    t__int gen__;
    struct s__and_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__and_info;
#define d__l__and_info 3478   


/* l__status_in_and */ 
typedef struct s__l__status_in_and {
    t__int d__;
    t__int gen__;
    t__status_in_and*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__status_in_and;
#define d__l__status_in_and 3475   


/* l__gen_constraint_range */ 
typedef struct s__l__gen_constraint_range {
    t__int d__;
    t__int gen__;
    struct s__gen_constraint_range **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__gen_constraint_range;
#define d__l__gen_constraint_range 3472   


/* l__gen_constraint_or */ 
typedef struct s__l__gen_constraint_or {
    t__int d__;
    t__int gen__;
    struct s__gen_constraint_or **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__gen_constraint_or;
#define d__l__gen_constraint_or 3473   


/* l__derived_or_info */ 
typedef struct s__l__derived_or_info {
    t__int d__;
    t__int gen__;
    struct s__derived_or_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__derived_or_info;
#define d__l__derived_or_info 3479   


/* l__or_info */ 
typedef struct s__l__or_info {
    t__int d__;
    t__int gen__;
    struct s__or_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__or_info;
#define d__l__or_info 3480   


/* l__status_in_or */ 
typedef struct s__l__status_in_or {
    t__int d__;
    t__int gen__;
    t__status_in_or*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__status_in_or;
#define d__l__status_in_or 3477   


/* l__sn_field_collector */ 
typedef struct s__l__sn_field_collector {
    t__int d__;
    t__int gen__;
    struct s__sn_field_collector **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_field_collector;
#define d__l__sn_field_collector 3513   


/* l__computed_struct_list */ 
typedef struct s__l__computed_struct_list {
    t__int d__;
    t__int gen__;
    struct s__computed_struct_list **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__computed_struct_list;
#define d__l__computed_struct_list 1530   


/* l__computed_name */ 
typedef struct s__l__computed_name {
    t__int d__;
    t__int gen__;
    struct s__computed_name **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__computed_name;
#define d__l__computed_name 1525   


/* l__unit_instance_info */ 
typedef struct s__l__unit_instance_info {
    t__int d__;
    t__int gen__;
    struct s__unit_instance_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__unit_instance_info;
#define d__l__unit_instance_info 1552   


/* k__subprogram_handle__subpr6617 */ 
typedef struct s__k__subprogram_handle__su9797 {
    t__int d__;
    t__int gen__;
    struct s__subprogram_handle **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__subprogram_handle__subpr6617;
#define d__k__subprogram_handle__subpr6617 1538   


/* l__translated_model_struct */ 
typedef struct s__l__translated_model_struct {
    t__int d__;
    t__int gen__;
    struct s__translated_model_struct **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__translated_model_struct;
#define d__l__translated_model_struct 1547   


/* k__desc_subprogram_info__un6620 */ 
typedef struct s__k__desc_subprogram_info_9796 {
    t__int d__;
    t__int gen__;
    struct s__desc_subprogram_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__desc_subprogram_info__un6620;
#define d__k__desc_subprogram_info__un6620 1570   


/* l__subprogram_handle */ 
typedef struct s__l__subprogram_handle {
    t__int d__;
    t__int gen__;
    struct s__subprogram_handle **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__subprogram_handle;
#define d__l__subprogram_handle 1568   


/* l__hdl_data_type */ 
typedef struct s__l__hdl_data_type {
    t__int d__;
    t__int gen__;
    t__hdl_data_type*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__hdl_data_type;
#define d__l__hdl_data_type 1565   


/* l__type_descriptor */ 
typedef struct s__l__type_descriptor {
    t__int d__;
    t__int gen__;
    struct s__type_descriptor **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__type_descriptor;
#define d__l__type_descriptor 386   


/* l__connecte_cell */ 
typedef struct s__l__connecte_cell {
    t__int d__;
    t__int gen__;
    struct s__connecte_cell **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__connecte_cell;
#define d__l__connecte_cell 1573   


/* k__hdl_struct__name */ 
typedef struct s__k__hdl_struct__name {
    t__int d__;
    t__int gen__;
    struct s__hdl_struct **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__hdl_struct__name;
#define d__k__hdl_struct__name 1553   


/* k__subprogram_handle__subpr6621 */ 
typedef struct s__k__subprogram_handle__su9790 {
    t__int d__;
    t__int gen__;
    struct s__subprogram_handle **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__subprogram_handle__subpr6621;
#define d__k__subprogram_handle__subpr6621 1577   


/* k__subprogram_entry__subpro6622 */ 
typedef struct s__k__subprogram_entry__sub9791 {
    t__int d__;
    t__int gen__;
    struct s__subprogram_entry **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__subprogram_entry__subpro6622;
#define d__k__subprogram_entry__subpro6622 1578   


/* l__subprogram_exp_info */ 
typedef struct s__l__subprogram_exp_info {
    t__int d__;
    t__int gen__;
    struct s__subprogram_exp_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__subprogram_exp_info;
#define d__l__subprogram_exp_info 1580   


/* l__computed_subprogram_list */ 
typedef struct s__l__computed_subprogram_list {
    t__int d__;
    t__int gen__;
    struct s__computed_subprogram_list **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__computed_subprogram_list;
#define d__l__computed_subprogram_list 1532   


/* l__computed_subprogram_name */ 
typedef struct s__l__computed_subprogram_name {
    t__int d__;
    t__int gen__;
    struct s__computed_subprogram_name **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__computed_subprogram_name;
#define d__l__computed_subprogram_name 1528   


/* k__any_unit__root___normal_6643 */ 
typedef struct s__k__any_unit__root___norm9792 {
    t__int d__;
    t__int gen__;
    struct s__any_unit **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__any_unit__root___normal_6643;
#define d__k__any_unit__root___normal_6643 1589   


/* k__type_descriptor__name */ 
typedef struct s__k__type_descriptor__name {
    t__int d__;
    t__int gen__;
    struct s__type_descriptor **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__type_descriptor__name;
#define d__k__type_descriptor__name 80   


/* l__external_pointer */ 
typedef struct s__l__external_pointer {
    t__int d__;
    t__int gen__;
    t__external_pointer*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__external_pointer;
#define d__l__external_pointer 67   


/* l__source_item */ 
typedef struct s__l__source_item {
    t__int d__;
    t__int gen__;
    struct s__source_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__source_item;
#define d__l__source_item 65   


/* l__entry_instance */ 
typedef struct s__l__entry_instance {
    t__int d__;
    t__int gen__;
    struct s__entry_instance **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__entry_instance;
#define d__l__entry_instance 976   


/* k__any_struct__it */ 
typedef struct s__k__any_struct__it {
    t__int d__;
    t__int gen__;
    struct s__any_struct **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__any_struct__it;
#define d__k__any_struct__it 696   


/* k__seed_domain__name */ 
typedef struct s__k__seed_domain__name {
    t__int d__;
    t__int gen__;
    struct s__seed_domain **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__seed_domain__name;
#define d__k__seed_domain__name 813   


/* k__list_seed_domain__name */ 
typedef struct s__k__list_seed_domain__name {
    t__int d__;
    t__int gen__;
    struct s__list_seed_domain **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__list_seed_domain__name;
#define d__k__list_seed_domain__name 814   


/* l__configuration_category */ 
typedef struct s__l__configuration_category {
    t__int d__;
    t__int gen__;
    struct s__configuration_category **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__configuration_category;
#define d__l__configuration_category 927   


/* l__configuration_option */ 
typedef struct s__l__configuration_option {
    t__int d__;
    t__int gen__;
    struct s__configuration_option **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__configuration_option;
#define d__l__configuration_option 932   


/* l__simple_entry_instance */ 
typedef struct s__l__simple_entry_instance {
    t__int d__;
    t__int gen__;
    struct s__simple_entry_instance **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__simple_entry_instance;
#define d__l__simple_entry_instance 1009   


/* l__script_call_entry_instance */ 
typedef struct s__l__script_call_entry_ins2458 {
    t__int d__;
    t__int gen__;
    struct s__script_call_entry_instance **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__script_call_entry_instance;
#define d__l__script_call_entry_instance 1010   


/* l__parallel_entry_instance */ 
typedef struct s__l__parallel_entry_instance {
    t__int d__;
    t__int gen__;
    struct s__parallel_entry_instance **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__parallel_entry_instance;
#define d__l__parallel_entry_instance 1011   


/* l__wait_entry */ 
typedef struct s__l__wait_entry {
    t__int d__;
    t__int gen__;
    struct s__wait_entry **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__wait_entry;
#define d__l__wait_entry 2047   


/* l__bool__32 */ 
typedef struct s__l__bool__32 {
    t__int d__;
    t__int gen__;
    t__bool__32*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__bool__32;
#define d__l__bool__32 2018   


/* l__counter_list */ 
typedef struct s__l__counter_list {
    t__int d__;
    t__int gen__;
    struct s__counter_list **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__counter_list;
#define d__l__counter_list 2019   


/* l__thread_elem */ 
typedef struct s__l__thread_elem {
    t__int d__;
    t__int gen__;
    struct s__thread_elem **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__thread_elem;
#define d__l__thread_elem 2829   


/* l__thread */ 
typedef struct s__l__thread {
    t__int d__;
    t__int gen__;
    struct s__thread **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__thread;
#define d__l__thread 2834   


/* k__thread_elem__unique_id */ 
typedef struct s__k__thread_elem__unique_id {
    t__int d__;
    t__int gen__;
    struct s__thread_elem **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__thread_elem__unique_id;
#define d__k__thread_elem__unique_id 2840   


/* l__ar_sr */ 
typedef struct s__l__ar_sr {
    t__int d__;
    t__int gen__;
    struct s__ar_sr **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__ar_sr;
#define d__l__ar_sr 2841   


/* l__on_request */ 
typedef struct s__l__on_request {
    t__int d__;
    t__int gen__;
    struct s__on_request **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__on_request;
#define d__l__on_request 504   


/* l__watch_item */ 
typedef struct s__l__watch_item {
    t__int d__;
    t__int gen__;
    struct s__watch_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__watch_item;
#define d__l__watch_item 2805   


/* l__branch_node */ 
typedef struct s__l__branch_node {
    t__int d__;
    t__int gen__;
    struct s__branch_node **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__branch_node;
#define d__l__branch_node 1686   


/* l__type_translation */ 
typedef struct s__l__type_translation {
    t__int d__;
    t__int gen__;
    struct s__type_translation **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__type_translation;
#define d__l__type_translation 83   


/* l__display_item */ 
typedef struct s__l__display_item {
    t__int d__;
    t__int gen__;
    struct s__display_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__display_item;
#define d__l__display_item 85   


/* k__method__name */ 
typedef struct s__k__method__name {
    t__int d__;
    t__int gen__;
    struct s__method **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__method__name;
#define d__k__method__name 87   


/* k__file_contents__file_name */ 
typedef struct s__k__file_contents__file_name {
    t__int d__;
    t__int gen__;
    struct s__file_contents **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__file_contents__file_name;
#define d__k__file_contents__file_name 488   


/* l__late_update_ntv */ 
typedef struct s__l__late_update_ntv {
    t__int d__;
    t__int gen__;
    struct s__late_update_ntv **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__late_update_ntv;
#define d__l__late_update_ntv 754   


/* k__method_sp_var_pair__method */ 
typedef struct s__k__method_sp_var_pair__m1313 {
    t__int d__;
    t__int gen__;
    struct s__method_sp_var_pair **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__method_sp_var_pair__method;
#define d__k__method_sp_var_pair__method 792   


/* k__sn_user_dir_pair__user_name */ 
typedef struct s__k__sn_user_dir_pair__use2883 {
    t__int d__;
    t__int gen__;
    struct s__sn_user_dir_pair **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_user_dir_pair__user_name;
#define d__k__sn_user_dir_pair__user_name 1037   


/* l__n__gen_keeping__action */ 
typedef struct s__l__n__gen_keeping__action {
    t__int d__;
    t__int gen__;
    struct s__n__gen_keeping__action **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__n__gen_keeping__action;
#define d__l__n__gen_keeping__action 4019   


/* l__n__constraint */ 
typedef struct s__l__n__constraint {
    t__int d__;
    t__int gen__;
    struct s__n__constraint **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__n__constraint;
#define d__l__n__constraint 1362   


/* l__file */ 
typedef struct s__l__file {
    t__int d__;
    t__int gen__;
    struct s__file **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__file;
#define d__l__file 1714   


/* l__sn_value_holder */ 
typedef struct s__l__sn_value_holder {
    t__int d__;
    t__int gen__;
    struct s__sn_value_holder **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_value_holder;
#define d__l__sn_value_holder 141   


/* l__trace_the_edge */ 
typedef struct s__l__trace_the_edge {
    t__int d__;
    t__int gen__;
    struct s__trace_the_edge **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__trace_the_edge;
#define d__l__trace_the_edge 3458   


/* l__an_edge */ 
typedef struct s__l__an_edge {
    t__int d__;
    t__int gen__;
    struct s__an_edge **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__an_edge;
#define d__l__an_edge 3459   


/* l__gdo_node */ 
typedef struct s__l__gdo_node {
    t__int d__;
    t__int gen__;
    struct s__gdo_node **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__gdo_node;
#define d__l__gdo_node 3764   


/* l__gdo_edge */ 
typedef struct s__l__gdo_edge {
    t__int d__;
    t__int gen__;
    struct s__gdo_edge **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__gdo_edge;
#define d__l__gdo_edge 3765   


/* l__gdo_frc */ 
typedef struct s__l__gdo_frc {
    t__int d__;
    t__int gen__;
    struct s__gdo_frc **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__gdo_frc;
#define d__l__gdo_frc 3766   


/* l__sn_msg_struct */ 
typedef struct s__l__sn_msg_struct {
    t__int d__;
    t__int gen__;
    struct s__sn_msg_struct **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_msg_struct;
#define d__l__sn_msg_struct 3730   


/* l__trace_gen_request */ 
typedef struct s__l__trace_gen_request {
    t__int d__;
    t__int gen__;
    struct s__trace_gen_request **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__trace_gen_request;
#define d__l__trace_gen_request 3771   


/* k__sn_msg_set_struct__value */ 
typedef struct s__k__sn_msg_set_struct__value {
    t__int d__;
    t__int gen__;
    struct s__sn_msg_set_struct **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_msg_set_struct__value;
#define d__k__sn_msg_set_struct__value 3731   


/* l__sn_msg_show_request */ 
typedef struct s__l__sn_msg_show_request {
    t__int d__;
    t__int gen__;
    struct s__sn_msg_show_request **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_msg_show_request;
#define d__l__sn_msg_show_request 3736   


/* k__sn_gen_repeat_counter__38405 */ 
typedef struct s__k__sn_gen_repeat_counte42208 {
    t__int d__;
    t__int gen__;
    struct s__sn_gen_repeat_counter **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_gen_repeat_counter__38405;
#define d__k__sn_gen_repeat_counter__38405 3740   


/* k__sn_gen_string_repeat_co38406 */ 
typedef struct s__k__sn_gen_string_repeat42209 {
    t__int d__;
    t__int gen__;
    struct s__sn_gen_string_repeat_counter **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_gen_string_repeat_co38406;
#define d__k__sn_gen_string_repeat_co38406 3741   


/* l__sn_msg_start_gen */ 
typedef struct s__l__sn_msg_start_gen {
    t__int d__;
    t__int gen__;
    struct s__sn_msg_start_gen **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_msg_start_gen;
#define d__l__sn_msg_start_gen 3745   


/* k__base_struct__it */ 
typedef struct s__k__base_struct__it {
    t__int d__;
    t__int gen__;
    struct s__base_struct **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__base_struct__it;
#define d__k__base_struct__it 374   


/* l__om_frame */ 
typedef struct s__l__om_frame {
    t__int d__;
    t__int gen__;
    struct s__om_frame **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__om_frame;
#define d__l__om_frame 3691   


/* l__om_node */ 
typedef struct s__l__om_node {
    t__int d__;
    t__int gen__;
    struct s__om_node **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__om_node;
#define d__l__om_node 3690   


/* l__om_item_node */ 
typedef struct s__l__om_item_node {
    t__int d__;
    t__int gen__;
    struct s__om_item_node **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__om_item_node;
#define d__l__om_item_node 3685   


/* k__role_count__role_str */ 
typedef struct s__k__role_count__role_str {
    t__int d__;
    t__int gen__;
    struct s__role_count **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__role_count__role_str;
#define d__k__role_count__role_str 3461   


/* l__gotf_info */ 
typedef struct s__l__gotf_info {
    t__int d__;
    t__int gen__;
    struct s__gotf_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__gotf_info;
#define d__l__gotf_info 3462   


/* k__field__it */ 
typedef struct s__k__field__it {
    t__int d__;
    t__int gen__;
    struct s__field **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__field__it;
#define d__k__field__it 3464   


/* l__static_om_f */ 
typedef struct s__l__static_om_f {
    t__int d__;
    t__int gen__;
    struct s__static_om_f **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__static_om_f;
#define d__l__static_om_f 3547   


/* l__struct_path_item */ 
typedef struct s__l__struct_path_item {
    t__int d__;
    t__int gen__;
    struct s__struct_path_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__struct_path_item;
#define d__l__struct_path_item 3699   


/* k__instanciated_fields_of_36297 */ 
typedef struct s__k__instanciated_fields_36402 {
    t__int d__;
    t__int gen__;
    struct s__instanciated_fields_of_36403 **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__instanciated_fields_of_36297;
#define d__k__instanciated_fields_of_36297 3557   


/* k__sn_instanciated_field__f */ 
typedef struct s__k__sn_instanciated_field__f {
    t__int d__;
    t__int gen__;
    struct s__sn_instanciated_field **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_instanciated_field__f;
#define d__k__sn_instanciated_field__f 3560   


/* l__gendb_field_in_gen */ 
typedef struct s__l__gendb_field_in_gen {
    t__int d__;
    t__int gen__;
    struct s__gendb_field_in_gen **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__gendb_field_in_gen;
#define d__l__gendb_field_in_gen 3622   


/* l__sn_instanciated_field */ 
typedef struct s__l__sn_instanciated_field {
    t__int d__;
    t__int gen__;
    struct s__sn_instanciated_field **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_instanciated_field;
#define d__l__sn_instanciated_field 3558   


/* k__sn_role_info__role_id */ 
typedef struct s__k__sn_role_info__role_id {
    t__int d__;
    t__int gen__;
    struct s__sn_role_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_role_info__role_id;
#define d__k__sn_role_info__role_id 3551   


/* l__sn_start_gen_event */ 
typedef struct s__l__sn_start_gen_event {
    t__int d__;
    t__int gen__;
    struct s__sn_start_gen_event **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_start_gen_event;
#define d__l__sn_start_gen_event 3552   


/* l__sn_gen_root_event */ 
typedef struct s__l__sn_gen_root_event {
    t__int d__;
    t__int gen__;
    struct s__sn_gen_root_event **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_gen_root_event;
#define d__l__sn_gen_root_event 3553   


/* l__sn_gdo_edge */ 
typedef struct s__l__sn_gdo_edge {
    t__int d__;
    t__int gen__;
    struct s__sn_gdo_edge **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_gdo_edge;
#define d__l__sn_gdo_edge 3566   


/* l__sn_gdo_node */ 
typedef struct s__l__sn_gdo_node {
    t__int d__;
    t__int gen__;
    struct s__sn_gdo_node **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_gdo_node;
#define d__l__sn_gdo_node 3567   


/* l__sn_gdo_frc */ 
typedef struct s__l__sn_gdo_frc {
    t__int d__;
    t__int gen__;
    struct s__sn_gdo_frc **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_gdo_frc;
#define d__l__sn_gdo_frc 3568   


/* l__sn_set_value_event */ 
typedef struct s__l__sn_set_value_event {
    t__int d__;
    t__int gen__;
    struct s__sn_set_value_event **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_set_value_event;
#define d__l__sn_set_value_event 3554   


/* l__sn_event_parameter */ 
typedef struct s__l__sn_event_parameter {
    t__int d__;
    t__int gen__;
    struct s__sn_event_parameter **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_event_parameter;
#define d__l__sn_event_parameter 3555   


/* k__sn_ci_to_fig__ci */ 
typedef struct s__k__sn_ci_to_fig__ci {
    t__int d__;
    t__int gen__;
    struct s__sn_ci_to_fig **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_ci_to_fig__ci;
#define d__k__sn_ci_to_fig__ci 3710   


/* k__sn_ci_to_deferred__ci */ 
typedef struct s__k__sn_ci_to_deferred__ci {
    t__int d__;
    t__int gen__;
    struct s__sn_ci_to_deferred **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_ci_to_deferred__ci;
#define d__k__sn_ci_to_deferred__ci 3715   


/* k__deferred_par__par_no */ 
typedef struct s__k__deferred_par__par_no {
    t__int d__;
    t__int gen__;
    struct s__deferred_par **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__deferred_par__par_no;
#define d__k__deferred_par__par_no 3714   


/* l__changed_gendb_item */ 
typedef struct s__l__changed_gendb_item {
    t__int d__;
    t__int gen__;
    struct s__changed_gendb_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__changed_gendb_item;
#define d__l__changed_gendb_item 3712   


/* l__sn_skeleton_event */ 
typedef struct s__l__sn_skeleton_event {
    t__int d__;
    t__int gen__;
    struct s__sn_skeleton_event **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_skeleton_event;
#define d__l__sn_skeleton_event 3562   


/* l__sn_ci_info */ 
typedef struct s__l__sn_ci_info {
    t__int d__;
    t__int gen__;
    struct s__sn_ci_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_ci_info;
#define d__l__sn_ci_info 1470   


/* l__sn_compute_select_struct */ 
typedef struct s__l__sn_compute_select_struct {
    t__int d__;
    t__int gen__;
    struct s__sn_compute_select_struct **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_compute_select_struct;
#define d__l__sn_compute_select_struct 3721   


/* k__int__it */ 
typedef struct s__k__int__it {
    t__int d__;
    t__int gen__;
    t__int*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__int__it;
#define d__k__int__it 375   


/* l__display_window */ 
typedef struct s__l__display_window {
    t__int d__;
    t__int gen__;
    struct s__display_window **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__display_window;
#define d__l__display_window 1817   


/* k__sn_action__p_s_key */ 
typedef struct s__k__sn_action__p_s_key {
    t__int d__;
    t__int gen__;
    struct s__sn_action **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_action__p_s_key;
#define d__k__sn_action__p_s_key 1809   


/* l__sn_action_widget */ 
typedef struct s__l__sn_action_widget {
    t__int d__;
    t__int gen__;
    struct s__sn_action_widget **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_action_widget;
#define d__l__sn_action_widget 1830   


/* k__dbg_thread_geometry__p_t9847 */ 
typedef struct s__k__dbg_thread_geometry_13474 {
    t__int d__;
    t__int gen__;
    struct s__dbg_thread_geometry **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__dbg_thread_geometry__p_t9847;
#define d__k__dbg_thread_geometry__p_t9847 1820   


/* k__sn_gui_tag_info__s_name */ 
typedef struct s__k__sn_gui_tag_info__s_name {
    t__int d__;
    t__int gen__;
    struct s__sn_gui_tag_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_gui_tag_info__s_name;
#define d__k__sn_gui_tag_info__s_name 1949   


/* k__property_item__p_s_prop13277 */ 
typedef struct s__k__property_item__p_s_p13513 {
    t__int d__;
    t__int gen__;
    struct s__property_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__property_item__p_s_prop13277;
#define d__k__property_item__p_s_prop13277 1989   


/* k__const__name */ 
typedef struct s__k__const__name {
    t__int d__;
    t__int gen__;
    struct s__const **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__const__name;
#define d__k__const__name 366   


/* k__inline_method__method_index */ 
typedef struct s__k__inline_method__method_326 {
    t__int d__;
    t__int gen__;
    struct s__inline_method **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__inline_method__method_index;
#define d__k__inline_method__method_index 133   


/* l__post_load_detail */ 
typedef struct s__l__post_load_detail {
    t__int d__;
    t__int gen__;
    struct s__post_load_detail **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__post_load_detail;
#define d__l__post_load_detail 57   


/* l__sn_filter_level */ 
typedef struct s__l__sn_filter_level {
    t__int d__;
    t__int gen__;
    t__sn_filter_level*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_filter_level;
#define d__l__sn_filter_level 54   


/* l__source_ref */ 
typedef struct s__l__source_ref {
    t__int d__;
    t__int gen__;
    t__source_ref*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__source_ref;
#define d__l__source_ref 734   


/* k__attr_item_info__name */ 
typedef struct s__k__attr_item_info__name {
    t__int d__;
    t__int gen__;
    struct s__attr_item_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__attr_item_info__name;
#define d__k__attr_item_info__name 855   


/* l__encrypt_module */ 
typedef struct s__l__encrypt_module {
    t__int d__;
    t__int gen__;
    struct s__encrypt_module **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__encrypt_module;
#define d__l__encrypt_module 1736   


/* l__byte */ 
typedef struct s__l__byte {
    t__int d__;
    t__int gen__;
    t__byte*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__byte;
#define d__l__byte 100   


/* k__verilog_macro__name */ 
typedef struct s__k__verilog_macro__name {
    t__int d__;
    t__int gen__;
    struct s__verilog_macro **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__verilog_macro__name;
#define d__k__verilog_macro__name 74   


/* k__deferred_macro__name */ 
typedef struct s__k__deferred_macro__name {
    t__int d__;
    t__int gen__;
    struct s__deferred_macro **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__deferred_macro__name;
#define d__k__deferred_macro__name 75   


/* l__sn_adapter_struct */ 
typedef struct s__l__sn_adapter_struct {
    t__int d__;
    t__int gen__;
    struct s__sn_adapter_struct **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_adapter_struct;
#define d__l__sn_adapter_struct 1588   


/* k__computed_name__name */ 
typedef struct s__k__computed_name__name {
    t__int d__;
    t__int gen__;
    struct s__computed_name **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__computed_name__name;
#define d__k__computed_name__name 1521   


/* k__computed_subprogram_name6616 */ 
typedef struct s__k__computed_subprogram_n9793 {
    t__int d__;
    t__int gen__;
    struct s__computed_subprogram_name **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__computed_subprogram_name6616;
#define d__k__computed_subprogram_name6616 1522   


/* k__vhdl_driver_inst__name */ 
typedef struct s__k__vhdl_driver_inst__name {
    t__int d__;
    t__int gen__;
    struct s__vhdl_driver_inst **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__vhdl_driver_inst__name;
#define d__k__vhdl_driver_inst__name 1523   


/* l__hdl_exp_info */ 
typedef struct s__l__hdl_exp_info {
    t__int d__;
    t__int gen__;
    struct s__hdl_exp_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__hdl_exp_info;
#define d__l__hdl_exp_info 1545   


/* k__translated_model_struct_6618 */ 
typedef struct s__k__translated_model_stru9794 {
    t__int d__;
    t__int gen__;
    struct s__translated_model_struct **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__translated_model_struct_6618;
#define d__k__translated_model_struct_6618 1546   


/* k__verilog_variable_inst__f6619 */ 
typedef struct s__k__verilog_variable_inst9795 {
    t__int d__;
    t__int gen__;
    struct s__verilog_variable_inst **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__verilog_variable_inst__f6619;
#define d__k__verilog_variable_inst__f6619 1548   


/* l__sn_verilog_code_inst */ 
typedef struct s__l__sn_verilog_code_inst {
    t__int d__;
    t__int gen__;
    struct s__sn_verilog_code_inst **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_verilog_code_inst;
#define d__l__sn_verilog_code_inst 1549   


/* l__subprogram_param_info */ 
typedef struct s__l__subprogram_param_info {
    t__int d__;
    t__int gen__;
    struct s__subprogram_param_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__subprogram_param_info;
#define d__l__subprogram_param_info 1575   


/* l__low_high */ 
typedef struct s__l__low_high {
    t__int d__;
    t__int gen__;
    struct s__low_high **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__low_high;
#define d__l__low_high 2264   


/* l__thread_list */ 
typedef struct s__l__thread_list {
    t__int d__;
    t__int gen__;
    struct s__thread_list **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__thread_list;
#define d__l__thread_list 1683   


/* l__script_instance */ 
typedef struct s__l__script_instance {
    t__int d__;
    t__int gen__;
    struct s__script_instance **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__script_instance;
#define d__l__script_instance 1682   


/* l__any_struct */ 
typedef struct s__l__any_struct {
    t__int d__;
    t__int gen__;
    struct s__any_struct **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__any_struct;
#define d__l__any_struct 676   


/* l__event_type */ 
typedef struct s__l__event_type {
    t__int d__;
    t__int gen__;
    struct s__event_type **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__event_type;
#define d__l__event_type 2011   


/* l__event_trace_type */ 
typedef struct s__l__event_trace_type {
    t__int d__;
    t__int gen__;
    struct s__event_trace_type **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__event_trace_type;
#define d__l__event_trace_type 2052   


/* l__sn_event_struct */ 
typedef struct s__l__sn_event_struct {
    t__int d__;
    t__int gen__;
    struct s__sn_event_struct **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_event_struct;
#define d__l__sn_event_struct 2053   


/* l__sn_queue */ 
typedef struct s__l__sn_queue {
    t__int d__;
    t__int gen__;
    struct s__sn_queue **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_queue;
#define d__l__sn_queue 2057   


/* l__sn_struct */ 
typedef struct s__l__sn_struct {
    t__int d__;
    t__int gen__;
    struct s__sn_struct **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_struct;
#define d__l__sn_struct 2055   


/* l__waiting_thread */ 
typedef struct s__l__waiting_thread {
    t__int d__;
    t__int gen__;
    struct s__waiting_thread **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__waiting_thread;
#define d__l__waiting_thread 2061   


/* l__tesv_store */ 
typedef struct s__l__tesv_store {
    t__int d__;
    t__int gen__;
    struct s__tesv_store **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__tesv_store;
#define d__l__tesv_store 2267   


/* l__te_memory */ 
typedef struct s__l__te_memory {
    t__int d__;
    t__int gen__;
    struct s__te_memory **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__te_memory;
#define d__l__te_memory 2266   


/* k__comm_transfered_out_req17441 */ 
typedef struct s__k__comm_transfered_out_17631 {
    t__int d__;
    t__int gen__;
    struct s__comm_transfered_out_request **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__comm_transfered_out_req17441;
#define d__k__comm_transfered_out_req17441 2375   


/* k__comm_waiting_in_reply__id */ 
typedef struct s__k__comm_waiting_in_reply__id {
    t__int d__;
    t__int gen__;
    struct s__comm_waiting_in_reply **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__comm_waiting_in_reply__id;
#define d__k__comm_waiting_in_reply__id 2372   


/* l__comm_client_application_desc */ 
typedef struct s__l__comm_client_applicat17628 {
    t__int d__;
    t__int gen__;
    struct s__comm_client_application_desc **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__comm_client_application_desc;
#define d__l__comm_client_application_desc 2387   


/* l__pat */ 
typedef struct s__l__pat {
    t__int d__;
    t__int gen__;
    t__pat*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__pat;
#define d__l__pat 462   


/* l__debug_item */ 
typedef struct s__l__debug_item {
    t__int d__;
    t__int gen__;
    struct s__debug_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__debug_item;
#define d__l__debug_item 1085   


/* l__pack_string_item */ 
typedef struct s__l__pack_string_item {
    t__int d__;
    t__int gen__;
    struct s__pack_string_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__pack_string_item;
#define d__l__pack_string_item 1084   


/* l__pack_originate_from */ 
typedef struct s__l__pack_originate_from {
    t__int d__;
    t__int gen__;
    t__pack_originate_from*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__pack_originate_from;
#define d__l__pack_originate_from 1086   


/* l__trans_table_item */ 
typedef struct s__l__trans_table_item {
    t__int d__;
    t__int gen__;
    struct s__trans_table_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__trans_table_item;
#define d__l__trans_table_item 4150   


/* l__abs_wave_command_manager */ 
typedef struct s__l__abs_wave_command_manager {
    t__int d__;
    t__int gen__;
    struct s__abs_wave_command_manager **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__abs_wave_command_manager;
#define d__l__abs_wave_command_manager 3065   


/* k__signal_naming_map__new_name */ 
typedef struct s__k__signal_naming_map__n30098 {
    t__int d__;
    t__int gen__;
    struct s__signal_naming_map **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__signal_naming_map__new_name;
#define d__k__signal_naming_map__new_name 3026   


/* k__fake_signal__name */ 
typedef struct s__k__fake_signal__name {
    t__int d__;
    t__int gen__;
    struct s__fake_signal **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__fake_signal__name;
#define d__k__fake_signal__name 1012   


/* l__select_list_with_prio */ 
typedef struct s__l__select_list_with_prio {
    t__int d__;
    t__int gen__;
    struct s__select_list_with_prio **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__select_list_with_prio;
#define d__l__select_list_with_prio 1078   


/* l__sort_item */ 
typedef struct s__l__sort_item {
    t__int d__;
    t__int gen__;
    struct s__sort_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sort_item;
#define d__l__sort_item 1079   


/* l__untyped_list_to_scalar_c6264 */ 
typedef struct s__l__untyped_list_to_scala6585 {
    t__int d__;
    t__int gen__;
    struct s__untyped_list_to_scalar_c6589 **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__untyped_list_to_scalar_c6264;
#define d__l__untyped_list_to_scalar_c6264 1367   


/* l__gen_frame */ 
typedef struct s__l__gen_frame {
    t__int d__;
    t__int gen__;
    struct s__gen_frame **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__gen_frame;
#define d__l__gen_frame 1458   


/* l__sn_library */ 
typedef struct s__l__sn_library {
    t__int d__;
    t__int gen__;
    struct s__sn_library **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_library;
#define d__l__sn_library 1508   


/* k__sn_component__name */ 
typedef struct s__k__sn_component__name {
    t__int d__;
    t__int gen__;
    struct s__sn_component **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_component__name;
#define d__k__sn_component__name 4214   


/* k__sn_patch_info__id */ 
typedef struct s__k__sn_patch_info__id {
    t__int d__;
    t__int gen__;
    struct s__sn_patch_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_patch_info__id;
#define d__k__sn_patch_info__id 4210   


/* k__sn_command_option_descr44153 */ 
typedef struct s__k__sn_command_option_de44872 {
    t__int d__;
    t__int gen__;
    struct s__sn_command_option_descriptor **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_command_option_descr44153;
#define d__k__sn_command_option_descr44153 4204   


/* l__line_kind */ 
typedef struct s__l__line_kind {
    t__int d__;
    t__int gen__;
    t__line_kind*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__line_kind;
#define d__l__line_kind 1694   


/* l__word_indices */ 
typedef struct s__l__word_indices {
    t__int d__;
    t__int gen__;
    struct s__word_indices **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__word_indices;
#define d__l__word_indices 1695   


/* k__sn_cvr_main_group_descr19957 */ 
typedef struct s__k__sn_cvr_main_group_de22606 {
    t__int d__;
    t__int gen__;
    struct s__sn_cvr_main_group_descriptor **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_cvr_main_group_descr19957;
#define d__k__sn_cvr_main_group_descr19957 2597   


/* l__sn_cover_test */ 
typedef struct s__l__sn_cover_test {
    t__int d__;
    t__int gen__;
    struct s__sn_cover_test **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cover_test;
#define d__l__sn_cover_test 2582   


/* l__sn_cvr_main_group_descriptor */ 
typedef struct s__l__sn_cvr_main_group_de22607 {
    t__int d__;
    t__int gen__;
    struct s__sn_cvr_main_group_descriptor **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cvr_main_group_descriptor;
#define d__l__sn_cvr_main_group_descriptor 2598   


/* k__sn_external_cover__kind */ 
typedef struct s__k__sn_external_cover__kind {
    t__int d__;
    t__int gen__;
    struct s__sn_external_cover **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_external_cover__kind;
#define d__k__sn_external_cover__kind 2609   


/* l__sn_external_group */ 
typedef struct s__l__sn_external_group {
    t__int d__;
    t__int gen__;
    struct s__sn_external_group **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_external_group;
#define d__l__sn_external_group 2608   


/* k__enum_item__name */ 
typedef struct s__k__enum_item__name {
    t__int d__;
    t__int gen__;
    struct s__enum_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__enum_item__name;
#define d__k__enum_item__name 126   


/* l__sn_search_item */ 
typedef struct s__l__sn_search_item {
    t__int d__;
    t__int gen__;
    struct s__sn_search_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_search_item;
#define d__l__sn_search_item 2621   


/* l__sn_cvr_external_type */ 
typedef struct s__l__sn_cvr_external_type {
    t__int d__;
    t__int gen__;
    t__sn_cvr_external_type*data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cvr_external_type;
#define d__l__sn_cvr_external_type 2722   


/* l__sn_cvr_test_rank_info */ 
typedef struct s__l__sn_cvr_test_rank_info {
    t__int d__;
    t__int gen__;
    struct s__sn_cvr_test_rank_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cvr_test_rank_info;
#define d__l__sn_cvr_test_rank_info 2737   


/* l__sn_cvr_group_rank_info */ 
typedef struct s__l__sn_cvr_group_rank_info {
    t__int d__;
    t__int gen__;
    struct s__sn_cvr_group_rank_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cvr_group_rank_info;
#define d__l__sn_cvr_group_rank_info 2727   


/* l__sn_cvr_item_rank_info */ 
typedef struct s__l__sn_cvr_item_rank_info {
    t__int d__;
    t__int gen__;
    struct s__sn_cvr_item_rank_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cvr_item_rank_info;
#define d__l__sn_cvr_item_rank_info 2730   


/* l__sn_cvr_bucket_rank_info */ 
typedef struct s__l__sn_cvr_bucket_rank_info {
    t__int d__;
    t__int gen__;
    struct s__sn_cvr_bucket_rank_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cvr_bucket_rank_info;
#define d__l__sn_cvr_bucket_rank_info 2732   


/* k__sn_cvr_test_rank_info__id */ 
typedef struct s__k__sn_cvr_test_rank_info__id {
    t__int d__;
    t__int gen__;
    struct s__sn_cvr_test_rank_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_cvr_test_rank_info__id;
#define d__k__sn_cvr_test_rank_info__id 2739   


/* l__sn_cvr_instance_group_d21843 */ 
typedef struct s__l__sn_cvr_instance_grou22666 {
    t__int d__;
    t__int gen__;
    struct s__sn_cvr_instance_group_d22605 **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cvr_instance_group_d21843;
#define d__l__sn_cvr_instance_group_d21843 2740   


/* l__sn_cvr_gui_curr_page */ 
typedef struct s__l__sn_cvr_gui_curr_page {
    t__int d__;
    t__int gen__;
    struct s__sn_cvr_gui_curr_page **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cvr_gui_curr_page;
#define d__l__sn_cvr_gui_curr_page 4251   


/* l__sn_cvr_table_column */ 
typedef struct s__l__sn_cvr_table_column {
    t__int d__;
    t__int gen__;
    struct s__sn_cvr_table_column **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cvr_table_column;
#define d__l__sn_cvr_table_column 4247   


/* l__sn_vt_menu */ 
typedef struct s__l__sn_vt_menu {
    t__int d__;
    t__int gen__;
    struct s__sn_vt_menu **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_vt_menu;
#define d__l__sn_vt_menu 3382   


/* l__sn_vt_action */ 
typedef struct s__l__sn_vt_action {
    t__int d__;
    t__int gen__;
    struct s__sn_vt_action **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_vt_action;
#define d__l__sn_vt_action 3384   


/* k__sn_p_key_store_entry__key */ 
typedef struct s__k__sn_p_key_store_entry__key {
    t__int d__;
    t__int gen__;
    struct s__sn_p_key_store_entry **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_p_key_store_entry__key;
#define d__k__sn_p_key_store_entry__key 1048   


/* l__sn_fl_te_node */ 
typedef struct s__l__sn_fl_te_node {
    t__int d__;
    t__int gen__;
    struct s__sn_fl_te_node **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_fl_te_node;
#define d__l__sn_fl_te_node 2190   


/* l__sn_fl_var_scndry */ 
typedef struct s__l__sn_fl_var_scndry {
    t__int d__;
    t__int gen__;
    struct s__sn_fl_var_scndry **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_fl_var_scndry;
#define d__l__sn_fl_var_scndry 2124   


/* k__sn_fl_fsm_entry__id */ 
typedef struct s__k__sn_fl_fsm_entry__id {
    t__int d__;
    t__int gen__;
    struct s__sn_fl_fsm_entry **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_fl_fsm_entry__id;
#define d__k__sn_fl_fsm_entry__id 2217   


/* l__sn_fl_fsm_edge */ 
typedef struct s__l__sn_fl_fsm_edge {
    t__int d__;
    t__int gen__;
    struct s__sn_fl_fsm_edge **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_fl_fsm_edge;
#define d__l__sn_fl_fsm_edge 2216   


/* k__sn_bdd_var__name */ 
typedef struct s__k__sn_bdd_var__name {
    t__int d__;
    t__int gen__;
    struct s__sn_bdd_var **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_bdd_var__name;
#define d__k__sn_bdd_var__name 2114   


/* k__sn_bdd_var__id */ 
typedef struct s__k__sn_bdd_var__id {
    t__int d__;
    t__int gen__;
    struct s__sn_bdd_var **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_bdd_var__id;
#define d__k__sn_bdd_var__id 2115   


/* l__sn_fl_var_exec */ 
typedef struct s__l__sn_fl_var_exec {
    t__int d__;
    t__int gen__;
    struct s__sn_fl_var_exec **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_fl_var_exec;
#define d__l__sn_fl_var_exec 2139   


/* l__sn_fl_var_alpha */ 
typedef struct s__l__sn_fl_var_alpha {
    t__int d__;
    t__int gen__;
    struct s__sn_fl_var_alpha **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_fl_var_alpha;
#define d__l__sn_fl_var_alpha 2214   


/* l__sn_fl_var_true */ 
typedef struct s__l__sn_fl_var_true {
    t__int d__;
    t__int gen__;
    struct s__sn_fl_var_true **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_fl_var_true;
#define d__l__sn_fl_var_true 2140   


/* l__sn_fl_fsm_entry */ 
typedef struct s__l__sn_fl_fsm_entry {
    t__int d__;
    t__int gen__;
    struct s__sn_fl_fsm_entry **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_fl_fsm_entry;
#define d__l__sn_fl_fsm_entry 2198   


/* l__sn_fl_detach_top_node */ 
typedef struct s__l__sn_fl_detach_top_node {
    t__int d__;
    t__int gen__;
    struct s__sn_fl_detach_top_node **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_fl_detach_top_node;
#define d__l__sn_fl_detach_top_node 2138   


/* l__sn_fl_var_event */ 
typedef struct s__l__sn_fl_var_event {
    t__int d__;
    t__int gen__;
    struct s__sn_fl_var_event **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_fl_var_event;
#define d__l__sn_fl_var_event 2153   


/* l__sn_fl_top_node */ 
typedef struct s__l__sn_fl_top_node {
    t__int d__;
    t__int gen__;
    struct s__sn_fl_top_node **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_fl_top_node;
#define d__l__sn_fl_top_node 2207   


/* l__tdb_break_point */ 
typedef struct s__l__tdb_break_point {
    t__int d__;
    t__int gen__;
    struct s__tdb_break_point **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__tdb_break_point;
#define d__l__tdb_break_point 2220   


/* k__sn_define2_descriptor__name */ 
typedef struct s__k__sn_define2_descripto16521 {
    t__int d__;
    t__int gen__;
    struct s__sn_define2_descriptor **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_define2_descriptor__name;
#define d__k__sn_define2_descriptor__name 2295   


/* k__def2_name_string__name */ 
typedef struct s__k__def2_name_string__name {
    t__int d__;
    t__int gen__;
    struct s__def2_name_string **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__def2_name_string__name;
#define d__k__def2_name_string__name 2294   


/* k__seamless_connection__tag */ 
typedef struct s__k__seamless_connection__tag {
    t__int d__;
    t__int gen__;
    struct s__seamless_connection **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__seamless_connection__tag;
#define d__k__seamless_connection__tag 2303   


/* k__sw_obj__descr */ 
typedef struct s__k__sw_obj__descr {
    t__int d__;
    t__int gen__;
    struct s__sw_obj **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sw_obj__descr;
#define d__k__sw_obj__descr 2304   


/* l__cvl_connection */ 
typedef struct s__l__cvl_connection {
    t__int d__;
    t__int gen__;
    struct s__cvl_connection **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__cvl_connection;
#define d__l__cvl_connection 2316   


/* l__queued_cvl_call */ 
typedef struct s__l__queued_cvl_call {
    t__int d__;
    t__int gen__;
    struct s__queued_cvl_call **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__queued_cvl_call;
#define d__l__queued_cvl_call 2313   


/* l__sn_checksum_t */ 
typedef struct s__l__sn_checksum_t {
    t__int d__;
    t__int gen__;
    struct s__sn_checksum_t **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_checksum_t;
#define d__l__sn_checksum_t 2317   


/* l__sn_cvl_method */ 
typedef struct s__l__sn_cvl_method {
    t__int d__;
    t__int gen__;
    struct s__sn_cvl_method **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_cvl_method;
#define d__l__sn_cvl_method 2332   


/* l__comm_pack_unpackable */ 
typedef struct s__l__comm_pack_unpackable {
    t__int d__;
    t__int gen__;
    struct s__comm_pack_unpackable **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__comm_pack_unpackable;
#define d__l__comm_pack_unpackable 2348   


/* k__sn_edl_struct_info__p_td */ 
typedef struct s__k__sn_edl_struct_info__p_td {
    t__int d__;
    t__int gen__;
    struct s__sn_edl_struct_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_edl_struct_info__p_td;
#define d__k__sn_edl_struct_info__p_td 2404   


/* k__sn_edl_method_info__p_method */ 
typedef struct s__k__sn_edl_method_info__18151 {
    t__int d__;
    t__int gen__;
    struct s__sn_edl_method_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_edl_method_info__p_method;
#define d__k__sn_edl_method_info__p_method 2406   


/* k__sn_edl_const_info__p_s_name */ 
typedef struct s__k__sn_edl_const_info__p18152 {
    t__int d__;
    t__int gen__;
    struct s__sn_edl_const_info **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_edl_const_info__p_s_name;
#define d__k__sn_edl_const_info__p_s_name 2407   


/* l__EDLPackage */ 
typedef struct s__l__EDLPackage {
    t__int d__;
    t__int gen__;
    struct s__EDLPackage **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__EDLPackage;
#define d__l__EDLPackage 2424   


/* l__EDLAbsUserType */ 
typedef struct s__l__EDLAbsUserType {
    t__int d__;
    t__int gen__;
    struct s__EDLAbsUserType **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__EDLAbsUserType;
#define d__l__EDLAbsUserType 2426   


/* k__EDLAbsUserType__it */ 
typedef struct s__k__EDLAbsUserType__it {
    t__int d__;
    t__int gen__;
    struct s__EDLAbsUserType **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__EDLAbsUserType__it;
#define d__k__EDLAbsUserType__it 2433   


/* l__EDLAbsBasicType */ 
typedef struct s__l__EDLAbsBasicType {
    t__int d__;
    t__int gen__;
    struct s__EDLAbsBasicType **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__EDLAbsBasicType;
#define d__l__EDLAbsBasicType 2452   


/* k__name_id_pair__name */ 
typedef struct s__k__name_id_pair__name {
    t__int d__;
    t__int gen__;
    struct s__name_id_pair **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__name_id_pair__name;
#define d__k__name_id_pair__name 2516   


/* l__snorb_data_descriptor */ 
typedef struct s__l__snorb_data_descriptor {
    t__int d__;
    t__int gen__;
    struct s__snorb_data_descriptor **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__snorb_data_descriptor;
#define d__l__snorb_data_descriptor 2517   


/* k__p_sn_string_hash_table_e2603 */ 
typedef struct s__k__p_sn_string_hash_tabl2885 {
    t__int d__;
    t__int gen__;
    struct s__p_sn_string_hash_table_entry **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__p_sn_string_hash_table_e2603;
#define d__k__p_sn_string_hash_table_e2603 1044   


/* k__p_map_entry__key */ 
typedef struct s__k__p_map_entry__key {
    t__int d__;
    t__int gen__;
    struct s__p_map_entry **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__p_map_entry__key;
#define d__k__p_map_entry__key 1040   


/* l__basic_event_log */ 
typedef struct s__l__basic_event_log {
    t__int d__;
    t__int gen__;
    struct s__basic_event_log **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__basic_event_log;
#define d__l__basic_event_log 2688   


/* l__sn_ec_point_environment */ 
typedef struct s__l__sn_ec_point_environment {
    t__int d__;
    t__int gen__;
    struct s__sn_ec_point_environment **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_ec_point_environment;
#define d__l__sn_ec_point_environment 2700   


/* l__any_interface */ 
typedef struct s__l__any_interface {
    t__int d__;
    t__int gen__;
    struct s__any_interface **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__any_interface;
#define d__l__any_interface 2953   


/* k__sn_service_deli_entry__28970 */ 
typedef struct s__k__sn_service_deli_entr29218 {
    t__int d__;
    t__int gen__;
    struct s__sn_service_deli_entry **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_service_deli_entry__28970;
#define d__k__sn_service_deli_entry__28970 2984   


/* l__sni_jcvr_change_listener */ 
typedef struct s__l__sni_jcvr_change_listener {
    t__int d__;
    t__int gen__;
    struct s__sni_jcvr_change_listener **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sni_jcvr_change_listener;
#define d__l__sni_jcvr_change_listener 3093   


/* k__sn_config_full_item__p_s_key */ 
typedef struct s__k__sn_config_full_item_34733 {
    t__int d__;
    t__int gen__;
    struct s__sn_config_full_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_config_full_item__p_s_key;
#define d__k__sn_config_full_item__p_s_key 3160   


/* l__sn_jconfig_category_val */ 
typedef struct s__l__sn_jconfig_category_val {
    t__int d__;
    t__int gen__;
    struct s__sn_jconfig_category_val **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_jconfig_category_val;
#define d__l__sn_jconfig_category_val 3141   


/* l__sn_jconfig_item_val */ 
typedef struct s__l__sn_jconfig_item_val {
    t__int d__;
    t__int gen__;
    struct s__sn_jconfig_item_val **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_jconfig_item_val;
#define d__l__sn_jconfig_item_val 3143   


/* k__scalars_holders__parent_id */ 
typedef struct s__k__scalars_holders__par34754 {
    t__int d__;
    t__int gen__;
    struct s__scalars_holders **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__scalars_holders__parent_id;
#define d__k__scalars_holders__parent_id 3362   


/* k__scalar_cache_node__chil33519 */ 
typedef struct s__k__scalar_cache_node__c34755 {
    t__int d__;
    t__int gen__;
    struct s__scalar_cache_node **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__scalar_cache_node__chil33519;
#define d__k__scalar_cache_node__chil33519 3364   


/* k__container_cache_node__u33520 */ 
typedef struct s__k__container_cache_node34756 {
    t__int d__;
    t__int gen__;
    struct s__container_cache_node **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__container_cache_node__u33520;
#define d__k__container_cache_node__u33520 3366   


/* l__abs_cache_node */ 
typedef struct s__l__abs_cache_node {
    t__int d__;
    t__int gen__;
    struct s__abs_cache_node **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__abs_cache_node;
#define d__l__abs_cache_node 3357   


/* k__null_container_cache_no33521 */ 
typedef struct s__k__null_container_cache34757 {
    t__int d__;
    t__int gen__;
    struct s__null_container_cache_node **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__null_container_cache_no33521;
#define d__k__null_container_cache_no33521 3367   


/* k__container_cache_node__id */ 
typedef struct s__k__container_cache_node__id {
    t__int d__;
    t__int gen__;
    struct s__container_cache_node **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__container_cache_node__id;
#define d__k__container_cache_node__id 3368   


/* l__cache_entry */ 
typedef struct s__l__cache_entry {
    t__int d__;
    t__int gen__;
    struct s__cache_entry **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__cache_entry;
#define d__l__cache_entry 3360   


/* k__sn_vt_buffer__name */ 
typedef struct s__k__sn_vt_buffer__name {
    t__int d__;
    t__int gen__;
    struct s__sn_vt_buffer **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_vt_buffer__name;
#define d__k__sn_vt_buffer__name 3431   


/* l__sn_vt_buffer */ 
typedef struct s__l__sn_vt_buffer {
    t__int d__;
    t__int gen__;
    struct s__sn_vt_buffer **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_vt_buffer;
#define d__l__sn_vt_buffer 3432   


/* l__sn_vt_box */ 
typedef struct s__l__sn_vt_box {
    t__int d__;
    t__int gen__;
    struct s__sn_vt_box **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_vt_box;
#define d__l__sn_vt_box 3451   


/* k__sn_denali_unit__denali_42857 */ 
typedef struct s__k__sn_denali_unit__dena44063 {
    t__int d__;
    t__int gen__;
    struct s__sn_denali_unit **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *k__sn_denali_unit__denali_42857;
#define d__k__sn_denali_unit__denali_42857 4120   


/* l__sn_denali_cb_data_item */ 
typedef struct s__l__sn_denali_cb_data_item {
    t__int d__;
    t__int gen__;
    struct s__sn_denali_cb_data_item **data;
    int size;
    int allocated;
    void *hash;
    int reserved;
} *l__sn_denali_cb_data_item;
#define d__l__sn_denali_cb_data_item 4123   

SN_EXTERNC SN_STRING sn_append_strings _SN_ANSI_ARGS_((int, ...));
SN_EXTERNC SN_STRING sn_appendf_comp _SN_ANSI_ARGS_((int, t__bool, ...));
/* line 0 "e/vrst_snfp_h.e"  From '' */
SN_EXTERNC void r__44907__global  _SN_ANSI_ARGS_ ((t__global));

/* line 56 "e/vrst_snfp_h.e"  From '' */
SN_EXTERNC struct s__l__bit * sn_l__bit__empty_routine  _SN_ANSI_ARGS_ (());

/* line 132 "e/vrst_snfp_h.e"  From '' */
SN_EXTERNC void r__44916__snfp_rnd_fp_s__init  _SN_ANSI_ARGS_ ((t__snfp_rnd_fp_s));

/* line 132 "e/vrst_snfp_h.e"  From '' */
SN_EXTERNC t__bool r__44917__snfp_rnd_fp_s  _SN_ANSI_ARGS_ ((t__snfp_rnd_fp_s,t__pack_options,l__bit,t__int,t__field));

/* line 146 "e/vrst_snfp_h.e"  From '' */
SN_EXTERNC void r__44918__snfp_rnd_fp_s__init  _SN_ANSI_ARGS_ ((t__snfp_rnd_fp_s));

/* line 146 "e/vrst_snfp_h.e"  From '' */
SN_EXTERNC t__bool r__44919__snfp_rnd_fp_s  _SN_ANSI_ARGS_ ((t__snfp_rnd_fp_s,t__pack_options,l__bit,t__int,t__field));

/* line 152 "e/vrst_snfp_h.e"  From '' */
SN_EXTERNC void r__44920__snfp_rnd_fp_s  _SN_ANSI_ARGS_ ((t__snfp_rnd_fp_s));

/* line 0 "e/vrst_snfp.e"  From '' */
SN_EXTERNC void r__44927__global  _SN_ANSI_ARGS_ ((t__global));

/* line 44 "e/vrst_snfp.e"  From '' */
SN_EXTERNC void r__44929__snfp_floating_point_s  _SN_ANSI_ARGS_ ((t__snfp_floating_point_s));

/* line 49 "e/vrst_snfp.e"  From '' */
SN_EXTERNC void r__44930__snfp_floating_point_s  _SN_ANSI_ARGS_ ((t__snfp_floating_point_s,t__string));

/* line 54 "e/vrst_snfp.e"  From '' */
SN_EXTERNC void c_str_to_efp  _SN_ANSI_ARGS_ ((t__snfp_floating_point_s));

/* line 64 "e/vrst_snfp.e"  From '' */
SN_EXTERNC t__bool r__44931__snfp_floating_point_s  _SN_ANSI_ARGS_ ((t__snfp_floating_point_s,t__snfp_floating_point_s));

/* line 70 "e/vrst_snfp.e"  From '' */
SN_EXTERNC t__bool r__44932__snfp_floating_point_s  _SN_ANSI_ARGS_ ((t__snfp_floating_point_s,t__snfp_floating_point_s));

/* line 84 "e/vrst_snfp.e"  From '' */
SN_EXTERNC void r__44933__snfp_floating_point_s  _SN_ANSI_ARGS_ ((t__snfp_floating_point_s));

/* line 87 "e/vrst_snfp.e"  From '' */
SN_EXTERNC void r__44934__snfp_floating_point_s  _SN_ANSI_ARGS_ ((t__snfp_floating_point_s));

/* line 94 "e/vrst_snfp.e"  From '' */
SN_EXTERNC t__string r__44935__snfp_floating_point_s  _SN_ANSI_ARGS_ ((t__snfp_floating_point_s));

/* line 95 "e/vrst_snfp.e"  From '' */
SN_EXTERNC struct s__l__bit * r__44936__snfp_floating_point_s  _SN_ANSI_ARGS_ ((t__snfp_floating_point_s));

/* line 98 "e/vrst_snfp.e"  From '' */
SN_EXTERNC void r__44937__snfp_floating_point_s  _SN_ANSI_ARGS_ ((t__snfp_floating_point_s));

/* line 99 "e/vrst_snfp.e"  From '' */
SN_EXTERNC void r__44938__snfp_floating_point_s  _SN_ANSI_ARGS_ ((t__snfp_floating_point_s));

/* line 108 "e/vrst_snfp.e"  From '' */
SN_EXTERNC void r__44939__snfp_floating_point_s  _SN_ANSI_ARGS_ ((t__snfp_floating_point_s));

/* line 112 "e/vrst_snfp.e"  From '' */
SN_EXTERNC void r__44940__snfp_floating_point_s  _SN_ANSI_ARGS_ ((t__snfp_floating_point_s));

/* line 120 "e/vrst_snfp.e"  From '' */
SN_EXTERNC t__string r__44941__snfp_floating_point_s  _SN_ANSI_ARGS_ ((t__snfp_floating_point_s));

/* line 121 "e/vrst_snfp.e"  From '' */
SN_EXTERNC struct s__l__bit * r__44942__snfp_floating_point_s  _SN_ANSI_ARGS_ ((t__snfp_floating_point_s));

/* line 124 "e/vrst_snfp.e"  From '' */
SN_EXTERNC void r__44943__snfp_floating_point_s  _SN_ANSI_ARGS_ ((t__snfp_floating_point_s));

/* line 125 "e/vrst_snfp.e"  From '' */
SN_EXTERNC void r__44944__snfp_floating_point_s  _SN_ANSI_ARGS_ ((t__snfp_floating_point_s));

/* line 152 "e/vrst_snfp.e"  From '' */
SN_EXTERNC void r__44945__snfp_floating_point_s  _SN_ANSI_ARGS_ ((t__snfp_floating_point_s));

/* line 163 "e/vrst_snfp.e"  From '' */
SN_EXTERNC void snfp_fn  _SN_ANSI_ARGS_ ((t__snfp_floating_point_function_s));

/* line 164 "e/vrst_snfp.e"  From '' */
SN_EXTERNC void r__44946  _SN_ANSI_ARGS_ ((t__snfp_floating_point_function_s));

/* line 174 "e/vrst_snfp.e"  From '' */
SN_EXTERNC t__bool r__44947  _SN_ANSI_ARGS_ ((t__snfp_floating_point_function_s));

/* line 182 "e/vrst_snfp.e"  From '' */
SN_EXTERNC t__bool r__44948  _SN_ANSI_ARGS_ ((t__snfp_floating_point_function_s));

/* line 189 "e/vrst_snfp.e"  From '' */
SN_EXTERNC void r__44949  _SN_ANSI_ARGS_ ((t__snfp_floating_point_function_s));

/* line 194 "e/vrst_snfp.e"  From '' */
SN_EXTERNC void r__44950  _SN_ANSI_ARGS_ ((t__snfp_floating_point_function_s));

/* line 203 "e/vrst_snfp.e"  From '' */
SN_EXTERNC t__string r__44951__snfp_rnd_fp_s  _SN_ANSI_ARGS_ ((t__snfp_rnd_fp_s));

/* line 218 "e/vrst_snfp.e"  From '' */
SN_EXTERNC t__string chop_zero_tail  _SN_ANSI_ARGS_ ((t__string));

/* line 695 "/proj/specman/src/append.e"  From '' */
SN_EXTERNC void sn_out_two  _SN_ANSI_ARGS_ ((t__string,t__string));

/* line 130 "/proj/specman/src/files.e"  From '' */
SN_EXTERNC t__string sn_str_join  _SN_ANSI_ARGS_ ((l__string,t__string));

/* line 133 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn_vec * sn_add2long  _SN_ANSI_ARGS_ ((t__sn_vec,t__sn_vec,t__sn_stack_of_temp_long));

/* line 134 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn_vec * sn_sub2long  _SN_ANSI_ARGS_ ((t__sn_vec,t__sn_vec,t__sn_stack_of_temp_long));

/* line 135 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn_vec * sn_mult2long  _SN_ANSI_ARGS_ ((t__sn_vec,t__sn_vec,t__sn_stack_of_temp_long));

/* line 136 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn_vec * sn_div2long  _SN_ANSI_ARGS_ ((t__sn_vec,t__sn_vec,t__sn_stack_of_temp_long));

/* line 137 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn_vec * sn_mod2long  _SN_ANSI_ARGS_ ((t__sn_vec,t__sn_vec,t__sn_stack_of_temp_long));

/* line 140 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn_vec * sn_bit_not_long  _SN_ANSI_ARGS_ ((t__sn_vec,t__sn_stack_of_temp_long));

/* line 141 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn_vec * sn_minus_long  _SN_ANSI_ARGS_ ((t__sn_vec,t__sn_stack_of_temp_long));

/* line 144 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC t__uint sn_long2uint  _SN_ANSI_ARGS_ ((t__sn_vec));

/* line 145 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn_vec * sn_sized_int2long  _SN_ANSI_ARGS_ ((t__int,t__int,t__sn_stack_of_temp_long));

/* line 146 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn_vec * sn_int2long  _SN_ANSI_ARGS_ ((t__int,t__sn_stack_of_temp_long));

/* line 147 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn_vec * sn_uint2long  _SN_ANSI_ARGS_ ((t__uint,t__sn_stack_of_temp_long));

/* line 148 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn_vec * sn_str2long  _SN_ANSI_ARGS_ ((t__string,t__sn_stack_of_temp_long));

/* line 150 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC t__int sn_order2long  _SN_ANSI_ARGS_ ((t__sn_vec,t__sn_vec));

/* line 152 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC t__bool sn_equal2long  _SN_ANSI_ARGS_ ((t__sn_vec,t__sn_vec));

/* line 153 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC t__bool sn_lt2long  _SN_ANSI_ARGS_ ((t__sn_vec,t__sn_vec));

/* line 154 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC t__bool sn_le2long  _SN_ANSI_ARGS_ ((t__sn_vec,t__sn_vec));

/* line 155 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC t__bool sn_gt2long  _SN_ANSI_ARGS_ ((t__sn_vec,t__sn_vec));

/* line 156 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC t__bool sn_ge2long  _SN_ANSI_ARGS_ ((t__sn_vec,t__sn_vec));

/* line 158 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn_vec * sn_shift_right  _SN_ANSI_ARGS_ ((t__sn_vec,t__int,t__sn_stack_of_temp_long));

/* line 159 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn_vec * sn_shift_left  _SN_ANSI_ARGS_ ((t__sn_vec,t__int,t__sn_stack_of_temp_long));

/* line 161 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn_vec * sn_or2long  _SN_ANSI_ARGS_ ((t__sn_vec,t__sn_vec,t__sn_stack_of_temp_long));

/* line 162 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn_vec * sn_and2long  _SN_ANSI_ARGS_ ((t__sn_vec,t__sn_vec,t__sn_stack_of_temp_long));

/* line 163 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC struct s__sn_vec * sn_xor2long  _SN_ANSI_ARGS_ ((t__sn_vec,t__sn_vec,t__sn_stack_of_temp_long));

/* line 165 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC void sn_assign  _SN_ANSI_ARGS_ ((t__sn_vec,t__sn_vec));

/* line 167 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC void sn_condense_last_byte  _SN_ANSI_ARGS_ ((t__sn_vec));

/* line 169 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC t__int sn_order_long  _SN_ANSI_ARGS_ ((t__sn_vec));

/* line 172 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC t__bool sn_is_long_value_int  _SN_ANSI_ARGS_ ((t__sn_vec));

/* line 173 "/proj/specman/src/exp.e"  From '' */
SN_EXTERNC t__bool sn_is_long_value_uint  _SN_ANSI_ARGS_ ((t__sn_vec));

